//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_H
#define DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_H

/**
 *  Crowd configuration parameters.

 */
struct enterprise_crowd_plugin_ns0_crowdConfiguration {


  /**
   * 
   */
  xmlChar *applicationName;

  /**
   * 
   */
  xmlChar *applicationPassword;

  /**
   * 
   */
  xmlChar *crowdServerUrl;

  /**
   * 
   */
  xmlChar *sessionKeyIsAuthenticated;

  /**
   * 
   */
  xmlChar *sessionKeyTokenKey;

  /**
   * 
   */
  int *sessionValidationInterval;

  /**
   * 
   */
  xmlChar *sessionKeyLastValidation;

  /**
   * 
   */
  int useGroups;

  /**
   * 
   */
  xmlChar *httpProxyHost;

  /**
   * 
   */
  int *httpProxyPort;

  /**
   * 
   */
  xmlChar *httpProxyUsername;

  /**
   * 
   */
  xmlChar *httpProxyPassword;

  /**
   * 
   */
  int *httpMaxConnections;

  /**
   * 
   */
  int *httpTimeout;

  /**
   * 
   */
  xmlChar *cookieTokenKey;
};

/**
 * Reads a CrowdConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_crowd_plugin_ns0_crowdConfiguration *xmlTextReaderReadNs0CrowdConfigurationType(xmlTextReaderPtr reader);

/**
 * Writes a CrowdConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationDTO The CrowdConfigurationDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationType(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfiguration *_crowdConfigurationDTO);

/**
 * Frees the elements of a CrowdConfigurationDTO.
 *
 * @param _crowdConfigurationDTO The CrowdConfigurationDTO to free.
 */
static void freeNs0CrowdConfigurationType(struct enterprise_crowd_plugin_ns0_crowdConfiguration *_crowdConfigurationDTO);

#endif /* DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_H */
#ifndef DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_H
#define DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_H

/**
 *  A rest request/response resource wrapper, that contains a data parameter, which is the crowd configuration.

 */
struct enterprise_crowd_plugin_ns0_crowdConfigurationResource {


  /**
   * 
   */
  struct enterprise_crowd_plugin_ns0_crowdConfiguration *data;
};

/**
 * Reads a CrowdConfigurationResource element from XML. The element to be read is "crowdConfigurationWrapper", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationResource, or NULL in case of error.
 */
struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xml_read_enterprise_crowd_plugin_ns0_crowdConfigurationResource(xmlTextReaderPtr reader);

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_crowd_plugin_ns0_crowdConfigurationResource(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

/**
 * Frees a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource to free.
 */
void free_enterprise_crowd_plugin_ns0_crowdConfigurationResource(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

/**
 * Reads a CrowdConfigurationResource element from XML. The element to be read is "crowdConfigurationWrapper", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationResource, or NULL in case of error.
 */
struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xmlTextReaderReadNs0CrowdConfigurationWrapperElement(xmlTextReaderPtr reader);

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationWrapperElement(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationWrapperElementNS(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource, int writeNamespaces);

/**
 * Frees the children of a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource whose children are to be free.
 */
static void freeNs0CrowdConfigurationWrapperElement(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

/**
 * Reads a CrowdConfigurationResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationResource, or NULL in case of error.
 */
static struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xmlTextReaderReadNs0CrowdConfigurationResourceType(xmlTextReaderPtr reader);

/**
 * Writes a CrowdConfigurationResource to XML.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationResourceType(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

/**
 * Frees the elements of a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource to free.
 */
static void freeNs0CrowdConfigurationResourceType(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource);

#endif /* DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_H */
#ifndef DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_M
#define DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_M

/**
 * Reads a CrowdConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the CrowdConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_crowd_plugin_ns0_crowdConfiguration *xmlTextReaderReadNs0CrowdConfigurationType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_crowd_plugin_ns0_crowdConfiguration *_crowdConfigurationDTO = calloc(1, sizeof(struct enterprise_crowd_plugin_ns0_crowdConfiguration));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
        free(_crowdConfigurationDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "applicationName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}applicationName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}applicationName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->applicationName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "applicationPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}applicationPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}applicationPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->applicationPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "crowdServerUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}crowdServerUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}crowdServerUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->crowdServerUrl = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sessionKeyIsAuthenticated", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sessionKeyIsAuthenticated of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sessionKeyIsAuthenticated of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->sessionKeyIsAuthenticated = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sessionKeyTokenKey", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sessionKeyTokenKey of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sessionKeyTokenKey of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->sessionKeyTokenKey = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sessionValidationInterval", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sessionValidationInterval of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sessionValidationInterval of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->sessionValidationInterval = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sessionKeyLastValidation", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sessionKeyLastValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sessionKeyLastValidation of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->sessionKeyLastValidation = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "useGroups", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}useGroups of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}useGroups of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->useGroups = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpProxyHost", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpProxyHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpProxyHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpProxyHost = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpProxyPort", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpProxyPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpProxyPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpProxyPort = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpProxyUsername", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpProxyUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpProxyUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpProxyUsername = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpProxyPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpProxyPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpProxyPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpProxyPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpMaxConnections", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpMaxConnections of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpMaxConnections of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpMaxConnections = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "httpTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}httpTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}httpTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->httpTimeout = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "cookieTokenKey", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}cookieTokenKey of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}cookieTokenKey of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationType(_crowdConfigurationDTO);
          free(_crowdConfigurationDTO);
          return NULL;
        }

        _crowdConfigurationDTO->cookieTokenKey = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}crowdConfiguration.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}crowdConfiguration. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _crowdConfigurationDTO;
}

/**
 * Writes a CrowdConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationDTO The CrowdConfigurationDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CrowdConfigurationType(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfiguration *_crowdConfigurationDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_crowdConfigurationDTO->applicationName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "applicationName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}applicationName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}applicationName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->applicationName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}applicationName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}applicationName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->applicationPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "applicationPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}applicationPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}applicationPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->applicationPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}applicationPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}applicationPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->crowdServerUrl != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "crowdServerUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}crowdServerUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}crowdServerUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->crowdServerUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}crowdServerUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}crowdServerUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->sessionKeyIsAuthenticated != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sessionKeyIsAuthenticated", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sessionKeyIsAuthenticated. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyIsAuthenticated...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->sessionKeyIsAuthenticated));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyIsAuthenticated. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sessionKeyIsAuthenticated. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->sessionKeyTokenKey != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sessionKeyTokenKey", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sessionKeyTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyTokenKey...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->sessionKeyTokenKey));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sessionKeyTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->sessionValidationInterval != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sessionValidationInterval", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sessionValidationInterval. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}sessionValidationInterval...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, (_crowdConfigurationDTO->sessionValidationInterval));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}sessionValidationInterval. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sessionValidationInterval. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->sessionKeyLastValidation != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sessionKeyLastValidation", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sessionKeyLastValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyLastValidation...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->sessionKeyLastValidation));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}sessionKeyLastValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sessionKeyLastValidation. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "useGroups", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}useGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}useGroups...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_crowdConfigurationDTO->useGroups));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}useGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}useGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpProxyHost != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpProxyHost", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpProxyHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyHost...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->httpProxyHost));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpProxyHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpProxyPort != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpProxyPort", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpProxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}httpProxyPort...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, (_crowdConfigurationDTO->httpProxyPort));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}httpProxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpProxyPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpProxyUsername != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpProxyUsername", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpProxyUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyUsername...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->httpProxyUsername));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpProxyUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpProxyPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpProxyPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpProxyPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->httpProxyPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}httpProxyPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpProxyPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpMaxConnections != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpMaxConnections", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpMaxConnections. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}httpMaxConnections...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, (_crowdConfigurationDTO->httpMaxConnections));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}httpMaxConnections. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpMaxConnections. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->httpTimeout != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "httpTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}httpTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}httpTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, (_crowdConfigurationDTO->httpTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}httpTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}httpTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_crowdConfigurationDTO->cookieTokenKey != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "cookieTokenKey", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}cookieTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}cookieTokenKey...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_crowdConfigurationDTO->cookieTokenKey));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}cookieTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}cookieTokenKey. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CrowdConfigurationDTO.
 *
 * @param _crowdConfigurationDTO The CrowdConfigurationDTO to free.
 */
static void freeNs0CrowdConfigurationType(struct enterprise_crowd_plugin_ns0_crowdConfiguration *_crowdConfigurationDTO) {
  int i;
  if (_crowdConfigurationDTO->applicationName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor applicationName of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->applicationName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor applicationName of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->applicationName);
  }
  if (_crowdConfigurationDTO->applicationPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor applicationPassword of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->applicationPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor applicationPassword of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->applicationPassword);
  }
  if (_crowdConfigurationDTO->crowdServerUrl != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor crowdServerUrl of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->crowdServerUrl);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor crowdServerUrl of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->crowdServerUrl);
  }
  if (_crowdConfigurationDTO->sessionKeyIsAuthenticated != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor sessionKeyIsAuthenticated of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->sessionKeyIsAuthenticated);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor sessionKeyIsAuthenticated of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->sessionKeyIsAuthenticated);
  }
  if (_crowdConfigurationDTO->sessionKeyTokenKey != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor sessionKeyTokenKey of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->sessionKeyTokenKey);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor sessionKeyTokenKey of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->sessionKeyTokenKey);
  }
  if (_crowdConfigurationDTO->sessionValidationInterval != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor sessionValidationInterval of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsIntType(_crowdConfigurationDTO->sessionValidationInterval);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor sessionValidationInterval of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->sessionValidationInterval);
  }
  if (_crowdConfigurationDTO->sessionKeyLastValidation != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor sessionKeyLastValidation of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->sessionKeyLastValidation);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor sessionKeyLastValidation of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->sessionKeyLastValidation);
  }
  if (_crowdConfigurationDTO->httpProxyHost != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpProxyHost of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->httpProxyHost);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpProxyHost of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpProxyHost);
  }
  if (_crowdConfigurationDTO->httpProxyPort != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpProxyPort of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsIntType(_crowdConfigurationDTO->httpProxyPort);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpProxyPort of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpProxyPort);
  }
  if (_crowdConfigurationDTO->httpProxyUsername != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpProxyUsername of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->httpProxyUsername);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpProxyUsername of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpProxyUsername);
  }
  if (_crowdConfigurationDTO->httpProxyPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpProxyPassword of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->httpProxyPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpProxyPassword of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpProxyPassword);
  }
  if (_crowdConfigurationDTO->httpMaxConnections != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpMaxConnections of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsIntType(_crowdConfigurationDTO->httpMaxConnections);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpMaxConnections of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpMaxConnections);
  }
  if (_crowdConfigurationDTO->httpTimeout != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor httpTimeout of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsIntType(_crowdConfigurationDTO->httpTimeout);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor httpTimeout of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->httpTimeout);
  }
  if (_crowdConfigurationDTO->cookieTokenKey != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor cookieTokenKey of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    freeXsStringType(_crowdConfigurationDTO->cookieTokenKey);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor cookieTokenKey of type enterprise_crowd_plugin_ns0_crowdConfiguration...\n");
#endif
    free(_crowdConfigurationDTO->cookieTokenKey);
  }
}
#endif /* DEF_enterprise_crowd_plugin_ns0_crowdConfiguration_M */
#ifndef DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_M
#define DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_M

/**
 * Reads a CrowdConfigurationResource element from XML. The element to be read is "crowdConfigurationWrapper", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationResource, or NULL in case of error.
 */
struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xml_read_enterprise_crowd_plugin_ns0_crowdConfigurationResource(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0CrowdConfigurationWrapperElement(reader);
}

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_crowd_plugin_ns0_crowdConfigurationResource(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  return xmlTextWriterWriteNs0CrowdConfigurationWrapperElementNS(writer, _crowdConfigurationResource, 1);
}

/**
 * Frees a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource to free.
 */
void free_enterprise_crowd_plugin_ns0_crowdConfigurationResource(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  freeNs0CrowdConfigurationResourceType(_crowdConfigurationResource);
  free(_crowdConfigurationResource);
}

/**
 * Reads a CrowdConfigurationResource element from XML. The element to be read is "crowdConfigurationWrapper", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CrowdConfigurationResource, or NULL in case of error.
 */
struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xmlTextReaderReadNs0CrowdConfigurationWrapperElement(xmlTextReaderPtr reader) {
  struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "crowdConfigurationWrapper", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}crowdConfigurationWrapper.\n");
#endif
    _crowdConfigurationResource = xmlTextReaderReadNs0CrowdConfigurationResourceType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_crowdConfigurationResource == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}crowdConfigurationWrapper failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}crowdConfigurationWrapper failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _crowdConfigurationResource;
}

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationWrapperElement(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  return xmlTextWriterWriteNs0CrowdConfigurationWrapperElementNS(writer, _crowdConfigurationResource, 0);
}

/**
 * Writes a CrowdConfigurationResource to XML under element name "crowdConfigurationWrapper".
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CrowdConfigurationWrapperElementNS(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "crowdConfigurationWrapper", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}crowdConfigurationWrapper. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}crowdConfigurationResource for root element {}crowdConfigurationWrapper...\n");
#endif
  status = xmlTextWriterWriteNs0CrowdConfigurationResourceType(writer, _crowdConfigurationResource);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}crowdConfigurationWrapper. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}crowdConfigurationWrapper. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource whose children are to be free.
 */
static void freeNs0CrowdConfigurationWrapperElement(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  freeNs0CrowdConfigurationResourceType(_crowdConfigurationResource);
}

/**
 * Reads a CrowdConfigurationResource from XML. The reader is assumed to be at the start element.
 *
 * @return the CrowdConfigurationResource, or NULL in case of error.
 */
static struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *xmlTextReaderReadNs0CrowdConfigurationResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource = calloc(1, sizeof(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CrowdConfigurationResourceType(_crowdConfigurationResource);
        free(_crowdConfigurationResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}crowdConfiguration.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CrowdConfigurationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}crowdConfiguration.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CrowdConfigurationResourceType(_crowdConfigurationResource);
          free(_crowdConfigurationResource);
          return NULL;
        }

        _crowdConfigurationResource->data = ((struct enterprise_crowd_plugin_ns0_crowdConfiguration*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}crowdConfigurationResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}crowdConfigurationResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _crowdConfigurationResource;
}

/**
 * Writes a CrowdConfigurationResource to XML.
 *
 * @param writer The XML writer.
 * @param _crowdConfigurationResource The CrowdConfigurationResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CrowdConfigurationResourceType(xmlTextWriterPtr writer, struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_crowdConfigurationResource->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}crowdConfiguration for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0CrowdConfigurationType(writer, (_crowdConfigurationResource->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}crowdConfiguration for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CrowdConfigurationResource.
 *
 * @param _crowdConfigurationResource The CrowdConfigurationResource to free.
 */
static void freeNs0CrowdConfigurationResourceType(struct enterprise_crowd_plugin_ns0_crowdConfigurationResource *_crowdConfigurationResource) {
  int i;
  if (_crowdConfigurationResource->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type enterprise_crowd_plugin_ns0_crowdConfigurationResource...\n");
#endif
    freeNs0CrowdConfigurationType(_crowdConfigurationResource->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_crowd_plugin_ns0_crowdConfigurationResource...\n");
#endif
    free(_crowdConfigurationResource->data);
  }
}
#endif /* DEF_enterprise_crowd_plugin_ns0_crowdConfigurationResource_M */
