//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource;
@class ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO;

#ifndef DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource_H
#define DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource_H

/**
 *  A rest request/response resource wrapper, that contains a data parameter, which is the crowd configuration.

 */
@interface ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource : NSObject <EnunciateXML>
{
  @private
    ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO *_data;
}

/**
 * 
 */
- (ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO *) data;

/**
 * 
 */
- (void) setData: (ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO *) newData;
@end /* interface ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource */

#endif /* DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationResource_H */
#ifndef DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO_H
#define DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO_H

/**
 *  Crowd configuration parameters.

 */
@interface ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO : NSObject
{
  @private
    NSString *_applicationName;
    NSString *_applicationPassword;
    NSString *_crowdServerUrl;
    NSString *_sessionKeyIsAuthenticated;
    NSString *_sessionKeyTokenKey;
    int *_sessionValidationInterval;
    NSString *_sessionKeyLastValidation;
    BOOL _useGroups;
    NSString *_httpProxyHost;
    int *_httpProxyPort;
    NSString *_httpProxyUsername;
    NSString *_httpProxyPassword;
    int *_httpMaxConnections;
    int *_httpTimeout;
    NSString *_cookieTokenKey;
}

/**
 * 
 */
- (NSString *) applicationName;

/**
 * 
 */
- (void) setApplicationName: (NSString *) newApplicationName;

/**
 * 
 */
- (NSString *) applicationPassword;

/**
 * 
 */
- (void) setApplicationPassword: (NSString *) newApplicationPassword;

/**
 * 
 */
- (NSString *) crowdServerUrl;

/**
 * 
 */
- (void) setCrowdServerUrl: (NSString *) newCrowdServerUrl;

/**
 * 
 */
- (NSString *) sessionKeyIsAuthenticated;

/**
 * 
 */
- (void) setSessionKeyIsAuthenticated: (NSString *) newSessionKeyIsAuthenticated;

/**
 * 
 */
- (NSString *) sessionKeyTokenKey;

/**
 * 
 */
- (void) setSessionKeyTokenKey: (NSString *) newSessionKeyTokenKey;

/**
 * 
 */
- (int *) sessionValidationInterval;

/**
 * 
 */
- (void) setSessionValidationInterval: (int *) newSessionValidationInterval;

/**
 * 
 */
- (NSString *) sessionKeyLastValidation;

/**
 * 
 */
- (void) setSessionKeyLastValidation: (NSString *) newSessionKeyLastValidation;

/**
 * 
 */
- (BOOL) useGroups;

/**
 * 
 */
- (void) setUseGroups: (BOOL) newUseGroups;

/**
 * 
 */
- (NSString *) httpProxyHost;

/**
 * 
 */
- (void) setHttpProxyHost: (NSString *) newHttpProxyHost;

/**
 * 
 */
- (int *) httpProxyPort;

/**
 * 
 */
- (void) setHttpProxyPort: (int *) newHttpProxyPort;

/**
 * 
 */
- (NSString *) httpProxyUsername;

/**
 * 
 */
- (void) setHttpProxyUsername: (NSString *) newHttpProxyUsername;

/**
 * 
 */
- (NSString *) httpProxyPassword;

/**
 * 
 */
- (void) setHttpProxyPassword: (NSString *) newHttpProxyPassword;

/**
 * 
 */
- (int *) httpMaxConnections;

/**
 * 
 */
- (void) setHttpMaxConnections: (int *) newHttpMaxConnections;

/**
 * 
 */
- (int *) httpTimeout;

/**
 * 
 */
- (void) setHttpTimeout: (int *) newHttpTimeout;

/**
 * 
 */
- (NSString *) cookieTokenKey;

/**
 * 
 */
- (void) setCookieTokenKey: (NSString *) newCookieTokenKey;
@end /* interface ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO */

#endif /* DEF_ENTERPRISE_CROWD_PLUGINNS0CrowdConfigurationDTO_H */
