//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest;
@class ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse;
@class ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse;
@class ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO;
@class ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest;

#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO_H

/**
 *  LDAP schema template object, contains defaults for a schema

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO : NSObject
{
  @private
    NSString *_name;
    ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *_userAndGroupConfig;
}

/**
 * 
 */
- (NSString *) name;

/**
 * 
 */
- (void) setName: (NSString *) newName;

/**
 * 
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *) userAndGroupConfig;

/**
 * 
 */
- (void) setUserAndGroupConfig: (ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *) newUserAndGroupConfig;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO_H

/**
 *  Object that holds the configuration of each configured LDAP
 server.
 
 @version $Revision$ $Date$

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO : NSObject
{
  @private
    ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *_connectionInfo;
    NSString *_id;
    NSString *_url;
    NSString *_name;
    ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *_userAndGroupConfig;
}

/**
 * CConnectionInfo
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *) connectionInfo;

/**
 * CConnectionInfo
 */
- (void) setConnectionInfo: (ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *) newConnectionInfo;

/**
 * String
 */
- (NSString *) id;

/**
 * String
 */
- (void) setId: (NSString *) newId;

/**
 * String
 */
- (NSString *) url;

/**
 * String
 */
- (void) setUrl: (NSString *) newUrl;

/**
 * String
 */
- (NSString *) name;

/**
 * String
 */
- (void) setName: (NSString *) newName;

/**
 * CUserAndGroupAuthConfiguration
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *) userAndGroupConfig;

/**
 * CUserAndGroupAuthConfiguration
 */
- (void) setUserAndGroupConfig: (ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO *) newUserAndGroupConfig;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse_H

/**
 *  Response wrapper object that contains the list of ldap servers.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * 
 */
- (NSArray *) data;

/**
 * 
 */
- (void) setData: (NSArray *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListResponse_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest_H

/**
 *  Request wrapper object that contains the ldap login test details.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest : NSObject <EnunciateXML>
{
  @private
    ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO *_data;
}

/**
 * 
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO *) data;

/**
 * 
 */
- (void) setData: (ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestRequest_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest_H

/**
 *  Request wrapper for setting up an ldap server configuration.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest : NSObject <EnunciateXML>
{
  @private
    ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *_data;
}

/**
 * 
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *) data;

/**
 * 
 */
- (void) setData: (ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerRequest_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO_H

/**
 *  Ldap User details.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO : NSObject
{
  @private
    NSString *_userId;
    NSArray *_roles;
    NSString *_name;
    NSString *_email;
}

/**
 * the userId
 */
- (NSString *) userId;

/**
 * the userId
 */
- (void) setUserId: (NSString *) newUserId;

/**
 * the roles
 */
- (NSArray *) roles;

/**
 * the roles
 */
- (void) setRoles: (NSArray *) newRoles;

/**
 * the name
 */
- (NSString *) name;

/**
 * the name
 */
- (void) setName: (NSString *) newName;

/**
 * the email
 */
- (NSString *) email;

/**
 * the email
 */
- (void) setEmail: (NSString *) newEmail;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse_H

/**
 *  Response wrapper that contains the list of ldap users.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * 
 */
- (NSArray *) data;

/**
 * 
 */
- (void) setData: (NSArray *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserListResponse_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO_H

/**
 *  The user and group mapping configuration mapping.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO : NSObject
{
  @private
    NSString *_emailAddressAttribute;
    NSString *_groupBaseDn;
    NSString *_groupIdAttribute;
    NSString *_groupMemberAttribute;
    NSString *_groupMemberFormat;
    NSString *_groupObjectClass;
    NSString *_userBaseDn;
    NSString *_userIdAttribute;
    NSString *_userMemberOfAttribute;
    NSString *_userObjectClass;
    NSString *_userPasswordAttribute;
    NSString *_userRealNameAttribute;
    BOOL _groupSubtree;
    BOOL _ldapGroupsAsRoles;
    BOOL _userSubtree;
    NSString *_ldapFilter;
}

/**
 * Get email Address Attribute.  The attribute that stores the
users email address.
 */
- (NSString *) emailAddressAttribute;

/**
 * Get email Address Attribute.  The attribute that stores the
users email address.
 */
- (void) setEmailAddressAttribute: (NSString *) newEmailAddressAttribute;

/**
 * Get group Base DN.  The base DN that defines Groups.
 */
- (NSString *) groupBaseDn;

/**
 * Get group Base DN.  The base DN that defines Groups.
 */
- (void) setGroupBaseDn: (NSString *) newGroupBaseDn;

/**
 * Get group Id Attribute. The ID attribute for the Group.
 */
- (NSString *) groupIdAttribute;

/**
 * Get group Id Attribute. The ID attribute for the Group.
 */
- (void) setGroupIdAttribute: (NSString *) newGroupIdAttribute;

/**
 * Get group Member Attribute,  An attribute that defines the a
user is a member of the group.
 */
- (NSString *) groupMemberAttribute;

/**
 * Get group Member Attribute,  An attribute that defines the a
user is a member of the group.
 */
- (void) setGroupMemberAttribute: (NSString *) newGroupMemberAttribute;

/**
 * Get group Member Format. The format that the user info is
stored in the groupMappingsAttribute.  Such as ${username},
or uid=${username},ou=people,o=yourBiz.  ${username} will be
replaced with the username.
 */
- (NSString *) groupMemberFormat;

/**
 * Get group Member Format. The format that the user info is
stored in the groupMappingsAttribute.  Such as ${username},
or uid=${username},ou=people,o=yourBiz.  ${username} will be
replaced with the username.
 */
- (void) setGroupMemberFormat: (NSString *) newGroupMemberFormat;

/**
 * Get group Object Class. The Object class used for groups.
 */
- (NSString *) groupObjectClass;

/**
 * Get group Object Class. The Object class used for groups.
 */
- (void) setGroupObjectClass: (NSString *) newGroupObjectClass;

/**
 * Get user Base DN. The base DN for the users.
 */
- (NSString *) userBaseDn;

/**
 * Get user Base DN. The base DN for the users.
 */
- (void) setUserBaseDn: (NSString *) newUserBaseDn;

/**
 * Get user Id Attribute.  THe attribute of the userId field.
 */
- (NSString *) userIdAttribute;

/**
 * Get user Id Attribute.  THe attribute of the userId field.
 */
- (void) setUserIdAttribute: (NSString *) newUserIdAttribute;

/**
 * Get groups are generally one of two types in LDAP systems -
static or dynamic. A static group maintains its own
membership list. A dynamic group records its membership on a
user entry. If dynamic groups this should be set to the
attribute used to store the group string in the user object.
 */
- (NSString *) userMemberOfAttribute;

/**
 * Get groups are generally one of two types in LDAP systems -
static or dynamic. A static group maintains its own
membership list. A dynamic group records its membership on a
user entry. If dynamic groups this should be set to the
attribute used to store the group string in the user object.
 */
- (void) setUserMemberOfAttribute: (NSString *) newUserMemberOfAttribute;

/**
 * Get user Object Class.  The object class used for users.
 */
- (NSString *) userObjectClass;

/**
 * Get user Object Class.  The object class used for users.
 */
- (void) setUserObjectClass: (NSString *) newUserObjectClass;

/**
 * Get user Password Attribute.  The attribute that stores the
users password.
 */
- (NSString *) userPasswordAttribute;

/**
 * Get user Password Attribute.  The attribute that stores the
users password.
 */
- (void) setUserPasswordAttribute: (NSString *) newUserPasswordAttribute;

/**
 * Get user Real Name Attribute.  The attribute that defines
the users real name.
 */
- (NSString *) userRealNameAttribute;

/**
 * Get user Real Name Attribute.  The attribute that defines
the users real name.
 */
- (void) setUserRealNameAttribute: (NSString *) newUserRealNameAttribute;

/**
 * Get groups are Stored in a subtree of the groupBaseDn.
 */
- (BOOL) groupSubtree;

/**
 * Get groups are Stored in a subtree of the groupBaseDn.
 */
- (void) setGroupSubtree: (BOOL) newGroupSubtree;

/**
 * Get use LDAP groups as roles.  True if LDAP groups should be
used as roles.
 */
- (BOOL) ldapGroupsAsRoles;

/**
 * Get use LDAP groups as roles.  True if LDAP groups should be
used as roles.
 */
- (void) setLdapGroupsAsRoles: (BOOL) newLdapGroupsAsRoles;

/**
 * Get users are Stored in a subtree of the userBaseDn.
 */
- (BOOL) userSubtree;

/**
 * Get users are Stored in a subtree of the userBaseDn.
 */
- (void) setUserSubtree: (BOOL) newUserSubtree;

/**
 * Return the filter expression added to the user search.
<p/>
Example: (&(mail=*@domain.com)(uid=user_*)
 */
- (NSString *) ldapFilter;

/**
 * Return the filter expression added to the user search.
<p/>
Example: (&(mail=*@domain.com)(uid=user_*)
 */
- (void) setLdapFilter: (NSString *) newLdapFilter;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapUserAndGroupAuthConfigurationDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest_H

/**
 *  Request wrapper object that contains the ordered list of ldap server ids.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * 
 */
- (NSArray *) data;

/**
 * 
 */
- (void) setData: (NSArray *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerOrderRequest_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO_H

/**
 *  Ldap Server login test parameters.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO : NSObject
{
  @private
    ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *_configuration;
    NSString *_username;
    NSString *_password;
}

/**
 * 
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *) configuration;

/**
 * 
 */
- (void) setConfiguration: (ENTERPRISE_LDAP_PLUGINNS0LdapServerConfigurationDTO *) newConfiguration;

/**
 * 
 */
- (NSString *) username;

/**
 * 
 */
- (void) setUsername: (NSString *) newUsername;

/**
 * 
 */
- (NSString *) password;

/**
 * 
 */
- (void) setPassword: (NSString *) newPassword;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerLoginTestDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO_H

/**
 *  List entry of an ldap server.

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO : NSObject
{
  @private
    NSString *_id;
    NSString *_name;
    NSString *_url;
    NSString *_ldapUrl;
}

/**
 * 
 */
- (NSString *) id;

/**
 * 
 */
- (void) setId: (NSString *) newId;

/**
 * 
 */
- (NSString *) name;

/**
 * 
 */
- (void) setName: (NSString *) newName;

/**
 * 
 */
- (NSString *) url;

/**
 * 
 */
- (void) setUrl: (NSString *) newUrl;

/**
 * 
 */
- (NSString *) ldapUrl;

/**
 * 
 */
- (void) setLdapUrl: (NSString *) newLdapUrl;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapServerListEntryDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse_H

/**
 *  Response wrapper object that contains the list of ldap schema templates

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * 
 */
- (NSArray *) data;

/**
 * 
 */
- (void) setData: (NSArray *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapSchemaTemplateListResponse_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO_H

/**
 *  LDAP Connection Information.
 
 @version $Revision$ $Date$

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO : NSObject
{
  @private
    NSString *_authScheme;
    NSString *_backupMirrorHost;
    int _backupMirrorPort;
    NSString *_backupMirrorProtocol;
    int _cacheTimeout;
    int _connectionRetryDelay;
    int _connectionTimeout;
    NSString *_host;
    int _port;
    NSString *_protocol;
    NSString *_realm;
    NSString *_searchBase;
    NSString *_systemPassword;
    NSString *_systemUsername;
}

/**
 * String
 */
- (NSString *) authScheme;

/**
 * String
 */
- (void) setAuthScheme: (NSString *) newAuthScheme;

/**
 * String
 */
- (NSString *) backupMirrorHost;

/**
 * String
 */
- (void) setBackupMirrorHost: (NSString *) newBackupMirrorHost;

/**
 * int
 */
- (int) backupMirrorPort;

/**
 * int
 */
- (void) setBackupMirrorPort: (int) newBackupMirrorPort;

/**
 * String
 */
- (NSString *) backupMirrorProtocol;

/**
 * String
 */
- (void) setBackupMirrorProtocol: (NSString *) newBackupMirrorProtocol;

/**
 * int
 */
- (int) cacheTimeout;

/**
 * int
 */
- (void) setCacheTimeout: (int) newCacheTimeout;

/**
 * int
 */
- (int) connectionRetryDelay;

/**
 * int
 */
- (void) setConnectionRetryDelay: (int) newConnectionRetryDelay;

/**
 * int
 */
- (int) connectionTimeout;

/**
 * int
 */
- (void) setConnectionTimeout: (int) newConnectionTimeout;

/**
 * String
 */
- (NSString *) host;

/**
 * String
 */
- (void) setHost: (NSString *) newHost;

/**
 * int
 */
- (int) port;

/**
 * int
 */
- (void) setPort: (int) newPort;

/**
 * String
 */
- (NSString *) protocol;

/**
 * String
 */
- (void) setProtocol: (NSString *) newProtocol;

/**
 * String
 */
- (NSString *) realm;

/**
 * String
 */
- (void) setRealm: (NSString *) newRealm;

/**
 * String
 */
- (NSString *) searchBase;

/**
 * String
 */
- (void) setSearchBase: (NSString *) newSearchBase;

/**
 * String
 */
- (NSString *) systemPassword;

/**
 * String
 */
- (void) setSystemPassword: (NSString *) newSystemPassword;

/**
 * String
 */
- (NSString *) systemUsername;

/**
 * String
 */
- (void) setSystemUsername: (NSString *) newSystemUsername;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO_H */
#ifndef DEF_ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest_H
#define DEF_ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest_H

/**
 *  Request wrapper object that contains the connection info

 */
@interface ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest : NSObject <EnunciateXML>
{
  @private
    ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *_data;
}

/**
 * 
 */
- (ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *) data;

/**
 * 
 */
- (void) setData: (ENTERPRISE_LDAP_PLUGINNS0LdapConnectionInfoDTO *) newData;
@end /* interface ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest */

#endif /* DEF_ENTERPRISE_LDAP_PLUGINNS0LdapAuthenticationTestRequest_H */
