//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse;
@class NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO;
@class NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO;

#ifndef DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse_H
#define DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse_H

/**
 *  The List response which contains the standard 'data' element, which is simply a list
 of archive types that we support to browser

 */
@interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * List<String>
 */
- (NSArray *) data;

/**
 * List<String>
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse */

#endif /* DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveTypeListResponse_H */
#ifndef DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO_H
#define DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO_H

/**
 *  The archive browser tree view resposne which contains the standard 'data' element, which is the tree node
 details.

 */
@interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO : NSObject <EnunciateXML>
{
  @private
    NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO *_data;
}

/**
 * 
 */
- (NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO *) data;

/**
 * 
 */
- (void) setData: (NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO *) newData;
@end /* interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO */

#endif /* DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeViewResponseDTO_H */
#ifndef DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO_H
#define DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO_H

/**
 *  A tree node item that gives all information necessary to browse into an archive.
 Including child nodes of the node (note that child nodes only go 1 level deep).

 */
@interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO : NSObject <EnunciateXML>
{
  @private
    BOOL _leaf;
    NSString *_nodeName;
    NSString *_path;
    NSArray *_children;
}

/**
 * 
 */
- (BOOL) leaf;

/**
 * 
 */
- (void) setLeaf: (BOOL) newLeaf;

/**
 * 
 */
- (NSString *) nodeName;

/**
 * 
 */
- (void) setNodeName: (NSString *) newNodeName;

/**
 * 
 */
- (NSString *) path;

/**
 * 
 */
- (void) setPath: (NSString *) newPath;

/**
 * 
 */
- (NSArray *) children;

/**
 * 
 */
- (void) setChildren: (NSArray *) newChildren;
@end /* interface NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO */

#endif /* DEF_NEXUS_ARCHIVE_BROWSER_PLUGINNS0ArchiveBrowserTreeNodeDTO_H */
