//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_licensing_plugin_ns0_accessContent_H
#define DEF_nexus_licensing_plugin_ns0_accessContent_H

/**
 *  The parameters set by the currently installed license

 */
struct nexus_licensing_plugin_ns0_accessContent {


  /**
   * (no documentation provided)
   */
  xmlChar *date;

  /**
   * (no documentation provided)
   */
  xmlChar *ipAddress;

  /**
   * (no documentation provided)
   */
  long timestamp;
};

/**
 * Reads a AccessContentDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The AccessContentDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_accessContent *xmlTextReaderReadNs0AccessContentType(xmlTextReaderPtr reader);

/**
 * Writes a AccessContentDTO to XML.
 *
 * @param writer The XML writer.
 * @param _accessContentDTO The AccessContentDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0AccessContentType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContent *_accessContentDTO);

/**
 * Frees the elements of a AccessContentDTO.
 *
 * @param _accessContentDTO The AccessContentDTO to free.
 */
static void freeNs0AccessContentType(struct nexus_licensing_plugin_ns0_accessContent *_accessContentDTO);

#endif /* DEF_nexus_licensing_plugin_ns0_accessContent_H */
#ifndef DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_H
#define DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_H

/**
 *  Response wrapper for the license content response.

 */
struct nexus_licensing_plugin_ns0_accessContentResponseDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_licensing_plugin_ns0_accessContent *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a AccessContentResponseDTO element from XML. The element to be read is "accessContentResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The AccessContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xml_read_nexus_licensing_plugin_ns0_accessContentResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_licensing_plugin_ns0_accessContentResponseDTO(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

/**
 * Frees a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO to free.
 */
void free_nexus_licensing_plugin_ns0_accessContentResponseDTO(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

/**
 * Reads a AccessContentResponseDTO element from XML. The element to be read is "accessContentResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The AccessContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xmlTextReaderReadNs0AccessContentResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0AccessContentResponseElement(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0AccessContentResponseElementNS(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO, int writeNamespaces);

/**
 * Frees the children of a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO whose children are to be free.
 */
static void freeNs0AccessContentResponseElement(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

/**
 * Reads a AccessContentResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The AccessContentResponseDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xmlTextReaderReadNs0AccessContentResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a AccessContentResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0AccessContentResponseDTOType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

/**
 * Frees the elements of a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO to free.
 */
static void freeNs0AccessContentResponseDTOType(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO);

#endif /* DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_H */
#ifndef DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_H
#define DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_H

/**
 *  Response wrapper for the license content response.

 */
struct nexus_licensing_plugin_ns0_licenseContentResponseDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_licensing_plugin_ns0_licenseContents *data;
};

/**
 * Reads a LicenseContentResponseDTO element from XML. The element to be read is "licenseContentResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LicenseContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xml_read_nexus_licensing_plugin_ns0_licenseContentResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_licensing_plugin_ns0_licenseContentResponseDTO(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

/**
 * Frees a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to free.
 */
void free_nexus_licensing_plugin_ns0_licenseContentResponseDTO(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

/**
 * Reads a LicenseContentResponseDTO element from XML. The element to be read is "licenseContentResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LicenseContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xmlTextReaderReadNs0LicenseContentResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LicenseContentResponseElement(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LicenseContentResponseElementNS(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO, int writeNamespaces);

/**
 * Frees the children of a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO whose children are to be free.
 */
static void freeNs0LicenseContentResponseElement(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

/**
 * Reads a LicenseContentResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LicenseContentResponseDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xmlTextReaderReadNs0LicenseContentResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a LicenseContentResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LicenseContentResponseDTOType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

/**
 * Frees the elements of a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to free.
 */
static void freeNs0LicenseContentResponseDTOType(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO);

#endif /* DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_H */
#ifndef DEF_nexus_licensing_plugin_ns0_licenseContents_H
#define DEF_nexus_licensing_plugin_ns0_licenseContents_H

/**
 *  The parameters set by the currently installed license

 */
struct nexus_licensing_plugin_ns0_licenseContents {


  /**
   * 
   */
  xmlChar *contactCountry;

  /**
   * 
   */
  xmlChar *contactEmail;

  /**
   * 
   */
  xmlChar *contactPhone;

  /**
   * 
   */
  xmlChar *contactCompany;

  /**
   * 
   */
  xmlChar *contactName;

  /**
   * 
   */
  xmlChar *effectiveDate;

  /**
   * 
   */
  xmlChar *expirationDate;

  /**
   * 
   */
  xmlChar *licenseType;

  /**
   * 
   */
  xmlChar *licensedUserCount;

  /**
   * 
   */
  xmlChar *maxLicensedUsers;

  /**
   * (no documentation provided)
   */
  xmlChar *licenseServiceUrl;

  /**
   * (no documentation provided)
   */
  xmlChar *fingerprint;
};

/**
 * Reads a LicenseContentsDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LicenseContentsDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_licenseContents *xmlTextReaderReadNs0LicenseContentsType(xmlTextReaderPtr reader);

/**
 * Writes a LicenseContentsDTO to XML.
 *
 * @param writer The XML writer.
 * @param _licenseContentsDTO The LicenseContentsDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LicenseContentsType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContents *_licenseContentsDTO);

/**
 * Frees the elements of a LicenseContentsDTO.
 *
 * @param _licenseContentsDTO The LicenseContentsDTO to free.
 */
static void freeNs0LicenseContentsType(struct nexus_licensing_plugin_ns0_licenseContents *_licenseContentsDTO);

#endif /* DEF_nexus_licensing_plugin_ns0_licenseContents_H */
#ifndef DEF_nexus_licensing_plugin_ns0_accessContent_M
#define DEF_nexus_licensing_plugin_ns0_accessContent_M

/**
 * Reads a AccessContentDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the AccessContentDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_accessContent *xmlTextReaderReadNs0AccessContentType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_licensing_plugin_ns0_accessContent *_accessContentDTO = calloc(1, sizeof(struct nexus_licensing_plugin_ns0_accessContent));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0AccessContentType(_accessContentDTO);
        free(_accessContentDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "date", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}date of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}date of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0AccessContentType(_accessContentDTO);
          free(_accessContentDTO);
          return NULL;
        }

        _accessContentDTO->date = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ipAddress", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ipAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ipAddress of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0AccessContentType(_accessContentDTO);
          free(_accessContentDTO);
          return NULL;
        }

        _accessContentDTO->ipAddress = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "timestamp", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}timestamp of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
        _child_accessor = xmlTextReaderReadXsLongType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}timestamp of type {http://www.w3.org/2001/XMLSchema}long.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0AccessContentType(_accessContentDTO);
          free(_accessContentDTO);
          return NULL;
        }

        _accessContentDTO->timestamp = *((long*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}accessContent.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}accessContent. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _accessContentDTO;
}

/**
 * Writes a AccessContentDTO to XML.
 *
 * @param writer The XML writer.
 * @param _accessContentDTO The AccessContentDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0AccessContentType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContent *_accessContentDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_accessContentDTO->date != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "date", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}date. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}date...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_accessContentDTO->date));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}date. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}date. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_accessContentDTO->ipAddress != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ipAddress", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ipAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ipAddress...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_accessContentDTO->ipAddress));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ipAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ipAddress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "timestamp", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}timestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}long for element {}timestamp...\n", status);
#endif
    status = xmlTextWriterWriteXsLongType(writer, &(_accessContentDTO->timestamp));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}long for element {}timestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}timestamp. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a AccessContentDTO.
 *
 * @param _accessContentDTO The AccessContentDTO to free.
 */
static void freeNs0AccessContentType(struct nexus_licensing_plugin_ns0_accessContent *_accessContentDTO) {
  int i;
  if (_accessContentDTO->date != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor date of type nexus_licensing_plugin_ns0_accessContent...\n");
#endif
    freeXsStringType(_accessContentDTO->date);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor date of type nexus_licensing_plugin_ns0_accessContent...\n");
#endif
    free(_accessContentDTO->date);
  }
  if (_accessContentDTO->ipAddress != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ipAddress of type nexus_licensing_plugin_ns0_accessContent...\n");
#endif
    freeXsStringType(_accessContentDTO->ipAddress);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ipAddress of type nexus_licensing_plugin_ns0_accessContent...\n");
#endif
    free(_accessContentDTO->ipAddress);
  }
}
#endif /* DEF_nexus_licensing_plugin_ns0_accessContent_M */
#ifndef DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_M
#define DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_M

/**
 * Reads a AccessContentResponseDTO element from XML. The element to be read is "accessContentResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The AccessContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xml_read_nexus_licensing_plugin_ns0_accessContentResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0AccessContentResponseElement(reader);
}

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_licensing_plugin_ns0_accessContentResponseDTO(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  return xmlTextWriterWriteNs0AccessContentResponseElementNS(writer, _accessContentResponseDTO, 1);
}

/**
 * Frees a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO to free.
 */
void free_nexus_licensing_plugin_ns0_accessContentResponseDTO(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  freeNs0AccessContentResponseDTOType(_accessContentResponseDTO);
  free(_accessContentResponseDTO);
}

/**
 * Reads a AccessContentResponseDTO element from XML. The element to be read is "accessContentResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The AccessContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xmlTextReaderReadNs0AccessContentResponseElement(xmlTextReaderPtr reader) {
  struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "accessContentResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}accessContentResponse.\n");
#endif
    _accessContentResponseDTO = xmlTextReaderReadNs0AccessContentResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_accessContentResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}accessContentResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}accessContentResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _accessContentResponseDTO;
}

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0AccessContentResponseElement(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  return xmlTextWriterWriteNs0AccessContentResponseElementNS(writer, _accessContentResponseDTO, 0);
}

/**
 * Writes a AccessContentResponseDTO to XML under element name "accessContentResponse".
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0AccessContentResponseElementNS(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "accessContentResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}accessContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}accessContentResponseDTO for root element {}accessContentResponse...\n");
#endif
  status = xmlTextWriterWriteNs0AccessContentResponseDTOType(writer, _accessContentResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}accessContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}accessContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO whose children are to be free.
 */
static void freeNs0AccessContentResponseElement(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  freeNs0AccessContentResponseDTOType(_accessContentResponseDTO);
}

/**
 * Reads a AccessContentResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the AccessContentResponseDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_accessContentResponseDTO *xmlTextReaderReadNs0AccessContentResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO = calloc(1, sizeof(struct nexus_licensing_plugin_ns0_accessContentResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0AccessContentResponseDTOType(_accessContentResponseDTO);
        free(_accessContentResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}accessContent.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0AccessContentType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}accessContent.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0AccessContentResponseDTOType(_accessContentResponseDTO);
          free(_accessContentResponseDTO);
          return NULL;
        }

        _accessContentResponseDTO->data = realloc(_accessContentResponseDTO->data, (_accessContentResponseDTO->_sizeof_data + 1) * sizeof(struct nexus_licensing_plugin_ns0_accessContent));
        memcpy(&(_accessContentResponseDTO->data[_accessContentResponseDTO->_sizeof_data++]), _child_accessor, sizeof(struct nexus_licensing_plugin_ns0_accessContent));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}accessContentResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}accessContentResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _accessContentResponseDTO;
}

/**
 * Writes a AccessContentResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _accessContentResponseDTO The AccessContentResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0AccessContentResponseDTOType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _accessContentResponseDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}accessContent for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0AccessContentType(writer, &(_accessContentResponseDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}accessContent for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a AccessContentResponseDTO.
 *
 * @param _accessContentResponseDTO The AccessContentResponseDTO to free.
 */
static void freeNs0AccessContentResponseDTOType(struct nexus_licensing_plugin_ns0_accessContentResponseDTO *_accessContentResponseDTO) {
  int i;
  if (_accessContentResponseDTO->data != NULL) {
    for (i = 0; i < _accessContentResponseDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_licensing_plugin_ns0_accessContentResponseDTO...\n", i);
#endif
      freeNs0AccessContentType(&(_accessContentResponseDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_licensing_plugin_ns0_accessContentResponseDTO...\n");
#endif
    free(_accessContentResponseDTO->data);
  }
}
#endif /* DEF_nexus_licensing_plugin_ns0_accessContentResponseDTO_M */
#ifndef DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_M
#define DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_M

/**
 * Reads a LicenseContentResponseDTO element from XML. The element to be read is "licenseContentResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LicenseContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xml_read_nexus_licensing_plugin_ns0_licenseContentResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0LicenseContentResponseElement(reader);
}

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_licensing_plugin_ns0_licenseContentResponseDTO(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  return xmlTextWriterWriteNs0LicenseContentResponseElementNS(writer, _licenseContentResponseDTO, 1);
}

/**
 * Frees a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to free.
 */
void free_nexus_licensing_plugin_ns0_licenseContentResponseDTO(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  freeNs0LicenseContentResponseDTOType(_licenseContentResponseDTO);
  free(_licenseContentResponseDTO);
}

/**
 * Reads a LicenseContentResponseDTO element from XML. The element to be read is "licenseContentResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LicenseContentResponseDTO, or NULL in case of error.
 */
struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xmlTextReaderReadNs0LicenseContentResponseElement(xmlTextReaderPtr reader) {
  struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "licenseContentResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}licenseContentResponse.\n");
#endif
    _licenseContentResponseDTO = xmlTextReaderReadNs0LicenseContentResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_licenseContentResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}licenseContentResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}licenseContentResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _licenseContentResponseDTO;
}

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0LicenseContentResponseElement(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  return xmlTextWriterWriteNs0LicenseContentResponseElementNS(writer, _licenseContentResponseDTO, 0);
}

/**
 * Writes a LicenseContentResponseDTO to XML under element name "licenseContentResponse".
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0LicenseContentResponseElementNS(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "licenseContentResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}licenseContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}licenseContentResponseDTO for root element {}licenseContentResponse...\n");
#endif
  status = xmlTextWriterWriteNs0LicenseContentResponseDTOType(writer, _licenseContentResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}licenseContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}licenseContentResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO whose children are to be free.
 */
static void freeNs0LicenseContentResponseElement(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  freeNs0LicenseContentResponseDTOType(_licenseContentResponseDTO);
}

/**
 * Reads a LicenseContentResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LicenseContentResponseDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *xmlTextReaderReadNs0LicenseContentResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO = calloc(1, sizeof(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LicenseContentResponseDTOType(_licenseContentResponseDTO);
        free(_licenseContentResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}licenseContents.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LicenseContentsType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}licenseContents.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentResponseDTOType(_licenseContentResponseDTO);
          free(_licenseContentResponseDTO);
          return NULL;
        }

        _licenseContentResponseDTO->data = ((struct nexus_licensing_plugin_ns0_licenseContents*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}licenseContentResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}licenseContentResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _licenseContentResponseDTO;
}

/**
 * Writes a LicenseContentResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LicenseContentResponseDTOType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_licenseContentResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}licenseContents for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0LicenseContentsType(writer, (_licenseContentResponseDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}licenseContents for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LicenseContentResponseDTO.
 *
 * @param _licenseContentResponseDTO The LicenseContentResponseDTO to free.
 */
static void freeNs0LicenseContentResponseDTOType(struct nexus_licensing_plugin_ns0_licenseContentResponseDTO *_licenseContentResponseDTO) {
  int i;
  if (_licenseContentResponseDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_licensing_plugin_ns0_licenseContentResponseDTO...\n");
#endif
    freeNs0LicenseContentsType(_licenseContentResponseDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_licensing_plugin_ns0_licenseContentResponseDTO...\n");
#endif
    free(_licenseContentResponseDTO->data);
  }
}
#endif /* DEF_nexus_licensing_plugin_ns0_licenseContentResponseDTO_M */
#ifndef DEF_nexus_licensing_plugin_ns0_licenseContents_M
#define DEF_nexus_licensing_plugin_ns0_licenseContents_M

/**
 * Reads a LicenseContentsDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LicenseContentsDTO, or NULL in case of error.
 */
static struct nexus_licensing_plugin_ns0_licenseContents *xmlTextReaderReadNs0LicenseContentsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_licensing_plugin_ns0_licenseContents *_licenseContentsDTO = calloc(1, sizeof(struct nexus_licensing_plugin_ns0_licenseContents));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LicenseContentsType(_licenseContentsDTO);
        free(_licenseContentsDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contactCountry", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contactCountry of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contactCountry of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->contactCountry = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contactEmail", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contactEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contactEmail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->contactEmail = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contactPhone", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contactPhone of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contactPhone of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->contactPhone = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contactCompany", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contactCompany of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contactCompany of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->contactCompany = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "contactName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}contactName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}contactName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->contactName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "effectiveDate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}effectiveDate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}effectiveDate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->effectiveDate = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "expirationDate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}expirationDate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}expirationDate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->expirationDate = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "licenseType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}licenseType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}licenseType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->licenseType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "licensedUserCount", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}licensedUserCount of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}licensedUserCount of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->licensedUserCount = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "maxLicensedUsers", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}maxLicensedUsers of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}maxLicensedUsers of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->maxLicensedUsers = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "licenseServiceUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}licenseServiceUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}licenseServiceUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->licenseServiceUrl = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "fingerprint", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LicenseContentsType(_licenseContentsDTO);
          free(_licenseContentsDTO);
          return NULL;
        }

        _licenseContentsDTO->fingerprint = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}licenseContents.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}licenseContents. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _licenseContentsDTO;
}

/**
 * Writes a LicenseContentsDTO to XML.
 *
 * @param writer The XML writer.
 * @param _licenseContentsDTO The LicenseContentsDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LicenseContentsType(xmlTextWriterPtr writer, struct nexus_licensing_plugin_ns0_licenseContents *_licenseContentsDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_licenseContentsDTO->contactCountry != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contactCountry", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contactCountry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contactCountry...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->contactCountry));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contactCountry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contactCountry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->contactEmail != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contactEmail", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contactEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contactEmail...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->contactEmail));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contactEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contactEmail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->contactPhone != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contactPhone", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contactPhone. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contactPhone...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->contactPhone));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contactPhone. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contactPhone. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->contactCompany != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contactCompany", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contactCompany. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contactCompany...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->contactCompany));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contactCompany. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contactCompany. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->contactName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "contactName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}contactName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}contactName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->contactName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}contactName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}contactName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->effectiveDate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "effectiveDate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}effectiveDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}effectiveDate...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->effectiveDate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}effectiveDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}effectiveDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->expirationDate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "expirationDate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}expirationDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}expirationDate...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->expirationDate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}expirationDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}expirationDate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->licenseType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "licenseType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}licenseType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}licenseType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->licenseType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}licenseType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}licenseType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->licensedUserCount != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "licensedUserCount", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}licensedUserCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}licensedUserCount...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->licensedUserCount));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}licensedUserCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}licensedUserCount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->maxLicensedUsers != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "maxLicensedUsers", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}maxLicensedUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}maxLicensedUsers...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->maxLicensedUsers));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}maxLicensedUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}maxLicensedUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->licenseServiceUrl != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "licenseServiceUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}licenseServiceUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}licenseServiceUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->licenseServiceUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}licenseServiceUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}licenseServiceUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_licenseContentsDTO->fingerprint != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "fingerprint", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}fingerprint...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_licenseContentsDTO->fingerprint));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LicenseContentsDTO.
 *
 * @param _licenseContentsDTO The LicenseContentsDTO to free.
 */
static void freeNs0LicenseContentsType(struct nexus_licensing_plugin_ns0_licenseContents *_licenseContentsDTO) {
  int i;
  if (_licenseContentsDTO->contactCountry != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contactCountry of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->contactCountry);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contactCountry of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->contactCountry);
  }
  if (_licenseContentsDTO->contactEmail != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contactEmail of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->contactEmail);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contactEmail of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->contactEmail);
  }
  if (_licenseContentsDTO->contactPhone != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contactPhone of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->contactPhone);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contactPhone of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->contactPhone);
  }
  if (_licenseContentsDTO->contactCompany != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contactCompany of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->contactCompany);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contactCompany of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->contactCompany);
  }
  if (_licenseContentsDTO->contactName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor contactName of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->contactName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor contactName of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->contactName);
  }
  if (_licenseContentsDTO->effectiveDate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor effectiveDate of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->effectiveDate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor effectiveDate of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->effectiveDate);
  }
  if (_licenseContentsDTO->expirationDate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor expirationDate of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->expirationDate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor expirationDate of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->expirationDate);
  }
  if (_licenseContentsDTO->licenseType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor licenseType of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->licenseType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor licenseType of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->licenseType);
  }
  if (_licenseContentsDTO->licensedUserCount != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor licensedUserCount of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->licensedUserCount);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor licensedUserCount of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->licensedUserCount);
  }
  if (_licenseContentsDTO->maxLicensedUsers != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor maxLicensedUsers of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->maxLicensedUsers);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor maxLicensedUsers of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->maxLicensedUsers);
  }
  if (_licenseContentsDTO->licenseServiceUrl != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor licenseServiceUrl of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->licenseServiceUrl);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor licenseServiceUrl of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->licenseServiceUrl);
  }
  if (_licenseContentsDTO->fingerprint != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor fingerprint of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    freeXsStringType(_licenseContentsDTO->fingerprint);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor fingerprint of type nexus_licensing_plugin_ns0_licenseContents...\n");
#endif
    free(_licenseContentsDTO->fingerprint);
  }
}
#endif /* DEF_nexus_licensing_plugin_ns0_licenseContents_M */
