//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO;
@class NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO;
@class NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO;
@class NEXUS_LICENSING_PLUGINNS0AccessContentDTO;

#ifndef DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO_H
#define DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO_H

/**
 *  Response wrapper for the license content response.

 */
@interface NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO : NSObject <EnunciateXML>
{
  @private
    NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO *_data;
}

/**
 * (no documentation provided)
 */
- (NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO *) newData;
@end /* interface NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO */

#endif /* DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentResponseDTO_H */
#ifndef DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO_H
#define DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO_H

/**
 *  The parameters set by the currently installed license

 */
@interface NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO : NSObject
{
  @private
    NSString *_contactCountry;
    NSString *_contactEmail;
    NSString *_contactPhone;
    NSString *_contactCompany;
    NSString *_contactName;
    NSString *_effectiveDate;
    NSString *_expirationDate;
    NSString *_licenseType;
    NSString *_licensedUserCount;
    NSString *_maxLicensedUsers;
    NSString *_licenseServiceUrl;
    NSString *_fingerprint;
}

/**
 * 
 */
- (NSString *) contactCountry;

/**
 * 
 */
- (void) setContactCountry: (NSString *) newContactCountry;

/**
 * 
 */
- (NSString *) contactEmail;

/**
 * 
 */
- (void) setContactEmail: (NSString *) newContactEmail;

/**
 * 
 */
- (NSString *) contactPhone;

/**
 * 
 */
- (void) setContactPhone: (NSString *) newContactPhone;

/**
 * 
 */
- (NSString *) contactCompany;

/**
 * 
 */
- (void) setContactCompany: (NSString *) newContactCompany;

/**
 * 
 */
- (NSString *) contactName;

/**
 * 
 */
- (void) setContactName: (NSString *) newContactName;

/**
 * 
 */
- (NSString *) effectiveDate;

/**
 * 
 */
- (void) setEffectiveDate: (NSString *) newEffectiveDate;

/**
 * 
 */
- (NSString *) expirationDate;

/**
 * 
 */
- (void) setExpirationDate: (NSString *) newExpirationDate;

/**
 * 
 */
- (NSString *) licenseType;

/**
 * 
 */
- (void) setLicenseType: (NSString *) newLicenseType;

/**
 * 
 */
- (NSString *) licensedUserCount;

/**
 * 
 */
- (void) setLicensedUserCount: (NSString *) newLicensedUserCount;

/**
 * 
 */
- (NSString *) maxLicensedUsers;

/**
 * 
 */
- (void) setMaxLicensedUsers: (NSString *) newMaxLicensedUsers;

/**
 * (no documentation provided)
 */
- (NSString *) licenseServiceUrl;

/**
 * (no documentation provided)
 */
- (void) setLicenseServiceUrl: (NSString *) newLicenseServiceUrl;

/**
 * (no documentation provided)
 */
- (NSString *) fingerprint;

/**
 * (no documentation provided)
 */
- (void) setFingerprint: (NSString *) newFingerprint;
@end /* interface NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO */

#endif /* DEF_NEXUS_LICENSING_PLUGINNS0LicenseContentsDTO_H */
#ifndef DEF_NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO_H
#define DEF_NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO_H

/**
 *  Response wrapper for the license content response.

 */
@interface NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * (no documentation provided)
 */
- (NSArray *) data;

/**
 * (no documentation provided)
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO */

#endif /* DEF_NEXUS_LICENSING_PLUGINNS0AccessContentResponseDTO_H */
#ifndef DEF_NEXUS_LICENSING_PLUGINNS0AccessContentDTO_H
#define DEF_NEXUS_LICENSING_PLUGINNS0AccessContentDTO_H

/**
 *  The parameters set by the currently installed license

 */
@interface NEXUS_LICENSING_PLUGINNS0AccessContentDTO : NSObject
{
  @private
    NSString *_date;
    NSString *_ipAddress;
    long _timestamp;
}

/**
 * (no documentation provided)
 */
- (NSString *) date;

/**
 * (no documentation provided)
 */
- (void) setDate: (NSString *) newDate;

/**
 * (no documentation provided)
 */
- (NSString *) ipAddress;

/**
 * (no documentation provided)
 */
- (void) setIpAddress: (NSString *) newIpAddress;

/**
 * (no documentation provided)
 */
- (long) timestamp;

/**
 * (no documentation provided)
 */
- (void) setTimestamp: (long) newTimestamp;
@end /* interface NEXUS_LICENSING_PLUGINNS0AccessContentDTO */

#endif /* DEF_NEXUS_LICENSING_PLUGINNS0AccessContentDTO_H */
