//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_H
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_H

/**
 * (no documentation provided)
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto {


  /**
   * (no documentation provided)
   */
  int readonly;

  /**
   * (no documentation provided)
   */
  xmlChar *downloadURI;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *settingsXmlText;
};

/**
 * Reads a M2SettingsTemplateDto from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateDto, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *xmlTextReaderReadNs0M2SettingsTemplateDtoType(xmlTextReaderPtr reader);

/**
 * Writes a M2SettingsTemplateDto to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateDto The M2SettingsTemplateDto to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateDtoType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *_m2SettingsTemplateDto);

/**
 * Frees the elements of a M2SettingsTemplateDto.
 *
 * @param _m2SettingsTemplateDto The M2SettingsTemplateDto to free.
 */
static void freeNs0M2SettingsTemplateDtoType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *_m2SettingsTemplateDto);

#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_H */
#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_H
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_H

/**
 * (no documentation provided)
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto {


  /**
   * (no documentation provided)
   */
  int readonly;

  /**
   * (no documentation provided)
   */
  xmlChar *downloadURI;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *id;
};

/**
 * Reads a M2SettingsTemplateListResponseDto from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateListResponseDto, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *xmlTextReaderReadNs0M2SettingsTemplateListResponseDtoType(xmlTextReaderPtr reader);

/**
 * Writes a M2SettingsTemplateListResponseDto to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateListResponseDto The M2SettingsTemplateListResponseDto to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateListResponseDtoType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *_m2SettingsTemplateListResponseDto);

/**
 * Frees the elements of a M2SettingsTemplateListResponseDto.
 *
 * @param _m2SettingsTemplateListResponseDto The M2SettingsTemplateListResponseDto to free.
 */
static void freeNs0M2SettingsTemplateListResponseDtoType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *_m2SettingsTemplateListResponseDto);

#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_H */
#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_H
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_H

/**
 * (no documentation provided)
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest {


  /**
   * (no documentation provided)
   */
  struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *data;
};

/**
 * Reads a M2SettingsTemplateRequest element from XML. The element to be read is "settings-template-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateRequest, or NULL in case of error.
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xml_read_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(xmlTextReaderPtr reader);

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

/**
 * Frees a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to free.
 */
void free_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

/**
 * Reads a M2SettingsTemplateRequest element from XML. The element to be read is "settings-template-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateRequest, or NULL in case of error.
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xmlTextReaderReadNs0Settings_template_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_template_requestElement(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_template_requestElementNS(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest, int writeNamespaces);

/**
 * Frees the children of a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest whose children are to be free.
 */
static void freeNs0Settings_template_requestElement(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

/**
 * Reads a M2SettingsTemplateRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateRequest, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xmlTextReaderReadNs0M2SettingsTemplateRequestType(xmlTextReaderPtr reader);

/**
 * Writes a M2SettingsTemplateRequest to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateRequestType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

/**
 * Frees the elements of a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to free.
 */
static void freeNs0M2SettingsTemplateRequestType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest);

#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_H */
#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_M
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_M

/**
 * Reads a M2SettingsTemplateDto from XML. The reader is assumed to be at the start element.
 *
 * @return the M2SettingsTemplateDto, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *xmlTextReaderReadNs0M2SettingsTemplateDtoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *_m2SettingsTemplateDto = calloc(1, sizeof(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
        free(_m2SettingsTemplateDto);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "readonly", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}readonly of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}readonly of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
          free(_m2SettingsTemplateDto);
          return NULL;
        }

        _m2SettingsTemplateDto->readonly = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "downloadURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}downloadURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}downloadURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
          free(_m2SettingsTemplateDto);
          return NULL;
        }

        _m2SettingsTemplateDto->downloadURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
          free(_m2SettingsTemplateDto);
          return NULL;
        }

        _m2SettingsTemplateDto->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
          free(_m2SettingsTemplateDto);
          return NULL;
        }

        _m2SettingsTemplateDto->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "settingsXmlText", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}settingsXmlText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}settingsXmlText of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateDto);
          free(_m2SettingsTemplateDto);
          return NULL;
        }

        _m2SettingsTemplateDto->settingsXmlText = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}m2SettingsTemplateDto.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}m2SettingsTemplateDto. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _m2SettingsTemplateDto;
}

/**
 * Writes a M2SettingsTemplateDto to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateDto The M2SettingsTemplateDto to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateDtoType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *_m2SettingsTemplateDto) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "readonly", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}readonly...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_m2SettingsTemplateDto->readonly));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateDto->downloadURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "downloadURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}downloadURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateDto->downloadURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateDto->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateDto->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateDto->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateDto->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateDto->settingsXmlText != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settingsXmlText", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}settingsXmlText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}settingsXmlText...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateDto->settingsXmlText));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}settingsXmlText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}settingsXmlText. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a M2SettingsTemplateDto.
 *
 * @param _m2SettingsTemplateDto The M2SettingsTemplateDto to free.
 */
static void freeNs0M2SettingsTemplateDtoType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto *_m2SettingsTemplateDto) {
  int i;
  if (_m2SettingsTemplateDto->downloadURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor downloadURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateDto->downloadURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor downloadURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    free(_m2SettingsTemplateDto->downloadURI);
  }
  if (_m2SettingsTemplateDto->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateDto->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    free(_m2SettingsTemplateDto->resourceURI);
  }
  if (_m2SettingsTemplateDto->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateDto->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    free(_m2SettingsTemplateDto->id);
  }
  if (_m2SettingsTemplateDto->settingsXmlText != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor settingsXmlText of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateDto->settingsXmlText);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor settingsXmlText of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto...\n");
#endif
    free(_m2SettingsTemplateDto->settingsXmlText);
  }
}
#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto_M */
#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_M
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_M

/**
 * Reads a M2SettingsTemplateListResponseDto from XML. The reader is assumed to be at the start element.
 *
 * @return the M2SettingsTemplateListResponseDto, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *xmlTextReaderReadNs0M2SettingsTemplateListResponseDtoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *_m2SettingsTemplateListResponseDto = calloc(1, sizeof(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0M2SettingsTemplateListResponseDtoType(_m2SettingsTemplateListResponseDto);
        free(_m2SettingsTemplateListResponseDto);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "readonly", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}readonly of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}readonly of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateListResponseDtoType(_m2SettingsTemplateListResponseDto);
          free(_m2SettingsTemplateListResponseDto);
          return NULL;
        }

        _m2SettingsTemplateListResponseDto->readonly = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "downloadURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}downloadURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}downloadURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateListResponseDtoType(_m2SettingsTemplateListResponseDto);
          free(_m2SettingsTemplateListResponseDto);
          return NULL;
        }

        _m2SettingsTemplateListResponseDto->downloadURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateListResponseDtoType(_m2SettingsTemplateListResponseDto);
          free(_m2SettingsTemplateListResponseDto);
          return NULL;
        }

        _m2SettingsTemplateListResponseDto->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateListResponseDtoType(_m2SettingsTemplateListResponseDto);
          free(_m2SettingsTemplateListResponseDto);
          return NULL;
        }

        _m2SettingsTemplateListResponseDto->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}m2SettingsTemplateListResponseDto.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}m2SettingsTemplateListResponseDto. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _m2SettingsTemplateListResponseDto;
}

/**
 * Writes a M2SettingsTemplateListResponseDto to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateListResponseDto The M2SettingsTemplateListResponseDto to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateListResponseDtoType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *_m2SettingsTemplateListResponseDto) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "readonly", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}readonly...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_m2SettingsTemplateListResponseDto->readonly));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}readonly. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateListResponseDto->downloadURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "downloadURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}downloadURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateListResponseDto->downloadURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}downloadURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateListResponseDto->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateListResponseDto->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_m2SettingsTemplateListResponseDto->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_m2SettingsTemplateListResponseDto->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a M2SettingsTemplateListResponseDto.
 *
 * @param _m2SettingsTemplateListResponseDto The M2SettingsTemplateListResponseDto to free.
 */
static void freeNs0M2SettingsTemplateListResponseDtoType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto *_m2SettingsTemplateListResponseDto) {
  int i;
  if (_m2SettingsTemplateListResponseDto->downloadURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor downloadURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateListResponseDto->downloadURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor downloadURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    free(_m2SettingsTemplateListResponseDto->downloadURI);
  }
  if (_m2SettingsTemplateListResponseDto->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateListResponseDto->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    free(_m2SettingsTemplateListResponseDto->resourceURI);
  }
  if (_m2SettingsTemplateListResponseDto->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    freeXsStringType(_m2SettingsTemplateListResponseDto->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto...\n");
#endif
    free(_m2SettingsTemplateListResponseDto->id);
  }
}
#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateListResponseDto_M */
#ifndef DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_M
#define DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_M

/**
 * Reads a M2SettingsTemplateRequest element from XML. The element to be read is "settings-template-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateRequest, or NULL in case of error.
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xml_read_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Settings_template_requestElement(reader);
}

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  return xmlTextWriterWriteNs0Settings_template_requestElementNS(writer, _m2SettingsTemplateRequest, 1);
}

/**
 * Frees a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to free.
 */
void free_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  freeNs0M2SettingsTemplateRequestType(_m2SettingsTemplateRequest);
  free(_m2SettingsTemplateRequest);
}

/**
 * Reads a M2SettingsTemplateRequest element from XML. The element to be read is "settings-template-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The M2SettingsTemplateRequest, or NULL in case of error.
 */
struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xmlTextReaderReadNs0Settings_template_requestElement(xmlTextReaderPtr reader) {
  struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "settings-template-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}settings-template-request.\n");
#endif
    _m2SettingsTemplateRequest = xmlTextReaderReadNs0M2SettingsTemplateRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_m2SettingsTemplateRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}settings-template-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}settings-template-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _m2SettingsTemplateRequest;
}

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_template_requestElement(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  return xmlTextWriterWriteNs0Settings_template_requestElementNS(writer, _m2SettingsTemplateRequest, 0);
}

/**
 * Writes a M2SettingsTemplateRequest to XML under element name "settings-template-request".
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_template_requestElementNS(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settings-template-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}settings-template-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}m2SettingsTemplateRequest for root element {}settings-template-request...\n");
#endif
  status = xmlTextWriterWriteNs0M2SettingsTemplateRequestType(writer, _m2SettingsTemplateRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}settings-template-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}settings-template-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest whose children are to be free.
 */
static void freeNs0Settings_template_requestElement(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  freeNs0M2SettingsTemplateRequestType(_m2SettingsTemplateRequest);
}

/**
 * Reads a M2SettingsTemplateRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the M2SettingsTemplateRequest, or NULL in case of error.
 */
static struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *xmlTextReaderReadNs0M2SettingsTemplateRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest = calloc(1, sizeof(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0M2SettingsTemplateRequestType(_m2SettingsTemplateRequest);
        free(_m2SettingsTemplateRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}m2SettingsTemplateDto.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0M2SettingsTemplateDtoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}m2SettingsTemplateDto.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0M2SettingsTemplateRequestType(_m2SettingsTemplateRequest);
          free(_m2SettingsTemplateRequest);
          return NULL;
        }

        _m2SettingsTemplateRequest->data = ((struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateDto*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}m2SettingsTemplateRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}m2SettingsTemplateRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _m2SettingsTemplateRequest;
}

/**
 * Writes a M2SettingsTemplateRequest to XML.
 *
 * @param writer The XML writer.
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0M2SettingsTemplateRequestType(xmlTextWriterPtr writer, struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_m2SettingsTemplateRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}m2SettingsTemplateDto for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0M2SettingsTemplateDtoType(writer, (_m2SettingsTemplateRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}m2SettingsTemplateDto for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a M2SettingsTemplateRequest.
 *
 * @param _m2SettingsTemplateRequest The M2SettingsTemplateRequest to free.
 */
static void freeNs0M2SettingsTemplateRequestType(struct nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest *_m2SettingsTemplateRequest) {
  int i;
  if (_m2SettingsTemplateRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest...\n");
#endif
    freeNs0M2SettingsTemplateDtoType(_m2SettingsTemplateRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest...\n");
#endif
    free(_m2SettingsTemplateRequest->data);
  }
}
#endif /* DEF_nexus_m2_settings_template_plugin_ns0_m2SettingsTemplateRequest_M */
