//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_H

/**
 *  The Maven coordinates (GAV) of the procured artifact.
 
 @author cstamas

 */
struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO {


  /**
   * The coordinate's groupId part.
   */
  xmlChar *groupId;

  /**
   * The coordinate's artifactId part.
   */
  xmlChar *artifactId;

  /**
   * The coordintate's version part/
   */
  xmlChar *version;
};

/**
 * Reads a ProcurementArtifactCoordinateDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementArtifactCoordinateDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *xmlTextReaderReadNs0ProcurementArtifactCoordinateDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementArtifactCoordinateDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementArtifactCoordinateDTO The ProcurementArtifactCoordinateDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementArtifactCoordinateDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *_procurementArtifactCoordinateDTO);

/**
 * Frees the elements of a ProcurementArtifactCoordinateDTO.
 *
 * @param _procurementArtifactCoordinateDTO The ProcurementArtifactCoordinateDTO to free.
 */
static void freeNs0ProcurementArtifactCoordinateDTOType(struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *_procurementArtifactCoordinateDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procuredRepository_H
#define DEF_nexus_procurement_plugin_ns0_procuredRepository_H

/**
 *  DTO holding the procurement repository informations: the procured repository ID, and the target identifiers.
 
 @author cstamas

 */
struct nexus_procurement_plugin_ns0_procuredRepository {


  /**
   * The repository ID of the procurement repository.
   */
  xmlChar *repositoryId;

  /**
   * The classId ("repository" or "group") of the target, that is being procured.
   */
  xmlChar *targetClassId;

  /**
   * The (repository or group) ID of the target, that is being procured.
   */
  xmlChar *targetId;
};

/**
 * Reads a ProcurementRepositoryDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procuredRepository *xmlTextReaderReadNs0ProcuredRepositoryType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRepositoryDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryDTO The ProcurementRepositoryDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcuredRepositoryType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procuredRepository *_procurementRepositoryDTO);

/**
 * Frees the elements of a ProcurementRepositoryDTO.
 *
 * @param _procurementRepositoryDTO The ProcurementRepositoryDTO to free.
 */
static void freeNs0ProcuredRepositoryType(struct nexus_procurement_plugin_ns0_procuredRepository *_procurementRepositoryDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procuredRepository_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_H

/**
 *  DTO holding a list of procurement repositories.
 
 @author cstamas

 */
struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO {


  /**
   * The list of procured repositories.
   */
  struct nexus_procurement_plugin_ns0_procuredRepository *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a ProcurementRepositoryListResponseDTO element from XML. The element to be read is "procuredRepositoriesList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

/**
 * Frees a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

/**
 * Reads a ProcurementRepositoryListResponseDTO element from XML. The element to be read is "procuredRepositoriesList", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xmlTextReaderReadNs0ProcuredRepositoriesListElement(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcuredRepositoriesListElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcuredRepositoriesListElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO, int writeNamespaces);

/**
 * Frees the children of a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO whose children are to be free.
 */
static void freeNs0ProcuredRepositoriesListElement(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

/**
 * Reads a ProcurementRepositoryListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xmlTextReaderReadNs0ProcurementRepositoryListResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementRepositoryListResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

/**
 * Frees the elements of a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to free.
 */
static void freeNs0ProcurementRepositoryListResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_artifactResolution_H
#define DEF_nexus_procurement_plugin_ns0_artifactResolution_H

/**
 *  A DTO holding the needed rule information.
 
 @author cstamas

 */
struct nexus_procurement_plugin_ns0_artifactResolution {


  /**
   * The ID of the rule.
   */
  xmlChar *id;

  /**
   * The artifact coordinates that is used to match.
   */
  struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *artifactCoordinate;

  /**
   * The type of the rule.
   */
  xmlChar *ruleTypeId;

  /**
   * Rule properties.
   */
  struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *properties;

  /**
   * Size of the properties array.
   */
  int _sizeof_properties;
};

/**
 * Reads a ProcurementRuleDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_artifactResolution *xmlTextReaderReadNs0ArtifactResolutionType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleDTO The ProcurementRuleDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ArtifactResolutionType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_artifactResolution *_procurementRuleDTO);

/**
 * Frees the elements of a ProcurementRuleDTO.
 *
 * @param _procurementRuleDTO The ProcurementRuleDTO to free.
 */
static void freeNs0ArtifactResolutionType(struct nexus_procurement_plugin_ns0_artifactResolution *_procurementRuleDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_artifactResolution_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_H

/**
 *  The list of procurement rules DTO.
 
 @author cstamas

 */
struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO {


  /**
   * The list of procurement rules.
   */
  struct nexus_procurement_plugin_ns0_artifactResolution *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a ProcurementRuleListResponseDTO element from XML. The element to be read is "resolutionListResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

/**
 * Frees a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

/**
 * Reads a ProcurementRuleListResponseDTO element from XML. The element to be read is "resolutionListResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xmlTextReaderReadNs0ResolutionListResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionListResponseElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionListResponseElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO, int writeNamespaces);

/**
 * Frees the children of a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO whose children are to be free.
 */
static void freeNs0ResolutionListResponseElement(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

/**
 * Reads a ProcurementRuleListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleListResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xmlTextReaderReadNs0ProcurementRuleListResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementRuleListResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

/**
 * Frees the elements of a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to free.
 */
static void freeNs0ProcurementRuleListResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO {


  /**
   * The procurement rule.
   */
  struct nexus_procurement_plugin_ns0_artifactResolution *data;
};

/**
 * Reads a ProcurementRuleRequestDTO element from XML. The element to be read is "resolutionRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

/**
 * Frees a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

/**
 * Reads a ProcurementRuleRequestDTO element from XML. The element to be read is "resolutionRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xmlTextReaderReadNs0ResolutionRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionRequestElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionRequestElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO, int writeNamespaces);

/**
 * Frees the children of a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO whose children are to be free.
 */
static void freeNs0ResolutionRequestElement(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

/**
 * Reads a ProcurementRuleRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleRequestDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xmlTextReaderReadNs0ProcurementRuleRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementRuleRequestDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

/**
 * Frees the elements of a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to free.
 */
static void freeNs0ProcurementRuleRequestDTOType(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_H

/**
 * (no documentation provided)
 */
struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO {


  /**
   * The procurement rule.
   */
  struct nexus_procurement_plugin_ns0_artifactResolution *data;
};

/**
 * Reads a ProcurementRuleResponseDTO element from XML. The element to be read is "resolutionResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

/**
 * Frees a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

/**
 * Reads a ProcurementRuleResponseDTO element from XML. The element to be read is "resolutionResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xmlTextReaderReadNs0ResolutionResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionResponseElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ResolutionResponseElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO, int writeNamespaces);

/**
 * Frees the children of a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO whose children are to be free.
 */
static void freeNs0ResolutionResponseElement(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

/**
 * Reads a ProcurementRuleResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xmlTextReaderReadNs0ProcurementRuleResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementRuleResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementRuleResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

/**
 * Frees the elements of a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to free.
 */
static void freeNs0ProcurementRuleResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_procurement_plugin_ns0_procurementStartRequestDTO {


  /**
   * The procurement request.
   */
  struct nexus_procurement_plugin_ns0_procuredRepository *data;
};

/**
 * Reads a ProcurementStartRequestDTO element from XML. The element to be read is "procurementStart", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementStartRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xml_read_nexus_procurement_plugin_ns0_procurementStartRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementStartRequestDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

/**
 * Frees a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementStartRequestDTO(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

/**
 * Reads a ProcurementStartRequestDTO element from XML. The element to be read is "procurementStart", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ProcurementStartRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xmlTextReaderReadNs0ProcurementStartElement(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementStartElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementStartElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO, int writeNamespaces);

/**
 * Frees the children of a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO whose children are to be free.
 */
static void freeNs0ProcurementStartElement(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

/**
 * Reads a ProcurementStartRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurementStartRequestDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xmlTextReaderReadNs0ProcurementStartRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurementStartRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurementStartRequestDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

/**
 * Frees the elements of a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to free.
 */
static void freeNs0ProcurementStartRequestDTOType(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_H
#define DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_H

/**
 * (no documentation provided)
 */
struct nexus_procurement_plugin_ns0_procurmentPropertyDTO {


  /**
   * Property key.
   */
  xmlChar *key;

  /**
   * Property value.
   */
  xmlChar *value;
};

/**
 * Reads a ProcurmentPropertyDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ProcurmentPropertyDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *xmlTextReaderReadNs0ProcurmentPropertyDTOType(xmlTextReaderPtr reader);

/**
 * Writes a ProcurmentPropertyDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurmentPropertyDTO The ProcurmentPropertyDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProcurmentPropertyDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *_procurmentPropertyDTO);

/**
 * Frees the elements of a ProcurmentPropertyDTO.
 *
 * @param _procurmentPropertyDTO The ProcurmentPropertyDTO to free.
 */
static void freeNs0ProcurmentPropertyDTOType(struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *_procurmentPropertyDTO);

#endif /* DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_H */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_M

/**
 * Reads a ProcurementArtifactCoordinateDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementArtifactCoordinateDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *xmlTextReaderReadNs0ProcurementArtifactCoordinateDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *_procurementArtifactCoordinateDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementArtifactCoordinateDTOType(_procurementArtifactCoordinateDTO);
        free(_procurementArtifactCoordinateDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementArtifactCoordinateDTOType(_procurementArtifactCoordinateDTO);
          free(_procurementArtifactCoordinateDTO);
          return NULL;
        }

        _procurementArtifactCoordinateDTO->groupId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementArtifactCoordinateDTOType(_procurementArtifactCoordinateDTO);
          free(_procurementArtifactCoordinateDTO);
          return NULL;
        }

        _procurementArtifactCoordinateDTO->artifactId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "version", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}version of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementArtifactCoordinateDTOType(_procurementArtifactCoordinateDTO);
          free(_procurementArtifactCoordinateDTO);
          return NULL;
        }

        _procurementArtifactCoordinateDTO->version = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementArtifactCoordinateDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementArtifactCoordinateDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementArtifactCoordinateDTO;
}

/**
 * Writes a ProcurementArtifactCoordinateDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementArtifactCoordinateDTO The ProcurementArtifactCoordinateDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementArtifactCoordinateDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *_procurementArtifactCoordinateDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementArtifactCoordinateDTO->groupId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementArtifactCoordinateDTO->groupId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementArtifactCoordinateDTO->artifactId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementArtifactCoordinateDTO->artifactId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementArtifactCoordinateDTO->version != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "version", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}version...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementArtifactCoordinateDTO->version));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}version. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementArtifactCoordinateDTO.
 *
 * @param _procurementArtifactCoordinateDTO The ProcurementArtifactCoordinateDTO to free.
 */
static void freeNs0ProcurementArtifactCoordinateDTOType(struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO *_procurementArtifactCoordinateDTO) {
  int i;
  if (_procurementArtifactCoordinateDTO->groupId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupId of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    freeXsStringType(_procurementArtifactCoordinateDTO->groupId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupId of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    free(_procurementArtifactCoordinateDTO->groupId);
  }
  if (_procurementArtifactCoordinateDTO->artifactId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactId of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    freeXsStringType(_procurementArtifactCoordinateDTO->artifactId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactId of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    free(_procurementArtifactCoordinateDTO->artifactId);
  }
  if (_procurementArtifactCoordinateDTO->version != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor version of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    freeXsStringType(_procurementArtifactCoordinateDTO->version);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor version of type nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO...\n");
#endif
    free(_procurementArtifactCoordinateDTO->version);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procuredRepository_M
#define DEF_nexus_procurement_plugin_ns0_procuredRepository_M

/**
 * Reads a ProcurementRepositoryDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRepositoryDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procuredRepository *xmlTextReaderReadNs0ProcuredRepositoryType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procuredRepository *_procurementRepositoryDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procuredRepository));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcuredRepositoryType(_procurementRepositoryDTO);
        free(_procurementRepositoryDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcuredRepositoryType(_procurementRepositoryDTO);
          free(_procurementRepositoryDTO);
          return NULL;
        }

        _procurementRepositoryDTO->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "targetClassId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}targetClassId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}targetClassId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcuredRepositoryType(_procurementRepositoryDTO);
          free(_procurementRepositoryDTO);
          return NULL;
        }

        _procurementRepositoryDTO->targetClassId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "targetId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}targetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}targetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcuredRepositoryType(_procurementRepositoryDTO);
          free(_procurementRepositoryDTO);
          return NULL;
        }

        _procurementRepositoryDTO->targetId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procuredRepository.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procuredRepository. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRepositoryDTO;
}

/**
 * Writes a ProcurementRepositoryDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryDTO The ProcurementRepositoryDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcuredRepositoryType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procuredRepository *_procurementRepositoryDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementRepositoryDTO->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementRepositoryDTO->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementRepositoryDTO->targetClassId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "targetClassId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}targetClassId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}targetClassId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementRepositoryDTO->targetClassId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}targetClassId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}targetClassId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementRepositoryDTO->targetId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "targetId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}targetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}targetId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementRepositoryDTO->targetId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}targetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}targetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRepositoryDTO.
 *
 * @param _procurementRepositoryDTO The ProcurementRepositoryDTO to free.
 */
static void freeNs0ProcuredRepositoryType(struct nexus_procurement_plugin_ns0_procuredRepository *_procurementRepositoryDTO) {
  int i;
  if (_procurementRepositoryDTO->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    freeXsStringType(_procurementRepositoryDTO->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    free(_procurementRepositoryDTO->repositoryId);
  }
  if (_procurementRepositoryDTO->targetClassId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor targetClassId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    freeXsStringType(_procurementRepositoryDTO->targetClassId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor targetClassId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    free(_procurementRepositoryDTO->targetClassId);
  }
  if (_procurementRepositoryDTO->targetId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor targetId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    freeXsStringType(_procurementRepositoryDTO->targetId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor targetId of type nexus_procurement_plugin_ns0_procuredRepository...\n");
#endif
    free(_procurementRepositoryDTO->targetId);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procuredRepository_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_M

/**
 * Reads a ProcurementRepositoryListResponseDTO element from XML. The element to be read is "procuredRepositoriesList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ProcuredRepositoriesListElement(reader);
}

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  return xmlTextWriterWriteNs0ProcuredRepositoriesListElementNS(writer, _procurementRepositoryListResponseDTO, 1);
}

/**
 * Frees a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
  free(_procurementRepositoryListResponseDTO);
}

/**
 * Reads a ProcurementRepositoryListResponseDTO element from XML. The element to be read is "procuredRepositoriesList", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xmlTextReaderReadNs0ProcuredRepositoriesListElement(xmlTextReaderPtr reader) {
  struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "procuredRepositoriesList", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}procuredRepositoriesList.\n");
#endif
    _procurementRepositoryListResponseDTO = xmlTextReaderReadNs0ProcurementRepositoryListResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_procurementRepositoryListResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}procuredRepositoriesList failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}procuredRepositoriesList failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _procurementRepositoryListResponseDTO;
}

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProcuredRepositoriesListElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  return xmlTextWriterWriteNs0ProcuredRepositoriesListElementNS(writer, _procurementRepositoryListResponseDTO, 0);
}

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML under element name "procuredRepositoriesList".
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProcuredRepositoriesListElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "procuredRepositoriesList", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}procuredRepositoriesList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}procurementRepositoryListResponseDTO for root element {}procuredRepositoriesList...\n");
#endif
  status = xmlTextWriterWriteNs0ProcurementRepositoryListResponseDTOType(writer, _procurementRepositoryListResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}procuredRepositoriesList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}procuredRepositoriesList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO whose children are to be free.
 */
static void freeNs0ProcuredRepositoriesListElement(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
}

/**
 * Reads a ProcurementRepositoryListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRepositoryListResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *xmlTextReaderReadNs0ProcurementRepositoryListResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
        free(_procurementRepositoryListResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
              free(_procurementRepositoryListResponseDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "procuredRepository", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}procuredRepository of type {}procuredRepository.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ProcuredRepositoryType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}procuredRepository of type {}procuredRepository.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
          free(_procurementRepositoryListResponseDTO);
          return NULL;
        }

        _procurementRepositoryListResponseDTO->data = realloc(_procurementRepositoryListResponseDTO->data, (_procurementRepositoryListResponseDTO->_sizeof_data + 1) * sizeof(struct nexus_procurement_plugin_ns0_procuredRepository));
        memcpy(&(_procurementRepositoryListResponseDTO->data[_procurementRepositoryListResponseDTO->_sizeof_data++]), _child_accessor, sizeof(struct nexus_procurement_plugin_ns0_procuredRepository));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0ProcurementRepositoryListResponseDTOType(_procurementRepositoryListResponseDTO);
          free(_procurementRepositoryListResponseDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementRepositoryListResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementRepositoryListResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRepositoryListResponseDTO;
}

/**
 * Writes a ProcurementRepositoryListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementRepositoryListResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_procurementRepositoryListResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _procurementRepositoryListResponseDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "procuredRepository", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}procuredRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}procuredRepository for element {}procuredRepository...\n", status);
#endif
    status = xmlTextWriterWriteNs0ProcuredRepositoryType(writer, &(_procurementRepositoryListResponseDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}procuredRepository for element {}procuredRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}procuredRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_procurementRepositoryListResponseDTO->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRepositoryListResponseDTO.
 *
 * @param _procurementRepositoryListResponseDTO The ProcurementRepositoryListResponseDTO to free.
 */
static void freeNs0ProcurementRepositoryListResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO *_procurementRepositoryListResponseDTO) {
  int i;
  if (_procurementRepositoryListResponseDTO->data != NULL) {
    for (i = 0; i < _procurementRepositoryListResponseDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO...\n", i);
#endif
      freeNs0ProcuredRepositoryType(&(_procurementRepositoryListResponseDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO...\n");
#endif
    free(_procurementRepositoryListResponseDTO->data);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementRepositoryListResponseDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_artifactResolution_M
#define DEF_nexus_procurement_plugin_ns0_artifactResolution_M

/**
 * Reads a ProcurementRuleDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRuleDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_artifactResolution *xmlTextReaderReadNs0ArtifactResolutionType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_artifactResolution *_procurementRuleDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_artifactResolution));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ArtifactResolutionType(_procurementRuleDTO);
        free(_procurementRuleDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactResolutionType(_procurementRuleDTO);
          free(_procurementRuleDTO);
          return NULL;
        }

        _procurementRuleDTO->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactCoordinate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactCoordinate of type {}procurementArtifactCoordinateDTO.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ProcurementArtifactCoordinateDTOType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactCoordinate of type {}procurementArtifactCoordinateDTO.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactResolutionType(_procurementRuleDTO);
          free(_procurementRuleDTO);
          return NULL;
        }

        _procurementRuleDTO->artifactCoordinate = ((struct nexus_procurement_plugin_ns0_procurementArtifactCoordinateDTO*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ruleTypeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ruleTypeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ruleTypeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactResolutionType(_procurementRuleDTO);
          free(_procurementRuleDTO);
          return NULL;
        }

        _procurementRuleDTO->ruleTypeId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "properties", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}properties...\n");
#endif
          //start wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0ArtifactResolutionType(_procurementRuleDTO);
              free(_procurementRuleDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "property", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}property of type {}procurmentPropertyDTO.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ProcurmentPropertyDTOType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}property of type {}procurmentPropertyDTO.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ArtifactResolutionType(_procurementRuleDTO);
          free(_procurementRuleDTO);
          return NULL;
        }

        _procurementRuleDTO->properties = realloc(_procurementRuleDTO->properties, (_procurementRuleDTO->_sizeof_properties + 1) * sizeof(struct nexus_procurement_plugin_ns0_procurmentPropertyDTO));
        memcpy(&(_procurementRuleDTO->properties[_procurementRuleDTO->_sizeof_properties++]), _child_accessor, sizeof(struct nexus_procurement_plugin_ns0_procurmentPropertyDTO));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}properties.\n");
#endif
          freeNs0ArtifactResolutionType(_procurementRuleDTO);
          free(_procurementRuleDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}artifactResolution.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}artifactResolution. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRuleDTO;
}

/**
 * Writes a ProcurementRuleDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleDTO The ProcurementRuleDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ArtifactResolutionType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_artifactResolution *_procurementRuleDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementRuleDTO->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementRuleDTO->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementRuleDTO->artifactCoordinate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactCoordinate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactCoordinate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}procurementArtifactCoordinateDTO for element {}artifactCoordinate...\n", status);
#endif
    status = xmlTextWriterWriteNs0ProcurementArtifactCoordinateDTOType(writer, (_procurementRuleDTO->artifactCoordinate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}procurementArtifactCoordinateDTO for element {}artifactCoordinate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactCoordinate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurementRuleDTO->ruleTypeId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ruleTypeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ruleTypeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ruleTypeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurementRuleDTO->ruleTypeId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ruleTypeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ruleTypeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_procurementRuleDTO->properties != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "properties", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _procurementRuleDTO->_sizeof_properties; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "property", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}procurmentPropertyDTO for element {}property...\n", status);
#endif
    status = xmlTextWriterWriteNs0ProcurmentPropertyDTOType(writer, &(_procurementRuleDTO->properties[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}procurmentPropertyDTO for element {}property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}property. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_procurementRuleDTO->properties != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRuleDTO.
 *
 * @param _procurementRuleDTO The ProcurementRuleDTO to free.
 */
static void freeNs0ArtifactResolutionType(struct nexus_procurement_plugin_ns0_artifactResolution *_procurementRuleDTO) {
  int i;
  if (_procurementRuleDTO->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    freeXsStringType(_procurementRuleDTO->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    free(_procurementRuleDTO->id);
  }
  if (_procurementRuleDTO->artifactCoordinate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor artifactCoordinate of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    freeNs0ProcurementArtifactCoordinateDTOType(_procurementRuleDTO->artifactCoordinate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor artifactCoordinate of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    free(_procurementRuleDTO->artifactCoordinate);
  }
  if (_procurementRuleDTO->ruleTypeId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ruleTypeId of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    freeXsStringType(_procurementRuleDTO->ruleTypeId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ruleTypeId of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    free(_procurementRuleDTO->ruleTypeId);
  }
  if (_procurementRuleDTO->properties != NULL) {
    for (i = 0; i < _procurementRuleDTO->_sizeof_properties; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor properties[%i] of type nexus_procurement_plugin_ns0_artifactResolution...\n", i);
#endif
      freeNs0ProcurmentPropertyDTOType(&(_procurementRuleDTO->properties[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor properties of type nexus_procurement_plugin_ns0_artifactResolution...\n");
#endif
    free(_procurementRuleDTO->properties);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_artifactResolution_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_M

/**
 * Reads a ProcurementRuleListResponseDTO element from XML. The element to be read is "resolutionListResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ResolutionListResponseElement(reader);
}

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  return xmlTextWriterWriteNs0ResolutionListResponseElementNS(writer, _procurementRuleListResponseDTO, 1);
}

/**
 * Frees a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
  free(_procurementRuleListResponseDTO);
}

/**
 * Reads a ProcurementRuleListResponseDTO element from XML. The element to be read is "resolutionListResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleListResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xmlTextReaderReadNs0ResolutionListResponseElement(xmlTextReaderPtr reader) {
  struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "resolutionListResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}resolutionListResponse.\n");
#endif
    _procurementRuleListResponseDTO = xmlTextReaderReadNs0ProcurementRuleListResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_procurementRuleListResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}resolutionListResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}resolutionListResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _procurementRuleListResponseDTO;
}

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionListResponseElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  return xmlTextWriterWriteNs0ResolutionListResponseElementNS(writer, _procurementRuleListResponseDTO, 0);
}

/**
 * Writes a ProcurementRuleListResponseDTO to XML under element name "resolutionListResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionListResponseElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resolutionListResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}resolutionListResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}procurementRuleListResponseDTO for root element {}resolutionListResponse...\n");
#endif
  status = xmlTextWriterWriteNs0ProcurementRuleListResponseDTOType(writer, _procurementRuleListResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}resolutionListResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}resolutionListResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO whose children are to be free.
 */
static void freeNs0ResolutionListResponseElement(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
}

/**
 * Reads a ProcurementRuleListResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRuleListResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *xmlTextReaderReadNs0ProcurementRuleListResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
        free(_procurementRuleListResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
              free(_procurementRuleListResponseDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "artifactResolution", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}artifactResolution of type {}artifactResolution.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ArtifactResolutionType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}artifactResolution of type {}artifactResolution.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
          free(_procurementRuleListResponseDTO);
          return NULL;
        }

        _procurementRuleListResponseDTO->data = realloc(_procurementRuleListResponseDTO->data, (_procurementRuleListResponseDTO->_sizeof_data + 1) * sizeof(struct nexus_procurement_plugin_ns0_artifactResolution));
        memcpy(&(_procurementRuleListResponseDTO->data[_procurementRuleListResponseDTO->_sizeof_data++]), _child_accessor, sizeof(struct nexus_procurement_plugin_ns0_artifactResolution));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0ProcurementRuleListResponseDTOType(_procurementRuleListResponseDTO);
          free(_procurementRuleListResponseDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementRuleListResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementRuleListResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRuleListResponseDTO;
}

/**
 * Writes a ProcurementRuleListResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementRuleListResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_procurementRuleListResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _procurementRuleListResponseDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "artifactResolution", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}artifactResolution. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifactResolution for element {}artifactResolution...\n", status);
#endif
    status = xmlTextWriterWriteNs0ArtifactResolutionType(writer, &(_procurementRuleListResponseDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifactResolution for element {}artifactResolution. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}artifactResolution. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_procurementRuleListResponseDTO->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRuleListResponseDTO.
 *
 * @param _procurementRuleListResponseDTO The ProcurementRuleListResponseDTO to free.
 */
static void freeNs0ProcurementRuleListResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRuleListResponseDTO *_procurementRuleListResponseDTO) {
  int i;
  if (_procurementRuleListResponseDTO->data != NULL) {
    for (i = 0; i < _procurementRuleListResponseDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_procurement_plugin_ns0_procurementRuleListResponseDTO...\n", i);
#endif
      freeNs0ArtifactResolutionType(&(_procurementRuleListResponseDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_procurement_plugin_ns0_procurementRuleListResponseDTO...\n");
#endif
    free(_procurementRuleListResponseDTO->data);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleListResponseDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_M

/**
 * Reads a ProcurementRuleRequestDTO element from XML. The element to be read is "resolutionRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ResolutionRequestElement(reader);
}

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  return xmlTextWriterWriteNs0ResolutionRequestElementNS(writer, _procurementRuleRequestDTO, 1);
}

/**
 * Frees a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleRequestDTO(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  freeNs0ProcurementRuleRequestDTOType(_procurementRuleRequestDTO);
  free(_procurementRuleRequestDTO);
}

/**
 * Reads a ProcurementRuleRequestDTO element from XML. The element to be read is "resolutionRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xmlTextReaderReadNs0ResolutionRequestElement(xmlTextReaderPtr reader) {
  struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "resolutionRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}resolutionRequest.\n");
#endif
    _procurementRuleRequestDTO = xmlTextReaderReadNs0ProcurementRuleRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_procurementRuleRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}resolutionRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}resolutionRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _procurementRuleRequestDTO;
}

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionRequestElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  return xmlTextWriterWriteNs0ResolutionRequestElementNS(writer, _procurementRuleRequestDTO, 0);
}

/**
 * Writes a ProcurementRuleRequestDTO to XML under element name "resolutionRequest".
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionRequestElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resolutionRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}resolutionRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}procurementRuleRequestDTO for root element {}resolutionRequest...\n");
#endif
  status = xmlTextWriterWriteNs0ProcurementRuleRequestDTOType(writer, _procurementRuleRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}resolutionRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}resolutionRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO whose children are to be free.
 */
static void freeNs0ResolutionRequestElement(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  freeNs0ProcurementRuleRequestDTOType(_procurementRuleRequestDTO);
}

/**
 * Reads a ProcurementRuleRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRuleRequestDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *xmlTextReaderReadNs0ProcurementRuleRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementRuleRequestDTOType(_procurementRuleRequestDTO);
        free(_procurementRuleRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}artifactResolution.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ArtifactResolutionType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}artifactResolution.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementRuleRequestDTOType(_procurementRuleRequestDTO);
          free(_procurementRuleRequestDTO);
          return NULL;
        }

        _procurementRuleRequestDTO->data = ((struct nexus_procurement_plugin_ns0_artifactResolution*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementRuleRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementRuleRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRuleRequestDTO;
}

/**
 * Writes a ProcurementRuleRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementRuleRequestDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementRuleRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifactResolution for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0ArtifactResolutionType(writer, (_procurementRuleRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifactResolution for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRuleRequestDTO.
 *
 * @param _procurementRuleRequestDTO The ProcurementRuleRequestDTO to free.
 */
static void freeNs0ProcurementRuleRequestDTOType(struct nexus_procurement_plugin_ns0_procurementRuleRequestDTO *_procurementRuleRequestDTO) {
  int i;
  if (_procurementRuleRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_procurement_plugin_ns0_procurementRuleRequestDTO...\n");
#endif
    freeNs0ArtifactResolutionType(_procurementRuleRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_procurement_plugin_ns0_procurementRuleRequestDTO...\n");
#endif
    free(_procurementRuleRequestDTO->data);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleRequestDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_M

/**
 * Reads a ProcurementRuleResponseDTO element from XML. The element to be read is "resolutionResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xml_read_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ResolutionResponseElement(reader);
}

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  return xmlTextWriterWriteNs0ResolutionResponseElementNS(writer, _procurementRuleResponseDTO, 1);
}

/**
 * Frees a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementRuleResponseDTO(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  freeNs0ProcurementRuleResponseDTOType(_procurementRuleResponseDTO);
  free(_procurementRuleResponseDTO);
}

/**
 * Reads a ProcurementRuleResponseDTO element from XML. The element to be read is "resolutionResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ProcurementRuleResponseDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xmlTextReaderReadNs0ResolutionResponseElement(xmlTextReaderPtr reader) {
  struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "resolutionResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}resolutionResponse.\n");
#endif
    _procurementRuleResponseDTO = xmlTextReaderReadNs0ProcurementRuleResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_procurementRuleResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}resolutionResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}resolutionResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _procurementRuleResponseDTO;
}

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionResponseElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  return xmlTextWriterWriteNs0ResolutionResponseElementNS(writer, _procurementRuleResponseDTO, 0);
}

/**
 * Writes a ProcurementRuleResponseDTO to XML under element name "resolutionResponse".
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ResolutionResponseElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resolutionResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}resolutionResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}procurementRuleResponseDTO for root element {}resolutionResponse...\n");
#endif
  status = xmlTextWriterWriteNs0ProcurementRuleResponseDTOType(writer, _procurementRuleResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}resolutionResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}resolutionResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO whose children are to be free.
 */
static void freeNs0ResolutionResponseElement(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  freeNs0ProcurementRuleResponseDTOType(_procurementRuleResponseDTO);
}

/**
 * Reads a ProcurementRuleResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementRuleResponseDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *xmlTextReaderReadNs0ProcurementRuleResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementRuleResponseDTOType(_procurementRuleResponseDTO);
        free(_procurementRuleResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}artifactResolution.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ArtifactResolutionType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}artifactResolution.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementRuleResponseDTOType(_procurementRuleResponseDTO);
          free(_procurementRuleResponseDTO);
          return NULL;
        }

        _procurementRuleResponseDTO->data = ((struct nexus_procurement_plugin_ns0_artifactResolution*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementRuleResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementRuleResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementRuleResponseDTO;
}

/**
 * Writes a ProcurementRuleResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementRuleResponseDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementRuleResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}artifactResolution for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0ArtifactResolutionType(writer, (_procurementRuleResponseDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}artifactResolution for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementRuleResponseDTO.
 *
 * @param _procurementRuleResponseDTO The ProcurementRuleResponseDTO to free.
 */
static void freeNs0ProcurementRuleResponseDTOType(struct nexus_procurement_plugin_ns0_procurementRuleResponseDTO *_procurementRuleResponseDTO) {
  int i;
  if (_procurementRuleResponseDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_procurement_plugin_ns0_procurementRuleResponseDTO...\n");
#endif
    freeNs0ArtifactResolutionType(_procurementRuleResponseDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_procurement_plugin_ns0_procurementRuleResponseDTO...\n");
#endif
    free(_procurementRuleResponseDTO->data);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementRuleResponseDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_M

/**
 * Reads a ProcurementStartRequestDTO element from XML. The element to be read is "procurementStart", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ProcurementStartRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xml_read_nexus_procurement_plugin_ns0_procurementStartRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ProcurementStartElement(reader);
}

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_procurement_plugin_ns0_procurementStartRequestDTO(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  return xmlTextWriterWriteNs0ProcurementStartElementNS(writer, _procurementStartRequestDTO, 1);
}

/**
 * Frees a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to free.
 */
void free_nexus_procurement_plugin_ns0_procurementStartRequestDTO(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  freeNs0ProcurementStartRequestDTOType(_procurementStartRequestDTO);
  free(_procurementStartRequestDTO);
}

/**
 * Reads a ProcurementStartRequestDTO element from XML. The element to be read is "procurementStart", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ProcurementStartRequestDTO, or NULL in case of error.
 */
struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xmlTextReaderReadNs0ProcurementStartElement(xmlTextReaderPtr reader) {
  struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "procurementStart", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}procurementStart.\n");
#endif
    _procurementStartRequestDTO = xmlTextReaderReadNs0ProcurementStartRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_procurementStartRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}procurementStart failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}procurementStart failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _procurementStartRequestDTO;
}

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProcurementStartElement(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  return xmlTextWriterWriteNs0ProcurementStartElementNS(writer, _procurementStartRequestDTO, 0);
}

/**
 * Writes a ProcurementStartRequestDTO to XML under element name "procurementStart".
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProcurementStartElementNS(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "procurementStart", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}procurementStart. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}procurementStartRequestDTO for root element {}procurementStart...\n");
#endif
  status = xmlTextWriterWriteNs0ProcurementStartRequestDTOType(writer, _procurementStartRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}procurementStart. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}procurementStart. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO whose children are to be free.
 */
static void freeNs0ProcurementStartElement(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  freeNs0ProcurementStartRequestDTOType(_procurementStartRequestDTO);
}

/**
 * Reads a ProcurementStartRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurementStartRequestDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *xmlTextReaderReadNs0ProcurementStartRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurementStartRequestDTOType(_procurementStartRequestDTO);
        free(_procurementStartRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}procuredRepository.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0ProcuredRepositoryType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}procuredRepository.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurementStartRequestDTOType(_procurementStartRequestDTO);
          free(_procurementStartRequestDTO);
          return NULL;
        }

        _procurementStartRequestDTO->data = ((struct nexus_procurement_plugin_ns0_procuredRepository*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurementStartRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurementStartRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurementStartRequestDTO;
}

/**
 * Writes a ProcurementStartRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurementStartRequestDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurementStartRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}procuredRepository for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0ProcuredRepositoryType(writer, (_procurementStartRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}procuredRepository for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurementStartRequestDTO.
 *
 * @param _procurementStartRequestDTO The ProcurementStartRequestDTO to free.
 */
static void freeNs0ProcurementStartRequestDTOType(struct nexus_procurement_plugin_ns0_procurementStartRequestDTO *_procurementStartRequestDTO) {
  int i;
  if (_procurementStartRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_procurement_plugin_ns0_procurementStartRequestDTO...\n");
#endif
    freeNs0ProcuredRepositoryType(_procurementStartRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_procurement_plugin_ns0_procurementStartRequestDTO...\n");
#endif
    free(_procurementStartRequestDTO->data);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurementStartRequestDTO_M */
#ifndef DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_M
#define DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_M

/**
 * Reads a ProcurmentPropertyDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the ProcurmentPropertyDTO, or NULL in case of error.
 */
static struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *xmlTextReaderReadNs0ProcurmentPropertyDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *_procurmentPropertyDTO = calloc(1, sizeof(struct nexus_procurement_plugin_ns0_procurmentPropertyDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ProcurmentPropertyDTOType(_procurmentPropertyDTO);
        free(_procurmentPropertyDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurmentPropertyDTOType(_procurmentPropertyDTO);
          free(_procurmentPropertyDTO);
          return NULL;
        }

        _procurmentPropertyDTO->key = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "value", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ProcurmentPropertyDTOType(_procurmentPropertyDTO);
          free(_procurmentPropertyDTO);
          return NULL;
        }

        _procurmentPropertyDTO->value = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}procurmentPropertyDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}procurmentPropertyDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _procurmentPropertyDTO;
}

/**
 * Writes a ProcurmentPropertyDTO to XML.
 *
 * @param writer The XML writer.
 * @param _procurmentPropertyDTO The ProcurmentPropertyDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ProcurmentPropertyDTOType(xmlTextWriterPtr writer, struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *_procurmentPropertyDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_procurmentPropertyDTO->key != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}key...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurmentPropertyDTO->key));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_procurmentPropertyDTO->value != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "value", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}value...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_procurmentPropertyDTO->value));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ProcurmentPropertyDTO.
 *
 * @param _procurmentPropertyDTO The ProcurmentPropertyDTO to free.
 */
static void freeNs0ProcurmentPropertyDTOType(struct nexus_procurement_plugin_ns0_procurmentPropertyDTO *_procurmentPropertyDTO) {
  int i;
  if (_procurmentPropertyDTO->key != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor key of type nexus_procurement_plugin_ns0_procurmentPropertyDTO...\n");
#endif
    freeXsStringType(_procurmentPropertyDTO->key);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor key of type nexus_procurement_plugin_ns0_procurmentPropertyDTO...\n");
#endif
    free(_procurmentPropertyDTO->key);
  }
  if (_procurmentPropertyDTO->value != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor value of type nexus_procurement_plugin_ns0_procurmentPropertyDTO...\n");
#endif
    freeXsStringType(_procurmentPropertyDTO->value);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor value of type nexus_procurement_plugin_ns0_procurmentPropertyDTO...\n");
#endif
    free(_procurmentPropertyDTO->value);
  }
}
#endif /* DEF_nexus_procurement_plugin_ns0_procurmentPropertyDTO_M */
