//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO;
@class NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO;

#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO_H

/**
 *  DTO holding a list of procurement repositories.
 
 @author cstamas

 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * The list of procured repositories.
 */
- (NSArray *) data;

/**
 * The list of procured repositories.
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryListResponseDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO_H

/**
 *  The list of procurement rules DTO.
 
 @author cstamas

 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO : NSObject <EnunciateXML>
{
  @private
    NSArray *_data;
}

/**
 * The list of procurement rules.
 */
- (NSArray *) data;

/**
 * The list of procurement rules.
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleListResponseDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO_H

/**
 * (no documentation provided)
 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO : NSObject <EnunciateXML>
{
  @private
    NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *_data;
}

/**
 * The procurement rule.
 */
- (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *) data;

/**
 * The procurement rule.
 */
- (void) setData: (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *) newData;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleResponseDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO_H

/**
 * (no documentation provided)
 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO : NSObject
{
  @private
    NSString *_key;
    NSString *_value;
}

/**
 * Property key.
 */
- (NSString *) key;

/**
 * Property key.
 */
- (void) setKey: (NSString *) newKey;

/**
 * Property value.
 */
- (NSString *) value;

/**
 * Property value.
 */
- (void) setValue: (NSString *) newValue;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurmentPropertyDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO_H

/**
 * (no documentation provided)
 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO : NSObject <EnunciateXML>
{
  @private
    NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO *_data;
}

/**
 * The procurement request.
 */
- (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO *) data;

/**
 * The procurement request.
 */
- (void) setData: (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO *) newData;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementStartRequestDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO_H

/**
 * (no documentation provided)
 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO : NSObject <EnunciateXML>
{
  @private
    NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *_data;
}

/**
 * The procurement rule.
 */
- (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *) data;

/**
 * The procurement rule.
 */
- (void) setData: (NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO *) newData;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleRequestDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO_H

/**
 *  A DTO holding the needed rule information.
 
 @author cstamas

 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO : NSObject
{
  @private
    NSString *_id;
    NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO *_artifactCoordinate;
    NSString *_ruleTypeId;
    NSArray *_properties;
}

/**
 * The ID of the rule.
 */
- (NSString *) id;

/**
 * The ID of the rule.
 */
- (void) setId: (NSString *) newId;

/**
 * The artifact coordinates that is used to match.
 */
- (NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO *) artifactCoordinate;

/**
 * The artifact coordinates that is used to match.
 */
- (void) setArtifactCoordinate: (NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO *) newArtifactCoordinate;

/**
 * The type of the rule.
 */
- (NSString *) ruleTypeId;

/**
 * The type of the rule.
 */
- (void) setRuleTypeId: (NSString *) newRuleTypeId;

/**
 * Rule properties.
 */
- (NSArray *) properties;

/**
 * Rule properties.
 */
- (void) setProperties: (NSArray *) newProperties;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRuleDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO_H

/**
 *  DTO holding the procurement repository informations: the procured repository ID, and the target identifiers.
 
 @author cstamas

 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO : NSObject
{
  @private
    NSString *_repositoryId;
    NSString *_targetClassId;
    NSString *_targetId;
}

/**
 * The repository ID of the procurement repository.
 */
- (NSString *) repositoryId;

/**
 * The repository ID of the procurement repository.
 */
- (void) setRepositoryId: (NSString *) newRepositoryId;

/**
 * The classId ("repository" or "group") of the target, that is being procured.
 */
- (NSString *) targetClassId;

/**
 * The classId ("repository" or "group") of the target, that is being procured.
 */
- (void) setTargetClassId: (NSString *) newTargetClassId;

/**
 * The (repository or group) ID of the target, that is being procured.
 */
- (NSString *) targetId;

/**
 * The (repository or group) ID of the target, that is being procured.
 */
- (void) setTargetId: (NSString *) newTargetId;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementRepositoryDTO_H */
#ifndef DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO_H
#define DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO_H

/**
 *  The Maven coordinates (GAV) of the procured artifact.
 
 @author cstamas

 */
@interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO : NSObject
{
  @private
    NSString *_groupId;
    NSString *_artifactId;
    NSString *_version;
}

/**
 * The coordinate's groupId part.
 */
- (NSString *) groupId;

/**
 * The coordinate's groupId part.
 */
- (void) setGroupId: (NSString *) newGroupId;

/**
 * The coordinate's artifactId part.
 */
- (NSString *) artifactId;

/**
 * The coordinate's artifactId part.
 */
- (void) setArtifactId: (NSString *) newArtifactId;

/**
 * The coordintate's version part/
 */
- (NSString *) version;

/**
 * The coordintate's version part/
 */
- (void) setVersion: (NSString *) newVersion;
@end /* interface NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO */

#endif /* DEF_NEXUS_PROCUREMENT_PLUGINNS0ProcurementArtifactCoordinateDTO_H */
