//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_user_account_plugin_ns0_captcha_H
#define DEF_nexus_user_account_plugin_ns0_captcha_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_captcha {


  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *key;
};

/**
 * Reads a CaptchaDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CaptchaDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_captcha *xmlTextReaderReadNs0CaptchaType(xmlTextReaderPtr reader);

/**
 * Writes a CaptchaDTO to XML.
 *
 * @param writer The XML writer.
 * @param _captchaDTO The CaptchaDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CaptchaType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captcha *_captchaDTO);

/**
 * Frees the elements of a CaptchaDTO.
 *
 * @param _captchaDTO The CaptchaDTO to free.
 */
static void freeNs0CaptchaType(struct nexus_user_account_plugin_ns0_captcha *_captchaDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_captcha_H */
#ifndef DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_H
#define DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_captchaResponseDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_captcha *data;
};

/**
 * Reads a CaptchaResponseDTO element from XML. The element to be read is "captchaResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CaptchaResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_captchaResponseDTO *xml_read_nexus_user_account_plugin_ns0_captchaResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_captchaResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

/**
 * Frees a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_captchaResponseDTO(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

/**
 * Reads a CaptchaResponseDTO element from XML. The element to be read is "captchaResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The CaptchaResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_captchaResponseDTO *xmlTextReaderReadNs0CaptchaResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CaptchaResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CaptchaResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO, int writeNamespaces);

/**
 * Frees the children of a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO whose children are to be free.
 */
static void freeNs0CaptchaResponseElement(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

/**
 * Reads a CaptchaResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The CaptchaResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_captchaResponseDTO *xmlTextReaderReadNs0CaptchaResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a CaptchaResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CaptchaResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

/**
 * Frees the elements of a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO to free.
 */
static void freeNs0CaptchaResponseDTOType(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_H
#define DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_signUpRequestDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_signUpUserAccount *userAccount;

  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_captcha *captcha;
};

/**
 * Reads a SignUpRequestDTO element from XML. The element to be read is "signUpRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SignUpRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpRequestDTO *xml_read_nexus_user_account_plugin_ns0_signUpRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_signUpRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

/**
 * Frees a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_signUpRequestDTO(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

/**
 * Reads a SignUpRequestDTO element from XML. The element to be read is "signUpRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SignUpRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpRequestDTO *xmlTextReaderReadNs0SignUpRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO, int writeNamespaces);

/**
 * Frees the children of a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO whose children are to be free.
 */
static void freeNs0SignUpRequestElement(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

/**
 * Reads a SignUpRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SignUpRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpRequestDTO *xmlTextReaderReadNs0SignUpRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a SignUpRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

/**
 * Frees the elements of a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO to free.
 */
static void freeNs0SignUpRequestDTOType(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpUserAccount_H
#define DEF_nexus_user_account_plugin_ns0_signUpUserAccount_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_signUpUserAccount {


  /**
   * (no documentation provided)
   */
  xmlChar *lastName;

  /**
   * (no documentation provided)
   */
  xmlChar *firstName;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *email;

  /**
   * (no documentation provided)
   */
  xmlChar *password;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *oldPassword;
};

/**
 * Reads a SignUpUserAccountDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpUserAccount *xmlTextReaderReadNs0SignUpUserAccountType(xmlTextReaderPtr reader);

/**
 * Writes a SignUpUserAccountDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountDTO The SignUpUserAccountDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccount *_signUpUserAccountDTO);

/**
 * Frees the elements of a SignUpUserAccountDTO.
 *
 * @param _signUpUserAccountDTO The SignUpUserAccountDTO to free.
 */
static void freeNs0SignUpUserAccountType(struct nexus_user_account_plugin_ns0_signUpUserAccount *_signUpUserAccountDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_signUpUserAccount_H */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_H
#define DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_signUpUserAccount *data;
};

/**
 * Reads a SignUpUserAccountWrapperDTO element from XML. The element to be read is "signUpUserAccountRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xml_read_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(xmlTextReaderPtr reader);

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

/**
 * Frees a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to free.
 */
void free_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

/**
 * Reads a SignUpUserAccountWrapperDTO element from XML. The element to be read is "signUpUserAccountRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xmlTextReaderReadNs0SignUpUserAccountRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO, int writeNamespaces);

/**
 * Frees the children of a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO whose children are to be free.
 */
static void freeNs0SignUpUserAccountRequestElement(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

/**
 * Reads a SignUpUserAccountWrapperDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xmlTextReaderReadNs0SignUpUserAccountWrapperDTOType(xmlTextReaderPtr reader);

/**
 * Writes a SignUpUserAccountWrapperDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountWrapperDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

/**
 * Frees the elements of a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to free.
 */
static void freeNs0SignUpUserAccountWrapperDTOType(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_H
#define DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO {


  /**
   * (no documentation provided)
   */
  xmlChar *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a UserAccountDefaultRolesRequestDTO element from XML. The element to be read is "userAccountDefaultRolesRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xml_read_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

/**
 * Frees a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

/**
 * Reads a UserAccountDefaultRolesRequestDTO element from XML. The element to be read is "userAccountDefaultRolesRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xmlTextReaderReadNs0UserAccountDefaultRolesRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO, int writeNamespaces);

/**
 * Frees the children of a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO whose children are to be free.
 */
static void freeNs0UserAccountDefaultRolesRequestElement(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

/**
 * Reads a UserAccountDefaultRolesRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xmlTextReaderReadNs0UserAccountDefaultRolesRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

/**
 * Frees the elements of a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to free.
 */
static void freeNs0UserAccountDefaultRolesRequestDTOType(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_H
#define DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO {


  /**
   * (no documentation provided)
   */
  xmlChar *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a UserAccountDefaultRolesResponseDTO element from XML. The element to be read is "userAccountDefaultRolesResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xml_read_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

/**
 * Frees a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

/**
 * Reads a UserAccountDefaultRolesResponseDTO element from XML. The element to be read is "userAccountDefaultRolesResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xmlTextReaderReadNs0UserAccountDefaultRolesResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO, int writeNamespaces);

/**
 * Frees the children of a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO whose children are to be free.
 */
static void freeNs0UserAccountDefaultRolesResponseElement(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

/**
 * Reads a UserAccountDefaultRolesResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xmlTextReaderReadNs0UserAccountDefaultRolesResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

/**
 * Frees the elements of a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to free.
 */
static void freeNs0UserAccountDefaultRolesResponseDTOType(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatus_H
#define DEF_nexus_user_account_plugin_ns0_userAccountStatus_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccountStatus {


  /**
   * (no documentation provided)
   */
  int enabled;
};

/**
 * Reads a UserAccountStatusDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatus *xmlTextReaderReadNs0UserAccountStatusType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusDTO The UserAccountStatusDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatus *_userAccountStatusDTO);

/**
 * Frees the elements of a UserAccountStatusDTO.
 *
 * @param _userAccountStatusDTO The UserAccountStatusDTO to free.
 */
static void freeNs0UserAccountStatusType(struct nexus_user_account_plugin_ns0_userAccountStatus *_userAccountStatusDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatus_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_H
#define DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_userAccountStatus *data;
};

/**
 * Reads a UserAccountStatusRequestDTO element from XML. The element to be read is "userAccountStatusRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xml_read_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

/**
 * Frees a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

/**
 * Reads a UserAccountStatusRequestDTO element from XML. The element to be read is "userAccountStatusRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xmlTextReaderReadNs0UserAccountStatusRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO, int writeNamespaces);

/**
 * Frees the children of a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO whose children are to be free.
 */
static void freeNs0UserAccountStatusRequestElement(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

/**
 * Reads a UserAccountStatusRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xmlTextReaderReadNs0UserAccountStatusRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

/**
 * Frees the elements of a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to free.
 */
static void freeNs0UserAccountStatusRequestDTOType(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_H
#define DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_user_account_plugin_ns0_userAccountStatus *data;
};

/**
 * Reads a UserAccountStatusResponseDTO element from XML. The element to be read is "userAccountStatusResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xml_read_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

/**
 * Frees a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

/**
 * Reads a UserAccountStatusResponseDTO element from XML. The element to be read is "userAccountStatusResponse", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xmlTextReaderReadNs0UserAccountStatusResponseElement(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO, int writeNamespaces);

/**
 * Frees the children of a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO whose children are to be free.
 */
static void freeNs0UserAccountStatusResponseElement(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

/**
 * Reads a UserAccountStatusResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xmlTextReaderReadNs0UserAccountStatusResponseDTOType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccountStatusResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

/**
 * Frees the elements of a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to free.
 */
static void freeNs0UserAccountStatusResponseDTOType(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_H */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccount_H
#define DEF_nexus_user_account_plugin_ns0_userAccount_H

/**
 * (no documentation provided)
 */
struct nexus_user_account_plugin_ns0_userAccount {


  /**
   * (no documentation provided)
   */
  xmlChar *lastName;

  /**
   * (no documentation provided)
   */
  xmlChar *firstName;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *email;
};

/**
 * Reads a UserAccount from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserAccount, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccount *xmlTextReaderReadNs0UserAccountType(xmlTextReaderPtr reader);

/**
 * Writes a UserAccount to XML.
 *
 * @param writer The XML writer.
 * @param _userAccount The UserAccount to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserAccountType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccount *_userAccount);

/**
 * Frees the elements of a UserAccount.
 *
 * @param _userAccount The UserAccount to free.
 */
static void freeNs0UserAccountType(struct nexus_user_account_plugin_ns0_userAccount *_userAccount);

#endif /* DEF_nexus_user_account_plugin_ns0_userAccount_H */
#ifndef DEF_nexus_user_account_plugin_ns0_captcha_M
#define DEF_nexus_user_account_plugin_ns0_captcha_M

/**
 * Reads a CaptchaDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the CaptchaDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_captcha *xmlTextReaderReadNs0CaptchaType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_captcha *_captchaDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_captcha));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CaptchaType(_captchaDTO);
        free(_captchaDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CaptchaType(_captchaDTO);
          free(_captchaDTO);
          return NULL;
        }

        _captchaDTO->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CaptchaType(_captchaDTO);
          free(_captchaDTO);
          return NULL;
        }

        _captchaDTO->key = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}captcha.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}captcha. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _captchaDTO;
}

/**
 * Writes a CaptchaDTO to XML.
 *
 * @param writer The XML writer.
 * @param _captchaDTO The CaptchaDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CaptchaType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captcha *_captchaDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_captchaDTO->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_captchaDTO->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_captchaDTO->key != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}key...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_captchaDTO->key));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CaptchaDTO.
 *
 * @param _captchaDTO The CaptchaDTO to free.
 */
static void freeNs0CaptchaType(struct nexus_user_account_plugin_ns0_captcha *_captchaDTO) {
  int i;
  if (_captchaDTO->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_user_account_plugin_ns0_captcha...\n");
#endif
    freeXsStringType(_captchaDTO->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_user_account_plugin_ns0_captcha...\n");
#endif
    free(_captchaDTO->resourceURI);
  }
  if (_captchaDTO->key != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor key of type nexus_user_account_plugin_ns0_captcha...\n");
#endif
    freeXsStringType(_captchaDTO->key);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor key of type nexus_user_account_plugin_ns0_captcha...\n");
#endif
    free(_captchaDTO->key);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_captcha_M */
#ifndef DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_M
#define DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_M

/**
 * Reads a CaptchaResponseDTO element from XML. The element to be read is "captchaResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The CaptchaResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_captchaResponseDTO *xml_read_nexus_user_account_plugin_ns0_captchaResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0CaptchaResponseElement(reader);
}

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_captchaResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  return xmlTextWriterWriteNs0CaptchaResponseElementNS(writer, _captchaResponseDTO, 1);
}

/**
 * Frees a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_captchaResponseDTO(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  freeNs0CaptchaResponseDTOType(_captchaResponseDTO);
  free(_captchaResponseDTO);
}

/**
 * Reads a CaptchaResponseDTO element from XML. The element to be read is "captchaResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The CaptchaResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_captchaResponseDTO *xmlTextReaderReadNs0CaptchaResponseElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "captchaResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}captchaResponse.\n");
#endif
    _captchaResponseDTO = xmlTextReaderReadNs0CaptchaResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_captchaResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}captchaResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}captchaResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _captchaResponseDTO;
}

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CaptchaResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  return xmlTextWriterWriteNs0CaptchaResponseElementNS(writer, _captchaResponseDTO, 0);
}

/**
 * Writes a CaptchaResponseDTO to XML under element name "captchaResponse".
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0CaptchaResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "captchaResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}captchaResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}captchaResponseDTO for root element {}captchaResponse...\n");
#endif
  status = xmlTextWriterWriteNs0CaptchaResponseDTOType(writer, _captchaResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}captchaResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}captchaResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO whose children are to be free.
 */
static void freeNs0CaptchaResponseElement(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  freeNs0CaptchaResponseDTOType(_captchaResponseDTO);
}

/**
 * Reads a CaptchaResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the CaptchaResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_captchaResponseDTO *xmlTextReaderReadNs0CaptchaResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_captchaResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CaptchaResponseDTOType(_captchaResponseDTO);
        free(_captchaResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}captcha.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CaptchaType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}captcha.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CaptchaResponseDTOType(_captchaResponseDTO);
          free(_captchaResponseDTO);
          return NULL;
        }

        _captchaResponseDTO->data = ((struct nexus_user_account_plugin_ns0_captcha*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}captchaResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}captchaResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _captchaResponseDTO;
}

/**
 * Writes a CaptchaResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _captchaResponseDTO The CaptchaResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CaptchaResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_captchaResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}captcha for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0CaptchaType(writer, (_captchaResponseDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}captcha for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a CaptchaResponseDTO.
 *
 * @param _captchaResponseDTO The CaptchaResponseDTO to free.
 */
static void freeNs0CaptchaResponseDTOType(struct nexus_user_account_plugin_ns0_captchaResponseDTO *_captchaResponseDTO) {
  int i;
  if (_captchaResponseDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_user_account_plugin_ns0_captchaResponseDTO...\n");
#endif
    freeNs0CaptchaType(_captchaResponseDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_captchaResponseDTO...\n");
#endif
    free(_captchaResponseDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_captchaResponseDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_M
#define DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_M

/**
 * Reads a SignUpRequestDTO element from XML. The element to be read is "signUpRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SignUpRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpRequestDTO *xml_read_nexus_user_account_plugin_ns0_signUpRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0SignUpRequestElement(reader);
}

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_signUpRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  return xmlTextWriterWriteNs0SignUpRequestElementNS(writer, _signUpRequestDTO, 1);
}

/**
 * Frees a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_signUpRequestDTO(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  freeNs0SignUpRequestDTOType(_signUpRequestDTO);
  free(_signUpRequestDTO);
}

/**
 * Reads a SignUpRequestDTO element from XML. The element to be read is "signUpRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SignUpRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpRequestDTO *xmlTextReaderReadNs0SignUpRequestElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "signUpRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}signUpRequest.\n");
#endif
    _signUpRequestDTO = xmlTextReaderReadNs0SignUpRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_signUpRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}signUpRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}signUpRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _signUpRequestDTO;
}

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SignUpRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  return xmlTextWriterWriteNs0SignUpRequestElementNS(writer, _signUpRequestDTO, 0);
}

/**
 * Writes a SignUpRequestDTO to XML under element name "signUpRequest".
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SignUpRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "signUpRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}signUpRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}signUpRequestDTO for root element {}signUpRequest...\n");
#endif
  status = xmlTextWriterWriteNs0SignUpRequestDTOType(writer, _signUpRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}signUpRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}signUpRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO whose children are to be free.
 */
static void freeNs0SignUpRequestElement(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  freeNs0SignUpRequestDTOType(_signUpRequestDTO);
}

/**
 * Reads a SignUpRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the SignUpRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpRequestDTO *xmlTextReaderReadNs0SignUpRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_signUpRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SignUpRequestDTOType(_signUpRequestDTO);
        free(_signUpRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userAccount", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userAccount of type {}signUpUserAccount.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0SignUpUserAccountType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userAccount of type {}signUpUserAccount.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpRequestDTOType(_signUpRequestDTO);
          free(_signUpRequestDTO);
          return NULL;
        }

        _signUpRequestDTO->userAccount = ((struct nexus_user_account_plugin_ns0_signUpUserAccount*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "captcha", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}captcha of type {}captcha.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CaptchaType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}captcha of type {}captcha.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpRequestDTOType(_signUpRequestDTO);
          free(_signUpRequestDTO);
          return NULL;
        }

        _signUpRequestDTO->captcha = ((struct nexus_user_account_plugin_ns0_captcha*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}signUpRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}signUpRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _signUpRequestDTO;
}

/**
 * Writes a SignUpRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpRequestDTO The SignUpRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SignUpRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_signUpRequestDTO->userAccount != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAccount", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userAccount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}signUpUserAccount for element {}userAccount...\n", status);
#endif
    status = xmlTextWriterWriteNs0SignUpUserAccountType(writer, (_signUpRequestDTO->userAccount));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}signUpUserAccount for element {}userAccount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userAccount. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpRequestDTO->captcha != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "captcha", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}captcha. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}captcha for element {}captcha...\n", status);
#endif
    status = xmlTextWriterWriteNs0CaptchaType(writer, (_signUpRequestDTO->captcha));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}captcha for element {}captcha. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}captcha. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SignUpRequestDTO.
 *
 * @param _signUpRequestDTO The SignUpRequestDTO to free.
 */
static void freeNs0SignUpRequestDTOType(struct nexus_user_account_plugin_ns0_signUpRequestDTO *_signUpRequestDTO) {
  int i;
  if (_signUpRequestDTO->userAccount != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userAccount of type nexus_user_account_plugin_ns0_signUpRequestDTO...\n");
#endif
    freeNs0SignUpUserAccountType(_signUpRequestDTO->userAccount);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userAccount of type nexus_user_account_plugin_ns0_signUpRequestDTO...\n");
#endif
    free(_signUpRequestDTO->userAccount);
  }
  if (_signUpRequestDTO->captcha != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor captcha of type nexus_user_account_plugin_ns0_signUpRequestDTO...\n");
#endif
    freeNs0CaptchaType(_signUpRequestDTO->captcha);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor captcha of type nexus_user_account_plugin_ns0_signUpRequestDTO...\n");
#endif
    free(_signUpRequestDTO->captcha);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_signUpRequestDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpUserAccount_M
#define DEF_nexus_user_account_plugin_ns0_signUpUserAccount_M

/**
 * Reads a SignUpUserAccountDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the SignUpUserAccountDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpUserAccount *xmlTextReaderReadNs0SignUpUserAccountType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_signUpUserAccount *_signUpUserAccountDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_signUpUserAccount));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
        free(_signUpUserAccountDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "lastName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->lastName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "firstName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->firstName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "oldPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}oldPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}oldPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountType(_signUpUserAccountDTO);
          free(_signUpUserAccountDTO);
          return NULL;
        }

        _signUpUserAccountDTO->oldPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}signUpUserAccount.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}signUpUserAccount. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _signUpUserAccountDTO;
}

/**
 * Writes a SignUpUserAccountDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountDTO The SignUpUserAccountDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SignUpUserAccountType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccount *_signUpUserAccountDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_signUpUserAccountDTO->lastName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "lastName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}lastName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->lastName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->firstName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "firstName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}firstName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->firstName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_signUpUserAccountDTO->oldPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "oldPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}oldPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_signUpUserAccountDTO->oldPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SignUpUserAccountDTO.
 *
 * @param _signUpUserAccountDTO The SignUpUserAccountDTO to free.
 */
static void freeNs0SignUpUserAccountType(struct nexus_user_account_plugin_ns0_signUpUserAccount *_signUpUserAccountDTO) {
  int i;
  if (_signUpUserAccountDTO->lastName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor lastName of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->lastName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor lastName of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->lastName);
  }
  if (_signUpUserAccountDTO->firstName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor firstName of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->firstName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor firstName of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->firstName);
  }
  if (_signUpUserAccountDTO->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->userId);
  }
  if (_signUpUserAccountDTO->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->email);
  }
  if (_signUpUserAccountDTO->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->password);
  }
  if (_signUpUserAccountDTO->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->resourceURI);
  }
  if (_signUpUserAccountDTO->oldPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor oldPassword of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    freeXsStringType(_signUpUserAccountDTO->oldPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor oldPassword of type nexus_user_account_plugin_ns0_signUpUserAccount...\n");
#endif
    free(_signUpUserAccountDTO->oldPassword);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_signUpUserAccount_M */
#ifndef DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_M
#define DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_M

/**
 * Reads a SignUpUserAccountWrapperDTO element from XML. The element to be read is "signUpUserAccountRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xml_read_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0SignUpUserAccountRequestElement(reader);
}

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  return xmlTextWriterWriteNs0SignUpUserAccountRequestElementNS(writer, _signUpUserAccountWrapperDTO, 1);
}

/**
 * Frees a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to free.
 */
void free_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  freeNs0SignUpUserAccountWrapperDTOType(_signUpUserAccountWrapperDTO);
  free(_signUpUserAccountWrapperDTO);
}

/**
 * Reads a SignUpUserAccountWrapperDTO element from XML. The element to be read is "signUpUserAccountRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xmlTextReaderReadNs0SignUpUserAccountRequestElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "signUpUserAccountRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}signUpUserAccountRequest.\n");
#endif
    _signUpUserAccountWrapperDTO = xmlTextReaderReadNs0SignUpUserAccountWrapperDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_signUpUserAccountWrapperDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}signUpUserAccountRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}signUpUserAccountRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _signUpUserAccountWrapperDTO;
}

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  return xmlTextWriterWriteNs0SignUpUserAccountRequestElementNS(writer, _signUpUserAccountWrapperDTO, 0);
}

/**
 * Writes a SignUpUserAccountWrapperDTO to XML under element name "signUpUserAccountRequest".
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0SignUpUserAccountRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "signUpUserAccountRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}signUpUserAccountRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}signUpUserAccountWrapperDTO for root element {}signUpUserAccountRequest...\n");
#endif
  status = xmlTextWriterWriteNs0SignUpUserAccountWrapperDTOType(writer, _signUpUserAccountWrapperDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}signUpUserAccountRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}signUpUserAccountRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO whose children are to be free.
 */
static void freeNs0SignUpUserAccountRequestElement(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  freeNs0SignUpUserAccountWrapperDTOType(_signUpUserAccountWrapperDTO);
}

/**
 * Reads a SignUpUserAccountWrapperDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the SignUpUserAccountWrapperDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *xmlTextReaderReadNs0SignUpUserAccountWrapperDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SignUpUserAccountWrapperDTOType(_signUpUserAccountWrapperDTO);
        free(_signUpUserAccountWrapperDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}signUpUserAccount.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0SignUpUserAccountType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}signUpUserAccount.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SignUpUserAccountWrapperDTOType(_signUpUserAccountWrapperDTO);
          free(_signUpUserAccountWrapperDTO);
          return NULL;
        }

        _signUpUserAccountWrapperDTO->data = ((struct nexus_user_account_plugin_ns0_signUpUserAccount*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}signUpUserAccountWrapperDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}signUpUserAccountWrapperDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _signUpUserAccountWrapperDTO;
}

/**
 * Writes a SignUpUserAccountWrapperDTO to XML.
 *
 * @param writer The XML writer.
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SignUpUserAccountWrapperDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_signUpUserAccountWrapperDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}signUpUserAccount for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0SignUpUserAccountType(writer, (_signUpUserAccountWrapperDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}signUpUserAccount for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SignUpUserAccountWrapperDTO.
 *
 * @param _signUpUserAccountWrapperDTO The SignUpUserAccountWrapperDTO to free.
 */
static void freeNs0SignUpUserAccountWrapperDTOType(struct nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO *_signUpUserAccountWrapperDTO) {
  int i;
  if (_signUpUserAccountWrapperDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO...\n");
#endif
    freeNs0SignUpUserAccountType(_signUpUserAccountWrapperDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO...\n");
#endif
    free(_signUpUserAccountWrapperDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_signUpUserAccountWrapperDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_M
#define DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_M

/**
 * Reads a UserAccountDefaultRolesRequestDTO element from XML. The element to be read is "userAccountDefaultRolesRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xml_read_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0UserAccountDefaultRolesRequestElement(reader);
}

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  return xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElementNS(writer, _userAccountDefaultRolesRequestDTO, 1);
}

/**
 * Frees a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  freeNs0UserAccountDefaultRolesRequestDTOType(_userAccountDefaultRolesRequestDTO);
  free(_userAccountDefaultRolesRequestDTO);
}

/**
 * Reads a UserAccountDefaultRolesRequestDTO element from XML. The element to be read is "userAccountDefaultRolesRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xmlTextReaderReadNs0UserAccountDefaultRolesRequestElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userAccountDefaultRolesRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}userAccountDefaultRolesRequest.\n");
#endif
    _userAccountDefaultRolesRequestDTO = xmlTextReaderReadNs0UserAccountDefaultRolesRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userAccountDefaultRolesRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}userAccountDefaultRolesRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}userAccountDefaultRolesRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userAccountDefaultRolesRequestDTO;
}

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  return xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElementNS(writer, _userAccountDefaultRolesRequestDTO, 0);
}

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML under element name "userAccountDefaultRolesRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAccountDefaultRolesRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}userAccountDefaultRolesRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userAccountDefaultRolesRequestDTO for root element {}userAccountDefaultRolesRequest...\n");
#endif
  status = xmlTextWriterWriteNs0UserAccountDefaultRolesRequestDTOType(writer, _userAccountDefaultRolesRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}userAccountDefaultRolesRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}userAccountDefaultRolesRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO whose children are to be free.
 */
static void freeNs0UserAccountDefaultRolesRequestElement(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  freeNs0UserAccountDefaultRolesRequestDTOType(_userAccountDefaultRolesRequestDTO);
}

/**
 * Reads a UserAccountDefaultRolesRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountDefaultRolesRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *xmlTextReaderReadNs0UserAccountDefaultRolesRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountDefaultRolesRequestDTOType(_userAccountDefaultRolesRequestDTO);
        free(_userAccountDefaultRolesRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountDefaultRolesRequestDTOType(_userAccountDefaultRolesRequestDTO);
          free(_userAccountDefaultRolesRequestDTO);
          return NULL;
        }

        _userAccountDefaultRolesRequestDTO->data = realloc(_userAccountDefaultRolesRequestDTO->data, (_userAccountDefaultRolesRequestDTO->_sizeof_data + 1) * sizeof(xmlChar));
        memcpy(&(_userAccountDefaultRolesRequestDTO->data[_userAccountDefaultRolesRequestDTO->_sizeof_data++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountDefaultRolesRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountDefaultRolesRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountDefaultRolesRequestDTO;
}

/**
 * Writes a UserAccountDefaultRolesRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _userAccountDefaultRolesRequestDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_userAccountDefaultRolesRequestDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountDefaultRolesRequestDTO.
 *
 * @param _userAccountDefaultRolesRequestDTO The UserAccountDefaultRolesRequestDTO to free.
 */
static void freeNs0UserAccountDefaultRolesRequestDTOType(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO *_userAccountDefaultRolesRequestDTO) {
  int i;
  if (_userAccountDefaultRolesRequestDTO->data != NULL) {
    for (i = 0; i < _userAccountDefaultRolesRequestDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO...\n", i);
#endif
      freeXsStringType(&(_userAccountDefaultRolesRequestDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO...\n");
#endif
    free(_userAccountDefaultRolesRequestDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesRequestDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_M
#define DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_M

/**
 * Reads a UserAccountDefaultRolesResponseDTO element from XML. The element to be read is "userAccountDefaultRolesResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xml_read_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0UserAccountDefaultRolesResponseElement(reader);
}

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  return xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElementNS(writer, _userAccountDefaultRolesResponseDTO, 1);
}

/**
 * Frees a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  freeNs0UserAccountDefaultRolesResponseDTOType(_userAccountDefaultRolesResponseDTO);
  free(_userAccountDefaultRolesResponseDTO);
}

/**
 * Reads a UserAccountDefaultRolesResponseDTO element from XML. The element to be read is "userAccountDefaultRolesResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xmlTextReaderReadNs0UserAccountDefaultRolesResponseElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userAccountDefaultRolesResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}userAccountDefaultRolesResponse.\n");
#endif
    _userAccountDefaultRolesResponseDTO = xmlTextReaderReadNs0UserAccountDefaultRolesResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userAccountDefaultRolesResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}userAccountDefaultRolesResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}userAccountDefaultRolesResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userAccountDefaultRolesResponseDTO;
}

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  return xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElementNS(writer, _userAccountDefaultRolesResponseDTO, 0);
}

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML under element name "userAccountDefaultRolesResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAccountDefaultRolesResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}userAccountDefaultRolesResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userAccountDefaultRolesResponseDTO for root element {}userAccountDefaultRolesResponse...\n");
#endif
  status = xmlTextWriterWriteNs0UserAccountDefaultRolesResponseDTOType(writer, _userAccountDefaultRolesResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}userAccountDefaultRolesResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}userAccountDefaultRolesResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO whose children are to be free.
 */
static void freeNs0UserAccountDefaultRolesResponseElement(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  freeNs0UserAccountDefaultRolesResponseDTOType(_userAccountDefaultRolesResponseDTO);
}

/**
 * Reads a UserAccountDefaultRolesResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountDefaultRolesResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *xmlTextReaderReadNs0UserAccountDefaultRolesResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountDefaultRolesResponseDTOType(_userAccountDefaultRolesResponseDTO);
        free(_userAccountDefaultRolesResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountDefaultRolesResponseDTOType(_userAccountDefaultRolesResponseDTO);
          free(_userAccountDefaultRolesResponseDTO);
          return NULL;
        }

        _userAccountDefaultRolesResponseDTO->data = realloc(_userAccountDefaultRolesResponseDTO->data, (_userAccountDefaultRolesResponseDTO->_sizeof_data + 1) * sizeof(xmlChar));
        memcpy(&(_userAccountDefaultRolesResponseDTO->data[_userAccountDefaultRolesResponseDTO->_sizeof_data++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountDefaultRolesResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountDefaultRolesResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountDefaultRolesResponseDTO;
}

/**
 * Writes a UserAccountDefaultRolesResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountDefaultRolesResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _userAccountDefaultRolesResponseDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_userAccountDefaultRolesResponseDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountDefaultRolesResponseDTO.
 *
 * @param _userAccountDefaultRolesResponseDTO The UserAccountDefaultRolesResponseDTO to free.
 */
static void freeNs0UserAccountDefaultRolesResponseDTOType(struct nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO *_userAccountDefaultRolesResponseDTO) {
  int i;
  if (_userAccountDefaultRolesResponseDTO->data != NULL) {
    for (i = 0; i < _userAccountDefaultRolesResponseDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO...\n", i);
#endif
      freeXsStringType(&(_userAccountDefaultRolesResponseDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO...\n");
#endif
    free(_userAccountDefaultRolesResponseDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccountDefaultRolesResponseDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatus_M
#define DEF_nexus_user_account_plugin_ns0_userAccountStatus_M

/**
 * Reads a UserAccountStatusDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountStatusDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatus *xmlTextReaderReadNs0UserAccountStatusType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccountStatus *_userAccountStatusDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccountStatus));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountStatusType(_userAccountStatusDTO);
        free(_userAccountStatusDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountStatusType(_userAccountStatusDTO);
          free(_userAccountStatusDTO);
          return NULL;
        }

        _userAccountStatusDTO->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountStatus.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountStatus. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountStatusDTO;
}

/**
 * Writes a UserAccountStatusDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusDTO The UserAccountStatusDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountStatusType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatus *_userAccountStatusDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_userAccountStatusDTO->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountStatusDTO.
 *
 * @param _userAccountStatusDTO The UserAccountStatusDTO to free.
 */
static void freeNs0UserAccountStatusType(struct nexus_user_account_plugin_ns0_userAccountStatus *_userAccountStatusDTO) {
  int i;
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatus_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_M
#define DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_M

/**
 * Reads a UserAccountStatusRequestDTO element from XML. The element to be read is "userAccountStatusRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xml_read_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0UserAccountStatusRequestElement(reader);
}

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  return xmlTextWriterWriteNs0UserAccountStatusRequestElementNS(writer, _userAccountStatusRequestDTO, 1);
}

/**
 * Frees a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  freeNs0UserAccountStatusRequestDTOType(_userAccountStatusRequestDTO);
  free(_userAccountStatusRequestDTO);
}

/**
 * Reads a UserAccountStatusRequestDTO element from XML. The element to be read is "userAccountStatusRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusRequestDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xmlTextReaderReadNs0UserAccountStatusRequestElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userAccountStatusRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}userAccountStatusRequest.\n");
#endif
    _userAccountStatusRequestDTO = xmlTextReaderReadNs0UserAccountStatusRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userAccountStatusRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}userAccountStatusRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}userAccountStatusRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userAccountStatusRequestDTO;
}

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  return xmlTextWriterWriteNs0UserAccountStatusRequestElementNS(writer, _userAccountStatusRequestDTO, 0);
}

/**
 * Writes a UserAccountStatusRequestDTO to XML under element name "userAccountStatusRequest".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAccountStatusRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}userAccountStatusRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userAccountStatusRequestDTO for root element {}userAccountStatusRequest...\n");
#endif
  status = xmlTextWriterWriteNs0UserAccountStatusRequestDTOType(writer, _userAccountStatusRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}userAccountStatusRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}userAccountStatusRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO whose children are to be free.
 */
static void freeNs0UserAccountStatusRequestElement(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  freeNs0UserAccountStatusRequestDTOType(_userAccountStatusRequestDTO);
}

/**
 * Reads a UserAccountStatusRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountStatusRequestDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *xmlTextReaderReadNs0UserAccountStatusRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountStatusRequestDTOType(_userAccountStatusRequestDTO);
        free(_userAccountStatusRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userAccountStatus.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserAccountStatusType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userAccountStatus.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountStatusRequestDTOType(_userAccountStatusRequestDTO);
          free(_userAccountStatusRequestDTO);
          return NULL;
        }

        _userAccountStatusRequestDTO->data = ((struct nexus_user_account_plugin_ns0_userAccountStatus*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountStatusRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountStatusRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountStatusRequestDTO;
}

/**
 * Writes a UserAccountStatusRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountStatusRequestDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userAccountStatusRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userAccountStatus for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserAccountStatusType(writer, (_userAccountStatusRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userAccountStatus for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountStatusRequestDTO.
 *
 * @param _userAccountStatusRequestDTO The UserAccountStatusRequestDTO to free.
 */
static void freeNs0UserAccountStatusRequestDTOType(struct nexus_user_account_plugin_ns0_userAccountStatusRequestDTO *_userAccountStatusRequestDTO) {
  int i;
  if (_userAccountStatusRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_user_account_plugin_ns0_userAccountStatusRequestDTO...\n");
#endif
    freeNs0UserAccountStatusType(_userAccountStatusRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_userAccountStatusRequestDTO...\n");
#endif
    free(_userAccountStatusRequestDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatusRequestDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_M
#define DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_M

/**
 * Reads a UserAccountStatusResponseDTO element from XML. The element to be read is "userAccountStatusResponse", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xml_read_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0UserAccountStatusResponseElement(reader);
}

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  return xmlTextWriterWriteNs0UserAccountStatusResponseElementNS(writer, _userAccountStatusResponseDTO, 1);
}

/**
 * Frees a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to free.
 */
void free_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  freeNs0UserAccountStatusResponseDTOType(_userAccountStatusResponseDTO);
  free(_userAccountStatusResponseDTO);
}

/**
 * Reads a UserAccountStatusResponseDTO element from XML. The element to be read is "userAccountStatusResponse", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserAccountStatusResponseDTO, or NULL in case of error.
 */
struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xmlTextReaderReadNs0UserAccountStatusResponseElement(xmlTextReaderPtr reader) {
  struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userAccountStatusResponse", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}userAccountStatusResponse.\n");
#endif
    _userAccountStatusResponseDTO = xmlTextReaderReadNs0UserAccountStatusResponseDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userAccountStatusResponseDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}userAccountStatusResponse failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}userAccountStatusResponse failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userAccountStatusResponseDTO;
}

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseElement(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  return xmlTextWriterWriteNs0UserAccountStatusResponseElementNS(writer, _userAccountStatusResponseDTO, 0);
}

/**
 * Writes a UserAccountStatusResponseDTO to XML under element name "userAccountStatusResponse".
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseElementNS(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAccountStatusResponse", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}userAccountStatusResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userAccountStatusResponseDTO for root element {}userAccountStatusResponse...\n");
#endif
  status = xmlTextWriterWriteNs0UserAccountStatusResponseDTOType(writer, _userAccountStatusResponseDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}userAccountStatusResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}userAccountStatusResponse. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO whose children are to be free.
 */
static void freeNs0UserAccountStatusResponseElement(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  freeNs0UserAccountStatusResponseDTOType(_userAccountStatusResponseDTO);
}

/**
 * Reads a UserAccountStatusResponseDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccountStatusResponseDTO, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *xmlTextReaderReadNs0UserAccountStatusResponseDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountStatusResponseDTOType(_userAccountStatusResponseDTO);
        free(_userAccountStatusResponseDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userAccountStatus.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserAccountStatusType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userAccountStatus.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountStatusResponseDTOType(_userAccountStatusResponseDTO);
          free(_userAccountStatusResponseDTO);
          return NULL;
        }

        _userAccountStatusResponseDTO->data = ((struct nexus_user_account_plugin_ns0_userAccountStatus*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccountStatusResponseDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccountStatusResponseDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccountStatusResponseDTO;
}

/**
 * Writes a UserAccountStatusResponseDTO to XML.
 *
 * @param writer The XML writer.
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountStatusResponseDTOType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userAccountStatusResponseDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userAccountStatus for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserAccountStatusType(writer, (_userAccountStatusResponseDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userAccountStatus for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccountStatusResponseDTO.
 *
 * @param _userAccountStatusResponseDTO The UserAccountStatusResponseDTO to free.
 */
static void freeNs0UserAccountStatusResponseDTOType(struct nexus_user_account_plugin_ns0_userAccountStatusResponseDTO *_userAccountStatusResponseDTO) {
  int i;
  if (_userAccountStatusResponseDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_user_account_plugin_ns0_userAccountStatusResponseDTO...\n");
#endif
    freeNs0UserAccountStatusType(_userAccountStatusResponseDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_user_account_plugin_ns0_userAccountStatusResponseDTO...\n");
#endif
    free(_userAccountStatusResponseDTO->data);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccountStatusResponseDTO_M */
#ifndef DEF_nexus_user_account_plugin_ns0_userAccount_M
#define DEF_nexus_user_account_plugin_ns0_userAccount_M

/**
 * Reads a UserAccount from XML. The reader is assumed to be at the start element.
 *
 * @return the UserAccount, or NULL in case of error.
 */
static struct nexus_user_account_plugin_ns0_userAccount *xmlTextReaderReadNs0UserAccountType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_user_account_plugin_ns0_userAccount *_userAccount = calloc(1, sizeof(struct nexus_user_account_plugin_ns0_userAccount));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserAccountType(_userAccount);
        free(_userAccount);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "lastName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->lastName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "firstName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->firstName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserAccountType(_userAccount);
          free(_userAccount);
          return NULL;
        }

        _userAccount->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userAccount.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userAccount. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userAccount;
}

/**
 * Writes a UserAccount to XML.
 *
 * @param writer The XML writer.
 * @param _userAccount The UserAccount to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserAccountType(xmlTextWriterPtr writer, struct nexus_user_account_plugin_ns0_userAccount *_userAccount) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userAccount->lastName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "lastName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}lastName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->lastName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->firstName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "firstName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}firstName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->firstName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userAccount->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userAccount->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserAccount.
 *
 * @param _userAccount The UserAccount to free.
 */
static void freeNs0UserAccountType(struct nexus_user_account_plugin_ns0_userAccount *_userAccount) {
  int i;
  if (_userAccount->lastName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor lastName of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->lastName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor lastName of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    free(_userAccount->lastName);
  }
  if (_userAccount->firstName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor firstName of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->firstName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor firstName of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    free(_userAccount->firstName);
  }
  if (_userAccount->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    free(_userAccount->userId);
  }
  if (_userAccount->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    freeXsStringType(_userAccount->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type nexus_user_account_plugin_ns0_userAccount...\n");
#endif
    free(_userAccount->email);
  }
}
#endif /* DEF_nexus_user_account_plugin_ns0_userAccount_M */
