#include <enunciate-common.c>
#ifndef DEF_nexus_usertoken_plugin_api_authToken_H
#define DEF_nexus_usertoken_plugin_api_authToken_H

/**
 * (no documentation provided)
 */
struct nexus_usertoken_plugin_api_authToken {


  /**
   * (no documentation provided)
   */
  xmlChar *u;

  /**
   * (no documentation provided)
   */
  xmlChar *p;
};

/**
 * Reads a AuthTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The AuthTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_authToken *xml_read_nexus_usertoken_plugin_api_authToken(xmlTextReaderPtr reader);

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_usertoken_plugin_api_authToken(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

/**
 * Frees a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO to free.
 */
void free_nexus_usertoken_plugin_api_authToken(struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

/**
 * Reads a AuthTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The AuthTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_authToken *xmlTextReaderReadApiAuthTokenElement(xmlTextReaderPtr reader);

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiAuthTokenElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiAuthTokenElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO, int writeNamespaces);

/**
 * Frees the children of a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO whose children are to be free.
 */
static void freeApiAuthTokenElement(struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

/**
 * Reads a AuthTokenXO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The AuthTokenXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_authToken *xmlTextReaderReadApiAuthTokenType(xmlTextReaderPtr reader);

/**
 * Writes a AuthTokenXO to XML.
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiAuthTokenType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

/**
 * Frees the elements of a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO to free.
 */
static void freeApiAuthTokenType(struct nexus_usertoken_plugin_api_authToken *_authTokenXO);

#endif /* DEF_nexus_usertoken_plugin_api_authToken_H */
#ifndef DEF_nexus_usertoken_plugin_api_settings_H
#define DEF_nexus_usertoken_plugin_api_settings_H

/**
 * (no documentation provided)
 */
struct nexus_usertoken_plugin_api_settings {


  /**
   * (no documentation provided)
   */
  int enabled;

  /**
   * (no documentation provided)
   */
  int protectContent;

  /**
   * (no documentation provided)
   */
  int *realmConfigured;
};

/**
 * Reads a SettingsXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_settings *xml_read_nexus_usertoken_plugin_api_settings(xmlTextReaderPtr reader);

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_usertoken_plugin_api_settings(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO);

/**
 * Frees a SettingsXO.
 *
 * @param _settingsXO The SettingsXO to free.
 */
void free_nexus_usertoken_plugin_api_settings(struct nexus_usertoken_plugin_api_settings *_settingsXO);

/**
 * Reads a SettingsXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SettingsXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_settings *xmlTextReaderReadApiSettingsElement(xmlTextReaderPtr reader);

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiSettingsElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO);

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiSettingsElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO, int writeNamespaces);

/**
 * Frees the children of a SettingsXO.
 *
 * @param _settingsXO The SettingsXO whose children are to be free.
 */
static void freeApiSettingsElement(struct nexus_usertoken_plugin_api_settings *_settingsXO);

/**
 * Reads a SettingsXO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SettingsXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_settings *xmlTextReaderReadApiSettingsType(xmlTextReaderPtr reader);

/**
 * Writes a SettingsXO to XML.
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiSettingsType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO);

/**
 * Frees the elements of a SettingsXO.
 *
 * @param _settingsXO The SettingsXO to free.
 */
static void freeApiSettingsType(struct nexus_usertoken_plugin_api_settings *_settingsXO);

#endif /* DEF_nexus_usertoken_plugin_api_settings_H */
#ifndef DEF_nexus_usertoken_plugin_api_status_H
#define DEF_nexus_usertoken_plugin_api_status_H

/**
 * (no documentation provided)
 */
struct nexus_usertoken_plugin_api_status {


  /**
   * (no documentation provided)
   */
  int enabled;
};

/**
 * Reads a StatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_status *xml_read_nexus_usertoken_plugin_api_status(xmlTextReaderPtr reader);

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_usertoken_plugin_api_status(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO);

/**
 * Frees a StatusXO.
 *
 * @param _statusXO The StatusXO to free.
 */
void free_nexus_usertoken_plugin_api_status(struct nexus_usertoken_plugin_api_status *_statusXO);

/**
 * Reads a StatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The StatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_status *xmlTextReaderReadApiStatusElement(xmlTextReaderPtr reader);

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiStatusElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO);

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiStatusElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO, int writeNamespaces);

/**
 * Frees the children of a StatusXO.
 *
 * @param _statusXO The StatusXO whose children are to be free.
 */
static void freeApiStatusElement(struct nexus_usertoken_plugin_api_status *_statusXO);

/**
 * Reads a StatusXO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StatusXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_status *xmlTextReaderReadApiStatusType(xmlTextReaderPtr reader);

/**
 * Writes a StatusXO to XML.
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiStatusType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO);

/**
 * Frees the elements of a StatusXO.
 *
 * @param _statusXO The StatusXO to free.
 */
static void freeApiStatusType(struct nexus_usertoken_plugin_api_status *_statusXO);

#endif /* DEF_nexus_usertoken_plugin_api_status_H */
#ifndef DEF_nexus_usertoken_plugin_api_userTokenStatus_H
#define DEF_nexus_usertoken_plugin_api_userTokenStatus_H

/**
 * (no documentation provided)
 */
struct nexus_usertoken_plugin_api_userTokenStatus {


  /**
   * (no documentation provided)
   */
  int provisioned;

  /**
   * (no documentation provided)
   */
  xmlChar *created;
};

/**
 * Reads a UserTokenStatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserTokenStatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userTokenStatus *xml_read_nexus_usertoken_plugin_api_userTokenStatus(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_usertoken_plugin_api_userTokenStatus(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

/**
 * Frees a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO to free.
 */
void free_nexus_usertoken_plugin_api_userTokenStatus(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

/**
 * Reads a UserTokenStatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserTokenStatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userTokenStatus *xmlTextReaderReadApiUserTokenStatusElement(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenStatusElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenStatusElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO, int writeNamespaces);

/**
 * Frees the children of a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO whose children are to be free.
 */
static void freeApiUserTokenStatusElement(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

/**
 * Reads a UserTokenStatusXO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserTokenStatusXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_userTokenStatus *xmlTextReaderReadApiUserTokenStatusType(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenStatusXO to XML.
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenStatusType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

/**
 * Frees the elements of a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO to free.
 */
static void freeApiUserTokenStatusType(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO);

#endif /* DEF_nexus_usertoken_plugin_api_userTokenStatus_H */
#ifndef DEF_nexus_usertoken_plugin_api_userToken_H
#define DEF_nexus_usertoken_plugin_api_userToken_H

/**
 * (no documentation provided)
 */
struct nexus_usertoken_plugin_api_userToken {


  /**
   * (no documentation provided)
   */
  xmlChar *nameCode;

  /**
   * (no documentation provided)
   */
  xmlChar *passCode;

  /**
   * (no documentation provided)
   */
  xmlChar *created;
};

/**
 * Reads a UserTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userToken *xml_read_nexus_usertoken_plugin_api_userToken(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_usertoken_plugin_api_userToken(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

/**
 * Frees a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO to free.
 */
void free_nexus_usertoken_plugin_api_userToken(struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

/**
 * Reads a UserTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userToken *xmlTextReaderReadApiUserTokenElement(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO, int writeNamespaces);

/**
 * Frees the children of a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO whose children are to be free.
 */
static void freeApiUserTokenElement(struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

/**
 * Reads a UserTokenXO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserTokenXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_userToken *xmlTextReaderReadApiUserTokenType(xmlTextReaderPtr reader);

/**
 * Writes a UserTokenXO to XML.
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteApiUserTokenType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

/**
 * Frees the elements of a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO to free.
 */
static void freeApiUserTokenType(struct nexus_usertoken_plugin_api_userToken *_userTokenXO);

#endif /* DEF_nexus_usertoken_plugin_api_userToken_H */
#ifndef DEF_nexus_usertoken_plugin_api_authToken_M
#define DEF_nexus_usertoken_plugin_api_authToken_M

/**
 * Reads a AuthTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The AuthTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_authToken *xml_read_nexus_usertoken_plugin_api_authToken(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadApiAuthTokenElement(reader);
}

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_usertoken_plugin_api_authToken(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  return xmlTextWriterWriteApiAuthTokenElementNS(writer, _authTokenXO, 1);
}

/**
 * Frees a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO to free.
 */
void free_nexus_usertoken_plugin_api_authToken(struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  freeApiAuthTokenType(_authTokenXO);
  free(_authTokenXO);
}

/**
 * Reads a AuthTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The AuthTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_authToken *xmlTextReaderReadApiAuthTokenElement(xmlTextReaderPtr reader) {
  struct nexus_usertoken_plugin_api_authToken *_authTokenXO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "authToken", xmlTextReaderConstLocalName(reader)) == 0
    && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken.\n");
#endif
    _authTokenXO = xmlTextReaderReadApiAuthTokenType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_authTokenXO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _authTokenXO;
}

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiAuthTokenElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  return xmlTextWriterWriteApiAuthTokenElementNS(writer, _authTokenXO, 0);
}

/**
 * Writes a AuthTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken".
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiAuthTokenElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "authToken", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  if (writeNamespaces) {
#if DEBUG_ENUNCIATE > 1
    printf("writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...\n");
#endif

    status = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("unable to write namespace attribute xmlns:api. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

#if DEBUG_ENUNCIATE > 1
  printf("writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken...\n");
#endif
  status = xmlTextWriterWriteApiAuthTokenType(writer, _authTokenXO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO whose children are to be free.
 */
static void freeApiAuthTokenElement(struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  freeApiAuthTokenType(_authTokenXO);
}

/**
 * Reads a AuthTokenXO from XML. The reader is assumed to be at the start element.
 *
 * @return the AuthTokenXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_authToken *xmlTextReaderReadApiAuthTokenType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_usertoken_plugin_api_authToken *_authTokenXO = calloc(1, sizeof(struct nexus_usertoken_plugin_api_authToken));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeApiAuthTokenType(_authTokenXO);
        free(_authTokenXO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "u", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}u of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}u of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiAuthTokenType(_authTokenXO);
          free(_authTokenXO);
          return NULL;
        }

        _authTokenXO->u = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "p", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}p of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}p of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiAuthTokenType(_authTokenXO);
          free(_authTokenXO);
          return NULL;
        }

        _authTokenXO->p = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}authToken. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _authTokenXO;
}

/**
 * Writes a AuthTokenXO to XML.
 *
 * @param writer The XML writer.
 * @param _authTokenXO The AuthTokenXO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteApiAuthTokenType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_authTokenXO->u != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "u", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}u. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}u...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authTokenXO->u));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}u. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}u. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_authTokenXO->p != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "p", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}p. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}p...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_authTokenXO->p));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}p. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}p. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a AuthTokenXO.
 *
 * @param _authTokenXO The AuthTokenXO to free.
 */
static void freeApiAuthTokenType(struct nexus_usertoken_plugin_api_authToken *_authTokenXO) {
  int i;
  if (_authTokenXO->u != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor u of type nexus_usertoken_plugin_api_authToken...\n");
#endif
    freeXsStringType(_authTokenXO->u);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor u of type nexus_usertoken_plugin_api_authToken...\n");
#endif
    free(_authTokenXO->u);
  }
  if (_authTokenXO->p != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor p of type nexus_usertoken_plugin_api_authToken...\n");
#endif
    freeXsStringType(_authTokenXO->p);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor p of type nexus_usertoken_plugin_api_authToken...\n");
#endif
    free(_authTokenXO->p);
  }
}
#endif /* DEF_nexus_usertoken_plugin_api_authToken_M */
#ifndef DEF_nexus_usertoken_plugin_api_settings_M
#define DEF_nexus_usertoken_plugin_api_settings_M

/**
 * Reads a SettingsXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_settings *xml_read_nexus_usertoken_plugin_api_settings(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadApiSettingsElement(reader);
}

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_usertoken_plugin_api_settings(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  return xmlTextWriterWriteApiSettingsElementNS(writer, _settingsXO, 1);
}

/**
 * Frees a SettingsXO.
 *
 * @param _settingsXO The SettingsXO to free.
 */
void free_nexus_usertoken_plugin_api_settings(struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  freeApiSettingsType(_settingsXO);
  free(_settingsXO);
}

/**
 * Reads a SettingsXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SettingsXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_settings *xmlTextReaderReadApiSettingsElement(xmlTextReaderPtr reader) {
  struct nexus_usertoken_plugin_api_settings *_settingsXO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "settings", xmlTextReaderConstLocalName(reader)) == 0
    && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings.\n");
#endif
    _settingsXO = xmlTextReaderReadApiSettingsType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_settingsXO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _settingsXO;
}

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiSettingsElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  return xmlTextWriterWriteApiSettingsElementNS(writer, _settingsXO, 0);
}

/**
 * Writes a SettingsXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings".
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiSettingsElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "settings", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  if (writeNamespaces) {
#if DEBUG_ENUNCIATE > 1
    printf("writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...\n");
#endif

    status = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("unable to write namespace attribute xmlns:api. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

#if DEBUG_ENUNCIATE > 1
  printf("writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings...\n");
#endif
  status = xmlTextWriterWriteApiSettingsType(writer, _settingsXO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SettingsXO.
 *
 * @param _settingsXO The SettingsXO whose children are to be free.
 */
static void freeApiSettingsElement(struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  freeApiSettingsType(_settingsXO);
}

/**
 * Reads a SettingsXO from XML. The reader is assumed to be at the start element.
 *
 * @return the SettingsXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_settings *xmlTextReaderReadApiSettingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_usertoken_plugin_api_settings *_settingsXO = calloc(1, sizeof(struct nexus_usertoken_plugin_api_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeApiSettingsType(_settingsXO);
        free(_settingsXO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiSettingsType(_settingsXO);
          free(_settingsXO);
          return NULL;
        }

        _settingsXO->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "protectContent", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}protectContent of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}protectContent of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiSettingsType(_settingsXO);
          free(_settingsXO);
          return NULL;
        }

        _settingsXO->protectContent = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "realmConfigured", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

          status = 1;
          if (xmlTextReaderMoveToAttributeNs(reader, BAD_CAST "nil", BAD_CAST "http://www.w3.org/2001/XMLSchema-instance")) {
            if (xmlStrcmp(BAD_CAST "true", xmlTextReaderConstValue(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
              printf("Choice {}realmConfigured was nil according to the xsi:nil attribute.\n");
#endif
              status = 0;
            }
          }

          xmlTextReaderMoveToElement(reader); //move back to the element
          if (status) { //if not "nil"...
#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}realmConfigured of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}realmConfigured of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiSettingsType(_settingsXO);
          free(_settingsXO);
          return NULL;
        }

        _settingsXO->realmConfigured = ((int*)_child_accessor);
          } //end "if not nil" clause
          else if (xmlTextReaderIsEmptyElement(reader) == 0) {
            //if it's not the empty element, skip it because it's nil.
            xmlTextReaderSkipElement(reader);
          }
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settingsXO;
}

/**
 * Writes a SettingsXO to XML.
 *
 * @param writer The XML writer.
 * @param _settingsXO The SettingsXO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteApiSettingsType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_settingsXO->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "protectContent", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}protectContent. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}protectContent...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_settingsXO->protectContent));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}protectContent. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}protectContent. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsXO->realmConfigured != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "realmConfigured", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}realmConfigured. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}realmConfigured...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, (_settingsXO->realmConfigured));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}realmConfigured. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}realmConfigured. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SettingsXO.
 *
 * @param _settingsXO The SettingsXO to free.
 */
static void freeApiSettingsType(struct nexus_usertoken_plugin_api_settings *_settingsXO) {
  int i;
  if (_settingsXO->realmConfigured != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor realmConfigured of type nexus_usertoken_plugin_api_settings...\n");
#endif
    freeXsBooleanType(_settingsXO->realmConfigured);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor realmConfigured of type nexus_usertoken_plugin_api_settings...\n");
#endif
    free(_settingsXO->realmConfigured);
  }
}
#endif /* DEF_nexus_usertoken_plugin_api_settings_M */
#ifndef DEF_nexus_usertoken_plugin_api_status_M
#define DEF_nexus_usertoken_plugin_api_status_M

/**
 * Reads a StatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_status *xml_read_nexus_usertoken_plugin_api_status(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadApiStatusElement(reader);
}

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_usertoken_plugin_api_status(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO) {
  return xmlTextWriterWriteApiStatusElementNS(writer, _statusXO, 1);
}

/**
 * Frees a StatusXO.
 *
 * @param _statusXO The StatusXO to free.
 */
void free_nexus_usertoken_plugin_api_status(struct nexus_usertoken_plugin_api_status *_statusXO) {
  freeApiStatusType(_statusXO);
  free(_statusXO);
}

/**
 * Reads a StatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The StatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_status *xmlTextReaderReadApiStatusElement(xmlTextReaderPtr reader) {
  struct nexus_usertoken_plugin_api_status *_statusXO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
    && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status.\n");
#endif
    _statusXO = xmlTextReaderReadApiStatusType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_statusXO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _statusXO;
}

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiStatusElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO) {
  return xmlTextWriterWriteApiStatusElementNS(writer, _statusXO, 0);
}

/**
 * Writes a StatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status".
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiStatusElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "status", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  if (writeNamespaces) {
#if DEBUG_ENUNCIATE > 1
    printf("writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...\n");
#endif

    status = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("unable to write namespace attribute xmlns:api. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

#if DEBUG_ENUNCIATE > 1
  printf("writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status...\n");
#endif
  status = xmlTextWriterWriteApiStatusType(writer, _statusXO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a StatusXO.
 *
 * @param _statusXO The StatusXO whose children are to be free.
 */
static void freeApiStatusElement(struct nexus_usertoken_plugin_api_status *_statusXO) {
  freeApiStatusType(_statusXO);
}

/**
 * Reads a StatusXO from XML. The reader is assumed to be at the start element.
 *
 * @return the StatusXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_status *xmlTextReaderReadApiStatusType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_usertoken_plugin_api_status *_statusXO = calloc(1, sizeof(struct nexus_usertoken_plugin_api_status));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeApiStatusType(_statusXO);
        free(_statusXO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiStatusType(_statusXO);
          free(_statusXO);
          return NULL;
        }

        _statusXO->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}status. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _statusXO;
}

/**
 * Writes a StatusXO to XML.
 *
 * @param writer The XML writer.
 * @param _statusXO The StatusXO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteApiStatusType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_status *_statusXO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_statusXO->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StatusXO.
 *
 * @param _statusXO The StatusXO to free.
 */
static void freeApiStatusType(struct nexus_usertoken_plugin_api_status *_statusXO) {
  int i;
}
#endif /* DEF_nexus_usertoken_plugin_api_status_M */
#ifndef DEF_nexus_usertoken_plugin_api_userTokenStatus_M
#define DEF_nexus_usertoken_plugin_api_userTokenStatus_M

/**
 * Reads a UserTokenStatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserTokenStatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userTokenStatus *xml_read_nexus_usertoken_plugin_api_userTokenStatus(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadApiUserTokenStatusElement(reader);
}

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_usertoken_plugin_api_userTokenStatus(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  return xmlTextWriterWriteApiUserTokenStatusElementNS(writer, _userTokenStatusXO, 1);
}

/**
 * Frees a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO to free.
 */
void free_nexus_usertoken_plugin_api_userTokenStatus(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  freeApiUserTokenStatusType(_userTokenStatusXO);
  free(_userTokenStatusXO);
}

/**
 * Reads a UserTokenStatusXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserTokenStatusXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userTokenStatus *xmlTextReaderReadApiUserTokenStatusElement(xmlTextReaderPtr reader) {
  struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userTokenStatus", xmlTextReaderConstLocalName(reader)) == 0
    && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus.\n");
#endif
    _userTokenStatusXO = xmlTextReaderReadApiUserTokenStatusType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userTokenStatusXO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userTokenStatusXO;
}

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiUserTokenStatusElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  return xmlTextWriterWriteApiUserTokenStatusElementNS(writer, _userTokenStatusXO, 0);
}

/**
 * Writes a UserTokenStatusXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus".
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiUserTokenStatusElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "userTokenStatus", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  if (writeNamespaces) {
#if DEBUG_ENUNCIATE > 1
    printf("writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...\n");
#endif

    status = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("unable to write namespace attribute xmlns:api. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

#if DEBUG_ENUNCIATE > 1
  printf("writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus...\n");
#endif
  status = xmlTextWriterWriteApiUserTokenStatusType(writer, _userTokenStatusXO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO whose children are to be free.
 */
static void freeApiUserTokenStatusElement(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  freeApiUserTokenStatusType(_userTokenStatusXO);
}

/**
 * Reads a UserTokenStatusXO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserTokenStatusXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_userTokenStatus *xmlTextReaderReadApiUserTokenStatusType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO = calloc(1, sizeof(struct nexus_usertoken_plugin_api_userTokenStatus));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeApiUserTokenStatusType(_userTokenStatusXO);
        free(_userTokenStatusXO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "provisioned", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}provisioned of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}provisioned of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiUserTokenStatusType(_userTokenStatusXO);
          free(_userTokenStatusXO);
          return NULL;
        }

        _userTokenStatusXO->provisioned = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "created", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

          status = 1;
          if (xmlTextReaderMoveToAttributeNs(reader, BAD_CAST "nil", BAD_CAST "http://www.w3.org/2001/XMLSchema-instance")) {
            if (xmlStrcmp(BAD_CAST "true", xmlTextReaderConstValue(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
              printf("Choice {}created was nil according to the xsi:nil attribute.\n");
#endif
              status = 0;
            }
          }

          xmlTextReaderMoveToElement(reader); //move back to the element
          if (status) { //if not "nil"...
#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiUserTokenStatusType(_userTokenStatusXO);
          free(_userTokenStatusXO);
          return NULL;
        }

        _userTokenStatusXO->created = ((xmlChar*)_child_accessor);
          } //end "if not nil" clause
          else if (xmlTextReaderIsEmptyElement(reader) == 0) {
            //if it's not the empty element, skip it because it's nil.
            xmlTextReaderSkipElement(reader);
          }
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userTokenStatus. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userTokenStatusXO;
}

/**
 * Writes a UserTokenStatusXO to XML.
 *
 * @param writer The XML writer.
 * @param _userTokenStatusXO The UserTokenStatusXO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteApiUserTokenStatusType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "provisioned", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}provisioned. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}provisioned...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_userTokenStatusXO->provisioned));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}provisioned. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}provisioned. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userTokenStatusXO->created != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "created", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}created...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userTokenStatusXO->created));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserTokenStatusXO.
 *
 * @param _userTokenStatusXO The UserTokenStatusXO to free.
 */
static void freeApiUserTokenStatusType(struct nexus_usertoken_plugin_api_userTokenStatus *_userTokenStatusXO) {
  int i;
  if (_userTokenStatusXO->created != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor created of type nexus_usertoken_plugin_api_userTokenStatus...\n");
#endif
    freeXsStringType(_userTokenStatusXO->created);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor created of type nexus_usertoken_plugin_api_userTokenStatus...\n");
#endif
    free(_userTokenStatusXO->created);
  }
}
#endif /* DEF_nexus_usertoken_plugin_api_userTokenStatus_M */
#ifndef DEF_nexus_usertoken_plugin_api_userToken_M
#define DEF_nexus_usertoken_plugin_api_userToken_M

/**
 * Reads a UserTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userToken *xml_read_nexus_usertoken_plugin_api_userToken(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadApiUserTokenElement(reader);
}

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_usertoken_plugin_api_userToken(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  return xmlTextWriterWriteApiUserTokenElementNS(writer, _userTokenXO, 1);
}

/**
 * Frees a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO to free.
 */
void free_nexus_usertoken_plugin_api_userToken(struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  freeApiUserTokenType(_userTokenXO);
  free(_userTokenXO);
}

/**
 * Reads a UserTokenXO element from XML. The element to be read is "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserTokenXO, or NULL in case of error.
 */
struct nexus_usertoken_plugin_api_userToken *xmlTextReaderReadApiUserTokenElement(xmlTextReaderPtr reader) {
  struct nexus_usertoken_plugin_api_userToken *_userTokenXO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userToken", xmlTextReaderConstLocalName(reader)) == 0
    && xmlStrcmp(BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0", xmlTextReaderConstNamespaceUri(reader)) == 0) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken.\n");
#endif
    _userTokenXO = xmlTextReaderReadApiUserTokenType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userTokenXO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userTokenXO;
}

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiUserTokenElement(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  return xmlTextWriterWriteApiUserTokenElementNS(writer, _userTokenXO, 0);
}

/**
 * Writes a UserTokenXO to XML under element name "{http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken".
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteApiUserTokenElementNS(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, BAD_CAST "api", BAD_CAST "userToken", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  if (writeNamespaces) {
#if DEBUG_ENUNCIATE > 1
    printf("writing namespaces for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...\n");
#endif

    status = xmlTextWriterWriteAttribute(writer, BAD_CAST "xmlns:api", BAD_CAST "http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0");
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("unable to write namespace attribute xmlns:api. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

#if DEBUG_ENUNCIATE > 1
  printf("writing type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken for root element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken...\n");
#endif
  status = xmlTextWriterWriteApiUserTokenType(writer, _userTokenXO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO whose children are to be free.
 */
static void freeApiUserTokenElement(struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  freeApiUserTokenType(_userTokenXO);
}

/**
 * Reads a UserTokenXO from XML. The reader is assumed to be at the start element.
 *
 * @return the UserTokenXO, or NULL in case of error.
 */
static struct nexus_usertoken_plugin_api_userToken *xmlTextReaderReadApiUserTokenType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_usertoken_plugin_api_userToken *_userTokenXO = calloc(1, sizeof(struct nexus_usertoken_plugin_api_userToken));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeApiUserTokenType(_userTokenXO);
        free(_userTokenXO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "nameCode", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}nameCode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}nameCode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiUserTokenType(_userTokenXO);
          free(_userTokenXO);
          return NULL;
        }

        _userTokenXO->nameCode = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "passCode", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}passCode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}passCode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiUserTokenType(_userTokenXO);
          free(_userTokenXO);
          return NULL;
        }

        _userTokenXO->passCode = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "created", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}created of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeApiUserTokenType(_userTokenXO);
          free(_userTokenXO);
          return NULL;
        }

        _userTokenXO->created = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {http://sonatype.com/xsd/nexus-usertoken-plugin/rest/1.0}userToken. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userTokenXO;
}

/**
 * Writes a UserTokenXO to XML.
 *
 * @param writer The XML writer.
 * @param _userTokenXO The UserTokenXO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteApiUserTokenType(xmlTextWriterPtr writer, struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userTokenXO->nameCode != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "nameCode", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}nameCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}nameCode...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userTokenXO->nameCode));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}nameCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}nameCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userTokenXO->passCode != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "passCode", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}passCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}passCode...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userTokenXO->passCode));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}passCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}passCode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userTokenXO->created != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "created", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}created...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userTokenXO->created));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}created. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserTokenXO.
 *
 * @param _userTokenXO The UserTokenXO to free.
 */
static void freeApiUserTokenType(struct nexus_usertoken_plugin_api_userToken *_userTokenXO) {
  int i;
  if (_userTokenXO->nameCode != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor nameCode of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    freeXsStringType(_userTokenXO->nameCode);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor nameCode of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    free(_userTokenXO->nameCode);
  }
  if (_userTokenXO->passCode != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor passCode of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    freeXsStringType(_userTokenXO->passCode);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor passCode of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    free(_userTokenXO->passCode);
  }
  if (_userTokenXO->created != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor created of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    freeXsStringType(_userTokenXO->created);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor created of type nexus_usertoken_plugin_api_userToken...\n");
#endif
    free(_userTokenXO->created);
  }
}
#endif /* DEF_nexus_usertoken_plugin_api_userToken_M */
