/*
 * Copyright (c) 2008-2012 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */

/*global $*/

var iframeLoaded = false;
$(document).ready(function() {
  "use strict";

  var
        // objects
        trialUrl = $('#trial-url').attr('href'),
        iframeContainer = $('#iframe-container'),
        iframe = iframeContainer.find('iframe'),
        query = {},
        // functions
        receiveMessage;

  $(window).bind("load resize", function() {
    iframeContainer.height($(window).height()-150);
  });

  iframeContainer.mask('Loading trial license request form...');

  receiveMessage = function(event) {
    // TODO if (!event.origin.contains("sonatype.com")) { return; }
    if (event.data === "trial-request-submitted") {
      window.location = "activate.html";
    } else if (event.data === "trial-request-loaded") {
      iframeLoaded = true;
      $('#iframe-container').unmask();
      $('#iframe-container iframe').show();
      $('#load-failed').hide();
    }
  };
  if (window.attachEvent) {
    // Internet Explorer
    window.attachEvent('onmessage',receiveMessage);
  } else {
    window.addEventListener("message", receiveMessage, false);
  }

  /**
   * Display error message when iframe fails to load or loads wrong content
   * (no 'trial-request-loaded' message)
   */
  window.setTimeout( function() {
          if ( !iframeLoaded ) {
            $('#iframe-container iframe').hide();
            $('#iframe-container').unmask();
            $('#load-failed').show();
          }
        },
        10000);

  if (window.location.search) {
    query.l = window.location.search.substring(1);
  }

  query.t = $.trim($('#bundle-type').text());

  // setting the src last to have message listeners in place before starting to load the content
  // l: current license id
  // t: bundle type
  iframe[0].src = trialUrl + '?t=' + query.t + (query.l ? '&l='+ query.l : '');
});

