//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_H
#define DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_H

/**
 *  Request wrapper object that contains the connection info

 */
struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *data;
};

/**
 * Reads a LdapAuthenticationTestRequest element from XML. The element to be read is "connectionInfoTest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapAuthenticationTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xml_read_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(xmlTextReaderPtr reader);

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

/**
 * Frees a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

/**
 * Reads a LdapAuthenticationTestRequest element from XML. The element to be read is "connectionInfoTest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapAuthenticationTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xmlTextReaderReadNs0ConnectionInfoTestElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ConnectionInfoTestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ConnectionInfoTestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest, int writeNamespaces);

/**
 * Frees the children of a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest whose children are to be free.
 */
static void freeNs0ConnectionInfoTestElement(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

/**
 * Reads a LdapAuthenticationTestRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapAuthenticationTestRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xmlTextReaderReadNs0LdapAuthenticationTestRequestType(xmlTextReaderPtr reader);

/**
 * Writes a LdapAuthenticationTestRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapAuthenticationTestRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

/**
 * Frees the elements of a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to free.
 */
static void freeNs0LdapAuthenticationTestRequestType(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_H
#define DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_H

/**
 *  LDAP Connection Information.
 
 @version $Revision$ $Date$

 */
struct enterprise_ldap_plugin_ns0_ldapConnectionInfo {


  /**
   * String
   */
  xmlChar *authScheme;

  /**
   * String
   */
  xmlChar *backupMirrorHost;

  /**
   * int
   */
  int backupMirrorPort;

  /**
   * String
   */
  xmlChar *backupMirrorProtocol;

  /**
   * int
   */
  int cacheTimeout;

  /**
   * int
   */
  int connectionRetryDelay;

  /**
   * int
   */
  int connectionTimeout;

  /**
   * String
   */
  xmlChar *host;

  /**
   * int
   */
  int port;

  /**
   * String
   */
  xmlChar *protocol;

  /**
   * String
   */
  xmlChar *realm;

  /**
   * String
   */
  xmlChar *searchBase;

  /**
   * String
   */
  xmlChar *systemPassword;

  /**
   * String
   */
  xmlChar *systemUsername;
};

/**
 * Reads a LdapConnectionInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapConnectionInfoDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *xmlTextReaderReadNs0LdapConnectionInfoType(xmlTextReaderPtr reader);

/**
 * Writes a LdapConnectionInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapConnectionInfoDTO The LdapConnectionInfoDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapConnectionInfoType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *_ldapConnectionInfoDTO);

/**
 * Frees the elements of a LdapConnectionInfoDTO.
 *
 * @param _ldapConnectionInfoDTO The LdapConnectionInfoDTO to free.
 */
static void freeNs0LdapConnectionInfoType(struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *_ldapConnectionInfoDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_H
#define DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_H

/**
 *  LDAP schema template object, contains defaults for a schema

 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate {


  /**
   * 
   */
  xmlChar *name;

  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *userAndGroupConfig;
};

/**
 * Reads a LdapSchemaTemplateDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *xmlTextReaderReadNs0LdapSchemaTemplateType(xmlTextReaderPtr reader);

/**
 * Writes a LdapSchemaTemplateDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateDTO The LdapSchemaTemplateDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapSchemaTemplateType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *_ldapSchemaTemplateDTO);

/**
 * Frees the elements of a LdapSchemaTemplateDTO.
 *
 * @param _ldapSchemaTemplateDTO The LdapSchemaTemplateDTO to free.
 */
static void freeNs0LdapSchemaTemplateType(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *_ldapSchemaTemplateDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_H
#define DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_H

/**
 *  Response wrapper object that contains the list of ldap schema templates

 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a LdapSchemaTemplateListResponse element from XML. The element to be read is "templateList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(xmlTextReaderPtr reader);

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

/**
 * Frees a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

/**
 * Reads a LdapSchemaTemplateListResponse element from XML. The element to be read is "templateList", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xmlTextReaderReadNs0TemplateListElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0TemplateListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0TemplateListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse, int writeNamespaces);

/**
 * Frees the children of a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse whose children are to be free.
 */
static void freeNs0TemplateListElement(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

/**
 * Reads a LdapSchemaTemplateListResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xmlTextReaderReadNs0LdapSchemaTemplateListResponseType(xmlTextReaderPtr reader);

/**
 * Writes a LdapSchemaTemplateListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapSchemaTemplateListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

/**
 * Frees the elements of a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to free.
 */
static void freeNs0LdapSchemaTemplateListResponseType(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_H

/**
 *  Object that holds the configuration of each configured LDAP
 server.
 
 @version $Revision$ $Date$

 */
struct enterprise_ldap_plugin_ns0_ldapServerConfiguration {


  /**
   * CConnectionInfo
   */
  struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *connectionInfo;

  /**
   * String
   */
  xmlChar *id;

  /**
   * String
   */
  xmlChar *url;

  /**
   * String
   */
  xmlChar *name;

  /**
   * CUserAndGroupAuthConfiguration
   */
  struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *userAndGroupConfig;
};

/**
 * Reads a LdapServerConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *xmlTextReaderReadNs0LdapServerConfigurationType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerConfigurationDTO The LdapServerConfigurationDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerConfigurationType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *_ldapServerConfigurationDTO);

/**
 * Frees the elements of a LdapServerConfigurationDTO.
 *
 * @param _ldapServerConfigurationDTO The LdapServerConfigurationDTO to free.
 */
static void freeNs0LdapServerConfigurationType(struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *_ldapServerConfigurationDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_H

/**
 *  List entry of an ldap server.

 */
struct enterprise_ldap_plugin_ns0_ldapServerListEntry {


  /**
   * 
   */
  xmlChar *id;

  /**
   * 
   */
  xmlChar *name;

  /**
   * 
   */
  xmlChar *url;

  /**
   * 
   */
  xmlChar *ldapUrl;
};

/**
 * Reads a LdapServerListEntryDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerListEntryDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerListEntry *xmlTextReaderReadNs0LdapServerListEntryType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerListEntryDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerListEntryDTO The LdapServerListEntryDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerListEntryType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListEntry *_ldapServerListEntryDTO);

/**
 * Frees the elements of a LdapServerListEntryDTO.
 *
 * @param _ldapServerListEntryDTO The LdapServerListEntryDTO to free.
 */
static void freeNs0LdapServerListEntryType(struct enterprise_ldap_plugin_ns0_ldapServerListEntry *_ldapServerListEntryDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_H

/**
 *  Response wrapper object that contains the list of ldap servers.

 */
struct enterprise_ldap_plugin_ns0_ldapServerListResponse {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapServerListEntry *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a LdapServerListResponse element from XML. The element to be read is "serverList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapServerListResponse(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

/**
 * Frees a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerListResponse(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

/**
 * Reads a LdapServerListResponse element from XML. The element to be read is "serverList", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapServerListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xmlTextReaderReadNs0ServerListElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ServerListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ServerListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse, int writeNamespaces);

/**
 * Frees the children of a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse whose children are to be free.
 */
static void freeNs0ServerListElement(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

/**
 * Reads a LdapServerListResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xmlTextReaderReadNs0LdapServerListResponseType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

/**
 * Frees the elements of a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse to free.
 */
static void freeNs0LdapServerListResponseType(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_H

/**
 *  Ldap Server login test parameters.

 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTest {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *configuration;

  /**
   * 
   */
  xmlChar *username;

  /**
   * 
   */
  xmlChar *password;
};

/**
 * Reads a LdapServerLoginTestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *xmlTextReaderReadNs0LdapServerLoginTestType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerLoginTestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestDTO The LdapServerLoginTestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerLoginTestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *_ldapServerLoginTestDTO);

/**
 * Frees the elements of a LdapServerLoginTestDTO.
 *
 * @param _ldapServerLoginTestDTO The LdapServerLoginTestDTO to free.
 */
static void freeNs0LdapServerLoginTestType(struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *_ldapServerLoginTestDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_H

/**
 *  Request wrapper object that contains the ldap login test details.

 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *data;
};

/**
 * Reads a LdapServerLoginTestRequest element from XML. The element to be read is "loginTestRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

/**
 * Frees a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

/**
 * Reads a LdapServerLoginTestRequest element from XML. The element to be read is "loginTestRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xmlTextReaderReadNs0LoginTestRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LoginTestRequestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LoginTestRequestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest, int writeNamespaces);

/**
 * Frees the children of a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest whose children are to be free.
 */
static void freeNs0LoginTestRequestElement(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

/**
 * Reads a LdapServerLoginTestRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xmlTextReaderReadNs0LdapServerLoginTestRequestType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerLoginTestRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerLoginTestRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

/**
 * Frees the elements of a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to free.
 */
static void freeNs0LdapServerLoginTestRequestType(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_H

/**
 *  Request wrapper object that contains the ordered list of ldap server ids.

 */
struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest {


  /**
   * 
   */
  xmlChar *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a LdapServerOrderRequest element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerOrderRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

/**
 * Frees a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

/**
 * Reads a LdapServerOrderRequest element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapServerOrderRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xmlTextReaderReadNs0OrderRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0OrderRequestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0OrderRequestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest, int writeNamespaces);

/**
 * Frees the children of a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest whose children are to be free.
 */
static void freeNs0OrderRequestElement(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

/**
 * Reads a LdapServerOrderRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerOrderRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xmlTextReaderReadNs0LdapServerOrderRequestType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerOrderRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerOrderRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

/**
 * Frees the elements of a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to free.
 */
static void freeNs0LdapServerOrderRequestType(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_H
#define DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_H

/**
 *  Request wrapper for setting up an ldap server configuration.

 */
struct enterprise_ldap_plugin_ns0_ldapServerRequest {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *data;
};

/**
 * Reads a LdapServerRequest element from XML. The element to be read is "server", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerRequest(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerRequest to XML under element name "server".
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

/**
 * Frees a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerRequest(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

/**
 * Reads a LdapServerRequest element from XML. The element to be read is "server", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapServerRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerRequest *xmlTextReaderReadNs0ServerElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerRequest to XML under element name "server".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ServerElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

/**
 * Writes a LdapServerRequest to XML under element name "server".
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ServerElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest, int writeNamespaces);

/**
 * Frees the children of a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest whose children are to be free.
 */
static void freeNs0ServerElement(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

/**
 * Reads a LdapServerRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapServerRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerRequest *xmlTextReaderReadNs0LdapServerRequestType(xmlTextReaderPtr reader);

/**
 * Writes a LdapServerRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapServerRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

/**
 * Frees the elements of a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest to free.
 */
static void freeNs0LdapServerRequestType(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_H
#define DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_H

/**
 *  The user and group mapping configuration mapping.

 */
struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration {


  /**
   * Get email Address Attribute.  The attribute that stores the
users email address.
   */
  xmlChar *emailAddressAttribute;

  /**
   * Get group Base DN.  The base DN that defines Groups.
   */
  xmlChar *groupBaseDn;

  /**
   * Get group Id Attribute. The ID attribute for the Group.
   */
  xmlChar *groupIdAttribute;

  /**
   * Get group Member Attribute,  An attribute that defines the a
user is a member of the group.
   */
  xmlChar *groupMemberAttribute;

  /**
   * Get group Member Format. The format that the user info is
stored in the groupMappingsAttribute.  Such as ${username},
or uid=${username},ou=people,o=yourBiz.  ${username} will be
replaced with the username.
   */
  xmlChar *groupMemberFormat;

  /**
   * Get group Object Class. The Object class used for groups.
   */
  xmlChar *groupObjectClass;

  /**
   * Get user Base DN. The base DN for the users.
   */
  xmlChar *userBaseDn;

  /**
   * Get user Id Attribute.  THe attribute of the userId field.
   */
  xmlChar *userIdAttribute;

  /**
   * Get groups are generally one of two types in LDAP systems -
static or dynamic. A static group maintains its own
membership list. A dynamic group records its membership on a
user entry. If dynamic groups this should be set to the
attribute used to store the group string in the user object.
   */
  xmlChar *userMemberOfAttribute;

  /**
   * Get user Object Class.  The object class used for users.
   */
  xmlChar *userObjectClass;

  /**
   * Get user Password Attribute.  The attribute that stores the
users password.
   */
  xmlChar *userPasswordAttribute;

  /**
   * Get user Real Name Attribute.  The attribute that defines
the users real name.
   */
  xmlChar *userRealNameAttribute;

  /**
   * Get groups are Stored in a subtree of the groupBaseDn.
   */
  int groupSubtree;

  /**
   * Get use LDAP groups as roles.  True if LDAP groups should be
used as roles.
   */
  int ldapGroupsAsRoles;

  /**
   * Get users are Stored in a subtree of the userBaseDn.
   */
  int userSubtree;

  /**
   * Return the filter expression added to the user search.
<p/>
Example: (&(mail=*@domain.com)(uid=user_*)
   */
  xmlChar *ldapFilter;
};

/**
 * Reads a LdapUserAndGroupAuthConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapUserAndGroupAuthConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *xmlTextReaderReadNs0LdapUserAndGroupAuthConfigurationType(xmlTextReaderPtr reader);

/**
 * Writes a LdapUserAndGroupAuthConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserAndGroupAuthConfigurationDTO The LdapUserAndGroupAuthConfigurationDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapUserAndGroupAuthConfigurationType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *_ldapUserAndGroupAuthConfigurationDTO);

/**
 * Frees the elements of a LdapUserAndGroupAuthConfigurationDTO.
 *
 * @param _ldapUserAndGroupAuthConfigurationDTO The LdapUserAndGroupAuthConfigurationDTO to free.
 */
static void freeNs0LdapUserAndGroupAuthConfigurationType(struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *_ldapUserAndGroupAuthConfigurationDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUser_H
#define DEF_enterprise_ldap_plugin_ns0_ldapUser_H

/**
 *  Ldap User details.

 */
struct enterprise_ldap_plugin_ns0_ldapUser {


  /**
   * the userId
   */
  xmlChar *userId;

  /**
   * the roles
   */
  xmlChar *roles;

  /**
   * Size of the roles array.
   */
  int _sizeof_roles;

  /**
   * the name
   */
  xmlChar *name;

  /**
   * the email
   */
  xmlChar *email;
};

/**
 * Reads a LdapUserDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapUserDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUser *xmlTextReaderReadNs0LdapUserType(xmlTextReaderPtr reader);

/**
 * Writes a LdapUserDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserDTO The LdapUserDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapUserType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUser *_ldapUserDTO);

/**
 * Frees the elements of a LdapUserDTO.
 *
 * @param _ldapUserDTO The LdapUserDTO to free.
 */
static void freeNs0LdapUserType(struct enterprise_ldap_plugin_ns0_ldapUser *_ldapUserDTO);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUser_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_H
#define DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_H

/**
 *  Response wrapper that contains the list of ldap users.

 */
struct enterprise_ldap_plugin_ns0_ldapUserListResponse {


  /**
   * 
   */
  struct enterprise_ldap_plugin_ns0_ldapUser *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a LdapUserListResponse element from XML. The element to be read is "userList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapUserListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapUserListResponse(xmlTextReaderPtr reader);

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapUserListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

/**
 * Frees a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapUserListResponse(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

/**
 * Reads a LdapUserListResponse element from XML. The element to be read is "userList", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The LdapUserListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xmlTextReaderReadNs0UserListElement(xmlTextReaderPtr reader);

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse, int writeNamespaces);

/**
 * Frees the children of a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse whose children are to be free.
 */
static void freeNs0UserListElement(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

/**
 * Reads a LdapUserListResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The LdapUserListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xmlTextReaderReadNs0LdapUserListResponseType(xmlTextReaderPtr reader);

/**
 * Writes a LdapUserListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0LdapUserListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

/**
 * Frees the elements of a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse to free.
 */
static void freeNs0LdapUserListResponseType(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse);

#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_H */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_M
#define DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_M

/**
 * Reads a LdapAuthenticationTestRequest element from XML. The element to be read is "connectionInfoTest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapAuthenticationTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xml_read_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ConnectionInfoTestElement(reader);
}

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  return xmlTextWriterWriteNs0ConnectionInfoTestElementNS(writer, _ldapAuthenticationTestRequest, 1);
}

/**
 * Frees a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  freeNs0LdapAuthenticationTestRequestType(_ldapAuthenticationTestRequest);
  free(_ldapAuthenticationTestRequest);
}

/**
 * Reads a LdapAuthenticationTestRequest element from XML. The element to be read is "connectionInfoTest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapAuthenticationTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xmlTextReaderReadNs0ConnectionInfoTestElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "connectionInfoTest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}connectionInfoTest.\n");
#endif
    _ldapAuthenticationTestRequest = xmlTextReaderReadNs0LdapAuthenticationTestRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapAuthenticationTestRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}connectionInfoTest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}connectionInfoTest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapAuthenticationTestRequest;
}

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ConnectionInfoTestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  return xmlTextWriterWriteNs0ConnectionInfoTestElementNS(writer, _ldapAuthenticationTestRequest, 0);
}

/**
 * Writes a LdapAuthenticationTestRequest to XML under element name "connectionInfoTest".
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ConnectionInfoTestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "connectionInfoTest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}connectionInfoTest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapAuthenticationTestRequest for root element {}connectionInfoTest...\n");
#endif
  status = xmlTextWriterWriteNs0LdapAuthenticationTestRequestType(writer, _ldapAuthenticationTestRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}connectionInfoTest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}connectionInfoTest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest whose children are to be free.
 */
static void freeNs0ConnectionInfoTestElement(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  freeNs0LdapAuthenticationTestRequestType(_ldapAuthenticationTestRequest);
}

/**
 * Reads a LdapAuthenticationTestRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapAuthenticationTestRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *xmlTextReaderReadNs0LdapAuthenticationTestRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapAuthenticationTestRequestType(_ldapAuthenticationTestRequest);
        free(_ldapAuthenticationTestRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}ldapConnectionInfo.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapConnectionInfoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}ldapConnectionInfo.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapAuthenticationTestRequestType(_ldapAuthenticationTestRequest);
          free(_ldapAuthenticationTestRequest);
          return NULL;
        }

        _ldapAuthenticationTestRequest->data = ((struct enterprise_ldap_plugin_ns0_ldapConnectionInfo*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapAuthenticationTestRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapAuthenticationTestRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapAuthenticationTestRequest;
}

/**
 * Writes a LdapAuthenticationTestRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapAuthenticationTestRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapAuthenticationTestRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapConnectionInfo for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapConnectionInfoType(writer, (_ldapAuthenticationTestRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapConnectionInfo for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapAuthenticationTestRequest.
 *
 * @param _ldapAuthenticationTestRequest The LdapAuthenticationTestRequest to free.
 */
static void freeNs0LdapAuthenticationTestRequestType(struct enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest *_ldapAuthenticationTestRequest) {
  int i;
  if (_ldapAuthenticationTestRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest...\n");
#endif
    freeNs0LdapConnectionInfoType(_ldapAuthenticationTestRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest...\n");
#endif
    free(_ldapAuthenticationTestRequest->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapAuthenticationTestRequest_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_M
#define DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_M

/**
 * Reads a LdapConnectionInfoDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapConnectionInfoDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *xmlTextReaderReadNs0LdapConnectionInfoType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *_ldapConnectionInfoDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapConnectionInfo));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
        free(_ldapConnectionInfoDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "authScheme", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}authScheme of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}authScheme of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->authScheme = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "backupMirrorHost", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}backupMirrorHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}backupMirrorHost of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->backupMirrorHost = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "backupMirrorPort", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}backupMirrorPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}backupMirrorPort of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->backupMirrorPort = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "backupMirrorProtocol", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}backupMirrorProtocol of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}backupMirrorProtocol of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->backupMirrorProtocol = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "cacheTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}cacheTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}cacheTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->cacheTimeout = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "connectionRetryDelay", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}connectionRetryDelay of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}connectionRetryDelay of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->connectionRetryDelay = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "connectionTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}connectionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}connectionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->connectionTimeout = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "protocol", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}protocol of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}protocol of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->protocol = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "realm", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}realm of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}realm of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->realm = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "searchBase", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}searchBase of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}searchBase of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->searchBase = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "systemPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}systemPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}systemPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->systemPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "systemUsername", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}systemUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}systemUsername of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapConnectionInfoType(_ldapConnectionInfoDTO);
          free(_ldapConnectionInfoDTO);
          return NULL;
        }

        _ldapConnectionInfoDTO->systemUsername = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapConnectionInfo.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapConnectionInfo. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapConnectionInfoDTO;
}

/**
 * Writes a LdapConnectionInfoDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapConnectionInfoDTO The LdapConnectionInfoDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapConnectionInfoType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *_ldapConnectionInfoDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapConnectionInfoDTO->authScheme != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "authScheme", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}authScheme. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}authScheme...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->authScheme));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}authScheme. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}authScheme. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->backupMirrorHost != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "backupMirrorHost", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}backupMirrorHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}backupMirrorHost...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->backupMirrorHost));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}backupMirrorHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}backupMirrorHost. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "backupMirrorPort", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}backupMirrorPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}backupMirrorPort...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_ldapConnectionInfoDTO->backupMirrorPort));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}backupMirrorPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}backupMirrorPort. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->backupMirrorProtocol != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "backupMirrorProtocol", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}backupMirrorProtocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}backupMirrorProtocol...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->backupMirrorProtocol));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}backupMirrorProtocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}backupMirrorProtocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "cacheTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}cacheTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}cacheTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_ldapConnectionInfoDTO->cacheTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}cacheTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}cacheTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "connectionRetryDelay", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}connectionRetryDelay. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}connectionRetryDelay...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_ldapConnectionInfoDTO->connectionRetryDelay));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}connectionRetryDelay. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}connectionRetryDelay. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "connectionTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}connectionTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_ldapConnectionInfoDTO->connectionTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}connectionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_ldapConnectionInfoDTO->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->protocol != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "protocol", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}protocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}protocol...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->protocol));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}protocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}protocol. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->realm != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "realm", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}realm. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}realm...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->realm));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}realm. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}realm. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->searchBase != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "searchBase", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}searchBase. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}searchBase...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->searchBase));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}searchBase. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}searchBase. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->systemPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "systemPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}systemPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}systemPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->systemPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}systemPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}systemPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapConnectionInfoDTO->systemUsername != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "systemUsername", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}systemUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}systemUsername...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapConnectionInfoDTO->systemUsername));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}systemUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}systemUsername. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapConnectionInfoDTO.
 *
 * @param _ldapConnectionInfoDTO The LdapConnectionInfoDTO to free.
 */
static void freeNs0LdapConnectionInfoType(struct enterprise_ldap_plugin_ns0_ldapConnectionInfo *_ldapConnectionInfoDTO) {
  int i;
  if (_ldapConnectionInfoDTO->authScheme != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor authScheme of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->authScheme);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor authScheme of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->authScheme);
  }
  if (_ldapConnectionInfoDTO->backupMirrorHost != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor backupMirrorHost of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->backupMirrorHost);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor backupMirrorHost of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->backupMirrorHost);
  }
  if (_ldapConnectionInfoDTO->backupMirrorProtocol != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor backupMirrorProtocol of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->backupMirrorProtocol);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor backupMirrorProtocol of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->backupMirrorProtocol);
  }
  if (_ldapConnectionInfoDTO->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->host);
  }
  if (_ldapConnectionInfoDTO->protocol != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor protocol of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->protocol);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor protocol of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->protocol);
  }
  if (_ldapConnectionInfoDTO->realm != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor realm of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->realm);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor realm of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->realm);
  }
  if (_ldapConnectionInfoDTO->searchBase != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor searchBase of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->searchBase);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor searchBase of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->searchBase);
  }
  if (_ldapConnectionInfoDTO->systemPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor systemPassword of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->systemPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor systemPassword of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->systemPassword);
  }
  if (_ldapConnectionInfoDTO->systemUsername != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor systemUsername of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    freeXsStringType(_ldapConnectionInfoDTO->systemUsername);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor systemUsername of type enterprise_ldap_plugin_ns0_ldapConnectionInfo...\n");
#endif
    free(_ldapConnectionInfoDTO->systemUsername);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapConnectionInfo_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_M
#define DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_M

/**
 * Reads a LdapSchemaTemplateDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapSchemaTemplateDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *xmlTextReaderReadNs0LdapSchemaTemplateType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *_ldapSchemaTemplateDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapSchemaTemplateType(_ldapSchemaTemplateDTO);
        free(_ldapSchemaTemplateDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapSchemaTemplateType(_ldapSchemaTemplateDTO);
          free(_ldapSchemaTemplateDTO);
          return NULL;
        }

        _ldapSchemaTemplateDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userAndGroupConfig", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userAndGroupConfig of type {}ldapUserAndGroupAuthConfiguration.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapUserAndGroupAuthConfigurationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userAndGroupConfig of type {}ldapUserAndGroupAuthConfiguration.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapSchemaTemplateType(_ldapSchemaTemplateDTO);
          free(_ldapSchemaTemplateDTO);
          return NULL;
        }

        _ldapSchemaTemplateDTO->userAndGroupConfig = ((struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapSchemaTemplate.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapSchemaTemplate. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapSchemaTemplateDTO;
}

/**
 * Writes a LdapSchemaTemplateDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateDTO The LdapSchemaTemplateDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapSchemaTemplateType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *_ldapSchemaTemplateDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapSchemaTemplateDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapSchemaTemplateDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapSchemaTemplateDTO->userAndGroupConfig != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAndGroupConfig", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapUserAndGroupAuthConfiguration for element {}userAndGroupConfig...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapUserAndGroupAuthConfigurationType(writer, (_ldapSchemaTemplateDTO->userAndGroupConfig));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapUserAndGroupAuthConfiguration for element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapSchemaTemplateDTO.
 *
 * @param _ldapSchemaTemplateDTO The LdapSchemaTemplateDTO to free.
 */
static void freeNs0LdapSchemaTemplateType(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate *_ldapSchemaTemplateDTO) {
  int i;
  if (_ldapSchemaTemplateDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type enterprise_ldap_plugin_ns0_ldapSchemaTemplate...\n");
#endif
    freeXsStringType(_ldapSchemaTemplateDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type enterprise_ldap_plugin_ns0_ldapSchemaTemplate...\n");
#endif
    free(_ldapSchemaTemplateDTO->name);
  }
  if (_ldapSchemaTemplateDTO->userAndGroupConfig != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userAndGroupConfig of type enterprise_ldap_plugin_ns0_ldapSchemaTemplate...\n");
#endif
    freeNs0LdapUserAndGroupAuthConfigurationType(_ldapSchemaTemplateDTO->userAndGroupConfig);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userAndGroupConfig of type enterprise_ldap_plugin_ns0_ldapSchemaTemplate...\n");
#endif
    free(_ldapSchemaTemplateDTO->userAndGroupConfig);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplate_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_M
#define DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_M

/**
 * Reads a LdapSchemaTemplateListResponse element from XML. The element to be read is "templateList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0TemplateListElement(reader);
}

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  return xmlTextWriterWriteNs0TemplateListElementNS(writer, _ldapSchemaTemplateListResponse, 1);
}

/**
 * Frees a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
  free(_ldapSchemaTemplateListResponse);
}

/**
 * Reads a LdapSchemaTemplateListResponse element from XML. The element to be read is "templateList", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapSchemaTemplateListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xmlTextReaderReadNs0TemplateListElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "templateList", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}templateList.\n");
#endif
    _ldapSchemaTemplateListResponse = xmlTextReaderReadNs0LdapSchemaTemplateListResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapSchemaTemplateListResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}templateList failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}templateList failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapSchemaTemplateListResponse;
}

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0TemplateListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  return xmlTextWriterWriteNs0TemplateListElementNS(writer, _ldapSchemaTemplateListResponse, 0);
}

/**
 * Writes a LdapSchemaTemplateListResponse to XML under element name "templateList".
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0TemplateListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "templateList", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}templateList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapSchemaTemplateListResponse for root element {}templateList...\n");
#endif
  status = xmlTextWriterWriteNs0LdapSchemaTemplateListResponseType(writer, _ldapSchemaTemplateListResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}templateList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}templateList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse whose children are to be free.
 */
static void freeNs0TemplateListElement(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
}

/**
 * Reads a LdapSchemaTemplateListResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapSchemaTemplateListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *xmlTextReaderReadNs0LdapSchemaTemplateListResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
        free(_ldapSchemaTemplateListResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
              free(_ldapSchemaTemplateListResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapSchemaTemplate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapSchemaTemplate of type {}ldapSchemaTemplate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapSchemaTemplateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapSchemaTemplate of type {}ldapSchemaTemplate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
          free(_ldapSchemaTemplateListResponse);
          return NULL;
        }

        _ldapSchemaTemplateListResponse->data = realloc(_ldapSchemaTemplateListResponse->data, (_ldapSchemaTemplateListResponse->_sizeof_data + 1) * sizeof(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate));
        memcpy(&(_ldapSchemaTemplateListResponse->data[_ldapSchemaTemplateListResponse->_sizeof_data++]), _child_accessor, sizeof(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplate));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0LdapSchemaTemplateListResponseType(_ldapSchemaTemplateListResponse);
          free(_ldapSchemaTemplateListResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapSchemaTemplateListResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapSchemaTemplateListResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapSchemaTemplateListResponse;
}

/**
 * Writes a LdapSchemaTemplateListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapSchemaTemplateListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_ldapSchemaTemplateListResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _ldapSchemaTemplateListResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapSchemaTemplate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapSchemaTemplate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapSchemaTemplate for element {}ldapSchemaTemplate...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapSchemaTemplateType(writer, &(_ldapSchemaTemplateListResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapSchemaTemplate for element {}ldapSchemaTemplate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapSchemaTemplate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_ldapSchemaTemplateListResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapSchemaTemplateListResponse.
 *
 * @param _ldapSchemaTemplateListResponse The LdapSchemaTemplateListResponse to free.
 */
static void freeNs0LdapSchemaTemplateListResponseType(struct enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse *_ldapSchemaTemplateListResponse) {
  int i;
  if (_ldapSchemaTemplateListResponse->data != NULL) {
    for (i = 0; i < _ldapSchemaTemplateListResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse...\n", i);
#endif
      freeNs0LdapSchemaTemplateType(&(_ldapSchemaTemplateListResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse...\n");
#endif
    free(_ldapSchemaTemplateListResponse->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapSchemaTemplateListResponse_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_M

/**
 * Reads a LdapServerConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *xmlTextReaderReadNs0LdapServerConfigurationType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *_ldapServerConfigurationDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerConfiguration));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
        free(_ldapServerConfigurationDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "connectionInfo", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}connectionInfo of type {}ldapConnectionInfo.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapConnectionInfoType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}connectionInfo of type {}ldapConnectionInfo.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
          free(_ldapServerConfigurationDTO);
          return NULL;
        }

        _ldapServerConfigurationDTO->connectionInfo = ((struct enterprise_ldap_plugin_ns0_ldapConnectionInfo*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
          free(_ldapServerConfigurationDTO);
          return NULL;
        }

        _ldapServerConfigurationDTO->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "url", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
          free(_ldapServerConfigurationDTO);
          return NULL;
        }

        _ldapServerConfigurationDTO->url = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
          free(_ldapServerConfigurationDTO);
          return NULL;
        }

        _ldapServerConfigurationDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userAndGroupConfig", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userAndGroupConfig of type {}ldapUserAndGroupAuthConfiguration.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapUserAndGroupAuthConfigurationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userAndGroupConfig of type {}ldapUserAndGroupAuthConfiguration.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerConfigurationType(_ldapServerConfigurationDTO);
          free(_ldapServerConfigurationDTO);
          return NULL;
        }

        _ldapServerConfigurationDTO->userAndGroupConfig = ((struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerConfiguration.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerConfiguration. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerConfigurationDTO;
}

/**
 * Writes a LdapServerConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerConfigurationDTO The LdapServerConfigurationDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerConfigurationType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *_ldapServerConfigurationDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapServerConfigurationDTO->connectionInfo != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "connectionInfo", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}connectionInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapConnectionInfo for element {}connectionInfo...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapConnectionInfoType(writer, (_ldapServerConfigurationDTO->connectionInfo));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapConnectionInfo for element {}connectionInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}connectionInfo. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerConfigurationDTO->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerConfigurationDTO->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerConfigurationDTO->url != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "url", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}url...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerConfigurationDTO->url));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerConfigurationDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerConfigurationDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerConfigurationDTO->userAndGroupConfig != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userAndGroupConfig", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapUserAndGroupAuthConfiguration for element {}userAndGroupConfig...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapUserAndGroupAuthConfigurationType(writer, (_ldapServerConfigurationDTO->userAndGroupConfig));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapUserAndGroupAuthConfiguration for element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userAndGroupConfig. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerConfigurationDTO.
 *
 * @param _ldapServerConfigurationDTO The LdapServerConfigurationDTO to free.
 */
static void freeNs0LdapServerConfigurationType(struct enterprise_ldap_plugin_ns0_ldapServerConfiguration *_ldapServerConfigurationDTO) {
  int i;
  if (_ldapServerConfigurationDTO->connectionInfo != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor connectionInfo of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    freeNs0LdapConnectionInfoType(_ldapServerConfigurationDTO->connectionInfo);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor connectionInfo of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    free(_ldapServerConfigurationDTO->connectionInfo);
  }
  if (_ldapServerConfigurationDTO->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    freeXsStringType(_ldapServerConfigurationDTO->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    free(_ldapServerConfigurationDTO->id);
  }
  if (_ldapServerConfigurationDTO->url != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor url of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    freeXsStringType(_ldapServerConfigurationDTO->url);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor url of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    free(_ldapServerConfigurationDTO->url);
  }
  if (_ldapServerConfigurationDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    freeXsStringType(_ldapServerConfigurationDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    free(_ldapServerConfigurationDTO->name);
  }
  if (_ldapServerConfigurationDTO->userAndGroupConfig != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userAndGroupConfig of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    freeNs0LdapUserAndGroupAuthConfigurationType(_ldapServerConfigurationDTO->userAndGroupConfig);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userAndGroupConfig of type enterprise_ldap_plugin_ns0_ldapServerConfiguration...\n");
#endif
    free(_ldapServerConfigurationDTO->userAndGroupConfig);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerConfiguration_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_M

/**
 * Reads a LdapServerListEntryDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerListEntryDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerListEntry *xmlTextReaderReadNs0LdapServerListEntryType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerListEntry *_ldapServerListEntryDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerListEntry));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerListEntryType(_ldapServerListEntryDTO);
        free(_ldapServerListEntryDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerListEntryType(_ldapServerListEntryDTO);
          free(_ldapServerListEntryDTO);
          return NULL;
        }

        _ldapServerListEntryDTO->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerListEntryType(_ldapServerListEntryDTO);
          free(_ldapServerListEntryDTO);
          return NULL;
        }

        _ldapServerListEntryDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "url", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}url of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerListEntryType(_ldapServerListEntryDTO);
          free(_ldapServerListEntryDTO);
          return NULL;
        }

        _ldapServerListEntryDTO->url = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapUrl", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapUrl of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerListEntryType(_ldapServerListEntryDTO);
          free(_ldapServerListEntryDTO);
          return NULL;
        }

        _ldapServerListEntryDTO->ldapUrl = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerListEntry.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerListEntry. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerListEntryDTO;
}

/**
 * Writes a LdapServerListEntryDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerListEntryDTO The LdapServerListEntryDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerListEntryType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListEntry *_ldapServerListEntryDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapServerListEntryDTO->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerListEntryDTO->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerListEntryDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerListEntryDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerListEntryDTO->url != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "url", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}url...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerListEntryDTO->url));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}url. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerListEntryDTO->ldapUrl != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapUrl", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ldapUrl...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerListEntryDTO->ldapUrl));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ldapUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapUrl. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerListEntryDTO.
 *
 * @param _ldapServerListEntryDTO The LdapServerListEntryDTO to free.
 */
static void freeNs0LdapServerListEntryType(struct enterprise_ldap_plugin_ns0_ldapServerListEntry *_ldapServerListEntryDTO) {
  int i;
  if (_ldapServerListEntryDTO->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    freeXsStringType(_ldapServerListEntryDTO->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    free(_ldapServerListEntryDTO->id);
  }
  if (_ldapServerListEntryDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    freeXsStringType(_ldapServerListEntryDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    free(_ldapServerListEntryDTO->name);
  }
  if (_ldapServerListEntryDTO->url != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor url of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    freeXsStringType(_ldapServerListEntryDTO->url);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor url of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    free(_ldapServerListEntryDTO->url);
  }
  if (_ldapServerListEntryDTO->ldapUrl != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ldapUrl of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    freeXsStringType(_ldapServerListEntryDTO->ldapUrl);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ldapUrl of type enterprise_ldap_plugin_ns0_ldapServerListEntry...\n");
#endif
    free(_ldapServerListEntryDTO->ldapUrl);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerListEntry_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_M

/**
 * Reads a LdapServerListResponse element from XML. The element to be read is "serverList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapServerListResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ServerListElement(reader);
}

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  return xmlTextWriterWriteNs0ServerListElementNS(writer, _ldapServerListResponse, 1);
}

/**
 * Frees a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerListResponse(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  freeNs0LdapServerListResponseType(_ldapServerListResponse);
  free(_ldapServerListResponse);
}

/**
 * Reads a LdapServerListResponse element from XML. The element to be read is "serverList", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapServerListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xmlTextReaderReadNs0ServerListElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "serverList", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}serverList.\n");
#endif
    _ldapServerListResponse = xmlTextReaderReadNs0LdapServerListResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapServerListResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}serverList failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}serverList failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapServerListResponse;
}

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ServerListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  return xmlTextWriterWriteNs0ServerListElementNS(writer, _ldapServerListResponse, 0);
}

/**
 * Writes a LdapServerListResponse to XML under element name "serverList".
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ServerListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "serverList", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}serverList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapServerListResponse for root element {}serverList...\n");
#endif
  status = xmlTextWriterWriteNs0LdapServerListResponseType(writer, _ldapServerListResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}serverList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}serverList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse whose children are to be free.
 */
static void freeNs0ServerListElement(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  freeNs0LdapServerListResponseType(_ldapServerListResponse);
}

/**
 * Reads a LdapServerListResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerListResponse *xmlTextReaderReadNs0LdapServerListResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerListResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerListResponseType(_ldapServerListResponse);
        free(_ldapServerListResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0LdapServerListResponseType(_ldapServerListResponse);
              free(_ldapServerListResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapServerListEntry", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapServerListEntry of type {}ldapServerListEntry.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapServerListEntryType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapServerListEntry of type {}ldapServerListEntry.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerListResponseType(_ldapServerListResponse);
          free(_ldapServerListResponse);
          return NULL;
        }

        _ldapServerListResponse->data = realloc(_ldapServerListResponse->data, (_ldapServerListResponse->_sizeof_data + 1) * sizeof(struct enterprise_ldap_plugin_ns0_ldapServerListEntry));
        memcpy(&(_ldapServerListResponse->data[_ldapServerListResponse->_sizeof_data++]), _child_accessor, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerListEntry));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0LdapServerListResponseType(_ldapServerListResponse);
          free(_ldapServerListResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerListResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerListResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerListResponse;
}

/**
 * Writes a LdapServerListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerListResponse The LdapServerListResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_ldapServerListResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _ldapServerListResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapServerListEntry", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapServerListEntry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapServerListEntry for element {}ldapServerListEntry...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapServerListEntryType(writer, &(_ldapServerListResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapServerListEntry for element {}ldapServerListEntry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapServerListEntry. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_ldapServerListResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerListResponse.
 *
 * @param _ldapServerListResponse The LdapServerListResponse to free.
 */
static void freeNs0LdapServerListResponseType(struct enterprise_ldap_plugin_ns0_ldapServerListResponse *_ldapServerListResponse) {
  int i;
  if (_ldapServerListResponse->data != NULL) {
    for (i = 0; i < _ldapServerListResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type enterprise_ldap_plugin_ns0_ldapServerListResponse...\n", i);
#endif
      freeNs0LdapServerListEntryType(&(_ldapServerListResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapServerListResponse...\n");
#endif
    free(_ldapServerListResponse->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerListResponse_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_M

/**
 * Reads a LdapServerLoginTestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerLoginTestDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *xmlTextReaderReadNs0LdapServerLoginTestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *_ldapServerLoginTestDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerLoginTest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerLoginTestType(_ldapServerLoginTestDTO);
        free(_ldapServerLoginTestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "configuration", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}configuration of type {}ldapServerConfiguration.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapServerConfigurationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}configuration of type {}ldapServerConfiguration.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerLoginTestType(_ldapServerLoginTestDTO);
          free(_ldapServerLoginTestDTO);
          return NULL;
        }

        _ldapServerLoginTestDTO->configuration = ((struct enterprise_ldap_plugin_ns0_ldapServerConfiguration*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "username", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}username of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerLoginTestType(_ldapServerLoginTestDTO);
          free(_ldapServerLoginTestDTO);
          return NULL;
        }

        _ldapServerLoginTestDTO->username = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerLoginTestType(_ldapServerLoginTestDTO);
          free(_ldapServerLoginTestDTO);
          return NULL;
        }

        _ldapServerLoginTestDTO->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerLoginTest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerLoginTest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerLoginTestDTO;
}

/**
 * Writes a LdapServerLoginTestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestDTO The LdapServerLoginTestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerLoginTestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *_ldapServerLoginTestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapServerLoginTestDTO->configuration != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "configuration", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}configuration. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapServerConfiguration for element {}configuration...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapServerConfigurationType(writer, (_ldapServerLoginTestDTO->configuration));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapServerConfiguration for element {}configuration. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}configuration. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerLoginTestDTO->username != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "username", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}username...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerLoginTestDTO->username));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}username. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapServerLoginTestDTO->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapServerLoginTestDTO->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerLoginTestDTO.
 *
 * @param _ldapServerLoginTestDTO The LdapServerLoginTestDTO to free.
 */
static void freeNs0LdapServerLoginTestType(struct enterprise_ldap_plugin_ns0_ldapServerLoginTest *_ldapServerLoginTestDTO) {
  int i;
  if (_ldapServerLoginTestDTO->configuration != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor configuration of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    freeNs0LdapServerConfigurationType(_ldapServerLoginTestDTO->configuration);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor configuration of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    free(_ldapServerLoginTestDTO->configuration);
  }
  if (_ldapServerLoginTestDTO->username != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor username of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    freeXsStringType(_ldapServerLoginTestDTO->username);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor username of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    free(_ldapServerLoginTestDTO->username);
  }
  if (_ldapServerLoginTestDTO->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    freeXsStringType(_ldapServerLoginTestDTO->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type enterprise_ldap_plugin_ns0_ldapServerLoginTest...\n");
#endif
    free(_ldapServerLoginTestDTO->password);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTest_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_M

/**
 * Reads a LdapServerLoginTestRequest element from XML. The element to be read is "loginTestRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0LoginTestRequestElement(reader);
}

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  return xmlTextWriterWriteNs0LoginTestRequestElementNS(writer, _ldapServerLoginTestRequest, 1);
}

/**
 * Frees a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  freeNs0LdapServerLoginTestRequestType(_ldapServerLoginTestRequest);
  free(_ldapServerLoginTestRequest);
}

/**
 * Reads a LdapServerLoginTestRequest element from XML. The element to be read is "loginTestRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapServerLoginTestRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xmlTextReaderReadNs0LoginTestRequestElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "loginTestRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}loginTestRequest.\n");
#endif
    _ldapServerLoginTestRequest = xmlTextReaderReadNs0LdapServerLoginTestRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapServerLoginTestRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}loginTestRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}loginTestRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapServerLoginTestRequest;
}

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0LoginTestRequestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  return xmlTextWriterWriteNs0LoginTestRequestElementNS(writer, _ldapServerLoginTestRequest, 0);
}

/**
 * Writes a LdapServerLoginTestRequest to XML under element name "loginTestRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0LoginTestRequestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "loginTestRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}loginTestRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapServerLoginTestRequest for root element {}loginTestRequest...\n");
#endif
  status = xmlTextWriterWriteNs0LdapServerLoginTestRequestType(writer, _ldapServerLoginTestRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}loginTestRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}loginTestRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest whose children are to be free.
 */
static void freeNs0LoginTestRequestElement(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  freeNs0LdapServerLoginTestRequestType(_ldapServerLoginTestRequest);
}

/**
 * Reads a LdapServerLoginTestRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerLoginTestRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *xmlTextReaderReadNs0LdapServerLoginTestRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerLoginTestRequestType(_ldapServerLoginTestRequest);
        free(_ldapServerLoginTestRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}ldapServerLoginTest.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapServerLoginTestType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}ldapServerLoginTest.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerLoginTestRequestType(_ldapServerLoginTestRequest);
          free(_ldapServerLoginTestRequest);
          return NULL;
        }

        _ldapServerLoginTestRequest->data = ((struct enterprise_ldap_plugin_ns0_ldapServerLoginTest*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerLoginTestRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerLoginTestRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerLoginTestRequest;
}

/**
 * Writes a LdapServerLoginTestRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerLoginTestRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapServerLoginTestRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapServerLoginTest for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapServerLoginTestType(writer, (_ldapServerLoginTestRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapServerLoginTest for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerLoginTestRequest.
 *
 * @param _ldapServerLoginTestRequest The LdapServerLoginTestRequest to free.
 */
static void freeNs0LdapServerLoginTestRequestType(struct enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest *_ldapServerLoginTestRequest) {
  int i;
  if (_ldapServerLoginTestRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest...\n");
#endif
    freeNs0LdapServerLoginTestType(_ldapServerLoginTestRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest...\n");
#endif
    free(_ldapServerLoginTestRequest->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerLoginTestRequest_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_M

/**
 * Reads a LdapServerOrderRequest element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerOrderRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0OrderRequestElement(reader);
}

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  return xmlTextWriterWriteNs0OrderRequestElementNS(writer, _ldapServerOrderRequest, 1);
}

/**
 * Frees a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerOrderRequest(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  freeNs0LdapServerOrderRequestType(_ldapServerOrderRequest);
  free(_ldapServerOrderRequest);
}

/**
 * Reads a LdapServerOrderRequest element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapServerOrderRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xmlTextReaderReadNs0OrderRequestElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "orderRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}orderRequest.\n");
#endif
    _ldapServerOrderRequest = xmlTextReaderReadNs0LdapServerOrderRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapServerOrderRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}orderRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}orderRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapServerOrderRequest;
}

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0OrderRequestElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  return xmlTextWriterWriteNs0OrderRequestElementNS(writer, _ldapServerOrderRequest, 0);
}

/**
 * Writes a LdapServerOrderRequest to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0OrderRequestElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "orderRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapServerOrderRequest for root element {}orderRequest...\n");
#endif
  status = xmlTextWriterWriteNs0LdapServerOrderRequestType(writer, _ldapServerOrderRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest whose children are to be free.
 */
static void freeNs0OrderRequestElement(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  freeNs0LdapServerOrderRequestType(_ldapServerOrderRequest);
}

/**
 * Reads a LdapServerOrderRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerOrderRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *xmlTextReaderReadNs0LdapServerOrderRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerOrderRequestType(_ldapServerOrderRequest);
        free(_ldapServerOrderRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerOrderRequestType(_ldapServerOrderRequest);
          free(_ldapServerOrderRequest);
          return NULL;
        }

        _ldapServerOrderRequest->data = realloc(_ldapServerOrderRequest->data, (_ldapServerOrderRequest->_sizeof_data + 1) * sizeof(xmlChar));
        memcpy(&(_ldapServerOrderRequest->data[_ldapServerOrderRequest->_sizeof_data++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerOrderRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerOrderRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerOrderRequest;
}

/**
 * Writes a LdapServerOrderRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerOrderRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  for (i = 0; i < _ldapServerOrderRequest->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_ldapServerOrderRequest->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerOrderRequest.
 *
 * @param _ldapServerOrderRequest The LdapServerOrderRequest to free.
 */
static void freeNs0LdapServerOrderRequestType(struct enterprise_ldap_plugin_ns0_ldapServerOrderRequest *_ldapServerOrderRequest) {
  int i;
  if (_ldapServerOrderRequest->data != NULL) {
    for (i = 0; i < _ldapServerOrderRequest->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type enterprise_ldap_plugin_ns0_ldapServerOrderRequest...\n", i);
#endif
      freeXsStringType(&(_ldapServerOrderRequest->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapServerOrderRequest...\n");
#endif
    free(_ldapServerOrderRequest->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerOrderRequest_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_M
#define DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_M

/**
 * Reads a LdapServerRequest element from XML. The element to be read is "server", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapServerRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerRequest *xml_read_enterprise_ldap_plugin_ns0_ldapServerRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ServerElement(reader);
}

/**
 * Writes a LdapServerRequest to XML under element name "server".
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapServerRequest(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  return xmlTextWriterWriteNs0ServerElementNS(writer, _ldapServerRequest, 1);
}

/**
 * Frees a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapServerRequest(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  freeNs0LdapServerRequestType(_ldapServerRequest);
  free(_ldapServerRequest);
}

/**
 * Reads a LdapServerRequest element from XML. The element to be read is "server", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapServerRequest, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapServerRequest *xmlTextReaderReadNs0ServerElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "server", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}server.\n");
#endif
    _ldapServerRequest = xmlTextReaderReadNs0LdapServerRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapServerRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}server failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}server failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapServerRequest;
}

/**
 * Writes a LdapServerRequest to XML under element name "server".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ServerElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  return xmlTextWriterWriteNs0ServerElementNS(writer, _ldapServerRequest, 0);
}

/**
 * Writes a LdapServerRequest to XML under element name "server".
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ServerElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "server", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}server. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapServerRequest for root element {}server...\n");
#endif
  status = xmlTextWriterWriteNs0LdapServerRequestType(writer, _ldapServerRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}server. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}server. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest whose children are to be free.
 */
static void freeNs0ServerElement(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  freeNs0LdapServerRequestType(_ldapServerRequest);
}

/**
 * Reads a LdapServerRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapServerRequest, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapServerRequest *xmlTextReaderReadNs0LdapServerRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapServerRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapServerRequestType(_ldapServerRequest);
        free(_ldapServerRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}ldapServerConfiguration.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapServerConfigurationType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}ldapServerConfiguration.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapServerRequestType(_ldapServerRequest);
          free(_ldapServerRequest);
          return NULL;
        }

        _ldapServerRequest->data = ((struct enterprise_ldap_plugin_ns0_ldapServerConfiguration*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapServerRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapServerRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapServerRequest;
}

/**
 * Writes a LdapServerRequest to XML.
 *
 * @param writer The XML writer.
 * @param _ldapServerRequest The LdapServerRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapServerRequestType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapServerRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapServerConfiguration for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapServerConfigurationType(writer, (_ldapServerRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapServerConfiguration for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapServerRequest.
 *
 * @param _ldapServerRequest The LdapServerRequest to free.
 */
static void freeNs0LdapServerRequestType(struct enterprise_ldap_plugin_ns0_ldapServerRequest *_ldapServerRequest) {
  int i;
  if (_ldapServerRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type enterprise_ldap_plugin_ns0_ldapServerRequest...\n");
#endif
    freeNs0LdapServerConfigurationType(_ldapServerRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapServerRequest...\n");
#endif
    free(_ldapServerRequest->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapServerRequest_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_M
#define DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_M

/**
 * Reads a LdapUserAndGroupAuthConfigurationDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapUserAndGroupAuthConfigurationDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *xmlTextReaderReadNs0LdapUserAndGroupAuthConfigurationType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *_ldapUserAndGroupAuthConfigurationDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
        free(_ldapUserAndGroupAuthConfigurationDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "emailAddressAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}emailAddressAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}emailAddressAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupBaseDn", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupBaseDn of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupBaseDn of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupBaseDn = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupIdAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupIdAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupIdAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupMemberAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupMemberAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupMemberAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupMemberFormat", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupMemberFormat of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupMemberFormat of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupObjectClass", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupObjectClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupObjectClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupObjectClass = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userBaseDn", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userBaseDn of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userBaseDn of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userBaseDn = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userIdAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userIdAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userIdAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userIdAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userMemberOfAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userMemberOfAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userMemberOfAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userObjectClass", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userObjectClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userObjectClass of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userObjectClass = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userPasswordAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userPasswordAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userPasswordAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userRealNameAttribute", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userRealNameAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userRealNameAttribute of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "groupSubtree", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}groupSubtree of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}groupSubtree of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->groupSubtree = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapGroupsAsRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapGroupsAsRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapGroupsAsRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->ldapGroupsAsRoles = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userSubtree", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userSubtree of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userSubtree of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->userSubtree = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapFilter", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapFilter of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapFilter of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserAndGroupAuthConfigurationType(_ldapUserAndGroupAuthConfigurationDTO);
          free(_ldapUserAndGroupAuthConfigurationDTO);
          return NULL;
        }

        _ldapUserAndGroupAuthConfigurationDTO->ldapFilter = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapUserAndGroupAuthConfiguration.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapUserAndGroupAuthConfiguration. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapUserAndGroupAuthConfigurationDTO;
}

/**
 * Writes a LdapUserAndGroupAuthConfigurationDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserAndGroupAuthConfigurationDTO The LdapUserAndGroupAuthConfigurationDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapUserAndGroupAuthConfigurationType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *_ldapUserAndGroupAuthConfigurationDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "emailAddressAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}emailAddressAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}emailAddressAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}emailAddressAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}emailAddressAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupBaseDn != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupBaseDn", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupBaseDn...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->groupBaseDn));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupIdAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupIdAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupMemberAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupMemberAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupMemberAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupMemberAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupMemberAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupMemberFormat", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupMemberFormat. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupMemberFormat...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupMemberFormat. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupMemberFormat. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupObjectClass != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupObjectClass", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}groupObjectClass...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->groupObjectClass));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}groupObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userBaseDn != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userBaseDn", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userBaseDn...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userBaseDn));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userBaseDn. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userIdAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userIdAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userIdAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userIdAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userIdAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userMemberOfAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userMemberOfAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userMemberOfAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userMemberOfAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userMemberOfAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userObjectClass != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userObjectClass", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userObjectClass...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userObjectClass));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userObjectClass. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userPasswordAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userPasswordAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userPasswordAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userPasswordAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userPasswordAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userRealNameAttribute", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userRealNameAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userRealNameAttribute...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userRealNameAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userRealNameAttribute. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "groupSubtree", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}groupSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}groupSubtree...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_ldapUserAndGroupAuthConfigurationDTO->groupSubtree));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}groupSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}groupSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapGroupsAsRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapGroupsAsRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}ldapGroupsAsRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_ldapUserAndGroupAuthConfigurationDTO->ldapGroupsAsRoles));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}ldapGroupsAsRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapGroupsAsRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userSubtree", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}userSubtree...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_ldapUserAndGroupAuthConfigurationDTO->userSubtree));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}userSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userSubtree. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->ldapFilter != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapFilter", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapFilter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}ldapFilter...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserAndGroupAuthConfigurationDTO->ldapFilter));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}ldapFilter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapFilter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapUserAndGroupAuthConfigurationDTO.
 *
 * @param _ldapUserAndGroupAuthConfigurationDTO The LdapUserAndGroupAuthConfigurationDTO to free.
 */
static void freeNs0LdapUserAndGroupAuthConfigurationType(struct enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration *_ldapUserAndGroupAuthConfigurationDTO) {
  int i;
  if (_ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor emailAddressAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor emailAddressAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->emailAddressAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupBaseDn != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupBaseDn of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->groupBaseDn);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupBaseDn of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->groupBaseDn);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupIdAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupIdAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->groupIdAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupMemberAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupMemberAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->groupMemberAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupMemberFormat of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupMemberFormat of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->groupMemberFormat);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->groupObjectClass != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor groupObjectClass of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->groupObjectClass);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor groupObjectClass of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->groupObjectClass);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userBaseDn != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userBaseDn of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userBaseDn);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userBaseDn of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userBaseDn);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userIdAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userIdAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userIdAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userIdAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userIdAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userMemberOfAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userMemberOfAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userMemberOfAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userObjectClass != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userObjectClass of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userObjectClass);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userObjectClass of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userObjectClass);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userPasswordAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userPasswordAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userPasswordAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userRealNameAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userRealNameAttribute of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->userRealNameAttribute);
  }
  if (_ldapUserAndGroupAuthConfigurationDTO->ldapFilter != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor ldapFilter of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    freeXsStringType(_ldapUserAndGroupAuthConfigurationDTO->ldapFilter);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor ldapFilter of type enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration...\n");
#endif
    free(_ldapUserAndGroupAuthConfigurationDTO->ldapFilter);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUserAndGroupAuthConfiguration_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUser_M
#define DEF_enterprise_ldap_plugin_ns0_ldapUser_M

/**
 * Reads a LdapUserDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapUserDTO, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUser *xmlTextReaderReadNs0LdapUserType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapUser *_ldapUserDTO = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapUser));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapUserType(_ldapUserDTO);
        free(_ldapUserDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserType(_ldapUserDTO);
          free(_ldapUserDTO);
          return NULL;
        }

        _ldapUserDTO->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "roles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}roles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}roles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserType(_ldapUserDTO);
          free(_ldapUserDTO);
          return NULL;
        }

        _ldapUserDTO->roles = realloc(_ldapUserDTO->roles, (_ldapUserDTO->_sizeof_roles + 1) * sizeof(xmlChar));
        memcpy(&(_ldapUserDTO->roles[_ldapUserDTO->_sizeof_roles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserType(_ldapUserDTO);
          free(_ldapUserDTO);
          return NULL;
        }

        _ldapUserDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserType(_ldapUserDTO);
          free(_ldapUserDTO);
          return NULL;
        }

        _ldapUserDTO->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapUser.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapUser. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapUserDTO;
}

/**
 * Writes a LdapUserDTO to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserDTO The LdapUserDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapUserType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUser *_ldapUserDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_ldapUserDTO->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserDTO->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _ldapUserDTO->_sizeof_roles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}roles...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_ldapUserDTO->roles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_ldapUserDTO->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_ldapUserDTO->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapUserDTO.
 *
 * @param _ldapUserDTO The LdapUserDTO to free.
 */
static void freeNs0LdapUserType(struct enterprise_ldap_plugin_ns0_ldapUser *_ldapUserDTO) {
  int i;
  if (_ldapUserDTO->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    freeXsStringType(_ldapUserDTO->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    free(_ldapUserDTO->userId);
  }
  if (_ldapUserDTO->roles != NULL) {
    for (i = 0; i < _ldapUserDTO->_sizeof_roles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor roles[%i] of type enterprise_ldap_plugin_ns0_ldapUser...\n", i);
#endif
      freeXsStringType(&(_ldapUserDTO->roles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor roles of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    free(_ldapUserDTO->roles);
  }
  if (_ldapUserDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    freeXsStringType(_ldapUserDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    free(_ldapUserDTO->name);
  }
  if (_ldapUserDTO->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    freeXsStringType(_ldapUserDTO->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type enterprise_ldap_plugin_ns0_ldapUser...\n");
#endif
    free(_ldapUserDTO->email);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUser_M */
#ifndef DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_M
#define DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_M

/**
 * Reads a LdapUserListResponse element from XML. The element to be read is "userList", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The LdapUserListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xml_read_enterprise_ldap_plugin_ns0_ldapUserListResponse(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0UserListElement(reader);
}

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_enterprise_ldap_plugin_ns0_ldapUserListResponse(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  return xmlTextWriterWriteNs0UserListElementNS(writer, _ldapUserListResponse, 1);
}

/**
 * Frees a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse to free.
 */
void free_enterprise_ldap_plugin_ns0_ldapUserListResponse(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  freeNs0LdapUserListResponseType(_ldapUserListResponse);
  free(_ldapUserListResponse);
}

/**
 * Reads a LdapUserListResponse element from XML. The element to be read is "userList", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The LdapUserListResponse, or NULL in case of error.
 */
struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xmlTextReaderReadNs0UserListElement(xmlTextReaderPtr reader) {
  struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "userList", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}userList.\n");
#endif
    _ldapUserListResponse = xmlTextReaderReadNs0LdapUserListResponseType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_ldapUserListResponse == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}userList failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}userList failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _ldapUserListResponse;
}

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserListElement(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  return xmlTextWriterWriteNs0UserListElementNS(writer, _ldapUserListResponse, 0);
}

/**
 * Writes a LdapUserListResponse to XML under element name "userList".
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0UserListElementNS(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userList", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}userList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}ldapUserListResponse for root element {}userList...\n");
#endif
  status = xmlTextWriterWriteNs0LdapUserListResponseType(writer, _ldapUserListResponse);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}userList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}userList. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse whose children are to be free.
 */
static void freeNs0UserListElement(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  freeNs0LdapUserListResponseType(_ldapUserListResponse);
}

/**
 * Reads a LdapUserListResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the LdapUserListResponse, or NULL in case of error.
 */
static struct enterprise_ldap_plugin_ns0_ldapUserListResponse *xmlTextReaderReadNs0LdapUserListResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse = calloc(1, sizeof(struct enterprise_ldap_plugin_ns0_ldapUserListResponse));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0LdapUserListResponseType(_ldapUserListResponse);
        free(_ldapUserListResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0LdapUserListResponseType(_ldapUserListResponse);
              free(_ldapUserListResponse);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "ldapUser", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}ldapUser of type {}ldapUser.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0LdapUserType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}ldapUser of type {}ldapUser.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0LdapUserListResponseType(_ldapUserListResponse);
          free(_ldapUserListResponse);
          return NULL;
        }

        _ldapUserListResponse->data = realloc(_ldapUserListResponse->data, (_ldapUserListResponse->_sizeof_data + 1) * sizeof(struct enterprise_ldap_plugin_ns0_ldapUser));
        memcpy(&(_ldapUserListResponse->data[_ldapUserListResponse->_sizeof_data++]), _child_accessor, sizeof(struct enterprise_ldap_plugin_ns0_ldapUser));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0LdapUserListResponseType(_ldapUserListResponse);
          free(_ldapUserListResponse);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}ldapUserListResponse.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}ldapUserListResponse. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _ldapUserListResponse;
}

/**
 * Writes a LdapUserListResponse to XML.
 *
 * @param writer The XML writer.
 * @param _ldapUserListResponse The LdapUserListResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0LdapUserListResponseType(xmlTextWriterPtr writer, struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_ldapUserListResponse->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _ldapUserListResponse->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "ldapUser", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}ldapUser. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}ldapUser for element {}ldapUser...\n", status);
#endif
    status = xmlTextWriterWriteNs0LdapUserType(writer, &(_ldapUserListResponse->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}ldapUser for element {}ldapUser. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}ldapUser. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_ldapUserListResponse->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a LdapUserListResponse.
 *
 * @param _ldapUserListResponse The LdapUserListResponse to free.
 */
static void freeNs0LdapUserListResponseType(struct enterprise_ldap_plugin_ns0_ldapUserListResponse *_ldapUserListResponse) {
  int i;
  if (_ldapUserListResponse->data != NULL) {
    for (i = 0; i < _ldapUserListResponse->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type enterprise_ldap_plugin_ns0_ldapUserListResponse...\n", i);
#endif
      freeNs0LdapUserType(&(_ldapUserListResponse->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type enterprise_ldap_plugin_ns0_ldapUserListResponse...\n");
#endif
    free(_ldapUserListResponse->data);
  }
}
#endif /* DEF_enterprise_ldap_plugin_ns0_ldapUserListResponse_M */
