#include <enunciate-common.c>
#ifndef DEF_nexus_smartproxy_plugin_ns0_certificate_H
#define DEF_nexus_smartproxy_plugin_ns0_certificate_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_certificate {


  /**
   * (no documentation provided)
   */
  xmlChar *fingerprint;

  /**
   * (no documentation provided)
   */
  xmlChar *detail;

  /**
   * (no documentation provided)
   */
  xmlChar *pem;
};

/**
 * Reads a Certificate from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The Certificate, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_certificate *xmlTextReaderReadNs0CertificateType(xmlTextReaderPtr reader);

/**
 * Writes a Certificate to XML.
 *
 * @param writer The XML writer.
 * @param _certificate The Certificate to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0CertificateType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_certificate *_certificate);

/**
 * Frees the elements of a Certificate.
 *
 * @param _certificate The Certificate to free.
 */
static void freeNs0CertificateType(struct nexus_smartproxy_plugin_ns0_certificate *_certificate);

#endif /* DEF_nexus_smartproxy_plugin_ns0_certificate_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *data;
};

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope element from XML. The element to be read is "publish-subscribe-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

/**
 * Frees a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope element from XML. The element to be read is "publish-subscribe-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xmlTextReaderReadNs0Publish_subscribe_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope, int writeNamespaces);

/**
 * Frees the children of a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope whose children are to be free.
 */
static void freeNs0Publish_subscribe_requestElement(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xmlTextReaderReadNs0ConfigurePublishSubscribeRequestEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ConfigurePublishSubscribeRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

/**
 * Frees the elements of a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to free.
 */
static void freeNs0ConfigurePublishSubscribeRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *data;
};

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope element from XML. The element to be read is "publish-subscribe-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

/**
 * Frees a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope element from XML. The element to be read is "publish-subscribe-response", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xmlTextReaderReadNs0Publish_subscribe_responseElement(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope, int writeNamespaces);

/**
 * Frees the children of a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope whose children are to be free.
 */
static void freeNs0Publish_subscribe_responseElement(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xmlTextReaderReadNs0ConfigurePublishSubscribeResponseEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ConfigurePublishSubscribeResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

/**
 * Frees the elements of a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to free.
 */
static void freeNs0ConfigurePublishSubscribeResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_H
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_publish_subscribe {


  /**
   * (no documentation provided)
   */
  int subscribe;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryId;

  /**
   * (no documentation provided)
   */
  int publish;

  /**
   * (no documentation provided)
   */
  int preemptiveFetch;
};

/**
 * Reads a PublishSubscribe from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PublishSubscribe, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe *xmlTextReaderReadNs0Publish_subscribeType(xmlTextReaderPtr reader);

/**
 * Writes a PublishSubscribe to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribe The PublishSubscribe to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe *_publishSubscribe);

/**
 * Frees the elements of a PublishSubscribe.
 *
 * @param _publishSubscribe The PublishSubscribe to free.
 */
static void freeNs0Publish_subscribeType(struct nexus_smartproxy_plugin_ns0_publish_subscribe *_publishSubscribe);

#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_H
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_publish_subscribe_request {


  /**
   * (no documentation provided)
   */
  int subscribe;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryId;

  /**
   * (no documentation provided)
   */
  int publish;

  /**
   * (no documentation provided)
   */
  int preemptiveFetch;
};

/**
 * Reads a PublishSubscribeRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PublishSubscribeRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *xmlTextReaderReadNs0Publish_subscribe_requestType(xmlTextReaderPtr reader);

/**
 * Writes a PublishSubscribeRequest to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribeRequest The PublishSubscribeRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *_publishSubscribeRequest);

/**
 * Frees the elements of a PublishSubscribeRequest.
 *
 * @param _publishSubscribeRequest The PublishSubscribeRequest to free.
 */
static void freeNs0Publish_subscribe_requestType(struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *_publishSubscribeRequest);

#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_H
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_publish_subscribe_response {


  /**
   * (no documentation provided)
   */
  int subscribe;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryId;

  /**
   * (no documentation provided)
   */
  int publish;

  /**
   * (no documentation provided)
   */
  int preemptiveFetch;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_certificate *certificate;

  /**
   * (no documentation provided)
   */
  xmlChar *subscriptionStatus;

  /**
   * (no documentation provided)
   */
  xmlChar *publishStatus;
};

/**
 * Reads a PublishSubscribeResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PublishSubscribeResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *xmlTextReaderReadNs0Publish_subscribe_responseType(xmlTextReaderPtr reader);

/**
 * Writes a PublishSubscribeResponse to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribeResponse The PublishSubscribeResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *_publishSubscribeResponse);

/**
 * Frees the elements of a PublishSubscribeResponse.
 *
 * @param _publishSubscribeResponse The PublishSubscribeResponse to free.
 */
static void freeNs0Publish_subscribe_responseType(struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *_publishSubscribeResponse);

#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_H
#define DEF_nexus_smartproxy_plugin_ns0_settings_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_settings {


  /**
   * (no documentation provided)
   */
  int *enabled;

  /**
   * (no documentation provided)
   */
  xmlChar *advertiseUri;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_certificate *identity;

  /**
   * (no documentation provided)
   */
  int port;

  /**
   * (no documentation provided)
   */
  xmlChar *host;
};

/**
 * Reads a Settings from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The Settings, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings *xmlTextReaderReadNs0SettingsType(xmlTextReaderPtr reader);

/**
 * Writes a Settings to XML.
 *
 * @param writer The XML writer.
 * @param _settings The Settings to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SettingsType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings *_settings);

/**
 * Frees the elements of a Settings.
 *
 * @param _settings The Settings to free.
 */
static void freeNs0SettingsType(struct nexus_smartproxy_plugin_ns0_settings *_settings);

#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_request_H
#define DEF_nexus_smartproxy_plugin_ns0_settings_request_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_settings_request {


  /**
   * (no documentation provided)
   */
  int *enabled;

  /**
   * (no documentation provided)
   */
  xmlChar *advertiseUri;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_certificate *identity;

  /**
   * (no documentation provided)
   */
  int port;

  /**
   * (no documentation provided)
   */
  xmlChar *host;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_trusted_key *trustedKeys;

  /**
   * Size of the trustedKeys array.
   */
  int _sizeof_trustedKeys;
};

/**
 * Reads a SettingsRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SettingsRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings_request *xmlTextReaderReadNs0Settings_requestType(xmlTextReaderPtr reader);

/**
 * Writes a SettingsRequest to XML.
 *
 * @param writer The XML writer.
 * @param _settingsRequest The SettingsRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_requestType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings_request *_settingsRequest);

/**
 * Frees the elements of a SettingsRequest.
 *
 * @param _settingsRequest The SettingsRequest to free.
 */
static void freeNs0Settings_requestType(struct nexus_smartproxy_plugin_ns0_settings_request *_settingsRequest);

#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_request_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_settings_request *data;
};

/**
 * Reads a SettingsRequestEnvelope element from XML. The element to be read is "settings-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

/**
 * Frees a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

/**
 * Reads a SettingsRequestEnvelope element from XML. The element to be read is "settings-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SettingsRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xmlTextReaderReadNs0Settings_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope, int writeNamespaces);

/**
 * Frees the children of a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope whose children are to be free.
 */
static void freeNs0Settings_requestElement(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

/**
 * Reads a SettingsRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SettingsRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xmlTextReaderReadNs0SettingsRequestEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a SettingsRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SettingsRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

/**
 * Frees the elements of a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to free.
 */
static void freeNs0SettingsRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_response_H
#define DEF_nexus_smartproxy_plugin_ns0_settings_response_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_settings_response {


  /**
   * (no documentation provided)
   */
  int *enabled;

  /**
   * (no documentation provided)
   */
  xmlChar *advertiseUri;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_certificate *identity;

  /**
   * (no documentation provided)
   */
  int port;

  /**
   * (no documentation provided)
   */
  xmlChar *host;

  /**
   * (no documentation provided)
   */
  xmlChar *status;
};

/**
 * Reads a SettingsResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SettingsResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings_response *xmlTextReaderReadNs0Settings_responseType(xmlTextReaderPtr reader);

/**
 * Writes a SettingsResponse to XML.
 *
 * @param writer The XML writer.
 * @param _settingsResponse The SettingsResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_responseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings_response *_settingsResponse);

/**
 * Frees the elements of a SettingsResponse.
 *
 * @param _settingsResponse The SettingsResponse to free.
 */
static void freeNs0Settings_responseType(struct nexus_smartproxy_plugin_ns0_settings_response *_settingsResponse);

#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_response_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_settings_response *data;
};

/**
 * Reads a SettingsResponseEnvelope element from XML. The element to be read is "settings-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

/**
 * Frees a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

/**
 * Reads a SettingsResponseEnvelope element from XML. The element to be read is "settings-response", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The SettingsResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xmlTextReaderReadNs0Settings_responseElement(xmlTextReaderPtr reader);

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Settings_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope, int writeNamespaces);

/**
 * Frees the children of a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope whose children are to be free.
 */
static void freeNs0Settings_responseElement(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

/**
 * Reads a SettingsResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The SettingsResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xmlTextReaderReadNs0SettingsResponseEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a SettingsResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0SettingsResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

/**
 * Frees the elements of a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to free.
 */
static void freeNs0SettingsResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trusted_key_H
#define DEF_nexus_smartproxy_plugin_ns0_trusted_key_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_trusted_key {


  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *certificate;

  /**
   * (no documentation provided)
   */
  xmlChar *description;
};

/**
 * Reads a TrustedKeyRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trusted_key *xmlTextReaderReadNs0Trusted_keyType(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyRequest to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequest The TrustedKeyRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_keyType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyRequest);

/**
 * Frees the elements of a TrustedKeyRequest.
 *
 * @param _trustedKeyRequest The TrustedKeyRequest to free.
 */
static void freeNs0Trusted_keyType(struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyRequest);

#endif /* DEF_nexus_smartproxy_plugin_ns0_trusted_key_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_trusted_key *data;
};

/**
 * Reads a TrustedKeyRequestEnvelope element from XML. The element to be read is "trusted-key-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

/**
 * Frees a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

/**
 * Reads a TrustedKeyRequestEnvelope element from XML. The element to be read is "trusted-key-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xmlTextReaderReadNs0Trusted_key_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_key_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_key_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope, int writeNamespaces);

/**
 * Frees the children of a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope whose children are to be free.
 */
static void freeNs0Trusted_key_requestElement(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

/**
 * Reads a TrustedKeyRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xmlTextReaderReadNs0TrustedKeyRequestEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0TrustedKeyRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

/**
 * Frees the elements of a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to free.
 */
static void freeNs0TrustedKeyRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trusted_key_H
#define DEF_nexus_smartproxy_plugin_ns0_trusted_key_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_trusted_key {


  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_certificate *certificate;

  /**
   * (no documentation provided)
   */
  xmlChar *id;
};

/**
 * Reads a TrustedKeyResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trusted_key *xmlTextReaderReadNs0Trusted_keyType(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyResponse to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponse The TrustedKeyResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_keyType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyResponse);

/**
 * Frees the elements of a TrustedKeyResponse.
 *
 * @param _trustedKeyResponse The TrustedKeyResponse to free.
 */
static void freeNs0Trusted_keyType(struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyResponse);

#endif /* DEF_nexus_smartproxy_plugin_ns0_trusted_key_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_trusted_key *data;
};

/**
 * Reads a TrustedKeyResponseEnvelope element from XML. The element to be read is "trusted-key-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

/**
 * Frees a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

/**
 * Reads a TrustedKeyResponseEnvelope element from XML. The element to be read is "trusted-key-response", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xmlTextReaderReadNs0Trusted_key_responseElement(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_key_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_key_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope, int writeNamespaces);

/**
 * Frees the children of a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope whose children are to be free.
 */
static void freeNs0Trusted_key_responseElement(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

/**
 * Reads a TrustedKeyResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xmlTextReaderReadNs0TrustedKeyResponseEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeyResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0TrustedKeyResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

/**
 * Frees the elements of a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to free.
 */
static void freeNs0TrustedKeyResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_H
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope {


  /**
   * (no documentation provided)
   */
  struct nexus_smartproxy_plugin_ns0_trusted_key *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a TrustedKeysResponseEnvelope element from XML. The element to be read is "trusted-keys-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeysResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

/**
 * Frees a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

/**
 * Reads a TrustedKeysResponseEnvelope element from XML. The element to be read is "trusted-keys-response", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeysResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xmlTextReaderReadNs0Trusted_keys_responseElement(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_keys_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Trusted_keys_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope, int writeNamespaces);

/**
 * Frees the children of a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope whose children are to be free.
 */
static void freeNs0Trusted_keys_responseElement(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

/**
 * Reads a TrustedKeysResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeysResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xmlTextReaderReadNs0TrustedKeysResponseEnvelopeType(xmlTextReaderPtr reader);

/**
 * Writes a TrustedKeysResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0TrustedKeysResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

/**
 * Frees the elements of a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to free.
 */
static void freeNs0TrustedKeysResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope);

#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_nexusResponse_H
#define DEF_nexus_smartproxy_plugin_ns0_nexusResponse_H

/**
 * (no documentation provided)
 */
struct nexus_smartproxy_plugin_ns0_nexusResponse {

};

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The NexusResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader);

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_nexusResponse *_nexusResponse);

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_smartproxy_plugin_ns0_nexusResponse *_nexusResponse);

#endif /* DEF_nexus_smartproxy_plugin_ns0_nexusResponse_H */
#ifndef DEF_nexus_smartproxy_plugin_ns0_certificate_M
#define DEF_nexus_smartproxy_plugin_ns0_certificate_M

/**
 * Reads a Certificate from XML. The reader is assumed to be at the start element.
 *
 * @return the Certificate, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_certificate *xmlTextReaderReadNs0CertificateType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_certificate *_certificate = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_certificate));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0CertificateType(_certificate);
        free(_certificate);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "fingerprint", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}fingerprint of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CertificateType(_certificate);
          free(_certificate);
          return NULL;
        }

        _certificate->fingerprint = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "detail", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}detail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}detail of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CertificateType(_certificate);
          free(_certificate);
          return NULL;
        }

        _certificate->detail = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "pem", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}pem of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}pem of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0CertificateType(_certificate);
          free(_certificate);
          return NULL;
        }

        _certificate->pem = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}certificate.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}certificate. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _certificate;
}

/**
 * Writes a Certificate to XML.
 *
 * @param writer The XML writer.
 * @param _certificate The Certificate to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0CertificateType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_certificate *_certificate) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_certificate->fingerprint != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "fingerprint", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}fingerprint...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_certificate->fingerprint));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}fingerprint. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_certificate->detail != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "detail", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}detail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}detail...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_certificate->detail));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}detail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}detail. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_certificate->pem != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "pem", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}pem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}pem...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_certificate->pem));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}pem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}pem. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a Certificate.
 *
 * @param _certificate The Certificate to free.
 */
static void freeNs0CertificateType(struct nexus_smartproxy_plugin_ns0_certificate *_certificate) {
  int i;
  if (_certificate->fingerprint != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor fingerprint of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    freeXsStringType(_certificate->fingerprint);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor fingerprint of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    free(_certificate->fingerprint);
  }
  if (_certificate->detail != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor detail of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    freeXsStringType(_certificate->detail);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor detail of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    free(_certificate->detail);
  }
  if (_certificate->pem != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor pem of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    freeXsStringType(_certificate->pem);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor pem of type nexus_smartproxy_plugin_ns0_certificate...\n");
#endif
    free(_certificate->pem);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_certificate_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_M

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope element from XML. The element to be read is "publish-subscribe-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Publish_subscribe_requestElement(reader);
}

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  return xmlTextWriterWriteNs0Publish_subscribe_requestElementNS(writer, _configurePublishSubscribeRequestEnvelope, 1);
}

/**
 * Frees a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  freeNs0ConfigurePublishSubscribeRequestEnvelopeType(_configurePublishSubscribeRequestEnvelope);
  free(_configurePublishSubscribeRequestEnvelope);
}

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope element from XML. The element to be read is "publish-subscribe-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xmlTextReaderReadNs0Publish_subscribe_requestElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "publish-subscribe-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}publish-subscribe-request.\n");
#endif
    _configurePublishSubscribeRequestEnvelope = xmlTextReaderReadNs0ConfigurePublishSubscribeRequestEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_configurePublishSubscribeRequestEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}publish-subscribe-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}publish-subscribe-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _configurePublishSubscribeRequestEnvelope;
}

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  return xmlTextWriterWriteNs0Publish_subscribe_requestElementNS(writer, _configurePublishSubscribeRequestEnvelope, 0);
}

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML under element name "publish-subscribe-request".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish-subscribe-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}publish-subscribe-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}configurePublishSubscribeRequestEnvelope for root element {}publish-subscribe-request...\n");
#endif
  status = xmlTextWriterWriteNs0ConfigurePublishSubscribeRequestEnvelopeType(writer, _configurePublishSubscribeRequestEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}publish-subscribe-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}publish-subscribe-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope whose children are to be free.
 */
static void freeNs0Publish_subscribe_requestElement(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  freeNs0ConfigurePublishSubscribeRequestEnvelopeType(_configurePublishSubscribeRequestEnvelope);
}

/**
 * Reads a ConfigurePublishSubscribeRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the ConfigurePublishSubscribeRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *xmlTextReaderReadNs0ConfigurePublishSubscribeRequestEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ConfigurePublishSubscribeRequestEnvelopeType(_configurePublishSubscribeRequestEnvelope);
        free(_configurePublishSubscribeRequestEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}publish-subscribe-request.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Publish_subscribe_requestType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}publish-subscribe-request.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ConfigurePublishSubscribeRequestEnvelopeType(_configurePublishSubscribeRequestEnvelope);
          free(_configurePublishSubscribeRequestEnvelope);
          return NULL;
        }

        _configurePublishSubscribeRequestEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_publish_subscribe_request*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}configurePublishSubscribeRequestEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}configurePublishSubscribeRequestEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _configurePublishSubscribeRequestEnvelope;
}

/**
 * Writes a ConfigurePublishSubscribeRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ConfigurePublishSubscribeRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_configurePublishSubscribeRequestEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}publish-subscribe-request for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Publish_subscribe_requestType(writer, (_configurePublishSubscribeRequestEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}publish-subscribe-request for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ConfigurePublishSubscribeRequestEnvelope.
 *
 * @param _configurePublishSubscribeRequestEnvelope The ConfigurePublishSubscribeRequestEnvelope to free.
 */
static void freeNs0ConfigurePublishSubscribeRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope *_configurePublishSubscribeRequestEnvelope) {
  int i;
  if (_configurePublishSubscribeRequestEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope...\n");
#endif
    freeNs0Publish_subscribe_requestType(_configurePublishSubscribeRequestEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope...\n");
#endif
    free(_configurePublishSubscribeRequestEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeRequestEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_M

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope element from XML. The element to be read is "publish-subscribe-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Publish_subscribe_responseElement(reader);
}

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  return xmlTextWriterWriteNs0Publish_subscribe_responseElementNS(writer, _configurePublishSubscribeResponseEnvelope, 1);
}

/**
 * Frees a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  freeNs0ConfigurePublishSubscribeResponseEnvelopeType(_configurePublishSubscribeResponseEnvelope);
  free(_configurePublishSubscribeResponseEnvelope);
}

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope element from XML. The element to be read is "publish-subscribe-response", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xmlTextReaderReadNs0Publish_subscribe_responseElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "publish-subscribe-response", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}publish-subscribe-response.\n");
#endif
    _configurePublishSubscribeResponseEnvelope = xmlTextReaderReadNs0ConfigurePublishSubscribeResponseEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_configurePublishSubscribeResponseEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}publish-subscribe-response failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}publish-subscribe-response failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _configurePublishSubscribeResponseEnvelope;
}

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  return xmlTextWriterWriteNs0Publish_subscribe_responseElementNS(writer, _configurePublishSubscribeResponseEnvelope, 0);
}

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML under element name "publish-subscribe-response".
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish-subscribe-response", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}publish-subscribe-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}configurePublishSubscribeResponseEnvelope for root element {}publish-subscribe-response...\n");
#endif
  status = xmlTextWriterWriteNs0ConfigurePublishSubscribeResponseEnvelopeType(writer, _configurePublishSubscribeResponseEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}publish-subscribe-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}publish-subscribe-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope whose children are to be free.
 */
static void freeNs0Publish_subscribe_responseElement(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  freeNs0ConfigurePublishSubscribeResponseEnvelopeType(_configurePublishSubscribeResponseEnvelope);
}

/**
 * Reads a ConfigurePublishSubscribeResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the ConfigurePublishSubscribeResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *xmlTextReaderReadNs0ConfigurePublishSubscribeResponseEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0ConfigurePublishSubscribeResponseEnvelopeType(_configurePublishSubscribeResponseEnvelope);
        free(_configurePublishSubscribeResponseEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}publish-subscribe-response.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Publish_subscribe_responseType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}publish-subscribe-response.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0ConfigurePublishSubscribeResponseEnvelopeType(_configurePublishSubscribeResponseEnvelope);
          free(_configurePublishSubscribeResponseEnvelope);
          return NULL;
        }

        _configurePublishSubscribeResponseEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_publish_subscribe_response*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}configurePublishSubscribeResponseEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}configurePublishSubscribeResponseEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _configurePublishSubscribeResponseEnvelope;
}

/**
 * Writes a ConfigurePublishSubscribeResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0ConfigurePublishSubscribeResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_configurePublishSubscribeResponseEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}publish-subscribe-response for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Publish_subscribe_responseType(writer, (_configurePublishSubscribeResponseEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}publish-subscribe-response for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a ConfigurePublishSubscribeResponseEnvelope.
 *
 * @param _configurePublishSubscribeResponseEnvelope The ConfigurePublishSubscribeResponseEnvelope to free.
 */
static void freeNs0ConfigurePublishSubscribeResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope *_configurePublishSubscribeResponseEnvelope) {
  int i;
  if (_configurePublishSubscribeResponseEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope...\n");
#endif
    freeNs0Publish_subscribe_responseType(_configurePublishSubscribeResponseEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope...\n");
#endif
    free(_configurePublishSubscribeResponseEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_configurePublishSubscribeResponseEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_M
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_M

/**
 * Reads a PublishSubscribe from XML. The reader is assumed to be at the start element.
 *
 * @return the PublishSubscribe, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe *xmlTextReaderReadNs0Publish_subscribeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_publish_subscribe *_publishSubscribe = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_publish_subscribe));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Publish_subscribeType(_publishSubscribe);
        free(_publishSubscribe);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "subscribe", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribeType(_publishSubscribe);
          free(_publishSubscribe);
          return NULL;
        }

        _publishSubscribe->subscribe = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribeType(_publishSubscribe);
          free(_publishSubscribe);
          return NULL;
        }

        _publishSubscribe->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "publish", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribeType(_publishSubscribe);
          free(_publishSubscribe);
          return NULL;
        }

        _publishSubscribe->publish = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "preemptiveFetch", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribeType(_publishSubscribe);
          free(_publishSubscribe);
          return NULL;
        }

        _publishSubscribe->preemptiveFetch = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}publish-subscribe.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}publish-subscribe. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _publishSubscribe;
}

/**
 * Writes a PublishSubscribe to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribe The PublishSubscribe to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Publish_subscribeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe *_publishSubscribe) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscribe", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribe->subscribe));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribe->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_publishSubscribe->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribe->publish));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "preemptiveFetch", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribe->preemptiveFetch));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PublishSubscribe.
 *
 * @param _publishSubscribe The PublishSubscribe to free.
 */
static void freeNs0Publish_subscribeType(struct nexus_smartproxy_plugin_ns0_publish_subscribe *_publishSubscribe) {
  int i;
  if (_publishSubscribe->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe...\n");
#endif
    freeXsStringType(_publishSubscribe->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe...\n");
#endif
    free(_publishSubscribe->repositoryId);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_M
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_M

/**
 * Reads a PublishSubscribeRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the PublishSubscribeRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *xmlTextReaderReadNs0Publish_subscribe_requestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *_publishSubscribeRequest = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_publish_subscribe_request));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Publish_subscribe_requestType(_publishSubscribeRequest);
        free(_publishSubscribeRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "subscribe", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_requestType(_publishSubscribeRequest);
          free(_publishSubscribeRequest);
          return NULL;
        }

        _publishSubscribeRequest->subscribe = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_requestType(_publishSubscribeRequest);
          free(_publishSubscribeRequest);
          return NULL;
        }

        _publishSubscribeRequest->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "publish", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_requestType(_publishSubscribeRequest);
          free(_publishSubscribeRequest);
          return NULL;
        }

        _publishSubscribeRequest->publish = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "preemptiveFetch", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_requestType(_publishSubscribeRequest);
          free(_publishSubscribeRequest);
          return NULL;
        }

        _publishSubscribeRequest->preemptiveFetch = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}publish-subscribe-request.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}publish-subscribe-request. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _publishSubscribeRequest;
}

/**
 * Writes a PublishSubscribeRequest to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribeRequest The PublishSubscribeRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Publish_subscribe_requestType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *_publishSubscribeRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscribe", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeRequest->subscribe));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribeRequest->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_publishSubscribeRequest->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeRequest->publish));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "preemptiveFetch", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeRequest->preemptiveFetch));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PublishSubscribeRequest.
 *
 * @param _publishSubscribeRequest The PublishSubscribeRequest to free.
 */
static void freeNs0Publish_subscribe_requestType(struct nexus_smartproxy_plugin_ns0_publish_subscribe_request *_publishSubscribeRequest) {
  int i;
  if (_publishSubscribeRequest->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe_request...\n");
#endif
    freeXsStringType(_publishSubscribeRequest->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe_request...\n");
#endif
    free(_publishSubscribeRequest->repositoryId);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_request_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_M
#define DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_M

/**
 * Reads a PublishSubscribeResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the PublishSubscribeResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *xmlTextReaderReadNs0Publish_subscribe_responseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *_publishSubscribeResponse = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_publish_subscribe_response));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
        free(_publishSubscribeResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "subscribe", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}subscribe of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->subscribe = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->repositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "publish", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}publish of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->publish = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "preemptiveFetch", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}preemptiveFetch of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->preemptiveFetch = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}certificate of type {}certificate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CertificateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}certificate of type {}certificate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->certificate = ((struct nexus_smartproxy_plugin_ns0_certificate*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "subscriptionStatus", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}subscriptionStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}subscriptionStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->subscriptionStatus = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "publishStatus", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}publishStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}publishStatus of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Publish_subscribe_responseType(_publishSubscribeResponse);
          free(_publishSubscribeResponse);
          return NULL;
        }

        _publishSubscribeResponse->publishStatus = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}publish-subscribe-response.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}publish-subscribe-response. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _publishSubscribeResponse;
}

/**
 * Writes a PublishSubscribeResponse to XML.
 *
 * @param writer The XML writer.
 * @param _publishSubscribeResponse The PublishSubscribeResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Publish_subscribe_responseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *_publishSubscribeResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscribe", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeResponse->subscribe));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}subscribe. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribeResponse->repositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_publishSubscribeResponse->repositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publish", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeResponse->publish));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}publish. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "preemptiveFetch", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_publishSubscribeResponse->preemptiveFetch));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}preemptiveFetch. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribeResponse->certificate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}certificate for element {}certificate...\n");
#endif
    status = xmlTextWriterWriteNs0CertificateType(writer, (_publishSubscribeResponse->certificate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}certificate for element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribeResponse->subscriptionStatus != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "subscriptionStatus", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}subscriptionStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}subscriptionStatus...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_publishSubscribeResponse->subscriptionStatus));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}subscriptionStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}subscriptionStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_publishSubscribeResponse->publishStatus != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "publishStatus", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}publishStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}publishStatus...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_publishSubscribeResponse->publishStatus));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}publishStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}publishStatus. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PublishSubscribeResponse.
 *
 * @param _publishSubscribeResponse The PublishSubscribeResponse to free.
 */
static void freeNs0Publish_subscribe_responseType(struct nexus_smartproxy_plugin_ns0_publish_subscribe_response *_publishSubscribeResponse) {
  int i;
  if (_publishSubscribeResponse->repositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    freeXsStringType(_publishSubscribeResponse->repositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryId of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    free(_publishSubscribeResponse->repositoryId);
  }
  if (_publishSubscribeResponse->certificate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor certificate of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    freeNs0CertificateType(_publishSubscribeResponse->certificate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor certificate of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    free(_publishSubscribeResponse->certificate);
  }
  if (_publishSubscribeResponse->subscriptionStatus != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor subscriptionStatus of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    freeXsStringType(_publishSubscribeResponse->subscriptionStatus);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor subscriptionStatus of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    free(_publishSubscribeResponse->subscriptionStatus);
  }
  if (_publishSubscribeResponse->publishStatus != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor publishStatus of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    freeXsStringType(_publishSubscribeResponse->publishStatus);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor publishStatus of type nexus_smartproxy_plugin_ns0_publish_subscribe_response...\n");
#endif
    free(_publishSubscribeResponse->publishStatus);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_publish_subscribe_response_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_M
#define DEF_nexus_smartproxy_plugin_ns0_settings_M

/**
 * Reads a Settings from XML. The reader is assumed to be at the start element.
 *
 * @return the Settings, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings *xmlTextReaderReadNs0SettingsType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_settings *_settings = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_settings));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SettingsType(_settings);
        free(_settings);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsType(_settings);
          free(_settings);
          return NULL;
        }

        _settings->enabled = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "advertiseUri", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsType(_settings);
          free(_settings);
          return NULL;
        }

        _settings->advertiseUri = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "identity", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}identity of type {}certificate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CertificateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}identity of type {}certificate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsType(_settings);
          free(_settings);
          return NULL;
        }

        _settings->identity = ((struct nexus_smartproxy_plugin_ns0_certificate*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsType(_settings);
          free(_settings);
          return NULL;
        }

        _settings->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsType(_settings);
          free(_settings);
          return NULL;
        }

        _settings->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}settings.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}settings. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settings;
}

/**
 * Writes a Settings to XML.
 *
 * @param writer The XML writer.
 * @param _settings The Settings to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SettingsType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings *_settings) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_settings->enabled != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, (_settings->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settings->advertiseUri != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "advertiseUri", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settings->advertiseUri));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settings->identity != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "identity", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}certificate for element {}identity...\n");
#endif
    status = xmlTextWriterWriteNs0CertificateType(writer, (_settings->identity));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}certificate for element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n");
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_settings->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settings->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settings->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a Settings.
 *
 * @param _settings The Settings to free.
 */
static void freeNs0SettingsType(struct nexus_smartproxy_plugin_ns0_settings *_settings) {
  int i;
  if (_settings->enabled != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor enabled of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    freeXsBooleanType(_settings->enabled);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor enabled of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    free(_settings->enabled);
  }
  if (_settings->advertiseUri != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    freeXsStringType(_settings->advertiseUri);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    free(_settings->advertiseUri);
  }
  if (_settings->identity != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor identity of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    freeNs0CertificateType(_settings->identity);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor identity of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    free(_settings->identity);
  }
  if (_settings->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    freeXsStringType(_settings->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type nexus_smartproxy_plugin_ns0_settings...\n");
#endif
    free(_settings->host);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_request_M
#define DEF_nexus_smartproxy_plugin_ns0_settings_request_M

/**
 * Reads a SettingsRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the SettingsRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings_request *xmlTextReaderReadNs0Settings_requestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_settings_request *_settingsRequest = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_settings_request));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Settings_requestType(_settingsRequest);
        free(_settingsRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->enabled = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "advertiseUri", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->advertiseUri = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "identity", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}identity of type {}certificate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CertificateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}identity of type {}certificate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->identity = ((struct nexus_smartproxy_plugin_ns0_certificate*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "trusted-keys", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}trusted-keys...\n");
#endif
          //start wrapper element "{}trusted-keys"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0Settings_requestType(_settingsRequest);
              free(_settingsRequest);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "trusted-key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}trusted-key of type {}trusted-key.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Trusted_keyType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}trusted-key of type {}trusted-key.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }

        _settingsRequest->trustedKeys = realloc(_settingsRequest->trustedKeys, (_settingsRequest->_sizeof_trustedKeys + 1) * sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));
        memcpy(&(_settingsRequest->trustedKeys[_settingsRequest->_sizeof_trustedKeys++]), _child_accessor, sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}trusted-keys.\n");
#endif
          freeNs0Settings_requestType(_settingsRequest);
          free(_settingsRequest);
          return NULL;
        }
        else {
          //end wrapper element "{}trusted-keys"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}settings-request.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}settings-request. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settingsRequest;
}

/**
 * Writes a SettingsRequest to XML.
 *
 * @param writer The XML writer.
 * @param _settingsRequest The SettingsRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Settings_requestType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings_request *_settingsRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_settingsRequest->enabled != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, (_settingsRequest->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsRequest->advertiseUri != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "advertiseUri", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settingsRequest->advertiseUri));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsRequest->identity != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "identity", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}certificate for element {}identity...\n");
#endif
    status = xmlTextWriterWriteNs0CertificateType(writer, (_settingsRequest->identity));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}certificate for element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n");
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_settingsRequest->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsRequest->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settingsRequest->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_settingsRequest->trustedKeys != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-keys", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}trusted-keys. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _settingsRequest->_sizeof_trustedKeys; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}trusted-key for element {}trusted-key...\n");
#endif
    status = xmlTextWriterWriteNs0Trusted_keyType(writer, &(_settingsRequest->trustedKeys[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}trusted-key for element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_settingsRequest->trustedKeys != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}trusted-keys. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SettingsRequest.
 *
 * @param _settingsRequest The SettingsRequest to free.
 */
static void freeNs0Settings_requestType(struct nexus_smartproxy_plugin_ns0_settings_request *_settingsRequest) {
  int i;
  if (_settingsRequest->enabled != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor enabled of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    freeXsBooleanType(_settingsRequest->enabled);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor enabled of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    free(_settingsRequest->enabled);
  }
  if (_settingsRequest->advertiseUri != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    freeXsStringType(_settingsRequest->advertiseUri);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    free(_settingsRequest->advertiseUri);
  }
  if (_settingsRequest->identity != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor identity of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    freeNs0CertificateType(_settingsRequest->identity);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor identity of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    free(_settingsRequest->identity);
  }
  if (_settingsRequest->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    freeXsStringType(_settingsRequest->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    free(_settingsRequest->host);
  }
  if (_settingsRequest->trustedKeys != NULL) {
    for (i = 0; i < _settingsRequest->_sizeof_trustedKeys; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor trustedKeys[%i] of type nexus_smartproxy_plugin_ns0_settings_request...\n", i);
#endif
      freeNs0Trusted_keyType(&(_settingsRequest->trustedKeys[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor trustedKeys of type nexus_smartproxy_plugin_ns0_settings_request...\n");
#endif
    free(_settingsRequest->trustedKeys);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_request_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_M

/**
 * Reads a SettingsRequestEnvelope element from XML. The element to be read is "settings-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Settings_requestElement(reader);
}

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  return xmlTextWriterWriteNs0Settings_requestElementNS(writer, _settingsRequestEnvelope, 1);
}

/**
 * Frees a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  freeNs0SettingsRequestEnvelopeType(_settingsRequestEnvelope);
  free(_settingsRequestEnvelope);
}

/**
 * Reads a SettingsRequestEnvelope element from XML. The element to be read is "settings-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SettingsRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xmlTextReaderReadNs0Settings_requestElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "settings-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}settings-request.\n");
#endif
    _settingsRequestEnvelope = xmlTextReaderReadNs0SettingsRequestEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_settingsRequestEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}settings-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}settings-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _settingsRequestEnvelope;
}

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  return xmlTextWriterWriteNs0Settings_requestElementNS(writer, _settingsRequestEnvelope, 0);
}

/**
 * Writes a SettingsRequestEnvelope to XML under element name "settings-request".
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settings-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}settingsRequestEnvelope for root element {}settings-request...\n");
#endif
  status = xmlTextWriterWriteNs0SettingsRequestEnvelopeType(writer, _settingsRequestEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}settings-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope whose children are to be free.
 */
static void freeNs0Settings_requestElement(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  freeNs0SettingsRequestEnvelopeType(_settingsRequestEnvelope);
}

/**
 * Reads a SettingsRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the SettingsRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *xmlTextReaderReadNs0SettingsRequestEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SettingsRequestEnvelopeType(_settingsRequestEnvelope);
        free(_settingsRequestEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}settings-request.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Settings_requestType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}settings-request.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsRequestEnvelopeType(_settingsRequestEnvelope);
          free(_settingsRequestEnvelope);
          return NULL;
        }

        _settingsRequestEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_settings_request*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}settingsRequestEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}settingsRequestEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settingsRequestEnvelope;
}

/**
 * Writes a SettingsRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SettingsRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_settingsRequestEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}settings-request for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Settings_requestType(writer, (_settingsRequestEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}settings-request for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SettingsRequestEnvelope.
 *
 * @param _settingsRequestEnvelope The SettingsRequestEnvelope to free.
 */
static void freeNs0SettingsRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_settingsRequestEnvelope *_settingsRequestEnvelope) {
  int i;
  if (_settingsRequestEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_settingsRequestEnvelope...\n");
#endif
    freeNs0Settings_requestType(_settingsRequestEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_settingsRequestEnvelope...\n");
#endif
    free(_settingsRequestEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_settingsRequestEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settings_response_M
#define DEF_nexus_smartproxy_plugin_ns0_settings_response_M

/**
 * Reads a SettingsResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the SettingsResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settings_response *xmlTextReaderReadNs0Settings_responseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_settings_response *_settingsResponse = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_settings_response));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Settings_responseType(_settingsResponse);
        free(_settingsResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->enabled = ((int*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "advertiseUri", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}advertiseUri of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->advertiseUri = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "identity", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}identity of type {}certificate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CertificateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}identity of type {}certificate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->identity = ((struct nexus_smartproxy_plugin_ns0_certificate*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "port", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}port of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->port = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "host", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}host of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->host = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Settings_responseType(_settingsResponse);
          free(_settingsResponse);
          return NULL;
        }

        _settingsResponse->status = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}settings-response.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}settings-response. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settingsResponse;
}

/**
 * Writes a SettingsResponse to XML.
 *
 * @param writer The XML writer.
 * @param _settingsResponse The SettingsResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Settings_responseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settings_response *_settingsResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_settingsResponse->enabled != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n");
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, (_settingsResponse->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsResponse->advertiseUri != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "advertiseUri", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settingsResponse->advertiseUri));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}advertiseUri. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsResponse->identity != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "identity", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}certificate for element {}identity...\n");
#endif
    status = xmlTextWriterWriteNs0CertificateType(writer, (_settingsResponse->identity));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}certificate for element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}identity. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "port", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}port...\n");
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_settingsResponse->port));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}port. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsResponse->host != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "host", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}host...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settingsResponse->host));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}host. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_settingsResponse->status != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "status", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}status...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_settingsResponse->status));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SettingsResponse.
 *
 * @param _settingsResponse The SettingsResponse to free.
 */
static void freeNs0Settings_responseType(struct nexus_smartproxy_plugin_ns0_settings_response *_settingsResponse) {
  int i;
  if (_settingsResponse->enabled != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor enabled of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    freeXsBooleanType(_settingsResponse->enabled);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor enabled of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    free(_settingsResponse->enabled);
  }
  if (_settingsResponse->advertiseUri != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    freeXsStringType(_settingsResponse->advertiseUri);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor advertiseUri of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    free(_settingsResponse->advertiseUri);
  }
  if (_settingsResponse->identity != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor identity of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    freeNs0CertificateType(_settingsResponse->identity);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor identity of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    free(_settingsResponse->identity);
  }
  if (_settingsResponse->host != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor host of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    freeXsStringType(_settingsResponse->host);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor host of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    free(_settingsResponse->host);
  }
  if (_settingsResponse->status != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor status of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    freeXsStringType(_settingsResponse->status);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor status of type nexus_smartproxy_plugin_ns0_settings_response...\n");
#endif
    free(_settingsResponse->status);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_settings_response_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_M

/**
 * Reads a SettingsResponseEnvelope element from XML. The element to be read is "settings-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The SettingsResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Settings_responseElement(reader);
}

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  return xmlTextWriterWriteNs0Settings_responseElementNS(writer, _settingsResponseEnvelope, 1);
}

/**
 * Frees a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  freeNs0SettingsResponseEnvelopeType(_settingsResponseEnvelope);
  free(_settingsResponseEnvelope);
}

/**
 * Reads a SettingsResponseEnvelope element from XML. The element to be read is "settings-response", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The SettingsResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xmlTextReaderReadNs0Settings_responseElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "settings-response", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}settings-response.\n");
#endif
    _settingsResponseEnvelope = xmlTextReaderReadNs0SettingsResponseEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_settingsResponseEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}settings-response failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}settings-response failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _settingsResponseEnvelope;
}

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  return xmlTextWriterWriteNs0Settings_responseElementNS(writer, _settingsResponseEnvelope, 0);
}

/**
 * Writes a SettingsResponseEnvelope to XML under element name "settings-response".
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Settings_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "settings-response", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}settings-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}settingsResponseEnvelope for root element {}settings-response...\n");
#endif
  status = xmlTextWriterWriteNs0SettingsResponseEnvelopeType(writer, _settingsResponseEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}settings-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}settings-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope whose children are to be free.
 */
static void freeNs0Settings_responseElement(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  freeNs0SettingsResponseEnvelopeType(_settingsResponseEnvelope);
}

/**
 * Reads a SettingsResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the SettingsResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *xmlTextReaderReadNs0SettingsResponseEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0SettingsResponseEnvelopeType(_settingsResponseEnvelope);
        free(_settingsResponseEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}settings-response.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Settings_responseType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}settings-response.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0SettingsResponseEnvelopeType(_settingsResponseEnvelope);
          free(_settingsResponseEnvelope);
          return NULL;
        }

        _settingsResponseEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_settings_response*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}settingsResponseEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}settingsResponseEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _settingsResponseEnvelope;
}

/**
 * Writes a SettingsResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0SettingsResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_settingsResponseEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}settings-response for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Settings_responseType(writer, (_settingsResponseEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}settings-response for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a SettingsResponseEnvelope.
 *
 * @param _settingsResponseEnvelope The SettingsResponseEnvelope to free.
 */
static void freeNs0SettingsResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_settingsResponseEnvelope *_settingsResponseEnvelope) {
  int i;
  if (_settingsResponseEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_settingsResponseEnvelope...\n");
#endif
    freeNs0Settings_responseType(_settingsResponseEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_settingsResponseEnvelope...\n");
#endif
    free(_settingsResponseEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_settingsResponseEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trusted_key_M
#define DEF_nexus_smartproxy_plugin_ns0_trusted_key_M

/**
 * Reads a TrustedKeyRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the TrustedKeyRequest, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trusted_key *xmlTextReaderReadNs0Trusted_keyType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyRequest = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Trusted_keyType(_trustedKeyRequest);
        free(_trustedKeyRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyRequest);
          free(_trustedKeyRequest);
          return NULL;
        }

        _trustedKeyRequest->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}certificate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}certificate of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyRequest);
          free(_trustedKeyRequest);
          return NULL;
        }

        _trustedKeyRequest->certificate = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyRequest);
          free(_trustedKeyRequest);
          return NULL;
        }

        _trustedKeyRequest->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}trusted-key.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}trusted-key. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _trustedKeyRequest;
}

/**
 * Writes a TrustedKeyRequest to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequest The TrustedKeyRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Trusted_keyType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_trustedKeyRequest->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_trustedKeyRequest->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_trustedKeyRequest->certificate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}certificate...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_trustedKeyRequest->certificate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_trustedKeyRequest->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_trustedKeyRequest->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a TrustedKeyRequest.
 *
 * @param _trustedKeyRequest The TrustedKeyRequest to free.
 */
static void freeNs0Trusted_keyType(struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyRequest) {
  int i;
  if (_trustedKeyRequest->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeXsStringType(_trustedKeyRequest->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyRequest->id);
  }
  if (_trustedKeyRequest->certificate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor certificate of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeXsStringType(_trustedKeyRequest->certificate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor certificate of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyRequest->certificate);
  }
  if (_trustedKeyRequest->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeXsStringType(_trustedKeyRequest->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyRequest->description);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_trusted_key_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_M

/**
 * Reads a TrustedKeyRequestEnvelope element from XML. The element to be read is "trusted-key-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Trusted_key_requestElement(reader);
}

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  return xmlTextWriterWriteNs0Trusted_key_requestElementNS(writer, _trustedKeyRequestEnvelope, 1);
}

/**
 * Frees a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  freeNs0TrustedKeyRequestEnvelopeType(_trustedKeyRequestEnvelope);
  free(_trustedKeyRequestEnvelope);
}

/**
 * Reads a TrustedKeyRequestEnvelope element from XML. The element to be read is "trusted-key-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyRequestEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xmlTextReaderReadNs0Trusted_key_requestElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-key-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}trusted-key-request.\n");
#endif
    _trustedKeyRequestEnvelope = xmlTextReaderReadNs0TrustedKeyRequestEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_trustedKeyRequestEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}trusted-key-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}trusted-key-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _trustedKeyRequestEnvelope;
}

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_key_requestElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  return xmlTextWriterWriteNs0Trusted_key_requestElementNS(writer, _trustedKeyRequestEnvelope, 0);
}

/**
 * Writes a TrustedKeyRequestEnvelope to XML under element name "trusted-key-request".
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_key_requestElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}trusted-key-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}trustedKeyRequestEnvelope for root element {}trusted-key-request...\n");
#endif
  status = xmlTextWriterWriteNs0TrustedKeyRequestEnvelopeType(writer, _trustedKeyRequestEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}trusted-key-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}trusted-key-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope whose children are to be free.
 */
static void freeNs0Trusted_key_requestElement(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  freeNs0TrustedKeyRequestEnvelopeType(_trustedKeyRequestEnvelope);
}

/**
 * Reads a TrustedKeyRequestEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the TrustedKeyRequestEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *xmlTextReaderReadNs0TrustedKeyRequestEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0TrustedKeyRequestEnvelopeType(_trustedKeyRequestEnvelope);
        free(_trustedKeyRequestEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}trusted-key.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Trusted_keyType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}trusted-key.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0TrustedKeyRequestEnvelopeType(_trustedKeyRequestEnvelope);
          free(_trustedKeyRequestEnvelope);
          return NULL;
        }

        _trustedKeyRequestEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_trusted_key*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}trustedKeyRequestEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}trustedKeyRequestEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _trustedKeyRequestEnvelope;
}

/**
 * Writes a TrustedKeyRequestEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0TrustedKeyRequestEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_trustedKeyRequestEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}trusted-key for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Trusted_keyType(writer, (_trustedKeyRequestEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}trusted-key for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a TrustedKeyRequestEnvelope.
 *
 * @param _trustedKeyRequestEnvelope The TrustedKeyRequestEnvelope to free.
 */
static void freeNs0TrustedKeyRequestEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope *_trustedKeyRequestEnvelope) {
  int i;
  if (_trustedKeyRequestEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope...\n");
#endif
    freeNs0Trusted_keyType(_trustedKeyRequestEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope...\n");
#endif
    free(_trustedKeyRequestEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeyRequestEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trusted_key_M
#define DEF_nexus_smartproxy_plugin_ns0_trusted_key_M

/**
 * Reads a TrustedKeyResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the TrustedKeyResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trusted_key *xmlTextReaderReadNs0Trusted_keyType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyResponse = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0Trusted_keyType(_trustedKeyResponse);
        free(_trustedKeyResponse);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyResponse);
          free(_trustedKeyResponse);
          return NULL;
        }

        _trustedKeyResponse->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "certificate", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}certificate of type {}certificate.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0CertificateType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}certificate of type {}certificate.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyResponse);
          free(_trustedKeyResponse);
          return NULL;
        }

        _trustedKeyResponse->certificate = ((struct nexus_smartproxy_plugin_ns0_certificate*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0Trusted_keyType(_trustedKeyResponse);
          free(_trustedKeyResponse);
          return NULL;
        }

        _trustedKeyResponse->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}trusted-key.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}trusted-key. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _trustedKeyResponse;
}

/**
 * Writes a TrustedKeyResponse to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponse The TrustedKeyResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0Trusted_keyType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_trustedKeyResponse->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_trustedKeyResponse->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_trustedKeyResponse->certificate != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "certificate", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}certificate for element {}certificate...\n");
#endif
    status = xmlTextWriterWriteNs0CertificateType(writer, (_trustedKeyResponse->certificate));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}certificate for element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}certificate. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_trustedKeyResponse->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n");
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_trustedKeyResponse->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a TrustedKeyResponse.
 *
 * @param _trustedKeyResponse The TrustedKeyResponse to free.
 */
static void freeNs0Trusted_keyType(struct nexus_smartproxy_plugin_ns0_trusted_key *_trustedKeyResponse) {
  int i;
  if (_trustedKeyResponse->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeXsStringType(_trustedKeyResponse->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyResponse->description);
  }
  if (_trustedKeyResponse->certificate != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor certificate of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeNs0CertificateType(_trustedKeyResponse->certificate);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor certificate of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyResponse->certificate);
  }
  if (_trustedKeyResponse->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    freeXsStringType(_trustedKeyResponse->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_smartproxy_plugin_ns0_trusted_key...\n");
#endif
    free(_trustedKeyResponse->id);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_trusted_key_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_M

/**
 * Reads a TrustedKeyResponseEnvelope element from XML. The element to be read is "trusted-key-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Trusted_key_responseElement(reader);
}

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  return xmlTextWriterWriteNs0Trusted_key_responseElementNS(writer, _trustedKeyResponseEnvelope, 1);
}

/**
 * Frees a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  freeNs0TrustedKeyResponseEnvelopeType(_trustedKeyResponseEnvelope);
  free(_trustedKeyResponseEnvelope);
}

/**
 * Reads a TrustedKeyResponseEnvelope element from XML. The element to be read is "trusted-key-response", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeyResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xmlTextReaderReadNs0Trusted_key_responseElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-key-response", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}trusted-key-response.\n");
#endif
    _trustedKeyResponseEnvelope = xmlTextReaderReadNs0TrustedKeyResponseEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_trustedKeyResponseEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}trusted-key-response failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}trusted-key-response failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _trustedKeyResponseEnvelope;
}

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_key_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  return xmlTextWriterWriteNs0Trusted_key_responseElementNS(writer, _trustedKeyResponseEnvelope, 0);
}

/**
 * Writes a TrustedKeyResponseEnvelope to XML under element name "trusted-key-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_key_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key-response", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}trusted-key-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}trustedKeyResponseEnvelope for root element {}trusted-key-response...\n");
#endif
  status = xmlTextWriterWriteNs0TrustedKeyResponseEnvelopeType(writer, _trustedKeyResponseEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}trusted-key-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}trusted-key-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope whose children are to be free.
 */
static void freeNs0Trusted_key_responseElement(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  freeNs0TrustedKeyResponseEnvelopeType(_trustedKeyResponseEnvelope);
}

/**
 * Reads a TrustedKeyResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the TrustedKeyResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *xmlTextReaderReadNs0TrustedKeyResponseEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0TrustedKeyResponseEnvelopeType(_trustedKeyResponseEnvelope);
        free(_trustedKeyResponseEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}trusted-key.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Trusted_keyType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}trusted-key.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0TrustedKeyResponseEnvelopeType(_trustedKeyResponseEnvelope);
          free(_trustedKeyResponseEnvelope);
          return NULL;
        }

        _trustedKeyResponseEnvelope->data = ((struct nexus_smartproxy_plugin_ns0_trusted_key*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}trustedKeyResponseEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}trustedKeyResponseEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _trustedKeyResponseEnvelope;
}

/**
 * Writes a TrustedKeyResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0TrustedKeyResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_trustedKeyResponseEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}trusted-key for element {}data...\n");
#endif
    status = xmlTextWriterWriteNs0Trusted_keyType(writer, (_trustedKeyResponseEnvelope->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}trusted-key for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a TrustedKeyResponseEnvelope.
 *
 * @param _trustedKeyResponseEnvelope The TrustedKeyResponseEnvelope to free.
 */
static void freeNs0TrustedKeyResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope *_trustedKeyResponseEnvelope) {
  int i;
  if (_trustedKeyResponseEnvelope->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope...\n");
#endif
    freeNs0Trusted_keyType(_trustedKeyResponseEnvelope->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope...\n");
#endif
    free(_trustedKeyResponseEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeyResponseEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_M
#define DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_M

/**
 * Reads a TrustedKeysResponseEnvelope element from XML. The element to be read is "trusted-keys-response", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The TrustedKeysResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xml_read_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Trusted_keys_responseElement(reader);
}

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  return xmlTextWriterWriteNs0Trusted_keys_responseElementNS(writer, _trustedKeysResponseEnvelope, 1);
}

/**
 * Frees a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to free.
 */
void free_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
  free(_trustedKeysResponseEnvelope);
}

/**
 * Reads a TrustedKeysResponseEnvelope element from XML. The element to be read is "trusted-keys-response", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The TrustedKeysResponseEnvelope, or NULL in case of error.
 */
struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xmlTextReaderReadNs0Trusted_keys_responseElement(xmlTextReaderPtr reader) {
  struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "trusted-keys-response", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}trusted-keys-response.\n");
#endif
    _trustedKeysResponseEnvelope = xmlTextReaderReadNs0TrustedKeysResponseEnvelopeType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_trustedKeysResponseEnvelope == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}trusted-keys-response failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}trusted-keys-response failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _trustedKeysResponseEnvelope;
}

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_keys_responseElement(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  return xmlTextWriterWriteNs0Trusted_keys_responseElementNS(writer, _trustedKeysResponseEnvelope, 0);
}

/**
 * Writes a TrustedKeysResponseEnvelope to XML under element name "trusted-keys-response".
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Trusted_keys_responseElementNS(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-keys-response", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}trusted-keys-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}trustedKeysResponseEnvelope for root element {}trusted-keys-response...\n");
#endif
  status = xmlTextWriterWriteNs0TrustedKeysResponseEnvelopeType(writer, _trustedKeysResponseEnvelope);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}trusted-keys-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}trusted-keys-response. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope whose children are to be free.
 */
static void freeNs0Trusted_keys_responseElement(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
}

/**
 * Reads a TrustedKeysResponseEnvelope from XML. The reader is assumed to be at the start element.
 *
 * @return the TrustedKeysResponseEnvelope, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *xmlTextReaderReadNs0TrustedKeysResponseEnvelopeType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
        free(_trustedKeysResponseEnvelope);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
              free(_trustedKeysResponseEnvelope);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "trusted-key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}trusted-key of type {}trusted-key.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0Trusted_keyType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}trusted-key of type {}trusted-key.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
          free(_trustedKeysResponseEnvelope);
          return NULL;
        }

        _trustedKeysResponseEnvelope->data = realloc(_trustedKeysResponseEnvelope->data, (_trustedKeysResponseEnvelope->_sizeof_data + 1) * sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));
        memcpy(&(_trustedKeysResponseEnvelope->data[_trustedKeysResponseEnvelope->_sizeof_data++]), _child_accessor, sizeof(struct nexus_smartproxy_plugin_ns0_trusted_key));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0TrustedKeysResponseEnvelopeType(_trustedKeysResponseEnvelope);
          free(_trustedKeysResponseEnvelope);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}trustedKeysResponseEnvelope.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}trustedKeysResponseEnvelope. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _trustedKeysResponseEnvelope;
}

/**
 * Writes a TrustedKeysResponseEnvelope to XML.
 *
 * @param writer The XML writer.
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0TrustedKeysResponseEnvelopeType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_trustedKeysResponseEnvelope->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _trustedKeysResponseEnvelope->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "trusted-key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
#if DEBUG_ENUNCIATE > 1
    printf("writing type {}trusted-key for element {}trusted-key...\n");
#endif
    status = xmlTextWriterWriteNs0Trusted_keyType(writer, &(_trustedKeysResponseEnvelope->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}trusted-key for element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}trusted-key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_trustedKeysResponseEnvelope->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a TrustedKeysResponseEnvelope.
 *
 * @param _trustedKeysResponseEnvelope The TrustedKeysResponseEnvelope to free.
 */
static void freeNs0TrustedKeysResponseEnvelopeType(struct nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope *_trustedKeysResponseEnvelope) {
  int i;
  if (_trustedKeysResponseEnvelope->data != NULL) {
    for (i = 0; i < _trustedKeysResponseEnvelope->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope...\n", i);
#endif
      freeNs0Trusted_keyType(&(_trustedKeysResponseEnvelope->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope...\n");
#endif
    free(_trustedKeysResponseEnvelope->data);
  }
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_trustedKeysResponseEnvelope_M */
#ifndef DEF_nexus_smartproxy_plugin_ns0_nexusResponse_M
#define DEF_nexus_smartproxy_plugin_ns0_nexusResponse_M

/**
 * Reads a NexusResponse from XML. The reader is assumed to be at the start element.
 *
 * @return the NexusResponse, or NULL in case of error.
 */
static struct nexus_smartproxy_plugin_ns0_nexusResponse *xmlTextReaderReadNs0NexusResponseType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_smartproxy_plugin_ns0_nexusResponse *_nexusResponse = calloc(1, sizeof(struct nexus_smartproxy_plugin_ns0_nexusResponse));




  return _nexusResponse;
}

/**
 * Writes a NexusResponse to XML.
 *
 * @param writer The XML writer.
 * @param _nexusResponse The NexusResponse to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0NexusResponseType(xmlTextWriterPtr writer, struct nexus_smartproxy_plugin_ns0_nexusResponse *_nexusResponse) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  return totalBytes;
}

/**
 * Frees the elements of a NexusResponse.
 *
 * @param _nexusResponse The NexusResponse to free.
 */
static void freeNs0NexusResponseType(struct nexus_smartproxy_plugin_ns0_nexusResponse *_nexusResponse) {
  int i;
}
#endif /* DEF_nexus_smartproxy_plugin_ns0_nexusResponse_M */
