//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_nexus_staging_plugin_ns0_stagingProfile_H
#define DEF_nexus_staging_plugin_ns0_stagingProfile_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingProfile {


  /**
   * (no documentation provided)
   */
  xmlChar *dropNotifyEmails;

  /**
   * (no documentation provided)
   */
  xmlChar *promotionNotifyEmails;

  /**
   * (no documentation provided)
   */
  xmlChar *promoteRuleSets;

  /**
   * Size of the promoteRuleSets array.
   */
  int _sizeof_promoteRuleSets;

  /**
   * (no documentation provided)
   */
  xmlChar *mode;

  /**
   * (no documentation provided)
   */
  xmlChar *dropNotifyRoles;

  /**
   * Size of the dropNotifyRoles array.
   */
  int _sizeof_dropNotifyRoles;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryType;

  /**
   * (no documentation provided)
   */
  int inProgress;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryTargetId;

  /**
   * (no documentation provided)
   */
  xmlChar *repositoryTemplateId;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  int promotionNotifyCreator;

  /**
   * (no documentation provided)
   */
  xmlChar *stagedRepositoryIds;

  /**
   * Size of the stagedRepositoryIds array.
   */
  int _sizeof_stagedRepositoryIds;

  /**
   * (no documentation provided)
   */
  int dropNotifyCreator;

  /**
   * (no documentation provided)
   */
  xmlChar *targetGroups;

  /**
   * Size of the targetGroups array.
   */
  int _sizeof_targetGroups;

  /**
   * (no documentation provided)
   */
  int order;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *closeRuleSets;

  /**
   * Size of the closeRuleSets array.
   */
  int _sizeof_closeRuleSets;

  /**
   * (no documentation provided)
   */
  int finishNotifyCreator;

  /**
   * (no documentation provided)
   */
  xmlChar *deployURI;

  /**
   * (no documentation provided)
   */
  int autoStagingDisabled;

  /**
   * (no documentation provided)
   */
  int repositoriesSearchable;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *promotionNotifyRoles;

  /**
   * Size of the promotionNotifyRoles array.
   */
  int _sizeof_promotionNotifyRoles;

  /**
   * (no documentation provided)
   */
  xmlChar *finishNotifyRoles;

  /**
   * Size of the finishNotifyRoles array.
   */
  int _sizeof_finishNotifyRoles;

  /**
   * (no documentation provided)
   */
  xmlChar *stagingRepositoryIds;

  /**
   * Size of the stagingRepositoryIds array.
   */
  int _sizeof_stagingRepositoryIds;

  /**
   * (no documentation provided)
   */
  xmlChar *promotionTargetRepository;

  /**
   * (no documentation provided)
   */
  xmlChar *finishNotifyEmails;
};

/**
 * Reads a StagingProfileDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfile *xmlTextReaderReadNs0StagingProfileType(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileDTO The StagingProfileDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingProfileType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfile *_stagingProfileDTO);

/**
 * Frees the elements of a StagingProfileDTO.
 *
 * @param _stagingProfileDTO The StagingProfileDTO to free.
 */
static void freeNs0StagingProfileType(struct nexus_staging_plugin_ns0_stagingProfile *_stagingProfileDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingProfile_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_H
#define DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO {


  /**
   * (no documentation provided)
   */
  xmlChar *data;

  /**
   * Size of the data array.
   */
  int _sizeof_data;
};

/**
 * Reads a StagingProfileOrderRequestDTO element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingProfileOrderRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

/**
 * Frees a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

/**
 * Reads a StagingProfileOrderRequestDTO element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileOrderRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xmlTextReaderReadNs0OrderRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0OrderRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0OrderRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO, int writeNamespaces);

/**
 * Frees the children of a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO whose children are to be free.
 */
static void freeNs0OrderRequestElement(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

/**
 * Reads a StagingProfileOrderRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileOrderRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xmlTextReaderReadNs0StagingProfileOrderRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileOrderRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingProfileOrderRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

/**
 * Frees the elements of a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to free.
 */
static void freeNs0StagingProfileOrderRequestDTOType(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_H
#define DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingProfileRequestDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_staging_plugin_ns0_stagingProfile *data;
};

/**
 * Reads a StagingProfileRequestDTO element from XML. The element to be read is "profileRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingProfileRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingProfileRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_staging_plugin_ns0_stagingProfileRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

/**
 * Frees a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingProfileRequestDTO(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

/**
 * Reads a StagingProfileRequestDTO element from XML. The element to be read is "profileRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xmlTextReaderReadNs0ProfileRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProfileRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0ProfileRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO, int writeNamespaces);

/**
 * Frees the children of a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO whose children are to be free.
 */
static void freeNs0ProfileRequestElement(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

/**
 * Reads a StagingProfileRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xmlTextReaderReadNs0StagingProfileRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a StagingProfileRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingProfileRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

/**
 * Frees the elements of a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to free.
 */
static void freeNs0StagingProfileRequestDTOType(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingPromote_H
#define DEF_nexus_staging_plugin_ns0_stagingPromote_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingPromote {


  /**
   * (no documentation provided)
   */
  xmlChar *targetRepositoryId;

  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  xmlChar *stagedRepositoryId;
};

/**
 * Reads a StagingPromoteDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingPromoteDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingPromote *xmlTextReaderReadNs0StagingPromoteType(xmlTextReaderPtr reader);

/**
 * Writes a StagingPromoteDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteDTO The StagingPromoteDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingPromoteType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromote *_stagingPromoteDTO);

/**
 * Frees the elements of a StagingPromoteDTO.
 *
 * @param _stagingPromoteDTO The StagingPromoteDTO to free.
 */
static void freeNs0StagingPromoteType(struct nexus_staging_plugin_ns0_stagingPromote *_stagingPromoteDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingPromote_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_H
#define DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_staging_plugin_ns0_stagingPromote *data;
};

/**
 * Reads a StagingPromoteRequestDTO element from XML. The element to be read is "promoteRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingPromoteRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

/**
 * Frees a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

/**
 * Reads a StagingPromoteRequestDTO element from XML. The element to be read is "promoteRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The StagingPromoteRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xmlTextReaderReadNs0PromoteRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PromoteRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PromoteRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO, int writeNamespaces);

/**
 * Frees the children of a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO whose children are to be free.
 */
static void freeNs0PromoteRequestElement(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

/**
 * Reads a StagingPromoteRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingPromoteRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xmlTextReaderReadNs0StagingPromoteRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a StagingPromoteRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingPromoteRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

/**
 * Frees the elements of a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to free.
 */
static void freeNs0StagingPromoteRequestDTOType(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRule_H
#define DEF_nexus_staging_plugin_ns0_stagingRule_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingRule {


  /**
   * (no documentation provided)
   */
  xmlChar *typeId;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  struct nexus_staging_plugin_ns0_stagingRuleProperty *properties;

  /**
   * Size of the properties array.
   */
  int _sizeof_properties;

  /**
   * (no documentation provided)
   */
  int enabled;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *typeName;
};

/**
 * Reads a StagingRuleDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingRuleDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRule *xmlTextReaderReadNs0StagingRuleType(xmlTextReaderPtr reader);

/**
 * Writes a StagingRuleDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleDTO The StagingRuleDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRuleType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRule *_stagingRuleDTO);

/**
 * Frees the elements of a StagingRuleDTO.
 *
 * @param _stagingRuleDTO The StagingRuleDTO to free.
 */
static void freeNs0StagingRuleType(struct nexus_staging_plugin_ns0_stagingRule *_stagingRuleDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingRule_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleProperty_H
#define DEF_nexus_staging_plugin_ns0_stagingRuleProperty_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingRuleProperty {


  /**
   * (no documentation provided)
   */
  xmlChar *key;

  /**
   * (no documentation provided)
   */
  xmlChar *value;
};

/**
 * Reads a StagingRulePropertyDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingRulePropertyDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleProperty *xmlTextReaderReadNs0StagingRulePropertyType(xmlTextReaderPtr reader);

/**
 * Writes a StagingRulePropertyDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRulePropertyDTO The StagingRulePropertyDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRulePropertyType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleProperty *_stagingRulePropertyDTO);

/**
 * Frees the elements of a StagingRulePropertyDTO.
 *
 * @param _stagingRulePropertyDTO The StagingRulePropertyDTO to free.
 */
static void freeNs0StagingRulePropertyType(struct nexus_staging_plugin_ns0_stagingRuleProperty *_stagingRulePropertyDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleProperty_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleSet_H
#define DEF_nexus_staging_plugin_ns0_stagingRuleSet_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingRuleSet {


  /**
   * (no documentation provided)
   */
  struct nexus_staging_plugin_ns0_stagingRule *rules;

  /**
   * Size of the rules array.
   */
  int _sizeof_rules;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *description;
};

/**
 * Reads a StagingRuleSetDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleSet *xmlTextReaderReadNs0StagingRuleSetType(xmlTextReaderPtr reader);

/**
 * Writes a StagingRuleSetDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetDTO The StagingRuleSetDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRuleSetType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSet *_stagingRuleSetDTO);

/**
 * Frees the elements of a StagingRuleSetDTO.
 *
 * @param _stagingRuleSetDTO The StagingRuleSetDTO to free.
 */
static void freeNs0StagingRuleSetType(struct nexus_staging_plugin_ns0_stagingRuleSet *_stagingRuleSetDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleSet_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_H
#define DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_H

/**
 * (no documentation provided)
 */
struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO {


  /**
   * (no documentation provided)
   */
  struct nexus_staging_plugin_ns0_stagingRuleSet *data;
};

/**
 * Reads a StagingRuleSetRequestDTO element from XML. The element to be read is "stagingRuleSetRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(xmlTextReaderPtr reader);

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

/**
 * Frees a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

/**
 * Reads a StagingRuleSetRequestDTO element from XML. The element to be read is "stagingRuleSetRequest", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xmlTextReaderReadNs0StagingRuleSetRequestElement(xmlTextReaderPtr reader);

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO, int writeNamespaces);

/**
 * Frees the children of a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO whose children are to be free.
 */
static void freeNs0StagingRuleSetRequestElement(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

/**
 * Reads a StagingRuleSetRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xmlTextReaderReadNs0StagingRuleSetRequestDTOType(xmlTextReaderPtr reader);

/**
 * Writes a StagingRuleSetRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

/**
 * Frees the elements of a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to free.
 */
static void freeNs0StagingRuleSetRequestDTOType(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO);

#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_H */
#ifndef DEF_nexus_staging_plugin_ns0_stagingProfile_M
#define DEF_nexus_staging_plugin_ns0_stagingProfile_M

/**
 * Reads a StagingProfileDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingProfileDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfile *xmlTextReaderReadNs0StagingProfileType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingProfile *_stagingProfileDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingProfile));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingProfileType(_stagingProfileDTO);
        free(_stagingProfileDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "dropNotifyEmails", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}dropNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}dropNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->dropNotifyEmails = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "promotionNotifyEmails", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}promotionNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}promotionNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->promotionNotifyEmails = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "promoteRuleSets", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}promoteRuleSets of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}promoteRuleSets of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->promoteRuleSets = realloc(_stagingProfileDTO->promoteRuleSets, (_stagingProfileDTO->_sizeof_promoteRuleSets + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->promoteRuleSets[_stagingProfileDTO->_sizeof_promoteRuleSets++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "mode", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}mode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}mode of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->mode = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "dropNotifyRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}dropNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}dropNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->dropNotifyRoles = realloc(_stagingProfileDTO->dropNotifyRoles, (_stagingProfileDTO->_sizeof_dropNotifyRoles + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->dropNotifyRoles[_stagingProfileDTO->_sizeof_dropNotifyRoles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryType", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryType of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->repositoryType = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "inProgress", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}inProgress of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}inProgress of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->inProgress = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryTargetId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryTargetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryTargetId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->repositoryTargetId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoryTemplateId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoryTemplateId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoryTemplateId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->repositoryTemplateId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "promotionNotifyCreator", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}promotionNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}promotionNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->promotionNotifyCreator = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "stagedRepositoryIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}stagedRepositoryIds of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}stagedRepositoryIds of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->stagedRepositoryIds = realloc(_stagingProfileDTO->stagedRepositoryIds, (_stagingProfileDTO->_sizeof_stagedRepositoryIds + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->stagedRepositoryIds[_stagingProfileDTO->_sizeof_stagedRepositoryIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "dropNotifyCreator", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}dropNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}dropNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->dropNotifyCreator = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "targetGroups", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}targetGroups of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}targetGroups of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->targetGroups = realloc(_stagingProfileDTO->targetGroups, (_stagingProfileDTO->_sizeof_targetGroups + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->targetGroups[_stagingProfileDTO->_sizeof_targetGroups++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "order", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}order of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}order of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->order = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "closeRuleSets", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}closeRuleSets of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}closeRuleSets of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->closeRuleSets = realloc(_stagingProfileDTO->closeRuleSets, (_stagingProfileDTO->_sizeof_closeRuleSets + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->closeRuleSets[_stagingProfileDTO->_sizeof_closeRuleSets++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "finishNotifyCreator", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}finishNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}finishNotifyCreator of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->finishNotifyCreator = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "deployURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}deployURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}deployURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->deployURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "autoStagingDisabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}autoStagingDisabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}autoStagingDisabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->autoStagingDisabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "repositoriesSearchable", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}repositoriesSearchable of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}repositoriesSearchable of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->repositoriesSearchable = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "promotionNotifyRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}promotionNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}promotionNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->promotionNotifyRoles = realloc(_stagingProfileDTO->promotionNotifyRoles, (_stagingProfileDTO->_sizeof_promotionNotifyRoles + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->promotionNotifyRoles[_stagingProfileDTO->_sizeof_promotionNotifyRoles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "finishNotifyRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}finishNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}finishNotifyRoles of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->finishNotifyRoles = realloc(_stagingProfileDTO->finishNotifyRoles, (_stagingProfileDTO->_sizeof_finishNotifyRoles + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->finishNotifyRoles[_stagingProfileDTO->_sizeof_finishNotifyRoles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "stagingRepositoryIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}stagingRepositoryIds of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}stagingRepositoryIds of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->stagingRepositoryIds = realloc(_stagingProfileDTO->stagingRepositoryIds, (_stagingProfileDTO->_sizeof_stagingRepositoryIds + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileDTO->stagingRepositoryIds[_stagingProfileDTO->_sizeof_stagingRepositoryIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "promotionTargetRepository", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}promotionTargetRepository of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}promotionTargetRepository of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->promotionTargetRepository = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "finishNotifyEmails", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}finishNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}finishNotifyEmails of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileType(_stagingProfileDTO);
          free(_stagingProfileDTO);
          return NULL;
        }

        _stagingProfileDTO->finishNotifyEmails = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingProfile.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingProfile. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingProfileDTO;
}

/**
 * Writes a StagingProfileDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileDTO The StagingProfileDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingProfileType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfile *_stagingProfileDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingProfileDTO->dropNotifyEmails != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "dropNotifyEmails", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}dropNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}dropNotifyEmails...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->dropNotifyEmails));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}dropNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}dropNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->promotionNotifyEmails != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promotionNotifyEmails", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}promotionNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}promotionNotifyEmails...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->promotionNotifyEmails));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}promotionNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}promotionNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_promoteRuleSets; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promoteRuleSets", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}promoteRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}promoteRuleSets...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->promoteRuleSets[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}promoteRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}promoteRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->mode != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "mode", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}mode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}mode...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->mode));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}mode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}mode. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_dropNotifyRoles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "dropNotifyRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}dropNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}dropNotifyRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->dropNotifyRoles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}dropNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}dropNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->repositoryType != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryType", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryType...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->repositoryType));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryType. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "inProgress", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}inProgress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}inProgress...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->inProgress));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}inProgress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}inProgress. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->repositoryTargetId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryTargetId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTargetId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->repositoryTargetId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryTargetId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->repositoryTemplateId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoryTemplateId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoryTemplateId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTemplateId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->repositoryTemplateId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}repositoryTemplateId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoryTemplateId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promotionNotifyCreator", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}promotionNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}promotionNotifyCreator...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->promotionNotifyCreator));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}promotionNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}promotionNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_stagedRepositoryIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagedRepositoryIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}stagedRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}stagedRepositoryIds...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->stagedRepositoryIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}stagedRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}stagedRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "dropNotifyCreator", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}dropNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}dropNotifyCreator...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->dropNotifyCreator));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}dropNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}dropNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_targetGroups; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "targetGroups", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}targetGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}targetGroups...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->targetGroups[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}targetGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}targetGroups. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "order", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}order. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}order...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_stagingProfileDTO->order));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}order. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}order. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_closeRuleSets; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "closeRuleSets", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}closeRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}closeRuleSets...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->closeRuleSets[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}closeRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}closeRuleSets. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "finishNotifyCreator", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}finishNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}finishNotifyCreator...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->finishNotifyCreator));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}finishNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}finishNotifyCreator. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->deployURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "deployURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}deployURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}deployURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->deployURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}deployURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}deployURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "autoStagingDisabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}autoStagingDisabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}autoStagingDisabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->autoStagingDisabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}autoStagingDisabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}autoStagingDisabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "repositoriesSearchable", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}repositoriesSearchable. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}repositoriesSearchable...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingProfileDTO->repositoriesSearchable));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}repositoriesSearchable. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}repositoriesSearchable. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_promotionNotifyRoles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promotionNotifyRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}promotionNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}promotionNotifyRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->promotionNotifyRoles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}promotionNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}promotionNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_finishNotifyRoles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "finishNotifyRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}finishNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}finishNotifyRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->finishNotifyRoles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}finishNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}finishNotifyRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileDTO->_sizeof_stagingRepositoryIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagingRepositoryIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}stagingRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}stagingRepositoryIds...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileDTO->stagingRepositoryIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}stagingRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}stagingRepositoryIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->promotionTargetRepository != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promotionTargetRepository", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}promotionTargetRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}promotionTargetRepository...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->promotionTargetRepository));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}promotionTargetRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}promotionTargetRepository. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingProfileDTO->finishNotifyEmails != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "finishNotifyEmails", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}finishNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}finishNotifyEmails...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingProfileDTO->finishNotifyEmails));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}finishNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}finishNotifyEmails. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingProfileDTO.
 *
 * @param _stagingProfileDTO The StagingProfileDTO to free.
 */
static void freeNs0StagingProfileType(struct nexus_staging_plugin_ns0_stagingProfile *_stagingProfileDTO) {
  int i;
  if (_stagingProfileDTO->dropNotifyEmails != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor dropNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->dropNotifyEmails);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor dropNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->dropNotifyEmails);
  }
  if (_stagingProfileDTO->promotionNotifyEmails != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor promotionNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->promotionNotifyEmails);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor promotionNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->promotionNotifyEmails);
  }
  if (_stagingProfileDTO->promoteRuleSets != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_promoteRuleSets; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor promoteRuleSets[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->promoteRuleSets[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor promoteRuleSets of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->promoteRuleSets);
  }
  if (_stagingProfileDTO->mode != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor mode of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->mode);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor mode of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->mode);
  }
  if (_stagingProfileDTO->dropNotifyRoles != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_dropNotifyRoles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor dropNotifyRoles[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->dropNotifyRoles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor dropNotifyRoles of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->dropNotifyRoles);
  }
  if (_stagingProfileDTO->repositoryType != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryType of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->repositoryType);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryType of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->repositoryType);
  }
  if (_stagingProfileDTO->repositoryTargetId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryTargetId of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->repositoryTargetId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryTargetId of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->repositoryTargetId);
  }
  if (_stagingProfileDTO->repositoryTemplateId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor repositoryTemplateId of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->repositoryTemplateId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor repositoryTemplateId of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->repositoryTemplateId);
  }
  if (_stagingProfileDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->name);
  }
  if (_stagingProfileDTO->stagedRepositoryIds != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_stagedRepositoryIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor stagedRepositoryIds[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->stagedRepositoryIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor stagedRepositoryIds of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->stagedRepositoryIds);
  }
  if (_stagingProfileDTO->targetGroups != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_targetGroups; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor targetGroups[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->targetGroups[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor targetGroups of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->targetGroups);
  }
  if (_stagingProfileDTO->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->resourceURI);
  }
  if (_stagingProfileDTO->closeRuleSets != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_closeRuleSets; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor closeRuleSets[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->closeRuleSets[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor closeRuleSets of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->closeRuleSets);
  }
  if (_stagingProfileDTO->deployURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor deployURI of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->deployURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor deployURI of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->deployURI);
  }
  if (_stagingProfileDTO->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->id);
  }
  if (_stagingProfileDTO->promotionNotifyRoles != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_promotionNotifyRoles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor promotionNotifyRoles[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->promotionNotifyRoles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor promotionNotifyRoles of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->promotionNotifyRoles);
  }
  if (_stagingProfileDTO->finishNotifyRoles != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_finishNotifyRoles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor finishNotifyRoles[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->finishNotifyRoles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor finishNotifyRoles of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->finishNotifyRoles);
  }
  if (_stagingProfileDTO->stagingRepositoryIds != NULL) {
    for (i = 0; i < _stagingProfileDTO->_sizeof_stagingRepositoryIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor stagingRepositoryIds[%i] of type nexus_staging_plugin_ns0_stagingProfile...\n", i);
#endif
      freeXsStringType(&(_stagingProfileDTO->stagingRepositoryIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor stagingRepositoryIds of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->stagingRepositoryIds);
  }
  if (_stagingProfileDTO->promotionTargetRepository != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor promotionTargetRepository of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->promotionTargetRepository);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor promotionTargetRepository of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->promotionTargetRepository);
  }
  if (_stagingProfileDTO->finishNotifyEmails != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor finishNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    freeXsStringType(_stagingProfileDTO->finishNotifyEmails);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor finishNotifyEmails of type nexus_staging_plugin_ns0_stagingProfile...\n");
#endif
    free(_stagingProfileDTO->finishNotifyEmails);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingProfile_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_M
#define DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_M

/**
 * Reads a StagingProfileOrderRequestDTO element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingProfileOrderRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0OrderRequestElement(reader);
}

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  return xmlTextWriterWriteNs0OrderRequestElementNS(writer, _stagingProfileOrderRequestDTO, 1);
}

/**
 * Frees a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
  free(_stagingProfileOrderRequestDTO);
}

/**
 * Reads a StagingProfileOrderRequestDTO element from XML. The element to be read is "orderRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileOrderRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xmlTextReaderReadNs0OrderRequestElement(xmlTextReaderPtr reader) {
  struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "orderRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}orderRequest.\n");
#endif
    _stagingProfileOrderRequestDTO = xmlTextReaderReadNs0StagingProfileOrderRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_stagingProfileOrderRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}orderRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}orderRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _stagingProfileOrderRequestDTO;
}

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0OrderRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  return xmlTextWriterWriteNs0OrderRequestElementNS(writer, _stagingProfileOrderRequestDTO, 0);
}

/**
 * Writes a StagingProfileOrderRequestDTO to XML under element name "orderRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0OrderRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "orderRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}stagingProfileOrderRequestDTO for root element {}orderRequest...\n");
#endif
  status = xmlTextWriterWriteNs0StagingProfileOrderRequestDTOType(writer, _stagingProfileOrderRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}orderRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO whose children are to be free.
 */
static void freeNs0OrderRequestElement(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
}

/**
 * Reads a StagingProfileOrderRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingProfileOrderRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *xmlTextReaderReadNs0StagingProfileOrderRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
        free(_stagingProfileOrderRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}data...\n");
#endif
          //start wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
              free(_stagingProfileOrderRequestDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "orderedProfile", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}orderedProfile of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}orderedProfile of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
          free(_stagingProfileOrderRequestDTO);
          return NULL;
        }

        _stagingProfileOrderRequestDTO->data = realloc(_stagingProfileOrderRequestDTO->data, (_stagingProfileOrderRequestDTO->_sizeof_data + 1) * sizeof(xmlChar));
        memcpy(&(_stagingProfileOrderRequestDTO->data[_stagingProfileOrderRequestDTO->_sizeof_data++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}data.\n");
#endif
          freeNs0StagingProfileOrderRequestDTOType(_stagingProfileOrderRequestDTO);
          free(_stagingProfileOrderRequestDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}data"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingProfileOrderRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingProfileOrderRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingProfileOrderRequestDTO;
}

/**
 * Writes a StagingProfileOrderRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingProfileOrderRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_stagingProfileOrderRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingProfileOrderRequestDTO->_sizeof_data; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "orderedProfile", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}orderedProfile. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}orderedProfile...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_stagingProfileOrderRequestDTO->data[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}orderedProfile. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}orderedProfile. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_stagingProfileOrderRequestDTO->data != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingProfileOrderRequestDTO.
 *
 * @param _stagingProfileOrderRequestDTO The StagingProfileOrderRequestDTO to free.
 */
static void freeNs0StagingProfileOrderRequestDTOType(struct nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO *_stagingProfileOrderRequestDTO) {
  int i;
  if (_stagingProfileOrderRequestDTO->data != NULL) {
    for (i = 0; i < _stagingProfileOrderRequestDTO->_sizeof_data; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor data[%i] of type nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO...\n", i);
#endif
      freeXsStringType(&(_stagingProfileOrderRequestDTO->data[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO...\n");
#endif
    free(_stagingProfileOrderRequestDTO->data);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingProfileOrderRequestDTO_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_M
#define DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_M

/**
 * Reads a StagingProfileRequestDTO element from XML. The element to be read is "profileRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingProfileRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingProfileRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0ProfileRequestElement(reader);
}

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_staging_plugin_ns0_stagingProfileRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  return xmlTextWriterWriteNs0ProfileRequestElementNS(writer, _stagingProfileRequestDTO, 1);
}

/**
 * Frees a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingProfileRequestDTO(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  freeNs0StagingProfileRequestDTOType(_stagingProfileRequestDTO);
  free(_stagingProfileRequestDTO);
}

/**
 * Reads a StagingProfileRequestDTO element from XML. The element to be read is "profileRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The StagingProfileRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xmlTextReaderReadNs0ProfileRequestElement(xmlTextReaderPtr reader) {
  struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "profileRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}profileRequest.\n");
#endif
    _stagingProfileRequestDTO = xmlTextReaderReadNs0StagingProfileRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_stagingProfileRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}profileRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}profileRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _stagingProfileRequestDTO;
}

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProfileRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  return xmlTextWriterWriteNs0ProfileRequestElementNS(writer, _stagingProfileRequestDTO, 0);
}

/**
 * Writes a StagingProfileRequestDTO to XML under element name "profileRequest".
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0ProfileRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "profileRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}profileRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}stagingProfileRequestDTO for root element {}profileRequest...\n");
#endif
  status = xmlTextWriterWriteNs0StagingProfileRequestDTOType(writer, _stagingProfileRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}profileRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}profileRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO whose children are to be free.
 */
static void freeNs0ProfileRequestElement(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  freeNs0StagingProfileRequestDTOType(_stagingProfileRequestDTO);
}

/**
 * Reads a StagingProfileRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingProfileRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *xmlTextReaderReadNs0StagingProfileRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingProfileRequestDTOType(_stagingProfileRequestDTO);
        free(_stagingProfileRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}stagingProfile.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0StagingProfileType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}stagingProfile.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingProfileRequestDTOType(_stagingProfileRequestDTO);
          free(_stagingProfileRequestDTO);
          return NULL;
        }

        _stagingProfileRequestDTO->data = ((struct nexus_staging_plugin_ns0_stagingProfile*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingProfileRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingProfileRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingProfileRequestDTO;
}

/**
 * Writes a StagingProfileRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingProfileRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingProfileRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}stagingProfile for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0StagingProfileType(writer, (_stagingProfileRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}stagingProfile for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingProfileRequestDTO.
 *
 * @param _stagingProfileRequestDTO The StagingProfileRequestDTO to free.
 */
static void freeNs0StagingProfileRequestDTOType(struct nexus_staging_plugin_ns0_stagingProfileRequestDTO *_stagingProfileRequestDTO) {
  int i;
  if (_stagingProfileRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_staging_plugin_ns0_stagingProfileRequestDTO...\n");
#endif
    freeNs0StagingProfileType(_stagingProfileRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_staging_plugin_ns0_stagingProfileRequestDTO...\n");
#endif
    free(_stagingProfileRequestDTO->data);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingProfileRequestDTO_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingPromote_M
#define DEF_nexus_staging_plugin_ns0_stagingPromote_M

/**
 * Reads a StagingPromoteDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingPromoteDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingPromote *xmlTextReaderReadNs0StagingPromoteType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingPromote *_stagingPromoteDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingPromote));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingPromoteType(_stagingPromoteDTO);
        free(_stagingPromoteDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "targetRepositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}targetRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}targetRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingPromoteType(_stagingPromoteDTO);
          free(_stagingPromoteDTO);
          return NULL;
        }

        _stagingPromoteDTO->targetRepositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingPromoteType(_stagingPromoteDTO);
          free(_stagingPromoteDTO);
          return NULL;
        }

        _stagingPromoteDTO->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "stagedRepositoryId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}stagedRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}stagedRepositoryId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingPromoteType(_stagingPromoteDTO);
          free(_stagingPromoteDTO);
          return NULL;
        }

        _stagingPromoteDTO->stagedRepositoryId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingPromote.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingPromote. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingPromoteDTO;
}

/**
 * Writes a StagingPromoteDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteDTO The StagingPromoteDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingPromoteType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromote *_stagingPromoteDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingPromoteDTO->targetRepositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "targetRepositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}targetRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}targetRepositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingPromoteDTO->targetRepositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}targetRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}targetRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingPromoteDTO->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingPromoteDTO->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingPromoteDTO->stagedRepositoryId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagedRepositoryId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}stagedRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}stagedRepositoryId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingPromoteDTO->stagedRepositoryId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}stagedRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}stagedRepositoryId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingPromoteDTO.
 *
 * @param _stagingPromoteDTO The StagingPromoteDTO to free.
 */
static void freeNs0StagingPromoteType(struct nexus_staging_plugin_ns0_stagingPromote *_stagingPromoteDTO) {
  int i;
  if (_stagingPromoteDTO->targetRepositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor targetRepositoryId of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    freeXsStringType(_stagingPromoteDTO->targetRepositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor targetRepositoryId of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    free(_stagingPromoteDTO->targetRepositoryId);
  }
  if (_stagingPromoteDTO->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    freeXsStringType(_stagingPromoteDTO->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    free(_stagingPromoteDTO->description);
  }
  if (_stagingPromoteDTO->stagedRepositoryId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor stagedRepositoryId of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    freeXsStringType(_stagingPromoteDTO->stagedRepositoryId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor stagedRepositoryId of type nexus_staging_plugin_ns0_stagingPromote...\n");
#endif
    free(_stagingPromoteDTO->stagedRepositoryId);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingPromote_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_M
#define DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_M

/**
 * Reads a StagingPromoteRequestDTO element from XML. The element to be read is "promoteRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingPromoteRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0PromoteRequestElement(reader);
}

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  return xmlTextWriterWriteNs0PromoteRequestElementNS(writer, _stagingPromoteRequestDTO, 1);
}

/**
 * Frees a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingPromoteRequestDTO(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  freeNs0StagingPromoteRequestDTOType(_stagingPromoteRequestDTO);
  free(_stagingPromoteRequestDTO);
}

/**
 * Reads a StagingPromoteRequestDTO element from XML. The element to be read is "promoteRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The StagingPromoteRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xmlTextReaderReadNs0PromoteRequestElement(xmlTextReaderPtr reader) {
  struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "promoteRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}promoteRequest.\n");
#endif
    _stagingPromoteRequestDTO = xmlTextReaderReadNs0StagingPromoteRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_stagingPromoteRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}promoteRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}promoteRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _stagingPromoteRequestDTO;
}

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0PromoteRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  return xmlTextWriterWriteNs0PromoteRequestElementNS(writer, _stagingPromoteRequestDTO, 0);
}

/**
 * Writes a StagingPromoteRequestDTO to XML under element name "promoteRequest".
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0PromoteRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "promoteRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}promoteRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}stagingPromoteRequestDTO for root element {}promoteRequest...\n");
#endif
  status = xmlTextWriterWriteNs0StagingPromoteRequestDTOType(writer, _stagingPromoteRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}promoteRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}promoteRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO whose children are to be free.
 */
static void freeNs0PromoteRequestElement(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  freeNs0StagingPromoteRequestDTOType(_stagingPromoteRequestDTO);
}

/**
 * Reads a StagingPromoteRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingPromoteRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *xmlTextReaderReadNs0StagingPromoteRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingPromoteRequestDTOType(_stagingPromoteRequestDTO);
        free(_stagingPromoteRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}stagingPromote.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0StagingPromoteType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}stagingPromote.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingPromoteRequestDTOType(_stagingPromoteRequestDTO);
          free(_stagingPromoteRequestDTO);
          return NULL;
        }

        _stagingPromoteRequestDTO->data = ((struct nexus_staging_plugin_ns0_stagingPromote*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingPromoteRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingPromoteRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingPromoteRequestDTO;
}

/**
 * Writes a StagingPromoteRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingPromoteRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingPromoteRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}stagingPromote for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0StagingPromoteType(writer, (_stagingPromoteRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}stagingPromote for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingPromoteRequestDTO.
 *
 * @param _stagingPromoteRequestDTO The StagingPromoteRequestDTO to free.
 */
static void freeNs0StagingPromoteRequestDTOType(struct nexus_staging_plugin_ns0_stagingPromoteRequestDTO *_stagingPromoteRequestDTO) {
  int i;
  if (_stagingPromoteRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_staging_plugin_ns0_stagingPromoteRequestDTO...\n");
#endif
    freeNs0StagingPromoteType(_stagingPromoteRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_staging_plugin_ns0_stagingPromoteRequestDTO...\n");
#endif
    free(_stagingPromoteRequestDTO->data);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingPromoteRequestDTO_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRule_M
#define DEF_nexus_staging_plugin_ns0_stagingRule_M

/**
 * Reads a StagingRuleDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingRuleDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRule *xmlTextReaderReadNs0StagingRuleType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingRule *_stagingRuleDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingRule));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingRuleType(_stagingRuleDTO);
        free(_stagingRuleDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->typeId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "properties", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}properties...\n");
#endif
          //start wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0StagingRuleType(_stagingRuleDTO);
              free(_stagingRuleDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "stagingRuleProperty", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}stagingRuleProperty of type {}stagingRuleProperty.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0StagingRulePropertyType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}stagingRuleProperty of type {}stagingRuleProperty.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->properties = realloc(_stagingRuleDTO->properties, (_stagingRuleDTO->_sizeof_properties + 1) * sizeof(struct nexus_staging_plugin_ns0_stagingRuleProperty));
        memcpy(&(_stagingRuleDTO->properties[_stagingRuleDTO->_sizeof_properties++]), _child_accessor, sizeof(struct nexus_staging_plugin_ns0_stagingRuleProperty));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}properties.\n");
#endif
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}properties"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "enabled", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}enabled of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->enabled = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "typeName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}typeName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}typeName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleType(_stagingRuleDTO);
          free(_stagingRuleDTO);
          return NULL;
        }

        _stagingRuleDTO->typeName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingRule.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingRule. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingRuleDTO;
}

/**
 * Writes a StagingRuleDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleDTO The StagingRuleDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingRuleType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRule *_stagingRuleDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingRuleDTO->typeId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleDTO->typeId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleDTO->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleDTO->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_stagingRuleDTO->properties != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "properties", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingRuleDTO->_sizeof_properties; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagingRuleProperty", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}stagingRuleProperty. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}stagingRuleProperty for element {}stagingRuleProperty...\n", status);
#endif
    status = xmlTextWriterWriteNs0StagingRulePropertyType(writer, &(_stagingRuleDTO->properties[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}stagingRuleProperty for element {}stagingRuleProperty. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}stagingRuleProperty. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_stagingRuleDTO->properties != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}properties. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "enabled", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_stagingRuleDTO->enabled));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}enabled. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleDTO->typeName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "typeName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}typeName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleDTO->typeName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}typeName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingRuleDTO.
 *
 * @param _stagingRuleDTO The StagingRuleDTO to free.
 */
static void freeNs0StagingRuleType(struct nexus_staging_plugin_ns0_stagingRule *_stagingRuleDTO) {
  int i;
  if (_stagingRuleDTO->typeId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeId of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    freeXsStringType(_stagingRuleDTO->typeId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeId of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    free(_stagingRuleDTO->typeId);
  }
  if (_stagingRuleDTO->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    freeXsStringType(_stagingRuleDTO->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    free(_stagingRuleDTO->resourceURI);
  }
  if (_stagingRuleDTO->properties != NULL) {
    for (i = 0; i < _stagingRuleDTO->_sizeof_properties; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor properties[%i] of type nexus_staging_plugin_ns0_stagingRule...\n", i);
#endif
      freeNs0StagingRulePropertyType(&(_stagingRuleDTO->properties[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor properties of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    free(_stagingRuleDTO->properties);
  }
  if (_stagingRuleDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    freeXsStringType(_stagingRuleDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    free(_stagingRuleDTO->name);
  }
  if (_stagingRuleDTO->typeName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor typeName of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    freeXsStringType(_stagingRuleDTO->typeName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor typeName of type nexus_staging_plugin_ns0_stagingRule...\n");
#endif
    free(_stagingRuleDTO->typeName);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingRule_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleProperty_M
#define DEF_nexus_staging_plugin_ns0_stagingRuleProperty_M

/**
 * Reads a StagingRulePropertyDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingRulePropertyDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleProperty *xmlTextReaderReadNs0StagingRulePropertyType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingRuleProperty *_stagingRulePropertyDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingRuleProperty));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingRulePropertyType(_stagingRulePropertyDTO);
        free(_stagingRulePropertyDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "key", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}key of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRulePropertyType(_stagingRulePropertyDTO);
          free(_stagingRulePropertyDTO);
          return NULL;
        }

        _stagingRulePropertyDTO->key = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "value", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}value of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRulePropertyType(_stagingRulePropertyDTO);
          free(_stagingRulePropertyDTO);
          return NULL;
        }

        _stagingRulePropertyDTO->value = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingRuleProperty.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingRuleProperty. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingRulePropertyDTO;
}

/**
 * Writes a StagingRulePropertyDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRulePropertyDTO The StagingRulePropertyDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingRulePropertyType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleProperty *_stagingRulePropertyDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingRulePropertyDTO->key != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "key", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}key...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRulePropertyDTO->key));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}key. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRulePropertyDTO->value != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "value", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}value...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRulePropertyDTO->value));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}value. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingRulePropertyDTO.
 *
 * @param _stagingRulePropertyDTO The StagingRulePropertyDTO to free.
 */
static void freeNs0StagingRulePropertyType(struct nexus_staging_plugin_ns0_stagingRuleProperty *_stagingRulePropertyDTO) {
  int i;
  if (_stagingRulePropertyDTO->key != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor key of type nexus_staging_plugin_ns0_stagingRuleProperty...\n");
#endif
    freeXsStringType(_stagingRulePropertyDTO->key);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor key of type nexus_staging_plugin_ns0_stagingRuleProperty...\n");
#endif
    free(_stagingRulePropertyDTO->key);
  }
  if (_stagingRulePropertyDTO->value != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor value of type nexus_staging_plugin_ns0_stagingRuleProperty...\n");
#endif
    freeXsStringType(_stagingRulePropertyDTO->value);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor value of type nexus_staging_plugin_ns0_stagingRuleProperty...\n");
#endif
    free(_stagingRulePropertyDTO->value);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleProperty_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleSet_M
#define DEF_nexus_staging_plugin_ns0_stagingRuleSet_M

/**
 * Reads a StagingRuleSetDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingRuleSetDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleSet *xmlTextReaderReadNs0StagingRuleSetType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingRuleSet *_stagingRuleSetDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingRuleSet));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingRuleSetType(_stagingRuleSetDTO);
        free(_stagingRuleSetDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "rules", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}rules...\n");
#endif
          //start wrapper element "{}rules"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0StagingRuleSetType(_stagingRuleSetDTO);
              free(_stagingRuleSetDTO);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "stagingRule", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}stagingRule of type {}stagingRule.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0StagingRuleType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}stagingRule of type {}stagingRule.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }

        _stagingRuleSetDTO->rules = realloc(_stagingRuleSetDTO->rules, (_stagingRuleSetDTO->_sizeof_rules + 1) * sizeof(struct nexus_staging_plugin_ns0_stagingRule));
        memcpy(&(_stagingRuleSetDTO->rules[_stagingRuleSetDTO->_sizeof_rules++]), _child_accessor, sizeof(struct nexus_staging_plugin_ns0_stagingRule));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}rules.\n");
#endif
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }
        else {
          //end wrapper element "{}rules"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }

        _stagingRuleSetDTO->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }

        _stagingRuleSetDTO->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }

        _stagingRuleSetDTO->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetType(_stagingRuleSetDTO);
          free(_stagingRuleSetDTO);
          return NULL;
        }

        _stagingRuleSetDTO->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingRuleSet.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingRuleSet. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingRuleSetDTO;
}

/**
 * Writes a StagingRuleSetDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetDTO The StagingRuleSetDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingRuleSetType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSet *_stagingRuleSetDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;

  if (_stagingRuleSetDTO->rules != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "rules", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}rules. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _stagingRuleSetDTO->_sizeof_rules; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagingRule", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}stagingRule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}stagingRule for element {}stagingRule...\n", status);
#endif
    status = xmlTextWriterWriteNs0StagingRuleType(writer, &(_stagingRuleSetDTO->rules[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}stagingRule for element {}stagingRule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}stagingRule. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_stagingRuleSetDTO->rules != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}rules. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleSetDTO->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleSetDTO->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleSetDTO->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleSetDTO->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleSetDTO->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleSetDTO->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_stagingRuleSetDTO->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_stagingRuleSetDTO->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingRuleSetDTO.
 *
 * @param _stagingRuleSetDTO The StagingRuleSetDTO to free.
 */
static void freeNs0StagingRuleSetType(struct nexus_staging_plugin_ns0_stagingRuleSet *_stagingRuleSetDTO) {
  int i;
  if (_stagingRuleSetDTO->rules != NULL) {
    for (i = 0; i < _stagingRuleSetDTO->_sizeof_rules; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor rules[%i] of type nexus_staging_plugin_ns0_stagingRuleSet...\n", i);
#endif
      freeNs0StagingRuleType(&(_stagingRuleSetDTO->rules[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor rules of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    free(_stagingRuleSetDTO->rules);
  }
  if (_stagingRuleSetDTO->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    freeXsStringType(_stagingRuleSetDTO->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    free(_stagingRuleSetDTO->resourceURI);
  }
  if (_stagingRuleSetDTO->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    freeXsStringType(_stagingRuleSetDTO->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    free(_stagingRuleSetDTO->id);
  }
  if (_stagingRuleSetDTO->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    freeXsStringType(_stagingRuleSetDTO->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    free(_stagingRuleSetDTO->name);
  }
  if (_stagingRuleSetDTO->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    freeXsStringType(_stagingRuleSetDTO->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type nexus_staging_plugin_ns0_stagingRuleSet...\n");
#endif
    free(_stagingRuleSetDTO->description);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleSet_M */
#ifndef DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_M
#define DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_M

/**
 * Reads a StagingRuleSetRequestDTO element from XML. The element to be read is "stagingRuleSetRequest", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xml_read_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0StagingRuleSetRequestElement(reader);
}

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  return xmlTextWriterWriteNs0StagingRuleSetRequestElementNS(writer, _stagingRuleSetRequestDTO, 1);
}

/**
 * Frees a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to free.
 */
void free_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  freeNs0StagingRuleSetRequestDTOType(_stagingRuleSetRequestDTO);
  free(_stagingRuleSetRequestDTO);
}

/**
 * Reads a StagingRuleSetRequestDTO element from XML. The element to be read is "stagingRuleSetRequest", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The StagingRuleSetRequestDTO, or NULL in case of error.
 */
struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xmlTextReaderReadNs0StagingRuleSetRequestElement(xmlTextReaderPtr reader) {
  struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "stagingRuleSetRequest", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}stagingRuleSetRequest.\n");
#endif
    _stagingRuleSetRequestDTO = xmlTextReaderReadNs0StagingRuleSetRequestDTOType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_stagingRuleSetRequestDTO == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}stagingRuleSetRequest failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}stagingRuleSetRequest failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _stagingRuleSetRequestDTO;
}

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestElement(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  return xmlTextWriterWriteNs0StagingRuleSetRequestElementNS(writer, _stagingRuleSetRequestDTO, 0);
}

/**
 * Writes a StagingRuleSetRequestDTO to XML under element name "stagingRuleSetRequest".
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestElementNS(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "stagingRuleSetRequest", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}stagingRuleSetRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}stagingRuleSetRequestDTO for root element {}stagingRuleSetRequest...\n");
#endif
  status = xmlTextWriterWriteNs0StagingRuleSetRequestDTOType(writer, _stagingRuleSetRequestDTO);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}stagingRuleSetRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}stagingRuleSetRequest. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO whose children are to be free.
 */
static void freeNs0StagingRuleSetRequestElement(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  freeNs0StagingRuleSetRequestDTOType(_stagingRuleSetRequestDTO);
}

/**
 * Reads a StagingRuleSetRequestDTO from XML. The reader is assumed to be at the start element.
 *
 * @return the StagingRuleSetRequestDTO, or NULL in case of error.
 */
static struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *xmlTextReaderReadNs0StagingRuleSetRequestDTOType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO = calloc(1, sizeof(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0StagingRuleSetRequestDTOType(_stagingRuleSetRequestDTO);
        free(_stagingRuleSetRequestDTO);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}stagingRuleSet.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0StagingRuleSetType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}stagingRuleSet.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0StagingRuleSetRequestDTOType(_stagingRuleSetRequestDTO);
          free(_stagingRuleSetRequestDTO);
          return NULL;
        }

        _stagingRuleSetRequestDTO->data = ((struct nexus_staging_plugin_ns0_stagingRuleSet*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}stagingRuleSetRequestDTO.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}stagingRuleSetRequestDTO. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _stagingRuleSetRequestDTO;
}

/**
 * Writes a StagingRuleSetRequestDTO to XML.
 *
 * @param writer The XML writer.
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0StagingRuleSetRequestDTOType(xmlTextWriterPtr writer, struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_stagingRuleSetRequestDTO->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}stagingRuleSet for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0StagingRuleSetType(writer, (_stagingRuleSetRequestDTO->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}stagingRuleSet for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a StagingRuleSetRequestDTO.
 *
 * @param _stagingRuleSetRequestDTO The StagingRuleSetRequestDTO to free.
 */
static void freeNs0StagingRuleSetRequestDTOType(struct nexus_staging_plugin_ns0_stagingRuleSetRequestDTO *_stagingRuleSetRequestDTO) {
  int i;
  if (_stagingRuleSetRequestDTO->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type nexus_staging_plugin_ns0_stagingRuleSetRequestDTO...\n");
#endif
    freeNs0StagingRuleSetType(_stagingRuleSetRequestDTO->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type nexus_staging_plugin_ns0_stagingRuleSetRequestDTO...\n");
#endif
    free(_stagingRuleSetRequestDTO->data);
  }
}
#endif /* DEF_nexus_staging_plugin_ns0_stagingRuleSetRequestDTO_M */
