//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>

#ifndef DEBUG_ENUNCIATE
#define DEBUG_ENUNCIATE 0
#endif

#ifndef ENUNCIATE_C_UTILITIES
#define ENUNCIATE_C_UTILITIES

/**
 * A basic xml node, used when (de)serializing unknown or "any" xml type.
 * We can't use the libxml xmlNodePtr because we can't reliably "free" it.
 */
struct xmlBasicNode {
  /**
   * The (local) name of the node.
   */
  xmlChar *name;

  /**
   * The namespace of the node.
   */
  xmlChar *ns;

  /**
   * The namespace prefix of the node.
   */
  xmlChar *prefix;

  /**
   * The (text) value of the node.
   */
  xmlChar *value;

  /**
   * The child elements of the node.
   */
  struct xmlBasicNode *child_elements;

  /**
   * The attributes of the node.
   */
  struct xmlBasicNode *attributes;

  /**
   * The next sibling (for a list of nodes).
   */
  struct xmlBasicNode *sibling;
};

/*******************xml utilities************************************/

static int xmlTextReaderAdvanceToNextStartOrEndElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderRead(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static int xmlTextReaderSkipElement(xmlTextReaderPtr reader) {
  int status = xmlTextReaderNext(reader);
  while (status && xmlTextReaderNodeType(reader) != XML_READER_TYPE_ELEMENT && xmlTextReaderNodeType(reader) != XML_READER_TYPE_END_ELEMENT) {
    status = xmlTextReaderRead(reader);
  }
  return status;
}

static xmlChar *xmlTextReaderReadEntireNodeValue(xmlTextReaderPtr reader) {
  xmlChar *buffer = calloc(1, sizeof(xmlChar));
  const xmlChar *snippet;
  int status;
  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ATTRIBUTE) {
    return xmlTextReaderValue(reader);
  }
  else if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status && (xmlTextReaderNodeType(reader) == XML_READER_TYPE_TEXT || xmlTextReaderNodeType(reader) == XML_READER_TYPE_CDATA || xmlTextReaderNodeType(reader) == XML_READER_TYPE_ENTITY_REFERENCE)) {
      snippet = xmlTextReaderConstValue(reader);
      buffer = realloc(buffer, (xmlStrlen(buffer) + xmlStrlen(snippet) + 1) * sizeof(xmlChar));
      xmlStrcat(buffer, snippet);
      status = xmlTextReaderRead(reader);
    }
  }
  return buffer;
}

/*******************base 64 utilities************************************/

/*
 * Base64 Translation Table as described in RFC1113.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

/*
 * Base64 Translation Table to decode (created by author)
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static const char cd64[]="|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

/*
 * encode 3 8-bit binary bytes as 4 '6-bit' characters
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param in the block to encode
 * @param out the block to encode to
 * @param len the length of the 'in' block.
 */
static void _encode_base64_block(unsigned char in[3], unsigned char out[4], int len) {
  out[0] = cb64[ in[0] >> 2 ];
  out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
  out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
  out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

/*
 * decode 4 '6-bit' characters into 3 8-bit binary bytes
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 */
static void _decode_base64_block( unsigned char in[4], unsigned char out[3] )
{
    out[ 0 ] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[ 1 ] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[ 2 ] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}

/*
 * base64 encode a stream adding padding and line breaks as per spec.
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param instream The stream to encode.
 * @param insize The size of the stream to encode.
 * @return The encoded string.
 */
xmlChar *_encode_base64(unsigned char *instream, int insize) {
  unsigned char in[3];
  unsigned char out[4];
  xmlChar *encoded;
  int i, in_index = 0, out_index = 0, blocklen;

  if (insize == 0) {
    return BAD_CAST "\0";
  }

  encoded = calloc(((insize / 3) * 4) + 10, sizeof(xmlChar));
  while (in_index <= insize) {
    blocklen = 0;
    for (i = 0; i < 3; i++) {
      in[i] = instream[in_index++];
      if (in_index <= insize) {
        blocklen++;
      }
      else {
        in[i] = 0;
      }
    }
    if (blocklen) {
      _encode_base64_block(in, out, blocklen);
      for( i = 0; i < 4; i++ ) {
        encoded[out_index++] = out[i];
      }
    }
  }

  return encoded;
}

/*
 * Decode a base64 encoded stream discarding padding, line breaks and noise
 *
 * This code was graciously ripped from http://base64.sourceforge.net
 *
 * @param invalue The string to decode.
 * @param outsize Holder for the length of the returned data.
 * @return The decoded data.
 */
unsigned char *_decode_base64( const xmlChar *invalue, int *outsize ) {
  xmlChar in[4];
  unsigned char out[3], v;
  int i, in_index = 0, out_index = 0, blocklen;
  unsigned char *outstream;

  if (invalue == NULL) {
    return NULL;
  }

  outstream = calloc(((xmlStrlen(invalue) / 4) * 3) + 1, sizeof(unsigned char));
  while (invalue[in_index] != '\0') {
    for (blocklen = 0, i = 0; i < 4 && invalue[in_index]; i++) {
      v = 0;
      while (invalue[in_index] != '\0' && v == 0) {
        v = (unsigned char) invalue[in_index++];
        v = (unsigned char) ((v < 43 || v > 122) ? 0 : cd64[ v - 43 ]);
        if (v) {
          v = (unsigned char) ((v == '$') ? 0 : v - 61);
        }
      }

      if (invalue[in_index] != '\0') {
        blocklen++;
        if (v) {
          in[i] = (unsigned char) (v - 1);
        }
      }
      else {
        in[i] = 0;
      }
    }

    if (blocklen) {
      _decode_base64_block( in, out );
      for( i = 0; i < blocklen - 1; i++ ) {
        outstream[out_index++] = out[i];
      }
    }
  }

  if (outsize != NULL) {
    *outsize = out_index;
  }

  return outstream;
}

#endif /* ENUNCIATE_C_UTILITIES */

#ifndef BASIC_XML_FUNCTIONS_Xs
#define BASIC_XML_FUNCTIONS_Xs

/*******************xs:boolean************************************/

/**
 * Read a boolean value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to 1 if "true" was read. pointer to 0 otherwise.
 */
static int *xmlTextReaderReadXsBooleanType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = (xmlStrcmp(BAD_CAST "true", nodeValue) == 0) ? 1 : 0;
  free(nodeValue);
  return value;
}

/**
 * Write a boolean value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsBooleanType(xmlTextWriterPtr writer, int *value) {
  if (*value) {
    return xmlTextWriterWriteString(writer, BAD_CAST "false");
  }
  else {
    return xmlTextWriterWriteString(writer, BAD_CAST "true");
  }
}

/**
 * Frees a boolean type from memory.
 *
 * @param value The value to free.
 */
static void freeXsBooleanType(int *value) {
  //no-op
}

/*******************xs:byte************************************/

/**
 * Read a byte value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the byte.
 */
static unsigned char *xmlTextReaderReadXsByteType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  unsigned char *value = malloc(sizeof(unsigned char));
  *value = (unsigned char) atoi((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a byte value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsByteType(xmlTextWriterPtr writer, unsigned char *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a byte type from memory.
 *
 * @param value The value to free.
 */
static void freeXsByteType(unsigned char *value) {
  //no-op
}

/*******************xs:double************************************/

/**
 * Read a double value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the double.
 */
static double *xmlTextReaderReadXsDoubleType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  double *value = malloc(sizeof(double));
  *value = atof((char *) nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a double value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDoubleType(xmlTextWriterPtr writer, double *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a double type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDoubleType(double *value) {
  //no-op
}

/*******************xs:float************************************/

/**
 * Read a float value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the float.
 */
static float *xmlTextReaderReadXsFloatType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  float *value = malloc(sizeof(float));
  *value = atof((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a float value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsFloatType(xmlTextWriterPtr writer, float *value) {
  return xmlTextWriterWriteFormatString(writer, "%f", *value);
}

/**
 * Frees a float type from memory.
 *
 * @param value The value to free.
 */
static void freeXsFloatType(float *value) {
  //no-op
}

/*******************xs:int************************************/

/**
 * Read a int value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @param value The value to be written.
 * @return pointer to the int.
 */
static int *xmlTextReaderReadXsIntType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  int *value = malloc(sizeof(int));
  *value = atoi((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a int value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntType(xmlTextWriterPtr writer, int *value) {
  return xmlTextWriterWriteFormatString(writer, "%i", *value);
}

/**
 * Frees a int type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntType(int *value) {
  //no-op
}

/*******************xs:long************************************/

/**
 * Read a long value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the long.
 */
static long *xmlTextReaderReadXsLongType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  long *value = malloc(sizeof(long));
  *value = atol((char *)nodeValue);
  free(nodeValue);
  return value;
}

/**
 * Write a long value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsLongType(xmlTextWriterPtr writer, long *value) {
  return xmlTextWriterWriteFormatString(writer, "%ld", *value);
}

/**
 * Frees a long type from memory.
 *
 * @param value The value to free.
 */
static void freeXsLongType(long *value) {
  //no-op
}

/*******************xs:short************************************/

/**
 * Read a short value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the short.
 */
static short *xmlTextReaderReadXsShortType(xmlTextReaderPtr reader) {
  xmlChar *nodeValue = xmlTextReaderReadEntireNodeValue(reader);
  short *value = malloc(sizeof(short));
  *value = atoi((char *)nodeValue);
  return value;
}

/**
 * Write a short value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsShortType(xmlTextWriterPtr writer, short *value) {
  return xmlTextWriterWriteFormatString(writer, "%hi", *value);
}

/**
 * Frees a short type from memory.
 *
 * @param value The value to free.
 */
static void freeXsShortType(short *value) {
  //no-op
}

/*******************xs:string************************************/

/**
 * Read a string value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the string.
 */
static xmlChar *xmlTextReaderReadXsStringType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadEntireNodeValue(reader);
}

/**
 * Write a string value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsStringType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a string type from memory.
 *
 * @param value The value to free.
 */
static void freeXsStringType(xmlChar *value) {
  //no-op
}

/*******************xs:ID************************************/

/**
 * Read a ID value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the ID.
 */
static xmlChar *xmlTextReaderReadXsIDType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a ID value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a ID type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:IDREF************************************/

/**
 * Read a IDREF value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the IDREF.
 */
static xmlChar *xmlTextReaderReadXsIDREFType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a IDREF value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIDREFType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a IDREF type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIDREFType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:integer************************************/

/**
 * Read a (big) integer value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the integer.
 */
static xmlChar *xmlTextReaderReadXsIntegerType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a integer value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsIntegerType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a integer type from memory.
 *
 * @param value The value to free.
 */
static void freeXsIntegerType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:decimal************************************/

/**
 * Read a (big) decimal value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the decimal.
 */
static xmlChar *xmlTextReaderReadXsDecimalType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a decimal value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDecimalType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a decimal type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDecimalType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:duration************************************/

/**
 * Read a duration value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the duration.
 */
static xmlChar *xmlTextReaderReadXsDurationType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a duration value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDurationType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a duration type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDurationType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:QName************************************/

/**
 * Read a QName value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the QName.
 */
static xmlChar *xmlTextReaderReadXsQNameType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a QName value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsQNameType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a QName type from memory.
 *
 * @param value The value to free.
 */
static void freeXsQNameType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:anyURI************************************/

/**
 * Read a anyURI value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyURI.
 */
static xmlChar *xmlTextReaderReadXsAnyURIType(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsStringType(reader);
}

/**
 * Write a anyURI value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyURIType(xmlTextWriterPtr writer, xmlChar *value) {
  return xmlTextWriterWriteString(writer, value);
}

/**
 * Frees a anyURI type from memory.
 *
 * @param value The value to free.
 */
static void freeXsAnyURIType(xmlChar *value) {
  freeXsStringType(value);
}

/*******************xs:dateTime************************************/

/**
 * Read a dateTime value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the dateTime.
 */
static struct tm *xmlTextReaderReadXsDateTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-ddThh:MM:ss+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to 'T' character.
  token_index = 0;
  while (index < len && timevalue[index] != 'T') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mday = atoi(token);
  if (token_index > 0) {
    success++; //assume 'day' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a dateTime value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02iT%02i:%02i:%02i.000%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a dateTime type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateTimeType(struct tm *value) {
  //no-op
}

/*******************xs:time************************************/

/**
 * Read a time value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the time.
 */
static struct tm *xmlTextReaderReadXsTimeType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: hh:MM:ss+oo:oo
  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_hour = atoi(token);
  if (token_index > 0) {
    success++; //assume 'hour' was successfully read.
    index++;
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_min = atoi(token);
  if (token_index > 0) {
    success++; //assume 'minutes' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a time value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsTimeType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%02i:%02i:%02i.000%+03i:%02i", value->tm_hour, value->tm_min, value->tm_sec, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a time type from memory.
 *
 * @param value The value to free.
 */
static void freeXsTimeType(struct tm *value) {
  //no-op
}

/*******************xs:date************************************/

/**
 * Read a date value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the date.
 */
static struct tm *xmlTextReaderReadXsDateType(xmlTextReaderPtr reader) {
  struct tm * time = calloc(1, sizeof(struct tm));
  xmlChar *timevalue = xmlTextReaderReadEntireNodeValue(reader);
  int success = 0, index = 0, token_index = 0, len = xmlStrlen(timevalue), offset_hours = 0, offset_min = 0;
  char token[len];

  //date time format: yyyy-mm-dd+oo:oo
  //go to first '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_year = atoi(token) - 1900;
  if (token_index > 0) {
    success++; //assume 'year' was successfully read.
    index++;
  }

  //go to next '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_mon = atoi(token) - 1;
  if (token_index > 0) {
    success++; //assume 'month' was successfully read.
    index++;
  }

  //go to '+' or '-' character.
  token_index = 0;
  while (index < len && timevalue[index] != '+' && timevalue[index] != '-') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  time->tm_sec = atof(token);
  if (token_index > 0) {
    success++; //assume 'seconds' was successfully read.
    if (timevalue[index] == '+') {
      index++;
    }
  }

  //go to ':' character.
  token_index = 0;
  while (index < len && timevalue[index] != ':') {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_hours = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset hours was successfully read.
    index++;
  }

  //go to end.
  token_index = 0;
  while (index < len) {
    token[token_index++] = timevalue[index++];
  }
  token[token_index] = '\n';
  offset_min = atoi(token);
  if (token_index > 0) {
    success++; //assume gmt offset minutes was successfully read.
    index++;
  }
  time->tm_gmtoff = ((offset_hours * 60) + offset_min) * 60;

  free(timevalue);
  return time;
}

/**
 * Write a date value to the writer.
 *
 * @param writer The writer.
 * @param value The value to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsDateType(xmlTextWriterPtr writer, struct tm *value) {
  return xmlTextWriterWriteFormatString(writer, "%04i-%02i-%02i%+03i:%02i", value->tm_year + 1900, value->tm_mon + 1, value->tm_mday, (int) (value->tm_gmtoff / 3600), (int) ((value->tm_gmtoff / 60) % 60));
}

/**
 * Frees a date type from memory.
 *
 * @param value The value to free.
 */
static void freeXsDateType(struct tm *value) {
  //no-op
}

/*******************xs:anyType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnyTypeType(struct xmlBasicNode *node) {
  if (node->attributes != NULL) {
    freeXsAnyTypeType(node->attributes);
  }
  if (node->value != NULL) {
    free(node->value);
  }
  if (node->child_elements != NULL) {
    freeXsAnyTypeType(node->child_elements);
  }
  if (node->name != NULL) {
    free(node->name);
  }
  if (node->prefix != NULL) {
    free(node->prefix);
  }
  if (node->ns != NULL) {
    free(node->ns);
  }
  if (node->sibling != NULL) {
    freeXsAnyTypeType(node->sibling);
    free(node->sibling);
  }
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *child, *next, *node = calloc(1, sizeof(struct xmlBasicNode));
  int status, depth = xmlTextReaderDepth(reader);
  const xmlChar *text;

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);

  if (xmlTextReaderHasAttributes(reader)) {
    child = NULL;
    while (xmlTextReaderMoveToNextAttribute(reader)) {
      next = calloc(1, sizeof(struct xmlBasicNode));
      if (child == NULL) {
        node->attributes = next;
      }
      else {
        child->sibling = next;
      }
      child = next;
      child->name = xmlTextReaderLocalName(reader);
      child->ns = xmlTextReaderNamespaceUri(reader);
      child->prefix = xmlTextReaderPrefix(reader);
      child->value = xmlTextReaderValue(reader);
    }

    status = xmlTextReaderMoveToElement(reader);
    if (status < 1) {
      //panic: unable to return to the element node.
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    status = xmlTextReaderRead(reader);
    while (status == 1 && xmlTextReaderDepth(reader) > depth) {
      switch (xmlTextReaderNodeType(reader)) {
        case XML_READER_TYPE_ELEMENT:
          child = xmlTextReaderReadXsAnyTypeType(reader);
          if (child == NULL) {
            //panic: xml read error
            freeXsAnyTypeType(node);
            free(node);
            return NULL;
          }

          next = node->child_elements;
          if (next == NULL) {
            node->child_elements = child;
          }
          else {
            while (1) {
              if (next->sibling == NULL) {
                next->sibling = child;
                break;
              }
              next = next->sibling;
            }
          }

          break;
        case XML_READER_TYPE_TEXT:
        case XML_READER_TYPE_CDATA:
          text = xmlTextReaderConstValue(reader);
          node->value = xmlStrncat(node->value, text, xmlStrlen(text));
          break;
        default:
          //skip anything else.
          break;
      }

      status = xmlTextReaderRead(reader);
    }

    if (status < 1) {
      //panic: xml read error
      freeXsAnyTypeType(node);
      free(node);
      return NULL;
    }
  }

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  int status;
  int totalBytes = 0;
  struct xmlBasicNode *next;

  status = xmlTextWriterStartElementNS(writer, node->prefix, node->name, node->ns);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  next = node->attributes;
  while (next != NULL) {
    status = xmlTextWriterWriteAttributeNS(writer, next->prefix, next->name, next->ns, next->value);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  if (node->value != NULL) {
    status = xmlTextWriterWriteString(writer, node->value);
    if (status < 0) {
      //panic: xml write error
      return status;
    }
    totalBytes += status;
  }

  next = node->child_elements;
  while (next != NULL) {
    status = xmlTextWriterWriteXsAnyTypeType(writer, next);
    if (status < 0) {
      return status;
    }
    totalBytes += status;
    next = next->sibling;
  }

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Read a anyType element value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnyTypeElement(xmlTextReaderPtr reader) {
  return xmlTextReaderReadXsAnyTypeType(reader);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElement(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Write a anyType element value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnyTypeElementNS(xmlTextWriterPtr writer, struct xmlBasicNode *node, int writeNamespaces) {
  return xmlTextWriterWriteXsAnyTypeType(writer, node);
}

/**
 * Free a anyType element value.
 *
 * @param node The node.
 */
static void freeXsAnyTypeElement(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/*******************xs:anySimpleType************************************/

/**
 * Frees a anyType type from memory.
 *
 * @param node The node to free.
 */
static void freeXsAnySimpleTypeType(struct xmlBasicNode *node) {
  freeXsAnyTypeType(node);
}

/**
 * Read a anyType value from the reader.
 *
 * @param reader The reader (pointing at a node with a value).
 * @return pointer to the anyType., or NULL if error.
 */
static struct xmlBasicNode *xmlTextReaderReadXsAnySimpleTypeType(xmlTextReaderPtr reader) {
  struct xmlBasicNode *node = calloc(1, sizeof(struct xmlBasicNode));

  node->name = xmlTextReaderLocalName(reader);
  node->ns = xmlTextReaderNamespaceUri(reader);
  node->prefix = xmlTextReaderPrefix(reader);
  node->value = xmlTextReaderReadEntireNodeValue(reader);

  return node;
}

/**
 * Write a anyType value to the writer.
 *
 * @param writer The writer.
 * @param node The node to be written.
 * @return the bytes written (may be 0 because of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteXsAnySimpleTypeType(xmlTextWriterPtr writer, struct xmlBasicNode *node) {
  if (node->value != NULL) {
    return xmlTextWriterWriteXsStringType(writer, node->value);
  }

  return 0;
}

#endif /* BASIC_XML_FUNCTIONS_Xs */

#ifndef DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_H
#define DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResource {


  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  int effectiveUsers;
};

/**
 * Reads a PlexusUserSearchCriteriaResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_plexusUserSearchCriteriaResource *xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceType(xmlTextReaderPtr reader);

/**
 * Writes a PlexusUserSearchCriteriaResource to XML.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResource The PlexusUserSearchCriteriaResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResource *_plexusUserSearchCriteriaResource);

/**
 * Frees the elements of a PlexusUserSearchCriteriaResource.
 *
 * @param _plexusUserSearchCriteriaResource The PlexusUserSearchCriteriaResource to free.
 */
static void freeNs0PlexusUserSearchCriteriaResourceType(struct security_rest_api_ns0_plexusUserSearchCriteriaResource *_plexusUserSearchCriteriaResource);

#endif /* DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_H */
#ifndef DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_H
#define DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_plexusUserSearchCriteriaResource *data;
};

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest element from XML. The element to be read is "user-search", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xml_read_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

/**
 * Frees a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to free.
 */
void free_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest element from XML. The element to be read is "user-search", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xmlTextReaderReadNs0User_searchElement(xmlTextReaderPtr reader);

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_searchElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_searchElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest, int writeNamespaces);

/**
 * Frees the children of a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest whose children are to be free.
 */
static void freeNs0User_searchElement(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

/**
 * Frees the elements of a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to free.
 */
static void freeNs0PlexusUserSearchCriteriaResourceRequestType(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest);

#endif /* DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_H */
#ifndef DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_H
#define DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResource {


  /**
   * (no documentation provided)
   */
  int onlySelected;

  /**
   * (no documentation provided)
   */
  xmlChar *selectedPrivilegeIds;

  /**
   * Size of the selectedPrivilegeIds array.
   */
  int _sizeof_selectedPrivilegeIds;

  /**
   * (no documentation provided)
   */
  int noExternalRoles;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *selectedRoleIds;

  /**
   * Size of the selectedRoleIds array.
   */
  int _sizeof_selectedRoleIds;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *hiddenRoleIds;

  /**
   * Size of the hiddenRoleIds array.
   */
  int _sizeof_hiddenRoleIds;

  /**
   * (no documentation provided)
   */
  int noPrivileges;

  /**
   * (no documentation provided)
   */
  xmlChar *hiddenPrivilegeIds;

  /**
   * Size of the hiddenPrivilegeIds array.
   */
  int _sizeof_hiddenPrivilegeIds;

  /**
   * (no documentation provided)
   */
  int noRoles;
};

/**
 * Reads a RoleAndPrivilegeListFilterResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceType(xmlTextReaderPtr reader);

/**
 * Writes a RoleAndPrivilegeListFilterResource to XML.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResource The RoleAndPrivilegeListFilterResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *_roleAndPrivilegeListFilterResource);

/**
 * Frees the elements of a RoleAndPrivilegeListFilterResource.
 *
 * @param _roleAndPrivilegeListFilterResource The RoleAndPrivilegeListFilterResource to free.
 */
static void freeNs0RoleAndPrivilegeListFilterResourceType(struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *_roleAndPrivilegeListFilterResource);

#endif /* DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_H */
#ifndef DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_H
#define DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *data;
};

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest element from XML. The element to be read is "roles-privs-list-filter", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xml_read_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

/**
 * Frees a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to free.
 */
void free_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest element from XML. The element to be read is "roles-privs-list-filter", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xmlTextReaderReadNs0Roles_privs_list_filterElement(xmlTextReaderPtr reader);

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Roles_privs_list_filterElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Roles_privs_list_filterElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest, int writeNamespaces);

/**
 * Frees the children of a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest whose children are to be free.
 */
static void freeNs0Roles_privs_list_filterElement(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

/**
 * Frees the elements of a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to free.
 */
static void freeNs0RoleAndPrivilegeListFilterResourceRequestType(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest);

#endif /* DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_H */
#ifndef DEF_security_rest_api_ns0_roleResource_H
#define DEF_security_rest_api_ns0_roleResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_roleResource {


  /**
   * (no documentation provided)
   */
  int sessionTimeout;

  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *name;

  /**
   * (no documentation provided)
   */
  xmlChar *description;

  /**
   * (no documentation provided)
   */
  xmlChar *roles;

  /**
   * Size of the roles array.
   */
  int _sizeof_roles;

  /**
   * (no documentation provided)
   */
  xmlChar *id;

  /**
   * (no documentation provided)
   */
  int userManaged;

  /**
   * (no documentation provided)
   */
  xmlChar *privileges;

  /**
   * Size of the privileges array.
   */
  int _sizeof_privileges;
};

/**
 * Reads a RoleResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RoleResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleResource *xmlTextReaderReadNs0RoleResourceType(xmlTextReaderPtr reader);

/**
 * Writes a RoleResource to XML.
 *
 * @param writer The XML writer.
 * @param _roleResource The RoleResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RoleResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResource *_roleResource);

/**
 * Frees the elements of a RoleResource.
 *
 * @param _roleResource The RoleResource to free.
 */
static void freeNs0RoleResourceType(struct security_rest_api_ns0_roleResource *_roleResource);

#endif /* DEF_security_rest_api_ns0_roleResource_H */
#ifndef DEF_security_rest_api_ns0_roleResourceRequest_H
#define DEF_security_rest_api_ns0_roleResourceRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_roleResourceRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_roleResource *data;
};

/**
 * Reads a RoleResourceRequest element from XML. The element to be read is "role-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleResourceRequest *xml_read_security_rest_api_ns0_roleResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_roleResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

/**
 * Frees a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest to free.
 */
void free_security_rest_api_ns0_roleResourceRequest(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

/**
 * Reads a RoleResourceRequest element from XML. The element to be read is "role-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The RoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleResourceRequest *xmlTextReaderReadNs0Role_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Role_requestElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0Role_requestElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest, int writeNamespaces);

/**
 * Frees the children of a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest whose children are to be free.
 */
static void freeNs0Role_requestElement(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

/**
 * Reads a RoleResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The RoleResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleResourceRequest *xmlTextReaderReadNs0RoleResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a RoleResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0RoleResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

/**
 * Frees the elements of a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest to free.
 */
static void freeNs0RoleResourceRequestType(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest);

#endif /* DEF_security_rest_api_ns0_roleResourceRequest_H */
#ifndef DEF_security_rest_api_ns0_userChangePasswordRequest_H
#define DEF_security_rest_api_ns0_userChangePasswordRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userChangePasswordRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_userChangePasswordResource *data;
};

/**
 * Reads a UserChangePasswordRequest element from XML. The element to be read is "user-changepw", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userChangePasswordRequest *xml_read_security_rest_api_ns0_userChangePasswordRequest(xmlTextReaderPtr reader);

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_userChangePasswordRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

/**
 * Frees a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest to free.
 */
void free_security_rest_api_ns0_userChangePasswordRequest(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

/**
 * Reads a UserChangePasswordRequest element from XML. The element to be read is "user-changepw", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userChangePasswordRequest *xmlTextReaderReadNs0User_changepwElement(xmlTextReaderPtr reader);

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_changepwElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_changepwElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest, int writeNamespaces);

/**
 * Frees the children of a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest whose children are to be free.
 */
static void freeNs0User_changepwElement(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

/**
 * Reads a UserChangePasswordRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userChangePasswordRequest *xmlTextReaderReadNs0UserChangePasswordRequestType(xmlTextReaderPtr reader);

/**
 * Writes a UserChangePasswordRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserChangePasswordRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

/**
 * Frees the elements of a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest to free.
 */
static void freeNs0UserChangePasswordRequestType(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest);

#endif /* DEF_security_rest_api_ns0_userChangePasswordRequest_H */
#ifndef DEF_security_rest_api_ns0_userChangePasswordResource_H
#define DEF_security_rest_api_ns0_userChangePasswordResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userChangePasswordResource {


  /**
   * (no documentation provided)
   */
  xmlChar *oldPassword;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *newPassword;
};

/**
 * Reads a UserChangePasswordResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userChangePasswordResource *xmlTextReaderReadNs0UserChangePasswordResourceType(xmlTextReaderPtr reader);

/**
 * Writes a UserChangePasswordResource to XML.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordResource The UserChangePasswordResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserChangePasswordResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordResource *_userChangePasswordResource);

/**
 * Frees the elements of a UserChangePasswordResource.
 *
 * @param _userChangePasswordResource The UserChangePasswordResource to free.
 */
static void freeNs0UserChangePasswordResourceType(struct security_rest_api_ns0_userChangePasswordResource *_userChangePasswordResource);

#endif /* DEF_security_rest_api_ns0_userChangePasswordResource_H */
#ifndef DEF_security_rest_api_ns0_userForgotPasswordRequest_H
#define DEF_security_rest_api_ns0_userForgotPasswordRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userForgotPasswordRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_userForgotPasswordResource *data;
};

/**
 * Reads a UserForgotPasswordRequest element from XML. The element to be read is "user-forgotpw", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userForgotPasswordRequest *xml_read_security_rest_api_ns0_userForgotPasswordRequest(xmlTextReaderPtr reader);

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_userForgotPasswordRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

/**
 * Frees a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to free.
 */
void free_security_rest_api_ns0_userForgotPasswordRequest(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

/**
 * Reads a UserForgotPasswordRequest element from XML. The element to be read is "user-forgotpw", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userForgotPasswordRequest *xmlTextReaderReadNs0User_forgotpwElement(xmlTextReaderPtr reader);

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_forgotpwElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_forgotpwElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest, int writeNamespaces);

/**
 * Frees the children of a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest whose children are to be free.
 */
static void freeNs0User_forgotpwElement(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

/**
 * Reads a UserForgotPasswordRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userForgotPasswordRequest *xmlTextReaderReadNs0UserForgotPasswordRequestType(xmlTextReaderPtr reader);

/**
 * Writes a UserForgotPasswordRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserForgotPasswordRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

/**
 * Frees the elements of a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to free.
 */
static void freeNs0UserForgotPasswordRequestType(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest);

#endif /* DEF_security_rest_api_ns0_userForgotPasswordRequest_H */
#ifndef DEF_security_rest_api_ns0_userForgotPasswordResource_H
#define DEF_security_rest_api_ns0_userForgotPasswordResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userForgotPasswordResource {


  /**
   * (no documentation provided)
   */
  xmlChar *email;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;
};

/**
 * Reads a UserForgotPasswordResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userForgotPasswordResource *xmlTextReaderReadNs0UserForgotPasswordResourceType(xmlTextReaderPtr reader);

/**
 * Writes a UserForgotPasswordResource to XML.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordResource The UserForgotPasswordResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserForgotPasswordResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordResource *_userForgotPasswordResource);

/**
 * Frees the elements of a UserForgotPasswordResource.
 *
 * @param _userForgotPasswordResource The UserForgotPasswordResource to free.
 */
static void freeNs0UserForgotPasswordResourceType(struct security_rest_api_ns0_userForgotPasswordResource *_userForgotPasswordResource);

#endif /* DEF_security_rest_api_ns0_userForgotPasswordResource_H */
#ifndef DEF_security_rest_api_ns0_userResource_H
#define DEF_security_rest_api_ns0_userResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userResource {


  /**
   * (no documentation provided)
   */
  xmlChar *resourceURI;

  /**
   * (no documentation provided)
   */
  xmlChar *lastName;

  /**
   * (no documentation provided)
   */
  xmlChar *email;

  /**
   * (no documentation provided)
   */
  xmlChar *firstName;

  /**
   * (no documentation provided)
   */
  xmlChar *password;

  /**
   * (no documentation provided)
   */
  xmlChar *roles;

  /**
   * Size of the roles array.
   */
  int _sizeof_roles;

  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *status;
};

/**
 * Reads a UserResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userResource *xmlTextReaderReadNs0UserResourceType(xmlTextReaderPtr reader);

/**
 * Writes a UserResource to XML.
 *
 * @param writer The XML writer.
 * @param _userResource The UserResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResource *_userResource);

/**
 * Frees the elements of a UserResource.
 *
 * @param _userResource The UserResource to free.
 */
static void freeNs0UserResourceType(struct security_rest_api_ns0_userResource *_userResource);

#endif /* DEF_security_rest_api_ns0_userResource_H */
#ifndef DEF_security_rest_api_ns0_userResourceRequest_H
#define DEF_security_rest_api_ns0_userResourceRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userResourceRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_userResource *data;
};

/**
 * Reads a UserResourceRequest element from XML. The element to be read is "user-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userResourceRequest *xml_read_security_rest_api_ns0_userResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_userResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

/**
 * Frees a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest to free.
 */
void free_security_rest_api_ns0_userResourceRequest(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

/**
 * Reads a UserResourceRequest element from XML. The element to be read is "user-request", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userResourceRequest *xmlTextReaderReadNs0User_requestElement(xmlTextReaderPtr reader);

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_requestElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_requestElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest, int writeNamespaces);

/**
 * Frees the children of a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest whose children are to be free.
 */
static void freeNs0User_requestElement(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

/**
 * Reads a UserResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userResourceRequest *xmlTextReaderReadNs0UserResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a UserResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

/**
 * Frees the elements of a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest to free.
 */
static void freeNs0UserResourceRequestType(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest);

#endif /* DEF_security_rest_api_ns0_userResourceRequest_H */
#ifndef DEF_security_rest_api_ns0_userToRoleResource_H
#define DEF_security_rest_api_ns0_userToRoleResource_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userToRoleResource {


  /**
   * (no documentation provided)
   */
  xmlChar *userId;

  /**
   * (no documentation provided)
   */
  xmlChar *source;

  /**
   * (no documentation provided)
   */
  xmlChar *roles;

  /**
   * Size of the roles array.
   */
  int _sizeof_roles;
};

/**
 * Reads a UserToRoleResource from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserToRoleResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userToRoleResource *xmlTextReaderReadNs0UserToRoleResourceType(xmlTextReaderPtr reader);

/**
 * Writes a UserToRoleResource to XML.
 *
 * @param writer The XML writer.
 * @param _userToRoleResource The UserToRoleResource to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserToRoleResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResource *_userToRoleResource);

/**
 * Frees the elements of a UserToRoleResource.
 *
 * @param _userToRoleResource The UserToRoleResource to free.
 */
static void freeNs0UserToRoleResourceType(struct security_rest_api_ns0_userToRoleResource *_userToRoleResource);

#endif /* DEF_security_rest_api_ns0_userToRoleResource_H */
#ifndef DEF_security_rest_api_ns0_userToRoleResourceRequest_H
#define DEF_security_rest_api_ns0_userToRoleResourceRequest_H

/**
 * (no documentation provided)
 */
struct security_rest_api_ns0_userToRoleResourceRequest {


  /**
   * (no documentation provided)
   */
  struct security_rest_api_ns0_userToRoleResource *data;
};

/**
 * Reads a UserToRoleResourceRequest element from XML. The element to be read is "user-to-role", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserToRoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userToRoleResourceRequest *xml_read_security_rest_api_ns0_userToRoleResourceRequest(xmlTextReaderPtr reader);

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
int xml_write_security_rest_api_ns0_userToRoleResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

/**
 * Frees a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to free.
 */
void free_security_rest_api_ns0_userToRoleResourceRequest(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

/**
 * Reads a UserToRoleResourceRequest element from XML. The element to be read is "user-to-role", and
 * it is assumed that the reader is already pointing to the element.
 *
 * @param reader The XML reader.
 * @return The UserToRoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userToRoleResourceRequest *xmlTextReaderReadNs0User_to_roleElement(xmlTextReaderPtr reader);

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_to_roleElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0User_to_roleElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest, int writeNamespaces);

/**
 * Frees the children of a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest whose children are to be free.
 */
static void freeNs0User_to_roleElement(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

/**
 * Reads a UserToRoleResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @param reader The XML reader.
 * @return The UserToRoleResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userToRoleResourceRequest *xmlTextReaderReadNs0UserToRoleResourceRequestType(xmlTextReaderPtr reader);

/**
 * Writes a UserToRoleResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return The bytes written (may be 0 in case of buffering) or -1 in case of error.
 */
static int xmlTextWriterWriteNs0UserToRoleResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

/**
 * Frees the elements of a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to free.
 */
static void freeNs0UserToRoleResourceRequestType(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest);

#endif /* DEF_security_rest_api_ns0_userToRoleResourceRequest_H */
#ifndef DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_M
#define DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_M

/**
 * Reads a PlexusUserSearchCriteriaResource from XML. The reader is assumed to be at the start element.
 *
 * @return the PlexusUserSearchCriteriaResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_plexusUserSearchCriteriaResource *xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_plexusUserSearchCriteriaResource *_plexusUserSearchCriteriaResource = calloc(1, sizeof(struct security_rest_api_ns0_plexusUserSearchCriteriaResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PlexusUserSearchCriteriaResourceType(_plexusUserSearchCriteriaResource);
        free(_plexusUserSearchCriteriaResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PlexusUserSearchCriteriaResourceType(_plexusUserSearchCriteriaResource);
          free(_plexusUserSearchCriteriaResource);
          return NULL;
        }

        _plexusUserSearchCriteriaResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "effectiveUsers", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}effectiveUsers of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}effectiveUsers of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PlexusUserSearchCriteriaResourceType(_plexusUserSearchCriteriaResource);
          free(_plexusUserSearchCriteriaResource);
          return NULL;
        }

        _plexusUserSearchCriteriaResource->effectiveUsers = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}plexusUserSearchCriteriaResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}plexusUserSearchCriteriaResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _plexusUserSearchCriteriaResource;
}

/**
 * Writes a PlexusUserSearchCriteriaResource to XML.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResource The PlexusUserSearchCriteriaResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResource *_plexusUserSearchCriteriaResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_plexusUserSearchCriteriaResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_plexusUserSearchCriteriaResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "effectiveUsers", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}effectiveUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}effectiveUsers...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_plexusUserSearchCriteriaResource->effectiveUsers));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}effectiveUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}effectiveUsers. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PlexusUserSearchCriteriaResource.
 *
 * @param _plexusUserSearchCriteriaResource The PlexusUserSearchCriteriaResource to free.
 */
static void freeNs0PlexusUserSearchCriteriaResourceType(struct security_rest_api_ns0_plexusUserSearchCriteriaResource *_plexusUserSearchCriteriaResource) {
  int i;
  if (_plexusUserSearchCriteriaResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_plexusUserSearchCriteriaResource...\n");
#endif
    freeXsStringType(_plexusUserSearchCriteriaResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_plexusUserSearchCriteriaResource...\n");
#endif
    free(_plexusUserSearchCriteriaResource->userId);
  }
}
#endif /* DEF_security_rest_api_ns0_plexusUserSearchCriteriaResource_M */
#ifndef DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_M
#define DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_M

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest element from XML. The element to be read is "user-search", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xml_read_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_searchElement(reader);
}

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  return xmlTextWriterWriteNs0User_searchElementNS(writer, _plexusUserSearchCriteriaResourceRequest, 1);
}

/**
 * Frees a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to free.
 */
void free_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  freeNs0PlexusUserSearchCriteriaResourceRequestType(_plexusUserSearchCriteriaResourceRequest);
  free(_plexusUserSearchCriteriaResourceRequest);
}

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest element from XML. The element to be read is "user-search", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xmlTextReaderReadNs0User_searchElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-search", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-search.\n");
#endif
    _plexusUserSearchCriteriaResourceRequest = xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_plexusUserSearchCriteriaResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-search failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-search failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _plexusUserSearchCriteriaResourceRequest;
}

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_searchElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  return xmlTextWriterWriteNs0User_searchElementNS(writer, _plexusUserSearchCriteriaResourceRequest, 0);
}

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML under element name "user-search".
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_searchElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-search", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-search. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}plexusUserSearchCriteriaResourceRequest for root element {}user-search...\n");
#endif
  status = xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceRequestType(writer, _plexusUserSearchCriteriaResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-search. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-search. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest whose children are to be free.
 */
static void freeNs0User_searchElement(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  freeNs0PlexusUserSearchCriteriaResourceRequestType(_plexusUserSearchCriteriaResourceRequest);
}

/**
 * Reads a PlexusUserSearchCriteriaResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the PlexusUserSearchCriteriaResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest = calloc(1, sizeof(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0PlexusUserSearchCriteriaResourceRequestType(_plexusUserSearchCriteriaResourceRequest);
        free(_plexusUserSearchCriteriaResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}plexusUserSearchCriteriaResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0PlexusUserSearchCriteriaResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}plexusUserSearchCriteriaResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0PlexusUserSearchCriteriaResourceRequestType(_plexusUserSearchCriteriaResourceRequest);
          free(_plexusUserSearchCriteriaResourceRequest);
          return NULL;
        }

        _plexusUserSearchCriteriaResourceRequest->data = ((struct security_rest_api_ns0_plexusUserSearchCriteriaResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}plexusUserSearchCriteriaResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}plexusUserSearchCriteriaResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _plexusUserSearchCriteriaResourceRequest;
}

/**
 * Writes a PlexusUserSearchCriteriaResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_plexusUserSearchCriteriaResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}plexusUserSearchCriteriaResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0PlexusUserSearchCriteriaResourceType(writer, (_plexusUserSearchCriteriaResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}plexusUserSearchCriteriaResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a PlexusUserSearchCriteriaResourceRequest.
 *
 * @param _plexusUserSearchCriteriaResourceRequest The PlexusUserSearchCriteriaResourceRequest to free.
 */
static void freeNs0PlexusUserSearchCriteriaResourceRequestType(struct security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest *_plexusUserSearchCriteriaResourceRequest) {
  int i;
  if (_plexusUserSearchCriteriaResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest...\n");
#endif
    freeNs0PlexusUserSearchCriteriaResourceType(_plexusUserSearchCriteriaResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest...\n");
#endif
    free(_plexusUserSearchCriteriaResourceRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_plexusUserSearchCriteriaResourceRequest_M */
#ifndef DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_M
#define DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_M

/**
 * Reads a RoleAndPrivilegeListFilterResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RoleAndPrivilegeListFilterResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *_roleAndPrivilegeListFilterResource = calloc(1, sizeof(struct security_rest_api_ns0_roleAndPrivilegeListFilterResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
        free(_roleAndPrivilegeListFilterResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "onlySelected", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}onlySelected of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}onlySelected of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->onlySelected = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "selctedPrivilegeIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}selctedPrivilegeIds...\n");
#endif
          //start wrapper element "{}selctedPrivilegeIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
              free(_roleAndPrivilegeListFilterResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "selectedPrivilegeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}selectedPrivilegeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}selectedPrivilegeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->selectedPrivilegeIds = realloc(_roleAndPrivilegeListFilterResource->selectedPrivilegeIds, (_roleAndPrivilegeListFilterResource->_sizeof_selectedPrivilegeIds + 1) * sizeof(xmlChar));
        memcpy(&(_roleAndPrivilegeListFilterResource->selectedPrivilegeIds[_roleAndPrivilegeListFilterResource->_sizeof_selectedPrivilegeIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}selctedPrivilegeIds.\n");
#endif
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }
        else {
          //end wrapper element "{}selctedPrivilegeIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "noExternalRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}noExternalRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}noExternalRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->noExternalRoles = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "selctedRoleIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}selctedRoleIds...\n");
#endif
          //start wrapper element "{}selctedRoleIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
              free(_roleAndPrivilegeListFilterResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "selectedRoleId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}selectedRoleId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}selectedRoleId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->selectedRoleIds = realloc(_roleAndPrivilegeListFilterResource->selectedRoleIds, (_roleAndPrivilegeListFilterResource->_sizeof_selectedRoleIds + 1) * sizeof(xmlChar));
        memcpy(&(_roleAndPrivilegeListFilterResource->selectedRoleIds[_roleAndPrivilegeListFilterResource->_sizeof_selectedRoleIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}selctedRoleIds.\n");
#endif
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }
        else {
          //end wrapper element "{}selctedRoleIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "hiddenRoleIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}hiddenRoleIds...\n");
#endif
          //start wrapper element "{}hiddenRoleIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
              free(_roleAndPrivilegeListFilterResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "hiddenRoleId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}hiddenRoleId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}hiddenRoleId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->hiddenRoleIds = realloc(_roleAndPrivilegeListFilterResource->hiddenRoleIds, (_roleAndPrivilegeListFilterResource->_sizeof_hiddenRoleIds + 1) * sizeof(xmlChar));
        memcpy(&(_roleAndPrivilegeListFilterResource->hiddenRoleIds[_roleAndPrivilegeListFilterResource->_sizeof_hiddenRoleIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}hiddenRoleIds.\n");
#endif
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }
        else {
          //end wrapper element "{}hiddenRoleIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "noPrivileges", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}noPrivileges of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}noPrivileges of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->noPrivileges = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "hiddenPrivilegeIds", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}hiddenPrivilegeIds...\n");
#endif
          //start wrapper element "{}hiddenPrivilegeIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
              free(_roleAndPrivilegeListFilterResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "hiddenPrivilegeId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}hiddenPrivilegeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}hiddenPrivilegeId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->hiddenPrivilegeIds = realloc(_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds, (_roleAndPrivilegeListFilterResource->_sizeof_hiddenPrivilegeIds + 1) * sizeof(xmlChar));
        memcpy(&(_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds[_roleAndPrivilegeListFilterResource->_sizeof_hiddenPrivilegeIds++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}hiddenPrivilegeIds.\n");
#endif
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }
        else {
          //end wrapper element "{}hiddenPrivilegeIds"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "noRoles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}noRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}noRoles of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResource);
          free(_roleAndPrivilegeListFilterResource);
          return NULL;
        }

        _roleAndPrivilegeListFilterResource->noRoles = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}roleAndPrivilegeListFilterResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}roleAndPrivilegeListFilterResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _roleAndPrivilegeListFilterResource;
}

/**
 * Writes a RoleAndPrivilegeListFilterResource to XML.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResource The RoleAndPrivilegeListFilterResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *_roleAndPrivilegeListFilterResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "onlySelected", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}onlySelected. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}onlySelected...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_roleAndPrivilegeListFilterResource->onlySelected));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}onlySelected. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}onlySelected. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->selectedPrivilegeIds != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "selctedPrivilegeIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}selctedPrivilegeIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_selectedPrivilegeIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "selectedPrivilegeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}selectedPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}selectedPrivilegeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleAndPrivilegeListFilterResource->selectedPrivilegeIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}selectedPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}selectedPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->selectedPrivilegeIds != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}selctedPrivilegeIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "noExternalRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}noExternalRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}noExternalRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_roleAndPrivilegeListFilterResource->noExternalRoles));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}noExternalRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}noExternalRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleAndPrivilegeListFilterResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleAndPrivilegeListFilterResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->selectedRoleIds != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "selctedRoleIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}selctedRoleIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_selectedRoleIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "selectedRoleId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}selectedRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}selectedRoleId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleAndPrivilegeListFilterResource->selectedRoleIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}selectedRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}selectedRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->selectedRoleIds != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}selctedRoleIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleAndPrivilegeListFilterResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleAndPrivilegeListFilterResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->hiddenRoleIds != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "hiddenRoleIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}hiddenRoleIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_hiddenRoleIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "hiddenRoleId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}hiddenRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}hiddenRoleId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleAndPrivilegeListFilterResource->hiddenRoleIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}hiddenRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}hiddenRoleId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->hiddenRoleIds != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}hiddenRoleIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "noPrivileges", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}noPrivileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}noPrivileges...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_roleAndPrivilegeListFilterResource->noPrivileges));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}noPrivileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}noPrivileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "hiddenPrivilegeIds", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}hiddenPrivilegeIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_hiddenPrivilegeIds; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "hiddenPrivilegeId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}hiddenPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}hiddenPrivilegeId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}hiddenPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}hiddenPrivilegeId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}hiddenPrivilegeIds. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "noRoles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}noRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}noRoles...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_roleAndPrivilegeListFilterResource->noRoles));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}noRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}noRoles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RoleAndPrivilegeListFilterResource.
 *
 * @param _roleAndPrivilegeListFilterResource The RoleAndPrivilegeListFilterResource to free.
 */
static void freeNs0RoleAndPrivilegeListFilterResourceType(struct security_rest_api_ns0_roleAndPrivilegeListFilterResource *_roleAndPrivilegeListFilterResource) {
  int i;
  if (_roleAndPrivilegeListFilterResource->selectedPrivilegeIds != NULL) {
    for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_selectedPrivilegeIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor selectedPrivilegeIds[%i] of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n", i);
#endif
      freeXsStringType(&(_roleAndPrivilegeListFilterResource->selectedPrivilegeIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor selectedPrivilegeIds of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->selectedPrivilegeIds);
  }
  if (_roleAndPrivilegeListFilterResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    freeXsStringType(_roleAndPrivilegeListFilterResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->name);
  }
  if (_roleAndPrivilegeListFilterResource->selectedRoleIds != NULL) {
    for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_selectedRoleIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor selectedRoleIds[%i] of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n", i);
#endif
      freeXsStringType(&(_roleAndPrivilegeListFilterResource->selectedRoleIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor selectedRoleIds of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->selectedRoleIds);
  }
  if (_roleAndPrivilegeListFilterResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    freeXsStringType(_roleAndPrivilegeListFilterResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->userId);
  }
  if (_roleAndPrivilegeListFilterResource->hiddenRoleIds != NULL) {
    for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_hiddenRoleIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor hiddenRoleIds[%i] of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n", i);
#endif
      freeXsStringType(&(_roleAndPrivilegeListFilterResource->hiddenRoleIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor hiddenRoleIds of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->hiddenRoleIds);
  }
  if (_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds != NULL) {
    for (i = 0; i < _roleAndPrivilegeListFilterResource->_sizeof_hiddenPrivilegeIds; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor hiddenPrivilegeIds[%i] of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n", i);
#endif
      freeXsStringType(&(_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor hiddenPrivilegeIds of type security_rest_api_ns0_roleAndPrivilegeListFilterResource...\n");
#endif
    free(_roleAndPrivilegeListFilterResource->hiddenPrivilegeIds);
  }
}
#endif /* DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResource_M */
#ifndef DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_M
#define DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_M

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest element from XML. The element to be read is "roles-privs-list-filter", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xml_read_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Roles_privs_list_filterElement(reader);
}

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  return xmlTextWriterWriteNs0Roles_privs_list_filterElementNS(writer, _roleAndPrivilegeListFilterResourceRequest, 1);
}

/**
 * Frees a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to free.
 */
void free_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  freeNs0RoleAndPrivilegeListFilterResourceRequestType(_roleAndPrivilegeListFilterResourceRequest);
  free(_roleAndPrivilegeListFilterResourceRequest);
}

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest element from XML. The element to be read is "roles-privs-list-filter", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xmlTextReaderReadNs0Roles_privs_list_filterElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "roles-privs-list-filter", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}roles-privs-list-filter.\n");
#endif
    _roleAndPrivilegeListFilterResourceRequest = xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_roleAndPrivilegeListFilterResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}roles-privs-list-filter failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}roles-privs-list-filter failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _roleAndPrivilegeListFilterResourceRequest;
}

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Roles_privs_list_filterElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  return xmlTextWriterWriteNs0Roles_privs_list_filterElementNS(writer, _roleAndPrivilegeListFilterResourceRequest, 0);
}

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML under element name "roles-privs-list-filter".
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Roles_privs_list_filterElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles-privs-list-filter", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}roles-privs-list-filter. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}roleAndPrivilegeListFilterResourceRequest for root element {}roles-privs-list-filter...\n");
#endif
  status = xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceRequestType(writer, _roleAndPrivilegeListFilterResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}roles-privs-list-filter. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}roles-privs-list-filter. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest whose children are to be free.
 */
static void freeNs0Roles_privs_list_filterElement(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  freeNs0RoleAndPrivilegeListFilterResourceRequestType(_roleAndPrivilegeListFilterResourceRequest);
}

/**
 * Reads a RoleAndPrivilegeListFilterResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the RoleAndPrivilegeListFilterResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest = calloc(1, sizeof(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RoleAndPrivilegeListFilterResourceRequestType(_roleAndPrivilegeListFilterResourceRequest);
        free(_roleAndPrivilegeListFilterResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "role-priv-list-filter", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}role-priv-list-filter of type {}roleAndPrivilegeListFilterResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0RoleAndPrivilegeListFilterResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}role-priv-list-filter of type {}roleAndPrivilegeListFilterResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleAndPrivilegeListFilterResourceRequestType(_roleAndPrivilegeListFilterResourceRequest);
          free(_roleAndPrivilegeListFilterResourceRequest);
          return NULL;
        }

        _roleAndPrivilegeListFilterResourceRequest->data = ((struct security_rest_api_ns0_roleAndPrivilegeListFilterResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}roleAndPrivilegeListFilterResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}roleAndPrivilegeListFilterResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _roleAndPrivilegeListFilterResourceRequest;
}

/**
 * Writes a RoleAndPrivilegeListFilterResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_roleAndPrivilegeListFilterResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "role-priv-list-filter", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}role-priv-list-filter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}roleAndPrivilegeListFilterResource for element {}role-priv-list-filter...\n", status);
#endif
    status = xmlTextWriterWriteNs0RoleAndPrivilegeListFilterResourceType(writer, (_roleAndPrivilegeListFilterResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}roleAndPrivilegeListFilterResource for element {}role-priv-list-filter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}role-priv-list-filter. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RoleAndPrivilegeListFilterResourceRequest.
 *
 * @param _roleAndPrivilegeListFilterResourceRequest The RoleAndPrivilegeListFilterResourceRequest to free.
 */
static void freeNs0RoleAndPrivilegeListFilterResourceRequestType(struct security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest *_roleAndPrivilegeListFilterResourceRequest) {
  int i;
  if (_roleAndPrivilegeListFilterResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest...\n");
#endif
    freeNs0RoleAndPrivilegeListFilterResourceType(_roleAndPrivilegeListFilterResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest...\n");
#endif
    free(_roleAndPrivilegeListFilterResourceRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_roleAndPrivilegeListFilterResourceRequest_M */
#ifndef DEF_security_rest_api_ns0_roleResource_M
#define DEF_security_rest_api_ns0_roleResource_M

/**
 * Reads a RoleResource from XML. The reader is assumed to be at the start element.
 *
 * @return the RoleResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleResource *xmlTextReaderReadNs0RoleResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_roleResource *_roleResource = calloc(1, sizeof(struct security_rest_api_ns0_roleResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RoleResourceType(_roleResource);
        free(_roleResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "sessionTimeout", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}sessionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
        _child_accessor = xmlTextReaderReadXsIntType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}sessionTimeout of type {http://www.w3.org/2001/XMLSchema}int.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->sessionTimeout = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "name", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}name of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->name = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "description", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}description of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->description = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "roles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}roles...\n");
#endif
          //start wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0RoleResourceType(_roleResource);
              free(_roleResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "role", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->roles = realloc(_roleResource->roles, (_roleResource->_sizeof_roles + 1) * sizeof(xmlChar));
        memcpy(&(_roleResource->roles[_roleResource->_sizeof_roles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}roles.\n");
#endif
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }
        else {
          //end wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "id", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}id of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->id = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userManaged", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userManaged of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
        _child_accessor = xmlTextReaderReadXsBooleanType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userManaged of type {http://www.w3.org/2001/XMLSchema}boolean.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->userManaged = *((int*)_child_accessor);
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "privileges", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}privileges of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}privileges of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceType(_roleResource);
          free(_roleResource);
          return NULL;
        }

        _roleResource->privileges = realloc(_roleResource->privileges, (_roleResource->_sizeof_privileges + 1) * sizeof(xmlChar));
        memcpy(&(_roleResource->privileges[_roleResource->_sizeof_privileges++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}roleResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}roleResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _roleResource;
}

/**
 * Writes a RoleResource to XML.
 *
 * @param writer The XML writer.
 * @param _roleResource The RoleResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RoleResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResource *_roleResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "sessionTimeout", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}sessionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}int for element {}sessionTimeout...\n", status);
#endif
    status = xmlTextWriterWriteXsIntType(writer, &(_roleResource->sessionTimeout));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}int for element {}sessionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}sessionTimeout. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleResource->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleResource->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleResource->name != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "name", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}name...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleResource->name));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}name. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleResource->description != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "description", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}description...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleResource->description));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}description. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleResource->roles != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleResource->_sizeof_roles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "role", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}role...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleResource->roles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_roleResource->roles != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_roleResource->id != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "id", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}id...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_roleResource->id));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}id. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (1) { //always write the primitive element.
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userManaged", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userManaged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}boolean for element {}userManaged...\n", status);
#endif
    status = xmlTextWriterWriteXsBooleanType(writer, &(_roleResource->userManaged));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}boolean for element {}userManaged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userManaged. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _roleResource->_sizeof_privileges; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "privileges", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}privileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}privileges...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_roleResource->privileges[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}privileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}privileges. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RoleResource.
 *
 * @param _roleResource The RoleResource to free.
 */
static void freeNs0RoleResourceType(struct security_rest_api_ns0_roleResource *_roleResource) {
  int i;
  if (_roleResource->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type security_rest_api_ns0_roleResource...\n");
#endif
    freeXsStringType(_roleResource->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->resourceURI);
  }
  if (_roleResource->name != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor name of type security_rest_api_ns0_roleResource...\n");
#endif
    freeXsStringType(_roleResource->name);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor name of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->name);
  }
  if (_roleResource->description != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor description of type security_rest_api_ns0_roleResource...\n");
#endif
    freeXsStringType(_roleResource->description);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor description of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->description);
  }
  if (_roleResource->roles != NULL) {
    for (i = 0; i < _roleResource->_sizeof_roles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor roles[%i] of type security_rest_api_ns0_roleResource...\n", i);
#endif
      freeXsStringType(&(_roleResource->roles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor roles of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->roles);
  }
  if (_roleResource->id != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor id of type security_rest_api_ns0_roleResource...\n");
#endif
    freeXsStringType(_roleResource->id);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor id of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->id);
  }
  if (_roleResource->privileges != NULL) {
    for (i = 0; i < _roleResource->_sizeof_privileges; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor privileges[%i] of type security_rest_api_ns0_roleResource...\n", i);
#endif
      freeXsStringType(&(_roleResource->privileges[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor privileges of type security_rest_api_ns0_roleResource...\n");
#endif
    free(_roleResource->privileges);
  }
}
#endif /* DEF_security_rest_api_ns0_roleResource_M */
#ifndef DEF_security_rest_api_ns0_roleResourceRequest_M
#define DEF_security_rest_api_ns0_roleResourceRequest_M

/**
 * Reads a RoleResourceRequest element from XML. The element to be read is "role-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The RoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleResourceRequest *xml_read_security_rest_api_ns0_roleResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0Role_requestElement(reader);
}

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_roleResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  return xmlTextWriterWriteNs0Role_requestElementNS(writer, _roleResourceRequest, 1);
}

/**
 * Frees a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest to free.
 */
void free_security_rest_api_ns0_roleResourceRequest(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  freeNs0RoleResourceRequestType(_roleResourceRequest);
  free(_roleResourceRequest);
}

/**
 * Reads a RoleResourceRequest element from XML. The element to be read is "role-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The RoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_roleResourceRequest *xmlTextReaderReadNs0Role_requestElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "role-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}role-request.\n");
#endif
    _roleResourceRequest = xmlTextReaderReadNs0RoleResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_roleResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}role-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}role-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _roleResourceRequest;
}

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Role_requestElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  return xmlTextWriterWriteNs0Role_requestElementNS(writer, _roleResourceRequest, 0);
}

/**
 * Writes a RoleResourceRequest to XML under element name "role-request".
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0Role_requestElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "role-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}role-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}roleResourceRequest for root element {}role-request...\n");
#endif
  status = xmlTextWriterWriteNs0RoleResourceRequestType(writer, _roleResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}role-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}role-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest whose children are to be free.
 */
static void freeNs0Role_requestElement(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  freeNs0RoleResourceRequestType(_roleResourceRequest);
}

/**
 * Reads a RoleResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the RoleResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_roleResourceRequest *xmlTextReaderReadNs0RoleResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest = calloc(1, sizeof(struct security_rest_api_ns0_roleResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0RoleResourceRequestType(_roleResourceRequest);
        free(_roleResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}roleResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0RoleResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}roleResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0RoleResourceRequestType(_roleResourceRequest);
          free(_roleResourceRequest);
          return NULL;
        }

        _roleResourceRequest->data = ((struct security_rest_api_ns0_roleResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}roleResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}roleResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _roleResourceRequest;
}

/**
 * Writes a RoleResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _roleResourceRequest The RoleResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0RoleResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_roleResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}roleResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0RoleResourceType(writer, (_roleResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}roleResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a RoleResourceRequest.
 *
 * @param _roleResourceRequest The RoleResourceRequest to free.
 */
static void freeNs0RoleResourceRequestType(struct security_rest_api_ns0_roleResourceRequest *_roleResourceRequest) {
  int i;
  if (_roleResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_roleResourceRequest...\n");
#endif
    freeNs0RoleResourceType(_roleResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_roleResourceRequest...\n");
#endif
    free(_roleResourceRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_roleResourceRequest_M */
#ifndef DEF_security_rest_api_ns0_userChangePasswordRequest_M
#define DEF_security_rest_api_ns0_userChangePasswordRequest_M

/**
 * Reads a UserChangePasswordRequest element from XML. The element to be read is "user-changepw", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userChangePasswordRequest *xml_read_security_rest_api_ns0_userChangePasswordRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_changepwElement(reader);
}

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_userChangePasswordRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  return xmlTextWriterWriteNs0User_changepwElementNS(writer, _userChangePasswordRequest, 1);
}

/**
 * Frees a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest to free.
 */
void free_security_rest_api_ns0_userChangePasswordRequest(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  freeNs0UserChangePasswordRequestType(_userChangePasswordRequest);
  free(_userChangePasswordRequest);
}

/**
 * Reads a UserChangePasswordRequest element from XML. The element to be read is "user-changepw", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserChangePasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userChangePasswordRequest *xmlTextReaderReadNs0User_changepwElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-changepw", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-changepw.\n");
#endif
    _userChangePasswordRequest = xmlTextReaderReadNs0UserChangePasswordRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userChangePasswordRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-changepw failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-changepw failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userChangePasswordRequest;
}

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_changepwElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  return xmlTextWriterWriteNs0User_changepwElementNS(writer, _userChangePasswordRequest, 0);
}

/**
 * Writes a UserChangePasswordRequest to XML under element name "user-changepw".
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_changepwElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-changepw", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-changepw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userChangePasswordRequest for root element {}user-changepw...\n");
#endif
  status = xmlTextWriterWriteNs0UserChangePasswordRequestType(writer, _userChangePasswordRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-changepw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-changepw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest whose children are to be free.
 */
static void freeNs0User_changepwElement(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  freeNs0UserChangePasswordRequestType(_userChangePasswordRequest);
}

/**
 * Reads a UserChangePasswordRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the UserChangePasswordRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userChangePasswordRequest *xmlTextReaderReadNs0UserChangePasswordRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest = calloc(1, sizeof(struct security_rest_api_ns0_userChangePasswordRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserChangePasswordRequestType(_userChangePasswordRequest);
        free(_userChangePasswordRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userChangePasswordResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserChangePasswordResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userChangePasswordResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserChangePasswordRequestType(_userChangePasswordRequest);
          free(_userChangePasswordRequest);
          return NULL;
        }

        _userChangePasswordRequest->data = ((struct security_rest_api_ns0_userChangePasswordResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userChangePasswordRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userChangePasswordRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userChangePasswordRequest;
}

/**
 * Writes a UserChangePasswordRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordRequest The UserChangePasswordRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserChangePasswordRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userChangePasswordRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userChangePasswordResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserChangePasswordResourceType(writer, (_userChangePasswordRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userChangePasswordResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserChangePasswordRequest.
 *
 * @param _userChangePasswordRequest The UserChangePasswordRequest to free.
 */
static void freeNs0UserChangePasswordRequestType(struct security_rest_api_ns0_userChangePasswordRequest *_userChangePasswordRequest) {
  int i;
  if (_userChangePasswordRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_userChangePasswordRequest...\n");
#endif
    freeNs0UserChangePasswordResourceType(_userChangePasswordRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_userChangePasswordRequest...\n");
#endif
    free(_userChangePasswordRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_userChangePasswordRequest_M */
#ifndef DEF_security_rest_api_ns0_userChangePasswordResource_M
#define DEF_security_rest_api_ns0_userChangePasswordResource_M

/**
 * Reads a UserChangePasswordResource from XML. The reader is assumed to be at the start element.
 *
 * @return the UserChangePasswordResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userChangePasswordResource *xmlTextReaderReadNs0UserChangePasswordResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userChangePasswordResource *_userChangePasswordResource = calloc(1, sizeof(struct security_rest_api_ns0_userChangePasswordResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserChangePasswordResourceType(_userChangePasswordResource);
        free(_userChangePasswordResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "oldPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}oldPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}oldPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserChangePasswordResourceType(_userChangePasswordResource);
          free(_userChangePasswordResource);
          return NULL;
        }

        _userChangePasswordResource->oldPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserChangePasswordResourceType(_userChangePasswordResource);
          free(_userChangePasswordResource);
          return NULL;
        }

        _userChangePasswordResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "newPassword", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}newPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}newPassword of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserChangePasswordResourceType(_userChangePasswordResource);
          free(_userChangePasswordResource);
          return NULL;
        }

        _userChangePasswordResource->newPassword = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userChangePasswordResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userChangePasswordResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userChangePasswordResource;
}

/**
 * Writes a UserChangePasswordResource to XML.
 *
 * @param writer The XML writer.
 * @param _userChangePasswordResource The UserChangePasswordResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserChangePasswordResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userChangePasswordResource *_userChangePasswordResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userChangePasswordResource->oldPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "oldPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}oldPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userChangePasswordResource->oldPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}oldPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userChangePasswordResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userChangePasswordResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userChangePasswordResource->newPassword != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "newPassword", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}newPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}newPassword...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userChangePasswordResource->newPassword));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}newPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}newPassword. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserChangePasswordResource.
 *
 * @param _userChangePasswordResource The UserChangePasswordResource to free.
 */
static void freeNs0UserChangePasswordResourceType(struct security_rest_api_ns0_userChangePasswordResource *_userChangePasswordResource) {
  int i;
  if (_userChangePasswordResource->oldPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor oldPassword of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    freeXsStringType(_userChangePasswordResource->oldPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor oldPassword of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    free(_userChangePasswordResource->oldPassword);
  }
  if (_userChangePasswordResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    freeXsStringType(_userChangePasswordResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    free(_userChangePasswordResource->userId);
  }
  if (_userChangePasswordResource->newPassword != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor newPassword of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    freeXsStringType(_userChangePasswordResource->newPassword);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor newPassword of type security_rest_api_ns0_userChangePasswordResource...\n");
#endif
    free(_userChangePasswordResource->newPassword);
  }
}
#endif /* DEF_security_rest_api_ns0_userChangePasswordResource_M */
#ifndef DEF_security_rest_api_ns0_userForgotPasswordRequest_M
#define DEF_security_rest_api_ns0_userForgotPasswordRequest_M

/**
 * Reads a UserForgotPasswordRequest element from XML. The element to be read is "user-forgotpw", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userForgotPasswordRequest *xml_read_security_rest_api_ns0_userForgotPasswordRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_forgotpwElement(reader);
}

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_userForgotPasswordRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  return xmlTextWriterWriteNs0User_forgotpwElementNS(writer, _userForgotPasswordRequest, 1);
}

/**
 * Frees a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to free.
 */
void free_security_rest_api_ns0_userForgotPasswordRequest(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  freeNs0UserForgotPasswordRequestType(_userForgotPasswordRequest);
  free(_userForgotPasswordRequest);
}

/**
 * Reads a UserForgotPasswordRequest element from XML. The element to be read is "user-forgotpw", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserForgotPasswordRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userForgotPasswordRequest *xmlTextReaderReadNs0User_forgotpwElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-forgotpw", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-forgotpw.\n");
#endif
    _userForgotPasswordRequest = xmlTextReaderReadNs0UserForgotPasswordRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userForgotPasswordRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-forgotpw failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-forgotpw failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userForgotPasswordRequest;
}

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_forgotpwElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  return xmlTextWriterWriteNs0User_forgotpwElementNS(writer, _userForgotPasswordRequest, 0);
}

/**
 * Writes a UserForgotPasswordRequest to XML under element name "user-forgotpw".
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_forgotpwElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-forgotpw", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-forgotpw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userForgotPasswordRequest for root element {}user-forgotpw...\n");
#endif
  status = xmlTextWriterWriteNs0UserForgotPasswordRequestType(writer, _userForgotPasswordRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-forgotpw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-forgotpw. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest whose children are to be free.
 */
static void freeNs0User_forgotpwElement(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  freeNs0UserForgotPasswordRequestType(_userForgotPasswordRequest);
}

/**
 * Reads a UserForgotPasswordRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the UserForgotPasswordRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userForgotPasswordRequest *xmlTextReaderReadNs0UserForgotPasswordRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest = calloc(1, sizeof(struct security_rest_api_ns0_userForgotPasswordRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserForgotPasswordRequestType(_userForgotPasswordRequest);
        free(_userForgotPasswordRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userForgotPasswordResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserForgotPasswordResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userForgotPasswordResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserForgotPasswordRequestType(_userForgotPasswordRequest);
          free(_userForgotPasswordRequest);
          return NULL;
        }

        _userForgotPasswordRequest->data = ((struct security_rest_api_ns0_userForgotPasswordResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userForgotPasswordRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userForgotPasswordRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userForgotPasswordRequest;
}

/**
 * Writes a UserForgotPasswordRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserForgotPasswordRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userForgotPasswordRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userForgotPasswordResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserForgotPasswordResourceType(writer, (_userForgotPasswordRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userForgotPasswordResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserForgotPasswordRequest.
 *
 * @param _userForgotPasswordRequest The UserForgotPasswordRequest to free.
 */
static void freeNs0UserForgotPasswordRequestType(struct security_rest_api_ns0_userForgotPasswordRequest *_userForgotPasswordRequest) {
  int i;
  if (_userForgotPasswordRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_userForgotPasswordRequest...\n");
#endif
    freeNs0UserForgotPasswordResourceType(_userForgotPasswordRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_userForgotPasswordRequest...\n");
#endif
    free(_userForgotPasswordRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_userForgotPasswordRequest_M */
#ifndef DEF_security_rest_api_ns0_userForgotPasswordResource_M
#define DEF_security_rest_api_ns0_userForgotPasswordResource_M

/**
 * Reads a UserForgotPasswordResource from XML. The reader is assumed to be at the start element.
 *
 * @return the UserForgotPasswordResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userForgotPasswordResource *xmlTextReaderReadNs0UserForgotPasswordResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userForgotPasswordResource *_userForgotPasswordResource = calloc(1, sizeof(struct security_rest_api_ns0_userForgotPasswordResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserForgotPasswordResourceType(_userForgotPasswordResource);
        free(_userForgotPasswordResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserForgotPasswordResourceType(_userForgotPasswordResource);
          free(_userForgotPasswordResource);
          return NULL;
        }

        _userForgotPasswordResource->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserForgotPasswordResourceType(_userForgotPasswordResource);
          free(_userForgotPasswordResource);
          return NULL;
        }

        _userForgotPasswordResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userForgotPasswordResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userForgotPasswordResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userForgotPasswordResource;
}

/**
 * Writes a UserForgotPasswordResource to XML.
 *
 * @param writer The XML writer.
 * @param _userForgotPasswordResource The UserForgotPasswordResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserForgotPasswordResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userForgotPasswordResource *_userForgotPasswordResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userForgotPasswordResource->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userForgotPasswordResource->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userForgotPasswordResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userForgotPasswordResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserForgotPasswordResource.
 *
 * @param _userForgotPasswordResource The UserForgotPasswordResource to free.
 */
static void freeNs0UserForgotPasswordResourceType(struct security_rest_api_ns0_userForgotPasswordResource *_userForgotPasswordResource) {
  int i;
  if (_userForgotPasswordResource->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type security_rest_api_ns0_userForgotPasswordResource...\n");
#endif
    freeXsStringType(_userForgotPasswordResource->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type security_rest_api_ns0_userForgotPasswordResource...\n");
#endif
    free(_userForgotPasswordResource->email);
  }
  if (_userForgotPasswordResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_userForgotPasswordResource...\n");
#endif
    freeXsStringType(_userForgotPasswordResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_userForgotPasswordResource...\n");
#endif
    free(_userForgotPasswordResource->userId);
  }
}
#endif /* DEF_security_rest_api_ns0_userForgotPasswordResource_M */
#ifndef DEF_security_rest_api_ns0_userResource_M
#define DEF_security_rest_api_ns0_userResource_M

/**
 * Reads a UserResource from XML. The reader is assumed to be at the start element.
 *
 * @return the UserResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userResource *xmlTextReaderReadNs0UserResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userResource *_userResource = calloc(1, sizeof(struct security_rest_api_ns0_userResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserResourceType(_userResource);
        free(_userResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "resourceURI", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}resourceURI of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->resourceURI = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "lastName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}lastName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->lastName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "email", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}email of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->email = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "firstName", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}firstName of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->firstName = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "password", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}password of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->password = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "roles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}roles...\n");
#endif
          //start wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0UserResourceType(_userResource);
              free(_userResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "role", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->roles = realloc(_userResource->roles, (_userResource->_sizeof_roles + 1) * sizeof(xmlChar));
        memcpy(&(_userResource->roles[_userResource->_sizeof_roles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}roles.\n");
#endif
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }
        else {
          //end wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "status", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}status of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceType(_userResource);
          free(_userResource);
          return NULL;
        }

        _userResource->status = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userResource;
}

/**
 * Writes a UserResource to XML.
 *
 * @param writer The XML writer.
 * @param _userResource The UserResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResource *_userResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userResource->resourceURI != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "resourceURI", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->resourceURI));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}resourceURI. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->lastName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "lastName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}lastName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->lastName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}lastName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->email != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "email", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}email...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->email));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}email. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->firstName != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "firstName", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}firstName...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->firstName));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}firstName. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->password != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "password", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}password...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->password));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}password. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_userResource->roles != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _userResource->_sizeof_roles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "role", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}role...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_userResource->roles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_userResource->roles != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userResource->status != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "status", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}status...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userResource->status));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}status. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserResource.
 *
 * @param _userResource The UserResource to free.
 */
static void freeNs0UserResourceType(struct security_rest_api_ns0_userResource *_userResource) {
  int i;
  if (_userResource->resourceURI != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor resourceURI of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->resourceURI);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor resourceURI of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->resourceURI);
  }
  if (_userResource->lastName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor lastName of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->lastName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor lastName of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->lastName);
  }
  if (_userResource->email != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor email of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->email);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor email of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->email);
  }
  if (_userResource->firstName != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor firstName of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->firstName);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor firstName of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->firstName);
  }
  if (_userResource->password != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor password of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->password);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor password of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->password);
  }
  if (_userResource->roles != NULL) {
    for (i = 0; i < _userResource->_sizeof_roles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor roles[%i] of type security_rest_api_ns0_userResource...\n", i);
#endif
      freeXsStringType(&(_userResource->roles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor roles of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->roles);
  }
  if (_userResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->userId);
  }
  if (_userResource->status != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor status of type security_rest_api_ns0_userResource...\n");
#endif
    freeXsStringType(_userResource->status);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor status of type security_rest_api_ns0_userResource...\n");
#endif
    free(_userResource->status);
  }
}
#endif /* DEF_security_rest_api_ns0_userResource_M */
#ifndef DEF_security_rest_api_ns0_userResourceRequest_M
#define DEF_security_rest_api_ns0_userResourceRequest_M

/**
 * Reads a UserResourceRequest element from XML. The element to be read is "user-request", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userResourceRequest *xml_read_security_rest_api_ns0_userResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_requestElement(reader);
}

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_userResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  return xmlTextWriterWriteNs0User_requestElementNS(writer, _userResourceRequest, 1);
}

/**
 * Frees a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest to free.
 */
void free_security_rest_api_ns0_userResourceRequest(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  freeNs0UserResourceRequestType(_userResourceRequest);
  free(_userResourceRequest);
}

/**
 * Reads a UserResourceRequest element from XML. The element to be read is "user-request", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userResourceRequest *xmlTextReaderReadNs0User_requestElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_userResourceRequest *_userResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-request", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-request.\n");
#endif
    _userResourceRequest = xmlTextReaderReadNs0UserResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-request failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-request failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userResourceRequest;
}

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_requestElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  return xmlTextWriterWriteNs0User_requestElementNS(writer, _userResourceRequest, 0);
}

/**
 * Writes a UserResourceRequest to XML under element name "user-request".
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_requestElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-request", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userResourceRequest for root element {}user-request...\n");
#endif
  status = xmlTextWriterWriteNs0UserResourceRequestType(writer, _userResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-request. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest whose children are to be free.
 */
static void freeNs0User_requestElement(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  freeNs0UserResourceRequestType(_userResourceRequest);
}

/**
 * Reads a UserResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the UserResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userResourceRequest *xmlTextReaderReadNs0UserResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userResourceRequest *_userResourceRequest = calloc(1, sizeof(struct security_rest_api_ns0_userResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserResourceRequestType(_userResourceRequest);
        free(_userResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserResourceRequestType(_userResourceRequest);
          free(_userResourceRequest);
          return NULL;
        }

        _userResourceRequest->data = ((struct security_rest_api_ns0_userResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userResourceRequest;
}

/**
 * Writes a UserResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userResourceRequest The UserResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserResourceType(writer, (_userResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserResourceRequest.
 *
 * @param _userResourceRequest The UserResourceRequest to free.
 */
static void freeNs0UserResourceRequestType(struct security_rest_api_ns0_userResourceRequest *_userResourceRequest) {
  int i;
  if (_userResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_userResourceRequest...\n");
#endif
    freeNs0UserResourceType(_userResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_userResourceRequest...\n");
#endif
    free(_userResourceRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_userResourceRequest_M */
#ifndef DEF_security_rest_api_ns0_userToRoleResource_M
#define DEF_security_rest_api_ns0_userToRoleResource_M

/**
 * Reads a UserToRoleResource from XML. The reader is assumed to be at the start element.
 *
 * @return the UserToRoleResource, or NULL in case of error.
 */
static struct security_rest_api_ns0_userToRoleResource *xmlTextReaderReadNs0UserToRoleResourceType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userToRoleResource *_userToRoleResource = calloc(1, sizeof(struct security_rest_api_ns0_userToRoleResource));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserToRoleResourceType(_userToRoleResource);
        free(_userToRoleResource);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "userId", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}userId of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserToRoleResourceType(_userToRoleResource);
          free(_userToRoleResource);
          return NULL;
        }

        _userToRoleResource->userId = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "source", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}source of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}source of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserToRoleResourceType(_userToRoleResource);
          free(_userToRoleResource);
          return NULL;
        }

        _userToRoleResource->source = ((xmlChar*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "roles", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

        if (xmlTextReaderIsEmptyElement(reader) == 0) {
#if DEBUG_ENUNCIATE > 1
          printf("Unwrapping wrapper element {}roles...\n");
#endif
          //start wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
          while (xmlTextReaderDepth(reader) > (depth + 1)) {
            if (status < 1) {
              //panic: XML read error.
#if DEBUG_ENUNCIATE
              printf("Failure to advance to next child element.\n");
#endif
              freeNs0UserToRoleResourceType(_userToRoleResource);
              free(_userToRoleResource);
              return NULL;
            }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "role", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
        _child_accessor = xmlTextReaderReadXsStringType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}role of type {http://www.w3.org/2001/XMLSchema}string.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserToRoleResourceType(_userToRoleResource);
          free(_userToRoleResource);
          return NULL;
        }

        _userToRoleResource->roles = realloc(_userToRoleResource->roles, (_userToRoleResource->_sizeof_roles + 1) * sizeof(xmlChar));
        memcpy(&(_userToRoleResource->roles[_userToRoleResource->_sizeof_roles++]), _child_accessor, sizeof(xmlChar));
        free(_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
          } // end "while in wrapper element" loop
        } //end "if empty element" clause

        if (status < 1) {
          //panic: XML read error.
#if DEBUG_ENUNCIATE
          printf("Failed to advance to end wrapper element {}roles.\n");
#endif
          freeNs0UserToRoleResourceType(_userToRoleResource);
          free(_userToRoleResource);
          return NULL;
        }
        else {
          //end wrapper element "{}roles"
          status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
        }
      } // end "if wrapper element" clause
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userToRoleResource.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userToRoleResource. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userToRoleResource;
}

/**
 * Writes a UserToRoleResource to XML.
 *
 * @param writer The XML writer.
 * @param _userToRoleResource The UserToRoleResource to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserToRoleResourceType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResource *_userToRoleResource) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userToRoleResource->userId != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "userId", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}userId...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userToRoleResource->userId));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}userId. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  if (_userToRoleResource->source != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "source", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}source. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}source...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, (_userToRoleResource->source));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}source. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}source. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_userToRoleResource->roles != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "roles", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }
  for (i = 0; i < _userToRoleResource->_sizeof_roles; i++) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "role", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {http://www.w3.org/2001/XMLSchema}string for element {}role...\n", status);
#endif
    status = xmlTextWriterWriteXsStringType(writer, &(_userToRoleResource->roles[i]));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {http://www.w3.org/2001/XMLSchema}string for element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}role. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  if (_userToRoleResource->roles != NULL) {
    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}roles. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserToRoleResource.
 *
 * @param _userToRoleResource The UserToRoleResource to free.
 */
static void freeNs0UserToRoleResourceType(struct security_rest_api_ns0_userToRoleResource *_userToRoleResource) {
  int i;
  if (_userToRoleResource->userId != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor userId of type security_rest_api_ns0_userToRoleResource...\n");
#endif
    freeXsStringType(_userToRoleResource->userId);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor userId of type security_rest_api_ns0_userToRoleResource...\n");
#endif
    free(_userToRoleResource->userId);
  }
  if (_userToRoleResource->source != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor source of type security_rest_api_ns0_userToRoleResource...\n");
#endif
    freeXsStringType(_userToRoleResource->source);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor source of type security_rest_api_ns0_userToRoleResource...\n");
#endif
    free(_userToRoleResource->source);
  }
  if (_userToRoleResource->roles != NULL) {
    for (i = 0; i < _userToRoleResource->_sizeof_roles; i++) {
#if DEBUG_ENUNCIATE > 1
      printf("Freeing accessor roles[%i] of type security_rest_api_ns0_userToRoleResource...\n", i);
#endif
      freeXsStringType(&(_userToRoleResource->roles[i]));
    }
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor roles of type security_rest_api_ns0_userToRoleResource...\n");
#endif
    free(_userToRoleResource->roles);
  }
}
#endif /* DEF_security_rest_api_ns0_userToRoleResource_M */
#ifndef DEF_security_rest_api_ns0_userToRoleResourceRequest_M
#define DEF_security_rest_api_ns0_userToRoleResourceRequest_M

/**
 * Reads a UserToRoleResourceRequest element from XML. The element to be read is "user-to-role", and
 * it is assumed that the reader is pointing to the XML document (not the element).
 *
 * @param reader The XML reader.
 * @return The UserToRoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userToRoleResourceRequest *xml_read_security_rest_api_ns0_userToRoleResourceRequest(xmlTextReaderPtr reader) {
  int status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
  return xmlTextReaderReadNs0User_to_roleElement(reader);
}

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
int xml_write_security_rest_api_ns0_userToRoleResourceRequest(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  return xmlTextWriterWriteNs0User_to_roleElementNS(writer, _userToRoleResourceRequest, 1);
}

/**
 * Frees a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to free.
 */
void free_security_rest_api_ns0_userToRoleResourceRequest(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  freeNs0UserToRoleResourceRequestType(_userToRoleResourceRequest);
  free(_userToRoleResourceRequest);
}

/**
 * Reads a UserToRoleResourceRequest element from XML. The element to be read is "user-to-role", and
 * it is assumed that the reader is pointing to that element.
 *
 * @param reader The XML reader.
 * @return The UserToRoleResourceRequest, or NULL in case of error.
 */
struct security_rest_api_ns0_userToRoleResourceRequest *xmlTextReaderReadNs0User_to_roleElement(xmlTextReaderPtr reader) {
  struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest = NULL;

  if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
    && xmlStrcmp(BAD_CAST "user-to-role", xmlTextReaderConstLocalName(reader)) == 0
    && xmlTextReaderConstNamespaceUri(reader) == NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Attempting to read root element {}user-to-role.\n");
#endif
    _userToRoleResourceRequest = xmlTextReaderReadNs0UserToRoleResourceRequestType(reader);
  }
#if DEBUG_ENUNCIATE
  if (_userToRoleResourceRequest == NULL) {
    if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
      printf("attempt to read {}user-to-role failed. current element: {}%s\n",  xmlTextReaderConstLocalName(reader));
    }
    else {
      printf("attempt to read {}user-to-role failed. current element: {%s}%s\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
    }
  }
#endif

  return _userToRoleResourceRequest;
}

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 * Does NOT write the namespace prefixes.
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_to_roleElement(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  return xmlTextWriterWriteNs0User_to_roleElementNS(writer, _userToRoleResourceRequest, 0);
}

/**
 * Writes a UserToRoleResourceRequest to XML under element name "user-to-role".
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @param writeNamespaces Whether to write the namespace prefixes.
 * @return 1 if successful, 0 otherwise.
 */
static int xmlTextWriterWriteNs0User_to_roleElementNS(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest, int writeNamespaces) {
  int totalBytes = 0;
  int status;

  status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "user-to-role", NULL);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write start element {}user-to-role. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

#if DEBUG_ENUNCIATE > 1
  printf("writing type {}userToRoleResourceRequest for root element {}user-to-role...\n");
#endif
  status = xmlTextWriterWriteNs0UserToRoleResourceRequestType(writer, _userToRoleResourceRequest);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to write type for start element {}user-to-role. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  status = xmlTextWriterEndElement(writer);
  if (status < 0) {
#if DEBUG_ENUNCIATE
    printf("unable to end element {}user-to-role. status: %i\n", status);
#endif
    return status;
  }
  totalBytes += status;

  return totalBytes;
}

/**
 * Frees the children of a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest whose children are to be free.
 */
static void freeNs0User_to_roleElement(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  freeNs0UserToRoleResourceRequestType(_userToRoleResourceRequest);
}

/**
 * Reads a UserToRoleResourceRequest from XML. The reader is assumed to be at the start element.
 *
 * @return the UserToRoleResourceRequest, or NULL in case of error.
 */
static struct security_rest_api_ns0_userToRoleResourceRequest *xmlTextReaderReadNs0UserToRoleResourceRequestType(xmlTextReaderPtr reader) {
  int status, depth;
  void *_child_accessor;
  struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest = calloc(1, sizeof(struct security_rest_api_ns0_userToRoleResourceRequest));



  if (xmlTextReaderIsEmptyElement(reader) == 0) {
    depth = xmlTextReaderDepth(reader);//track the depth.
    status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);

    while (xmlTextReaderDepth(reader) > depth) {
      if (status < 1) {
        //panic: XML read error.
#if DEBUG_ENUNCIATE
        printf("Failure to advance to next child element.\n");
#endif
        freeNs0UserToRoleResourceRequestType(_userToRoleResourceRequest);
        free(_userToRoleResourceRequest);
        return NULL;
      }
      else if (xmlTextReaderNodeType(reader) == XML_READER_TYPE_ELEMENT
        && xmlStrcmp(BAD_CAST "data", xmlTextReaderConstLocalName(reader)) == 0
        && xmlTextReaderConstNamespaceUri(reader) == NULL) {

#if DEBUG_ENUNCIATE > 1
        printf("Attempting to read choice {}data of type {}userToRoleResource.\n");
#endif
        _child_accessor = xmlTextReaderReadNs0UserToRoleResourceType(reader);
        if (_child_accessor == NULL) {
#if DEBUG_ENUNCIATE
          printf("Failed to read choice {}data of type {}userToRoleResource.\n");
#endif
          //panic: unable to read the child element for some reason.
          freeNs0UserToRoleResourceRequestType(_userToRoleResourceRequest);
          free(_userToRoleResourceRequest);
          return NULL;
        }

        _userToRoleResourceRequest->data = ((struct security_rest_api_ns0_userToRoleResource*)_child_accessor);
        status = xmlTextReaderAdvanceToNextStartOrEndElement(reader);
      }
      else {
#if DEBUG_ENUNCIATE > 1
        if (xmlTextReaderConstNamespaceUri(reader) == NULL) {
          printf("unknown child element {}%s for type {}userToRoleResourceRequest.  Skipping...\n",  xmlTextReaderConstLocalName(reader));
        }
        else {
          printf("unknown child element {%s}%s for type {}userToRoleResourceRequest. Skipping...\n", xmlTextReaderConstNamespaceUri(reader), xmlTextReaderConstLocalName(reader));
        }
#endif
        status = xmlTextReaderSkipElement(reader);
      }
    }
  }

  return _userToRoleResourceRequest;
}

/**
 * Writes a UserToRoleResourceRequest to XML.
 *
 * @param writer The XML writer.
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to write.
 * @return The total bytes written, or -1 on error;
 */
static int xmlTextWriterWriteNs0UserToRoleResourceRequestType(xmlTextWriterPtr writer, struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  int status, totalBytes = 0, i;
  xmlChar *binaryData;
  if (_userToRoleResourceRequest->data != NULL) {
    status = xmlTextWriterStartElementNS(writer, NULL, BAD_CAST "data", NULL);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write start element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

#if DEBUG_ENUNCIATE > 1
    printf("writing type {}userToRoleResource for element {}data...\n", status);
#endif
    status = xmlTextWriterWriteNs0UserToRoleResourceType(writer, (_userToRoleResourceRequest->data));
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write type {}userToRoleResource for element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;

    status = xmlTextWriterEndElement(writer);
    if (status < 0) {
#if DEBUG_ENUNCIATE
      printf("Failed to write end element {}data. status: %i\n", status);
#endif
      return status;
    }
    totalBytes += status;
  }

  return totalBytes;
}

/**
 * Frees the elements of a UserToRoleResourceRequest.
 *
 * @param _userToRoleResourceRequest The UserToRoleResourceRequest to free.
 */
static void freeNs0UserToRoleResourceRequestType(struct security_rest_api_ns0_userToRoleResourceRequest *_userToRoleResourceRequest) {
  int i;
  if (_userToRoleResourceRequest->data != NULL) {
#if DEBUG_ENUNCIATE > 1
    printf("Freeing type of accessor data of type security_rest_api_ns0_userToRoleResourceRequest...\n");
#endif
    freeNs0UserToRoleResourceType(_userToRoleResourceRequest->data);
#if DEBUG_ENUNCIATE > 1
    printf("Freeing accessor data of type security_rest_api_ns0_userToRoleResourceRequest...\n");
#endif
    free(_userToRoleResourceRequest->data);
  }
}
#endif /* DEF_security_rest_api_ns0_userToRoleResourceRequest_M */
